/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/event","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/process","fs","os","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetry","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/codicons","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/performance","vs/editor/common/core/range","vs/base/common/marshalling","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/base/common/functional","vs/base/common/json","vs/base/common/mime","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","url","vs/platform/shell/node/shellEnv","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","vs/base/common/assert","path","net","vs/editor/common/core/position","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/normalization","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/telemetry/common/commonProperties","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/common/extensionGalleryService","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/server/node/extensionHostConnection","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/extpath","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","https","http","yauzl","yazl","zlib","vs/server/node/server.main"],we=function(oe){for(var e=[],v=0,t=oe.length;v<t;v++)e[v]=ve[oe[v]];return e};define(ve[133],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class v{static get(){const D=new Map,C=new Map,T=new Map,P=new Map;function p(y,h){y.has(h.detail)||y.set(h.detail,-h.timestamp)}function b(y,h){const w=y.get(h.detail);!w||w>=0||y.set(h.detail,w+h.timestamp)}const R=oe.getStats().slice(0).sort((y,h)=>y.timestamp-h.timestamp);for(const y of R)switch(y.type){case 10:p(D,y);break;case 11:case 12:b(D,y);break;case 21:p(C,y);break;case 22:b(C,y);break;case 33:p(T,y);break;case 34:b(T,y);break;case 31:p(P,y);break;case 32:b(P,y);break}let k=0;T.forEach(y=>k+=y);function S(y){const h=[];return y.forEach((w,E)=>h.push([E,w])),h}return{amdLoad:S(D),amdInvoke:S(C),nodeRequire:S(T),nodeEval:S(P),nodeRequireTotal:k}}static toMarkdownTable(D,C){let T="";const P=[];return D.forEach((p,b)=>{P[b]=p.length}),C.forEach(p=>{p.forEach((b,R)=>{typeof b>"u"&&(b=p[R]="-");const k=b.toString().length;P[R]=Math.max(k,P[R])})}),D.forEach((p,b)=>{T+=`| ${p+" ".repeat(P[b]-p.toString().length)} `}),T+=`|
`,D.forEach((p,b)=>{T+=`| ${"-".repeat(P[b])} `}),T+=`|
`,C.forEach(p=>{p.forEach((b,R)=>{typeof b<"u"&&(T+=`| ${b+" ".repeat(P[R]-b.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=v}),define(ve[40],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(T){return T?T.replace(/\$\((.*?)\)/g,(P,p)=>` ${p} `).trim():""}e.getCodiconAriaLabel=v;class t{constructor(P,p,b){this.id=P,this.definition=p,this.description=b,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(T,P){const p=["codicon","codicon-"+T];return P&&p.push("codicon-modifier-"+P),p}e.getClassNamesArray=D;var C;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function p(k){if(k instanceof t)return["codicon","codicon-"+k.id];const S=P.exec(k.id);if(!S)return p(t.error);const[,y,h]=S,w=["codicon","codicon-"+y];return h&&w.push("codicon-modifier-"+h.substr(1)),w}T.asClassNameArray=p;function b(k){return p(k).join(" ")}T.asClassName=b;function R(k){return"."+p(k).join(".")}T.asCSSSelector=R})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ve[82],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(T){return(P,p,b)=>{let R=null,k=null;if(typeof b.value=="function"?(R="value",k=b.value):typeof b.get=="function"&&(R="get",k=b.get),!k)throw new Error("not supported");b[R]=T(k,p)}}e.createDecorator=v;function t(T,P,p){let b=null,R=null;if(typeof p.value=="function"?(b="value",R=p.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(b="get",R=p.get),!R)throw new Error("not supported");const k=`$memoize$${P}`;p[b]=function(...S){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,S)}),this[k]}}e.memoize=t;function D(T,P,p){return v((b,R)=>{const k=`$debounce$${R}`,S=`$debounce$result$${R}`;return function(...y){this[S]||(this[S]=p?p():void 0),clearTimeout(this[k]),P&&(this[S]=P(this[S],...y),y=[this[S]]),this[k]=setTimeout(()=>{b.apply(this,y),this[S]=p?p():void 0},T)}})}e.debounce=D;function C(T,P,p){return v((b,R)=>{const k=`$throttle$timer$${R}`,S=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,h=`$throttle$pending$${R}`;return function(...w){if(this[S]||(this[S]=p?p():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[S]=P(this[S],...w)),this[h])return;const E=this[y]+T;E<=Date.now()?(this[y]=Date.now(),b.apply(this,[this[S]]),this[S]=p?p():void 0):(this[h]=!0,this[k]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),b.apply(this,[this[S]]),this[S]=p?p():void 0},E-Date.now()))}})}e.throttle=C}),define(ve[10],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?f.isErrorNoTelemetry(r)?new f(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(o=>{o(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=v,e.errorHandler=new v;function t(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=t;function D(u){p(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=D;function C(u){p(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=C;function T(u){if(u instanceof Error){const{name:r,message:o}=u,n=u.stacktrace||u.stack;return{$isError:!0,name:r,message:o,stack:n,noTelemetry:f.isErrorNoTelemetry(u)}}return u}e.transformErrorForSerialization=T;const P="Canceled";function p(u){return u instanceof b?!0:u instanceof Error&&u.name===P&&u.message===P}e.isCancellationError=p;class b extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=b;function R(){const u=new Error(P);return u.name=u.message,u}e.canceled=R;function k(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=k;function S(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=S;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function h(u){const r=new Error(`${u} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=w;class E extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=E;class g extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=g;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=m;class f extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof f)return r;const o=new f;return o.message=r.message,o.stack=r.stack,o}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class c extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype);debugger}}e.BugIndicatingError=c}),define(ve[18],we([1,0,10]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t($,Y=0){return $[$.length-(1+Y)]}e.tail=t;function D($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=D;function C($,Y,ee=(z,q)=>z===q){if($===Y)return!0;if(!$||!Y||$.length!==Y.length)return!1;for(let z=0,q=$.length;z<q;z++)if(!ee($[z],Y[z]))return!1;return!0}e.equals=C;function T($,Y){const ee=$.length-1;Y<ee&&($[Y]=$[ee]),$.pop()}e.removeFastWithoutKeepingOrder=T;function P($,Y,ee){return p($.length,z=>ee($[z],Y))}e.binarySearch=P;function p($,Y){let ee=0,z=$-1;for(;ee<=z;){const q=(ee+z)/2|0,H=Y(q);if(H<0)ee=q+1;else if(H>0)z=q-1;else return q}return-(ee+1)}e.binarySearch2=p;function b($,Y){let ee=0,z=$.length;if(z===0)return 0;for(;ee<z;){const q=Math.floor((ee+z)/2);Y($[q])?z=q:ee=q+1}return ee}e.findFirstInSorted=b;function R($,Y,ee){if($=$|0,$>=Y.length)throw new TypeError("invalid index");const z=Y[Math.floor(Y.length*Math.random())],q=[],H=[],K=[];for(const le of Y){const pe=ee(le,z);pe<0?q.push(le):pe>0?H.push(le):K.push(le)}return $<q.length?R($,q,ee):$<q.length+K.length?K[0]:R($-(q.length+K.length),H,ee)}e.quickSelect=R;function k($,Y){const ee=[];let z;for(const q of $.slice(0).sort(Y))!z||Y(z[0],q)!==0?(z=[q],ee.push(z)):z.push(q);return ee}e.groupBy=k;function S($,Y,ee){const z=[];function q(le,pe,ke){if(pe===0&&ke.length===0)return;const Te=z[z.length-1];Te&&Te.start+Te.deleteCount===le?(Te.deleteCount+=pe,Te.toInsert.push(...ke)):z.push({start:le,deleteCount:pe,toInsert:ke})}let H=0,K=0;for(;;){if(H===$.length){q(H,0,Y.slice(K));break}if(K===Y.length){q(H,$.length-H,[]);break}const le=$[H],pe=Y[K],ke=ee(le,pe);ke===0?(H+=1,K+=1):ke<0?(q(H,1,[]),H+=1):ke>0&&(q(H,0,[pe]),K+=1)}return z}e.sortedDiff=S;function y($,Y,ee){const z=S($,Y,ee),q=[],H=[];for(const K of z)q.push(...$.slice(K.start,K.start+K.deleteCount)),H.push(...K.toInsert);return{removed:q,added:H}}e.delta=y;function h($,Y,ee){if(ee===0)return[];const z=$.slice(0,ee).sort(Y);return E($,Y,z,ee,$.length),z}e.top=h;function w($,Y,ee,z,q){return ee===0?Promise.resolve([]):new Promise((H,K)=>{(async()=>{const le=$.length,pe=$.slice(0,ee).sort(Y);for(let ke=ee,Te=Math.min(ee+z,le);ke<le;ke=Te,Te=Math.min(Te+z,le)){if(ke>ee&&await new Promise(Ne=>setTimeout(Ne)),q&&q.isCancellationRequested)throw new v.CancellationError;E($,Y,pe,ke,Te)}return pe})().then(H,K)})}e.topAsync=w;function E($,Y,ee,z,q){for(const H=ee.length;z<q;z++){const K=$[z];if(Y(K,ee[H-1])<0){ee.pop();const le=b(ee,pe=>Y(K,pe)<0);ee.splice(le,0,K)}}}function g($){return $.filter(Y=>!!Y)}e.coalesce=g;function m($){let Y=0;for(let ee=0;ee<$.length;ee++)$[ee]&&($[Y]=$[ee],Y+=1);$.length=Y}e.coalesceInPlace=m;function f($,Y,ee){$.splice(ee,0,$.splice(Y,1)[0])}e.move=f;function c($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=c;function u($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=u;function r($,Y=ee=>ee){const ee=new Set;return $.filter(z=>{const q=Y(z);return ee.has(q)?!1:(ee.add(q),!0)})}e.distinct=r;function o($){const Y=new Set;return ee=>{const z=$(ee);return Y.has(z)?!1:(Y.add(z),!0)}}e.uniqueFilter=o;function n($,Y){const ee=i($,Y);if(ee!==-1)return $[ee]}e.findLast=n;function i($,Y){for(let ee=$.length-1;ee>=0;ee--){const z=$[ee];if(Y(z))return ee}return-1}e.lastIndex=i;function s($,Y){return $.length>0?$[0]:Y}e.firstOrDefault=s;function a($,Y){return $.length>0?$[$.length-1]:Y}e.lastOrDefault=a;function l($,Y,ee=(z,q)=>z===q){let z=0;for(let q=0,H=Math.min($.length,Y.length);q<H&&ee($[q],Y[q]);q++)z++;return z}e.commonPrefixLength=l;function d($){return[].concat(...$)}e.flatten=d;function I($,Y){let ee=typeof Y=="number"?$:0;typeof Y=="number"?ee=$:(ee=0,Y=$);const z=[];if(ee<=Y)for(let q=ee;q<Y;q++)z.push(q);else for(let q=ee;q>Y;q--)z.push(q);return z}e.range=I;function L($,Y,ee){return $.reduce((z,q)=>(z[Y(q)]=ee?ee(q):q,z),Object.create(null))}e.index=L;function B($,Y){return $.push(Y),()=>J($,Y)}e.insert=B;function J($,Y){const ee=$.indexOf(Y);if(ee>-1)return $.splice(ee,1),Y}e.remove=J;function Z($,Y,ee){const z=$.slice(0,Y),q=$.slice(Y);return z.concat(ee,q)}e.arrayInsert=Z;function _($,Y){let ee;if(typeof Y=="number"){let z=Y;ee=()=>{const q=Math.sin(z++)*179426549;return q-Math.floor(q)}}else ee=Math.random;for(let z=$.length-1;z>0;z-=1){const q=Math.floor(ee()*(z+1)),H=$[z];$[z]=$[q],$[q]=H}}e.shuffle=_;function te($,Y){const ee=$.indexOf(Y);ee>-1&&($.splice(ee,1),$.unshift(Y))}e.pushToStart=te;function se($,Y){const ee=$.indexOf(Y);ee>-1&&($.splice(ee,1),$.push(Y))}e.pushToEnd=se;function W($,Y){for(const ee of Y)$.push(ee)}e.pushMany=W;function fe($,Y){return Array.isArray($)?$.map(Y):Y($)}e.mapArrayOrNot=fe;function j($){return Array.isArray($)?$:[$]}e.asArray=j;function X($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=X;function O($,Y){for(const ee of $){const z=Y(ee);if(z!==void 0)return z}}e.mapFind=O;function U($,Y,ee){const z=ae($,Y),q=$.length,H=ee.length;$.length=q+H;for(let K=q-1;K>=z;K--)$[K+H]=$[K];for(let K=0;K<H;K++)$[K+z]=ee[K]}e.insertInto=U;function x($,Y,ee,z){const q=ae($,Y),H=$.splice(q,ee);return U($,q,z),H}e.splice=x;function ae($,Y){return Y<0?Math.max(Y+$.length,0):Math.min(Y,$.length)}var ue;(function($){function Y(q){return q<0}$.isLessThan=Y;function ee(q){return q>0}$.isGreaterThan=ee;function z(q){return q===0}$.isNeitherLessOrGreaterThan=z,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(ue=e.CompareResult||(e.CompareResult={}));function Q($,Y){return(ee,z)=>Y($(ee),$(z))}e.compareBy=Q;function re(...$){return(Y,ee)=>{for(const z of $){const q=z(Y,ee);if(!ue.isNeitherLessOrGreaterThan(q))return q}return ue.neitherLessOrGreaterThan}}e.tieBreakComparators=re;const F=($,Y)=>$-Y;e.numberComparator=F;function M($,Y){if($.length===0)return;let ee=$[0];for(let z=1;z<$.length;z++){const q=$[z];Y(q,ee)>0&&(ee=q)}return ee}e.findMaxBy=M;function G($,Y){if($.length===0)return;let ee=$[0];for(let z=1;z<$.length;z++){const q=$[z];Y(q,ee)>=0&&(ee=q)}return ee}e.findLastMaxBy=G;function ie($,Y){return M($,(ee,z)=>-Y(ee,z))}e.findMinBy=ie;class he{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let ee=this.firstIdx;for(;ee<this.items.length&&Y(this.items[ee]);)ee++;const z=ee===this.firstIdx?null:this.items.slice(this.firstIdx,ee);return this.firstIdx=ee,z}takeFromEndWhile(Y){let ee=this.lastIdx;for(;ee>=0&&Y(this.items[ee]);)ee--;const z=ee===this.lastIdx?null:this.items.slice(ee+1,this.lastIdx+1);return this.lastIdx=ee,z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Y=this.items[this.firstIdx];return this.firstIdx++,Y}removeLast(){const Y=this.items[this.lastIdx];return this.lastIdx--,Y}takeCount(Y){const ee=this.items.slice(this.firstIdx,this.firstIdx+Y);return this.firstIdx+=Y,ee}}e.ArrayQueue=he;class Ee{constructor(Y){this.iterate=Y}forEach(Y){this.iterate(ee=>(Y(ee),!0))}toArray(){const Y=[];return this.iterate(ee=>(Y.push(ee),!0)),Y}filter(Y){return new Ee(ee=>this.iterate(z=>Y(z)?ee(z):!0))}map(Y){return new Ee(ee=>this.iterate(z=>ee(Y(z))))}some(Y){let ee=!1;return this.iterate(z=>(ee=Y(z),!ee)),ee}findFirst(Y){let ee;return this.iterate(z=>Y(z)?(ee=z,!1):!0),ee}findLast(Y){let ee;return this.iterate(z=>(Y(z)&&(ee=z),!0)),ee}findLastMaxBy(Y){let ee,z=!0;return this.iterate(q=>((z||ue.isGreaterThan(Y(q,ee)))&&(z=!1,ee=q),!0)),ee}}e.CallbackIterable=Ee,Ee.empty=new Ee($=>{})}),define(ve[83],we([1,0,10]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(p,b){if(!p)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=t;function D(p,b="Unreachable"){throw new Error(b)}e.assertNever=D;function C(p){if(!p)throw new v.BugIndicatingError("Assertion Failed")}e.assert=C;function T(p){if(!p()){debugger;p(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function P(p,b){let R=0;for(;R<p.length-1;){const k=p[R],S=p[R+1];if(!b(k,S))return!1;R++}return!0}e.checkAdjacentItems=P}),define(ve[64],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(t){const D=this;let C=!1,T;return function(){return C||(C=!0,T=t.apply(D,arguments)),T}}e.once=v}),define(ve[44],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(t){function D(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=D;const C=Object.freeze([]);function T(){return C}t.empty=T;function*P(o){yield o}t.single=P;function p(o){return o||C}t.from=p;function b(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=b;function R(o){return o[Symbol.iterator]().next().value}t.first=R;function k(o,n){for(const i of o)if(n(i))return!0;return!1}t.some=k;function S(o,n){for(const i of o)if(n(i))return i}t.find=S;function*y(o,n){for(const i of o)n(i)&&(yield i)}t.filter=y;function*h(o,n){let i=0;for(const s of o)yield n(s,i++)}t.map=h;function*w(...o){for(const n of o)for(const i of n)yield i}t.concat=w;function*E(o){for(const n of o)for(const i of n)yield i}t.concatNested=E;function g(o,n,i){let s=i;for(const a of o)s=n(s,a);return s}t.reduce=g;function m(o,n){let i=0;for(const s of o)n(s,i++)}t.forEach=m;function*f(o,n,i=o.length){for(n<0&&(n+=o.length),i<0?i+=o.length:i>o.length&&(i=o.length);n<i;n++)yield o[n]}t.slice=f;function c(o,n=Number.POSITIVE_INFINITY){const i=[];if(n===0)return[i,o];const s=o[Symbol.iterator]();for(let a=0;a<n;a++){const l=s.next();if(l.done)return[i,t.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=c;function u(o){return c(o)[0]}t.collect=u;function r(o,n,i=(s,a)=>s===a){const s=o[Symbol.iterator](),a=n[Symbol.iterator]();for(;;){const l=s.next(),d=a.next();if(l.done!==d.done)return!1;if(l.done)return!0;if(!i(l.value,d.value))return!1}}t.equals=r})(v=e.Iterable||(e.Iterable={}))}),define(ve[65],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(r){r.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function T(r,o=!1){let n=0;const i=r.length;let s="",a=0,l=16,d=0;function I(se){let W=0,fe=0;for(;W<se;){const j=r.charCodeAt(n);if(j>=48&&j<=57)fe=fe*16+j-48;else if(j>=65&&j<=70)fe=fe*16+j-65+10;else if(j>=97&&j<=102)fe=fe*16+j-97+10;else break;n++,W++}return W<se&&(fe=-1),fe}function L(se){n=se,s="",a=0,l=16,d=0}function B(){const se=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&b(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&b(r.charCodeAt(n)))for(n++;n<r.length&&b(r.charCodeAt(n));)n++;else return d=3,r.substring(se,n);let W=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&b(r.charCodeAt(n))){for(n++;n<r.length&&b(r.charCodeAt(n));)n++;W=n}else d=3;return r.substring(se,W)}function J(){let se="",W=n;for(;;){if(n>=i){se+=r.substring(W,n),d=2;break}const fe=r.charCodeAt(n);if(fe===34){se+=r.substring(W,n),n++;break}if(fe===92){if(se+=r.substring(W,n),n++,n>=i){d=2;break}switch(r.charCodeAt(n++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const X=I(4);X>=0?se+=String.fromCharCode(X):d=4;break}default:d=5}W=n;continue}if(fe>=0&&fe<=31)if(p(fe)){se+=r.substring(W,n),d=2;break}else d=6;n++}return se}function Z(){if(s="",d=0,a=n,n>=i)return a=i,l=17;let se=r.charCodeAt(n);if(P(se)){do n++,s+=String.fromCharCode(se),se=r.charCodeAt(n);while(P(se));return l=15}if(p(se))return n++,s+=String.fromCharCode(se),se===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),l=14;switch(se){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,s=J(),l=10;case 47:{const W=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<i&&!p(r.charCodeAt(n));)n++;return s=r.substring(W,n),l=12}if(r.charCodeAt(n+1)===42){n+=2;const fe=i-1;let j=!1;for(;n<fe;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,j=!0;break}n++}return j||(n++,d=1),s=r.substring(W,n),l=13}return s+=String.fromCharCode(se),n++,l=16}case 45:if(s+=String.fromCharCode(se),n++,n===i||!b(r.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=B(),l=11;default:for(;n<i&&_(se);)n++,se=r.charCodeAt(n);if(a!==n){switch(s=r.substring(a,n),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(se),n++,l=16}}function _(se){if(P(se)||p(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function te(){let se;do se=Z();while(se>=12&&se<=15);return se}return{setPosition:L,getPosition:()=>n,scan:o?te:Z,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>d}}e.createScanner=T;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function p(r){return r===10||r===13||r===8232||r===8233}function b(r){return r>=48&&r<=57}var R;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(R||(R={}));function k(r,o){const n=[],i=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function d(I,L,B,J){a.value=I,a.offset=L,a.length=B,a.type=J,a.colonOffset=void 0,s=a}try{f(r,{onObjectBegin:(I,L)=>{if(o<=I)throw i;s=void 0,l=o>I,n.push("")},onObjectProperty:(I,L,B)=>{if(o<L||(d(I,L,B,"property"),n[n.length-1]=I,o<=L+B))throw i},onObjectEnd:(I,L)=>{if(o<=I)throw i;s=void 0,n.pop()},onArrayBegin:(I,L)=>{if(o<=I)throw i;s=void 0,n.push(0)},onArrayEnd:(I,L)=>{if(o<=I)throw i;s=void 0,n.pop()},onLiteralValue:(I,L,B)=>{if(o<L||(d(I,L,B,u(I)),o<=L+B))throw i},onSeparator:(I,L,B)=>{if(o<=L)throw i;if(I===":"&&s&&s.type==="property")s.colonOffset=L,l=!1,s=void 0;else if(I===","){const J=n[n.length-1];typeof J=="number"?n[n.length-1]=J+1:(l=!0,n[n.length-1]=""),s=void 0}}})}catch(I){if(I!==i)throw I}return{path:n,previousNode:s,isAtPropertyKey:l,matches:I=>{let L=0;for(let B=0;L<I.length&&B<n.length;B++)if(I[L]===n[B]||I[L]==="*")L++;else if(I[L]!=="**")return!1;return L===I.length}}}e.getLocation=k;function S(r,o=[],n=C.DEFAULT){let i=null,s=[];const a=[];function l(I){Array.isArray(s)?s.push(I):i!==null&&(s[i]=I)}return f(r,{onObjectBegin:()=>{const I={};l(I),a.push(s),s=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const I=[];l(I),a.push(s),s=I,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:l,onError:(I,L,B)=>{o.push({error:I,offset:L,length:B})}},n),s[0]}e.parse=S;function y(r,o=[],n=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function a(I){return i.children.push(I),I}f(r,{onObjectBegin:I=>{i=a({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,L,B)=>{i=a({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:L,length:B,parent:i})},onObjectEnd:(I,L)=>{i.length=I+L-i.offset,i=i.parent,s(I+L)},onArrayBegin:(I,L)=>{i=a({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,L)=>{i.length=I+L-i.offset,i=i.parent,s(I+L)},onLiteralValue:(I,L,B)=>{a({type:u(I),offset:L,length:B,parent:i,value:I}),s(L+B)},onSeparator:(I,L,B)=>{i.type==="property"&&(I===":"?i.colonOffset=L:I===","&&s(L))},onError:(I,L,B)=>{o.push({error:I,offset:L,length:B})}},n);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=y;function h(r,o){if(!r)return;let n=r;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===i){n=a.children[1],s=!0;break}if(!s)return}else{const s=i;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function w(r){if(!r.parent||!r.parent.children)return[];const o=w(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;o.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&o.push(n)}return o}e.getNodePath=w;function E(r){switch(r.type){case"array":return r.children.map(E);case"object":{const o=Object.create(null);for(const n of r.children){const i=n.children[1];i&&(o[n.children[0].value]=E(i))}return o}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=E;function g(r,o,n=!1){return o>=r.offset&&o<r.offset+r.length||n&&o===r.offset+r.length}e.contains=g;function m(r,o,n=!1){if(g(r,o,n)){const i=r.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const a=m(i[s],o,n);if(a)return a}return r}}e.findNodeAtOffset=m;function f(r,o,n=C.DEFAULT){const i=T(r,!1);function s(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(Q){return Q?re=>Q(re,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=s(o.onObjectBegin),d=a(o.onObjectProperty),I=s(o.onObjectEnd),L=s(o.onArrayBegin),B=s(o.onArrayEnd),J=a(o.onLiteralValue),Z=a(o.onSeparator),_=s(o.onComment),te=a(o.onError),se=n&&n.disallowComments,W=n&&n.allowTrailingComma;function fe(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:se||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(Q){case 12:case 13:se?j(10):_();break;case 16:j(1);break;case 15:case 14:break;default:return Q}}}function j(Q,re=[],F=[]){if(te(Q),re.length+F.length>0){let M=i.getToken();for(;M!==17;){if(re.indexOf(M)!==-1){fe();break}else if(F.indexOf(M)!==-1)break;M=fe()}}}function X(Q){const re=i.getTokenValue();return Q?J(re):d(re),fe(),!0}function O(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(j(2),Q=0)}catch{j(2)}J(Q);break}case 7:J(null);break;case 8:J(!0);break;case 9:J(!1);break;default:return!1}return fe(),!0}function U(){return i.getToken()!==10?(j(3,[],[2,5]),!1):(X(!1),i.getToken()===6?(Z(":"),fe(),ue()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function x(){l(),fe();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||j(4,[],[]),Z(","),fe(),i.getToken()===2&&W)break}else Q&&j(6,[],[]);U()||j(4,[],[2,5]),Q=!0}return I(),i.getToken()!==2?j(7,[2],[]):fe(),!0}function ae(){L(),fe();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||j(4,[],[]),Z(","),fe(),i.getToken()===4&&W)break}else Q&&j(6,[],[]);ue()||j(4,[],[4,5]),Q=!0}return B(),i.getToken()!==4?j(8,[4],[]):fe(),!0}function ue(){switch(i.getToken()){case 3:return ae();case 1:return x();case 10:return X(!0);default:return O()}}return fe(),i.getToken()===17?n.allowEmptyContent?!0:(j(4,[],[]),!1):ue()?(i.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=f;function c(r,o){const n=T(r),i=[];let s,a=0,l;do switch(l=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:a!==l&&i.push(r.substring(a,l)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),a=n.getPosition();break}while(s!==17);return i.join("")}e.stripComments=c;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ve[134],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new v(()=>D(this.getValue()))}}e.Lazy=v}),define(ve[2],we([1,0,64,44]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function T(s){C=s}if(e.setDisposableTracker=T,D){const s="__is_disposable_tracked__";T(new class{trackDisposable(a){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(l)},3e3)}setParent(a,l){if(a&&a!==m.None)try{a[s]=!0}catch{}}markAsDisposed(a){if(a&&a!==m.None)try{a[s]=!0}catch{}}markAsSingleton(a){}})}function P(s){return C?.trackDisposable(s),s}function p(s){C?.markAsDisposed(s)}function b(s,a){C?.setParent(s,a)}function R(s,a){if(!!C)for(const l of s)C.setParent(l,a)}function k(s){return C?.markAsSingleton(s),s}e.markAsSingleton=k;function S(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=S;function y(s){if(t.Iterable.is(s)){const a=[];for(const l of s)if(l)try{l.dispose()}catch(d){a.push(d)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=y;function h(s){for(const a of s)S(a)&&a.dispose();return[]}e.disposeIfDisposable=h;function w(...s){const a=E(()=>y(s));return R(s,a),a}e.combinedDisposable=w;function E(s){const a=P({dispose:(0,v.once)(()=>{p(a),s()})});return a}e.toDisposable=E;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{y(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return b(a,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new g,P(this),b(this._store,this)}dispose(){p(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&b(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&b(a,null),a}}e.MutableDisposable=f;class c{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let l=a;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,p(this))},this}}e.SafeDisposable=u;class r{constructor(){this.references=new Map}acquire(a,...l){let d=this.references.get(a);d||(d={counter:0,object:this.createReferencedObject(a,...l)},this.references.set(a,d));const{object:I}=d,L=(0,v.once)(()=>{--d.counter===0&&(this.destroyReferencedObject(a,d.object),this.references.delete(a))});return d.counter++,{object:I,dispose:L}}}e.ReferenceCollection=r;class o{constructor(a){this.referenceCollection=a}async acquire(a,...l){const d=this.referenceCollection.acquire(a,...l);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(I){throw d.dispose(),I}}}e.AsyncReferenceCollection=o;class n{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=n;function i(s){const a=new g;try{s(a)}finally{a.dispose()}}e.disposeOnReturn=i}),define(ve[135],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(C){this.element=C,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class t{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let C=this._first;for(;C!==v.Undefined;){const T=C.next;C.prev=v.Undefined,C.next=v.Undefined,C=T}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,T){const P=new v(C);if(this._first===v.Undefined)this._first=P,this._last=P;else if(T){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(P))}}shift(){if(this._first!==v.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==v.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==v.Undefined&&C.next!==v.Undefined){const T=C.prev;T.next=C.next,C.next.prev=T}else C.prev===v.Undefined&&C.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):C.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):C.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==v.Undefined;)yield C.element,C=C.next}}e.LinkedList=t}),function(oe,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ve[136],we([0]),e):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e($,Y){for(var ee=0;ee<Y.length;ee++){var z=Y[ee];z.enumerable=z.enumerable||!1,z.configurable=!0,"value"in z&&(z.writable=!0),Object.defineProperty($,z.key,z)}}function v($,Y,ee){return Y&&e($.prototype,Y),ee&&e($,ee),Object.defineProperty($,"prototype",{writable:!1}),$}function t($,Y){if(!!$){if(typeof $=="string")return D($,Y);var ee=Object.prototype.toString.call($).slice(8,-1);if(ee==="Object"&&$.constructor&&(ee=$.constructor.name),ee==="Map"||ee==="Set")return Array.from($);if(ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ee))return D($,Y)}}function D($,Y){(Y==null||Y>$.length)&&(Y=$.length);for(var ee=0,z=new Array(Y);ee<Y;ee++)z[ee]=$[ee];return z}function C($,Y){var ee=typeof Symbol<"u"&&$[Symbol.iterator]||$["@@iterator"];if(ee)return(ee=ee.call($)).next.bind(ee);if(Array.isArray($)||(ee=t($))||Y&&$&&typeof $.length=="number"){ee&&($=ee);var z=0;return function(){return z>=$.length?{done:!0}:{done:!1,value:$[z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=T();function P($){oe.defaults=$}var p=/[&<>"']/,b=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(Y){return S[Y]};function h($,Y){if(Y){if(p.test($))return $.replace(b,y)}else if(R.test($))return $.replace(k,y);return $}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function E($){return $.replace(w,function(Y,ee){return ee=ee.toLowerCase(),ee==="colon"?":":ee.charAt(0)==="#"?ee.charAt(1)==="x"?String.fromCharCode(parseInt(ee.substring(2),16)):String.fromCharCode(+ee.substring(1)):""})}var g=/(^|[^\[])\^/g;function m($,Y){$=typeof $=="string"?$:$.source,Y=Y||"";var ee={replace:function(q,H){return H=H.source||H,H=H.replace(g,"$1"),$=$.replace(q,H),ee},getRegex:function(){return new RegExp($,Y)}};return ee}var f=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u($,Y,ee){if($){var z;try{z=decodeURIComponent(E(ee)).replace(f,"").toLowerCase()}catch{return null}if(z.indexOf("javascript:")===0||z.indexOf("vbscript:")===0||z.indexOf("data:")===0)return null}Y&&!c.test(ee)&&(ee=s(Y,ee));try{ee=encodeURI(ee).replace(/%25/g,"%")}catch{return null}return ee}var r={},o=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s($,Y){r[" "+$]||(o.test($)?r[" "+$]=$+"/":r[" "+$]=I($,"/",!0)),$=r[" "+$];var ee=$.indexOf(":")===-1;return Y.substring(0,2)==="//"?ee?Y:$.replace(n,"$1")+Y:Y.charAt(0)==="/"?ee?Y:$.replace(i,"$1")+Y:$+Y}var a={exec:function(){}};function l($){for(var Y=1,ee,z;Y<arguments.length;Y++){ee=arguments[Y];for(z in ee)Object.prototype.hasOwnProperty.call(ee,z)&&($[z]=ee[z])}return $}function d($,Y){var ee=$.replace(/\|/g,function(H,K,le){for(var pe=!1,ke=K;--ke>=0&&le[ke]==="\\";)pe=!pe;return pe?"|":" |"}),z=ee.split(/ \|/),q=0;if(z[0].trim()||z.shift(),z.length>0&&!z[z.length-1].trim()&&z.pop(),z.length>Y)z.splice(Y);else for(;z.length<Y;)z.push("");for(;q<z.length;q++)z[q]=z[q].trim().replace(/\\\|/g,"|");return z}function I($,Y,ee){var z=$.length;if(z===0)return"";for(var q=0;q<z;){var H=$.charAt(z-q-1);if(H===Y&&!ee)q++;else if(H!==Y&&ee)q++;else break}return $.slice(0,z-q)}function L($,Y){if($.indexOf(Y[1])===-1)return-1;for(var ee=$.length,z=0,q=0;q<ee;q++)if($[q]==="\\")q++;else if($[q]===Y[0])z++;else if($[q]===Y[1]&&(z--,z<0))return q;return-1}function B($){$&&$.sanitize&&!$.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function J($,Y){if(Y<1)return"";for(var ee="";Y>1;)Y&1&&(ee+=$),Y>>=1,$+=$;return ee+$}function Z($,Y,ee,z){var q=Y.href,H=Y.title?h(Y.title):null,K=$[1].replace(/\\([\[\]])/g,"$1");if($[0].charAt(0)!=="!"){z.state.inLink=!0;var le={type:"link",raw:ee,href:q,title:H,text:K,tokens:z.inlineTokens(K)};return z.state.inLink=!1,le}return{type:"image",raw:ee,href:q,title:H,text:h(K)}}function _($,Y){var ee=$.match(/^(\s+)(?:```)/);if(ee===null)return Y;var z=ee[1];return Y.split(`
`).map(function(q){var H=q.match(/^\s+/);if(H===null)return q;var K=H[0];return K.length>=z.length?q.slice(z.length):q}).join(`
`)}var te=function(){function $(ee){this.options=ee||oe.defaults}var Y=$.prototype;return Y.space=function(z){var q=this.rules.block.newline.exec(z);if(q&&q[0].length>0)return{type:"space",raw:q[0]}},Y.code=function(z){var q=this.rules.block.code.exec(z);if(q){var H=q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:q[0],codeBlockStyle:"indented",text:this.options.pedantic?H:I(H,`
`)}}},Y.fences=function(z){var q=this.rules.block.fences.exec(z);if(q){var H=q[0],K=_(H,q[3]||"");return{type:"code",raw:H,lang:q[2]?q[2].trim():q[2],text:K}}},Y.heading=function(z){var q=this.rules.block.heading.exec(z);if(q){var H=q[2].trim();if(/#$/.test(H)){var K=I(H,"#");(this.options.pedantic||!K||/ $/.test(K))&&(H=K.trim())}return{type:"heading",raw:q[0],depth:q[1].length,text:H,tokens:this.lexer.inline(H)}}},Y.hr=function(z){var q=this.rules.block.hr.exec(z);if(q)return{type:"hr",raw:q[0]}},Y.blockquote=function(z){var q=this.rules.block.blockquote.exec(z);if(q){var H=q[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:q[0],tokens:this.lexer.blockTokens(H,[]),text:H}}},Y.list=function(z){var q=this.rules.block.list.exec(z);if(q){var H,K,le,pe,ke,Te,Ne,Le,me,be,ye,Me,Oe=q[1].trim(),Qe=Oe.length>1,je={type:"list",raw:"",ordered:Qe,start:Qe?+Oe.slice(0,-1):"",loose:!1,items:[]};Oe=Qe?"\\d{1,9}\\"+Oe.slice(-1):"\\"+Oe,this.options.pedantic&&(Oe=Qe?Oe:"[*+-]");for(var qe=new RegExp("^( {0,3}"+Oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");z&&(Me=!1,!(!(q=qe.exec(z))||this.rules.block.hr.test(z)));){if(H=q[0],z=z.substring(H.length),Le=q[2].split(`
`,1)[0],me=z.split(`
`,1)[0],this.options.pedantic?(pe=2,ye=Le.trimLeft()):(pe=q[2].search(/[^ ]/),pe=pe>4?1:pe,ye=Le.slice(pe),pe+=q[1].length),Te=!1,!Le&&/^ *$/.test(me)&&(H+=me+`
`,z=z.substring(me.length+1),Me=!0),!Me)for(var Ve=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ye=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),$e=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");z&&(be=z.split(`
`,1)[0],Le=be,this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ye.test(Le)||$e.test(Le)||Ve.test(Le)||xe.test(z)));){if(Le.search(/[^ ]/)>=pe||!Le.trim())ye+=`
`+Le.slice(pe);else if(!Te)ye+=`
`+Le;else break;!Te&&!Le.trim()&&(Te=!0),H+=be+`
`,z=z.substring(be.length+1)}je.loose||(Ne?je.loose=!0:/\n *\n *$/.test(H)&&(Ne=!0)),this.options.gfm&&(K=/^\[[ xX]\] /.exec(ye),K&&(le=K[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:H,task:!!K,checked:le,loose:!1,text:ye}),je.raw+=H}je.items[je.items.length-1].raw=H.trimRight(),je.items[je.items.length-1].text=ye.trimRight(),je.raw=je.raw.trimRight();var Ke=je.items.length;for(ke=0;ke<Ke;ke++){this.lexer.state.top=!1,je.items[ke].tokens=this.lexer.blockTokens(je.items[ke].text,[]);var ce=je.items[ke].tokens.filter(function(De){return De.type==="space"}),Ce=ce.every(function(De){for(var Re=De.raw.split(""),Be=0,We=C(Re),Ge;!(Ge=We()).done;){var rt=Ge.value;if(rt===`
`&&(Be+=1),Be>1)return!0}return!1});!je.loose&&ce.length&&Ce&&(je.loose=!0,je.items[ke].loose=!0)}return je}},Y.html=function(z){var q=this.rules.block.html.exec(z);if(q){var H={type:"html",raw:q[0],pre:!this.options.sanitizer&&(q[1]==="pre"||q[1]==="script"||q[1]==="style"),text:q[0]};if(this.options.sanitize){var K=this.options.sanitizer?this.options.sanitizer(q[0]):h(q[0]);H.type="paragraph",H.text=K,H.tokens=this.lexer.inline(K)}return H}},Y.def=function(z){var q=this.rules.block.def.exec(z);if(q){q[3]&&(q[3]=q[3].substring(1,q[3].length-1));var H=q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:H,raw:q[0],href:q[2],title:q[3]}}},Y.table=function(z){var q=this.rules.block.table.exec(z);if(q){var H={type:"table",header:d(q[1]).map(function(Ne){return{text:Ne}}),align:q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:q[3]&&q[3].trim()?q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=q[0];var K=H.align.length,le,pe,ke,Te;for(le=0;le<K;le++)/^ *-+: *$/.test(H.align[le])?H.align[le]="right":/^ *:-+: *$/.test(H.align[le])?H.align[le]="center":/^ *:-+ *$/.test(H.align[le])?H.align[le]="left":H.align[le]=null;for(K=H.rows.length,le=0;le<K;le++)H.rows[le]=d(H.rows[le],H.header.length).map(function(Ne){return{text:Ne}});for(K=H.header.length,pe=0;pe<K;pe++)H.header[pe].tokens=this.lexer.inline(H.header[pe].text);for(K=H.rows.length,pe=0;pe<K;pe++)for(Te=H.rows[pe],ke=0;ke<Te.length;ke++)Te[ke].tokens=this.lexer.inline(Te[ke].text);return H}}},Y.lheading=function(z){var q=this.rules.block.lheading.exec(z);if(q)return{type:"heading",raw:q[0],depth:q[2].charAt(0)==="="?1:2,text:q[1],tokens:this.lexer.inline(q[1])}},Y.paragraph=function(z){var q=this.rules.block.paragraph.exec(z);if(q){var H=q[1].charAt(q[1].length-1)===`
`?q[1].slice(0,-1):q[1];return{type:"paragraph",raw:q[0],text:H,tokens:this.lexer.inline(H)}}},Y.text=function(z){var q=this.rules.block.text.exec(z);if(q)return{type:"text",raw:q[0],text:q[0],tokens:this.lexer.inline(q[0])}},Y.escape=function(z){var q=this.rules.inline.escape.exec(z);if(q)return{type:"escape",raw:q[0],text:h(q[1])}},Y.tag=function(z){var q=this.rules.inline.tag.exec(z);if(q)return!this.lexer.state.inLink&&/^<a /i.test(q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(q[0]):h(q[0]):q[0]}},Y.link=function(z){var q=this.rules.inline.link.exec(z);if(q){var H=q[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var K=I(H.slice(0,-1),"\\");if((H.length-K.length)%2===0)return}else{var le=L(q[2],"()");if(le>-1){var pe=q[0].indexOf("!")===0?5:4,ke=pe+q[1].length+le;q[2]=q[2].substring(0,le),q[0]=q[0].substring(0,ke).trim(),q[3]=""}}var Te=q[2],Ne="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);Le&&(Te=Le[1],Ne=Le[3])}else Ne=q[3]?q[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(H)?Te=Te.slice(1):Te=Te.slice(1,-1)),Z(q,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},q[0],this.lexer)}},Y.reflink=function(z,q){var H;if((H=this.rules.inline.reflink.exec(z))||(H=this.rules.inline.nolink.exec(z))){var K=(H[2]||H[1]).replace(/\s+/g," ");if(K=q[K.toLowerCase()],!K||!K.href){var le=H[0].charAt(0);return{type:"text",raw:le,text:le}}return Z(H,K,H[0],this.lexer)}},Y.emStrong=function(z,q,H){H===void 0&&(H="");var K=this.rules.inline.emStrong.lDelim.exec(z);if(!!K&&!(K[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=K[1]||K[2]||"";if(!le||le&&(H===""||this.rules.inline.punctuation.exec(H))){var pe=K[0].length-1,ke,Te,Ne=pe,Le=0,me=K[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,q=q.slice(-1*z.length+pe);(K=me.exec(q))!=null;)if(ke=K[1]||K[2]||K[3]||K[4]||K[5]||K[6],!!ke){if(Te=ke.length,K[3]||K[4]){Ne+=Te;continue}else if((K[5]||K[6])&&pe%3&&!((pe+Te)%3)){Le+=Te;continue}if(Ne-=Te,!(Ne>0)){if(Te=Math.min(Te,Te+Ne+Le),Math.min(pe,Te)%2){var be=z.slice(1,pe+K.index+Te);return{type:"em",raw:z.slice(0,pe+K.index+Te+1),text:be,tokens:this.lexer.inlineTokens(be)}}var ye=z.slice(2,pe+K.index+Te-1);return{type:"strong",raw:z.slice(0,pe+K.index+Te+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},Y.codespan=function(z){var q=this.rules.inline.code.exec(z);if(q){var H=q[2].replace(/\n/g," "),K=/[^ ]/.test(H),le=/^ /.test(H)&&/ $/.test(H);return K&&le&&(H=H.substring(1,H.length-1)),H=h(H,!0),{type:"codespan",raw:q[0],text:H}}},Y.br=function(z){var q=this.rules.inline.br.exec(z);if(q)return{type:"br",raw:q[0]}},Y.del=function(z){var q=this.rules.inline.del.exec(z);if(q)return{type:"del",raw:q[0],text:q[2],tokens:this.lexer.inlineTokens(q[2])}},Y.autolink=function(z,q){var H=this.rules.inline.autolink.exec(z);if(H){var K,le;return H[2]==="@"?(K=h(this.options.mangle?q(H[1]):H[1]),le="mailto:"+K):(K=h(H[1]),le=K),{type:"link",raw:H[0],text:K,href:le,tokens:[{type:"text",raw:K,text:K}]}}},Y.url=function(z,q){var H;if(H=this.rules.inline.url.exec(z)){var K,le;if(H[2]==="@")K=h(this.options.mangle?q(H[0]):H[0]),le="mailto:"+K;else{var pe;do pe=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(pe!==H[0]);K=h(H[0]),H[1]==="www."?le="http://"+K:le=K}return{type:"link",raw:H[0],text:K,href:le,tokens:[{type:"text",raw:K,text:K}]}}},Y.inlineText=function(z,q){var H=this.rules.inline.text.exec(z);if(H){var K;return this.lexer.state.inRawBlock?K=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):h(H[0]):H[0]:K=h(this.options.smartypants?q(H[0]):H[0]),{type:"text",raw:H[0],text:K}}},$}(),se={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};se._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,se._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,se.def=m(se.def).replace("label",se._label).replace("title",se._title).getRegex(),se.bullet=/(?:[*+-]|\d{1,9}[.)])/,se.listItemStart=m(/^( *)(bull) */).replace("bull",se.bullet).getRegex(),se.list=m(se.list).replace(/bull/g,se.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+se.def.source+")").getRegex(),se._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",se._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,se.html=m(se.html,"i").replace("comment",se._comment).replace("tag",se._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),se.paragraph=m(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.blockquote=m(se.blockquote).replace("paragraph",se.paragraph).getRegex(),se.normal=l({},se),se.gfm=l({},se.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),se.gfm.table=m(se.gfm.table).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.gfm.paragraph=m(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",se.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.pedantic=l({},se.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",se._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:m(se.normal._paragraph).replace("hr",se.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",se.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=m(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=m(se._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=m(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=m(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=m(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=m(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=m(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=m(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=m(W.reflink).replace("label",W._label).replace("ref",se._label).getRegex(),W.nolink=m(W.nolink).replace("ref",se._label).getRegex(),W.reflinkSearch=m(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=l({},W),W.pedantic=l({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=l({},W.normal,{escape:m(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=m(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=l({},W.gfm,{br:m(W.br).replace("{2,}","*").getRegex(),text:m(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function fe($){return $.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j($){var Y="",ee,z,q=$.length;for(ee=0;ee<q;ee++)z=$.charCodeAt(ee),Math.random()>.5&&(z="x"+z.toString(16)),Y+="&#"+z+";";return Y}var X=function(){function $(ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=ee||oe.defaults,this.options.tokenizer=this.options.tokenizer||new te,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var z={block:se.normal,inline:W.normal};this.options.pedantic?(z.block=se.pedantic,z.inline=W.pedantic):this.options.gfm&&(z.block=se.gfm,this.options.breaks?z.inline=W.breaks:z.inline=W.gfm),this.tokenizer.rules=z}$.lex=function(z,q){var H=new $(q);return H.lex(z)},$.lexInline=function(z,q){var H=new $(q);return H.inlineTokens(z)};var Y=$.prototype;return Y.lex=function(z){z=z.replace(/\r\n|\r/g,`
`),this.blockTokens(z,this.tokens);for(var q;q=this.inlineQueue.shift();)this.inlineTokens(q.src,q.tokens);return this.tokens},Y.blockTokens=function(z,q){var H=this;q===void 0&&(q=[]),this.options.pedantic?z=z.replace(/\t/g,"    ").replace(/^ +$/gm,""):z=z.replace(/^( *)(\t+)/gm,function(Ne,Le,me){return Le+"    ".repeat(me.length)});for(var K,le,pe,ke;z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(K=Ne.call({lexer:H},z,q))?(z=z.substring(K.raw.length),q.push(K),!0):!1}))){if(K=this.tokenizer.space(z)){z=z.substring(K.raw.length),K.raw.length===1&&q.length>0?q[q.length-1].raw+=`
`:q.push(K);continue}if(K=this.tokenizer.code(z)){z=z.substring(K.raw.length),le=q[q.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+K.raw,le.text+=`
`+K.text,this.inlineQueue[this.inlineQueue.length-1].src=le.text):q.push(K);continue}if(K=this.tokenizer.fences(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.heading(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.hr(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.blockquote(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.list(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.html(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.def(z)){z=z.substring(K.raw.length),le=q[q.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+K.raw,le.text+=`
`+K.raw,this.inlineQueue[this.inlineQueue.length-1].src=le.text):this.tokens.links[K.tag]||(this.tokens.links[K.tag]={href:K.href,title:K.title});continue}if(K=this.tokenizer.table(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.lheading(z)){z=z.substring(K.raw.length),q.push(K);continue}if(pe=z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,Le=z.slice(1),me=void 0;H.options.extensions.startBlock.forEach(function(be){me=be.call({lexer:this},Le),typeof me=="number"&&me>=0&&(Ne=Math.min(Ne,me))}),Ne<1/0&&Ne>=0&&(pe=z.substring(0,Ne+1))}(),this.state.top&&(K=this.tokenizer.paragraph(pe))){le=q[q.length-1],ke&&le.type==="paragraph"?(le.raw+=`
`+K.raw,le.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):q.push(K),ke=pe.length!==z.length,z=z.substring(K.raw.length);continue}if(K=this.tokenizer.text(z)){z=z.substring(K.raw.length),le=q[q.length-1],le&&le.type==="text"?(le.raw+=`
`+K.raw,le.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):q.push(K);continue}if(z){var Te="Infinite loop on byte: "+z.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,q},Y.inline=function(z,q){return q===void 0&&(q=[]),this.inlineQueue.push({src:z,tokens:q}),q},Y.inlineTokens=function(z,q){var H=this;q===void 0&&(q=[]);var K,le,pe,ke=z,Te,Ne,Le;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)me.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Te.index)+"["+J("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"["+J("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;z;)if(Ne||(Le=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(K=ye.call({lexer:H},z,q))?(z=z.substring(K.raw.length),q.push(K),!0):!1}))){if(K=this.tokenizer.escape(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.tag(z)){z=z.substring(K.raw.length),le=q[q.length-1],le&&K.type==="text"&&le.type==="text"?(le.raw+=K.raw,le.text+=K.text):q.push(K);continue}if(K=this.tokenizer.link(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.reflink(z,this.tokens.links)){z=z.substring(K.raw.length),le=q[q.length-1],le&&K.type==="text"&&le.type==="text"?(le.raw+=K.raw,le.text+=K.text):q.push(K);continue}if(K=this.tokenizer.emStrong(z,ke,Le)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.codespan(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.br(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.del(z)){z=z.substring(K.raw.length),q.push(K);continue}if(K=this.tokenizer.autolink(z,j)){z=z.substring(K.raw.length),q.push(K);continue}if(!this.state.inLink&&(K=this.tokenizer.url(z,j))){z=z.substring(K.raw.length),q.push(K);continue}if(pe=z,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Me=z.slice(1),Oe=void 0;H.options.extensions.startInline.forEach(function(Qe){Oe=Qe.call({lexer:this},Me),typeof Oe=="number"&&Oe>=0&&(ye=Math.min(ye,Oe))}),ye<1/0&&ye>=0&&(pe=z.substring(0,ye+1))}(),K=this.tokenizer.inlineText(pe,fe)){z=z.substring(K.raw.length),K.raw.slice(-1)!=="_"&&(Le=K.raw.slice(-1)),Ne=!0,le=q[q.length-1],le&&le.type==="text"?(le.raw+=K.raw,le.text+=K.text):q.push(K);continue}if(z){var be="Infinite loop on byte: "+z.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return q},v($,null,[{key:"rules",get:function(){return{block:se,inline:W}}}]),$}(),O=function(){function $(ee){this.options=ee||oe.defaults}var Y=$.prototype;return Y.code=function(z,q,H){var K=(q||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(z,K);le!=null&&le!==z&&(H=!0,z=le)}return z=z.replace(/\n$/,"")+`
`,K?'<pre><code class="'+this.options.langPrefix+h(K,!0)+'">'+(H?z:h(z,!0))+`</code></pre>
`:"<pre><code>"+(H?z:h(z,!0))+`</code></pre>
`},Y.blockquote=function(z){return`<blockquote>
`+z+`</blockquote>
`},Y.html=function(z){return z},Y.heading=function(z,q,H,K){if(this.options.headerIds){var le=this.options.headerPrefix+K.slug(H);return"<h"+q+' id="'+le+'">'+z+"</h"+q+`>
`}return"<h"+q+">"+z+"</h"+q+`>
`},Y.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Y.list=function(z,q,H){var K=q?"ol":"ul",le=q&&H!==1?' start="'+H+'"':"";return"<"+K+le+`>
`+z+"</"+K+`>
`},Y.listitem=function(z){return"<li>"+z+`</li>
`},Y.checkbox=function(z){return"<input "+(z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Y.paragraph=function(z){return"<p>"+z+`</p>
`},Y.table=function(z,q){return q&&(q="<tbody>"+q+"</tbody>"),`<table>
<thead>
`+z+`</thead>
`+q+`</table>
`},Y.tablerow=function(z){return`<tr>
`+z+`</tr>
`},Y.tablecell=function(z,q){var H=q.header?"th":"td",K=q.align?"<"+H+' align="'+q.align+'">':"<"+H+">";return K+z+("</"+H+`>
`)},Y.strong=function(z){return"<strong>"+z+"</strong>"},Y.em=function(z){return"<em>"+z+"</em>"},Y.codespan=function(z){return"<code>"+z+"</code>"},Y.br=function(){return this.options.xhtml?"<br/>":"<br>"},Y.del=function(z){return"<del>"+z+"</del>"},Y.link=function(z,q,H){if(z=u(this.options.sanitize,this.options.baseUrl,z),z===null)return H;var K='<a href="'+h(z)+'"';return q&&(K+=' title="'+q+'"'),K+=">"+H+"</a>",K},Y.image=function(z,q,H){if(z=u(this.options.sanitize,this.options.baseUrl,z),z===null)return H;var K='<img src="'+z+'" alt="'+H+'"';return q&&(K+=' title="'+q+'"'),K+=this.options.xhtml?"/>":">",K},Y.text=function(z){return z},$}(),U=function(){function $(){}var Y=$.prototype;return Y.strong=function(z){return z},Y.em=function(z){return z},Y.codespan=function(z){return z},Y.del=function(z){return z},Y.html=function(z){return z},Y.text=function(z){return z},Y.link=function(z,q,H){return""+H},Y.image=function(z,q,H){return""+H},Y.br=function(){return""},$}(),x=function(){function $(){this.seen={}}var Y=$.prototype;return Y.serialize=function(z){return z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Y.getNextSafeSlug=function(z,q){var H=z,K=0;if(this.seen.hasOwnProperty(H)){K=this.seen[z];do K++,H=z+"-"+K;while(this.seen.hasOwnProperty(H))}return q||(this.seen[z]=K,this.seen[H]=0),H},Y.slug=function(z,q){q===void 0&&(q={});var H=this.serialize(z);return this.getNextSafeSlug(H,q.dryrun)},$}(),ae=function(){function $(ee){this.options=ee||oe.defaults,this.options.renderer=this.options.renderer||new O,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new U,this.slugger=new x}$.parse=function(z,q){var H=new $(q);return H.parse(z)},$.parseInline=function(z,q){var H=new $(q);return H.parseInline(z)};var Y=$.prototype;return Y.parse=function(z,q){q===void 0&&(q=!0);var H="",K,le,pe,ke,Te,Ne,Le,me,be,ye,Me,Oe,Qe,je,qe,Ve,xe,Ye,$e,Ke=z.length;for(K=0;K<Ke;K++){if(ye=z[K],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&($e=this.options.extensions.renderers[ye.type].call({parser:this},ye),$e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){H+=$e||"";continue}switch(ye.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,E(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(me="",Le="",ke=ye.header.length,le=0;le<ke;le++)Le+=this.renderer.tablecell(this.parseInline(ye.header[le].tokens),{header:!0,align:ye.align[le]});for(me+=this.renderer.tablerow(Le),be="",ke=ye.rows.length,le=0;le<ke;le++){for(Ne=ye.rows[le],Le="",Te=Ne.length,pe=0;pe<Te;pe++)Le+=this.renderer.tablecell(this.parseInline(Ne[pe].tokens),{header:!1,align:ye.align[pe]});be+=this.renderer.tablerow(Le)}H+=this.renderer.table(me,be);continue}case"blockquote":{be=this.parse(ye.tokens),H+=this.renderer.blockquote(be);continue}case"list":{for(Me=ye.ordered,Oe=ye.start,Qe=ye.loose,ke=ye.items.length,be="",le=0;le<ke;le++)qe=ye.items[le],Ve=qe.checked,xe=qe.task,je="",qe.task&&(Ye=this.renderer.checkbox(Ve),Qe?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=Ye+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=Ye+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:Ye}):je+=Ye),je+=this.parse(qe.tokens,Qe),be+=this.renderer.listitem(je,xe,Ve);H+=this.renderer.list(be,Me,Oe);continue}case"html":{H+=this.renderer.html(ye.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(be=ye.tokens?this.parseInline(ye.tokens):ye.text;K+1<Ke&&z[K+1].type==="text";)ye=z[++K],be+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);H+=q?this.renderer.paragraph(be):be;continue}default:{var ce='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(ce);return}else throw new Error(ce)}}}return H},Y.parseInline=function(z,q){q=q||this.renderer;var H="",K,le,pe,ke=z.length;for(K=0;K<ke;K++){if(le=z[K],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(pe=this.options.extensions.renderers[le.type].call({parser:this},le),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(le.type))){H+=pe||"";continue}switch(le.type){case"escape":{H+=q.text(le.text);break}case"html":{H+=q.html(le.text);break}case"link":{H+=q.link(le.href,le.title,this.parseInline(le.tokens,q));break}case"image":{H+=q.image(le.href,le.title,le.text);break}case"strong":{H+=q.strong(this.parseInline(le.tokens,q));break}case"em":{H+=q.em(this.parseInline(le.tokens,q));break}case"codespan":{H+=q.codespan(le.text);break}case"br":{H+=q.br();break}case"del":{H+=q.del(this.parseInline(le.tokens,q));break}case"text":{H+=q.text(le.text);break}default:{var Te='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return H},$}();function ue($,Y,ee){if(typeof $>"u"||$===null)throw new Error("marked(): input parameter is undefined or null");if(typeof $!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call($)+", string expected");if(typeof Y=="function"&&(ee=Y,Y=null),Y=l({},ue.defaults,Y||{}),B(Y),ee){var z=Y.highlight,q;try{q=X.lex($,Y)}catch(ke){return ee(ke)}var H=function(Te){var Ne;if(!Te)try{Y.walkTokens&&ue.walkTokens(q,Y.walkTokens),Ne=ae.parse(q,Y)}catch(Le){Te=Le}return Y.highlight=z,Te?ee(Te):ee(null,Ne)};if(!z||z.length<3||(delete Y.highlight,!q.length))return H();var K=0;ue.walkTokens(q,function(ke){ke.type==="code"&&(K++,setTimeout(function(){z(ke.text,ke.lang,function(Te,Ne){if(Te)return H(Te);Ne!=null&&Ne!==ke.text&&(ke.text=Ne,ke.escaped=!0),K--,K===0&&H()})},0))}),K===0&&H();return}function le(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+h(ke.message+"",!0)+"</pre>";throw ke}try{var pe=X.lex($,Y);if(Y.walkTokens){if(Y.async)return Promise.all(ue.walkTokens(pe,Y.walkTokens)).then(function(){return ae.parse(pe,Y)}).catch(le);ue.walkTokens(pe,Y.walkTokens)}return ae.parse(pe,Y)}catch(ke){le(ke)}}ue.options=ue.setOptions=function($){return l(ue.defaults,$),P(ue.defaults),ue},ue.getDefaults=T,ue.defaults=oe.defaults,ue.use=function(){for(var $=arguments.length,Y=new Array($),ee=0;ee<$;ee++)Y[ee]=arguments[ee];var z=l.apply(void 0,[{}].concat(Y)),q=ue.defaults.extensions||{renderers:{},childTokens:{}},H;Y.forEach(function(K){if(K.extensions&&(H=!0,K.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var ke=q.renderers?q.renderers[pe.name]:null;ke?q.renderers[pe.name]=function(){for(var Te=arguments.length,Ne=new Array(Te),Le=0;Le<Te;Le++)Ne[Le]=arguments[Le];var me=pe.renderer.apply(this,Ne);return me===!1&&(me=ke.apply(this,Ne)),me}:q.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");q[pe.level]?q[pe.level].unshift(pe.tokenizer):q[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?q.startBlock?q.startBlock.push(pe.start):q.startBlock=[pe.start]:pe.level==="inline"&&(q.startInline?q.startInline.push(pe.start):q.startInline=[pe.start]))}pe.childTokens&&(q.childTokens[pe.name]=pe.childTokens)})),K.renderer&&function(){var pe=ue.defaults.renderer||new O,ke=function(Le){var me=pe[Le];pe[Le]=function(){for(var be=arguments.length,ye=new Array(be),Me=0;Me<be;Me++)ye[Me]=arguments[Me];var Oe=K.renderer[Le].apply(pe,ye);return Oe===!1&&(Oe=me.apply(pe,ye)),Oe}};for(var Te in K.renderer)ke(Te);z.renderer=pe}(),K.tokenizer&&function(){var pe=ue.defaults.tokenizer||new te,ke=function(Le){var me=pe[Le];pe[Le]=function(){for(var be=arguments.length,ye=new Array(be),Me=0;Me<be;Me++)ye[Me]=arguments[Me];var Oe=K.tokenizer[Le].apply(pe,ye);return Oe===!1&&(Oe=me.apply(pe,ye)),Oe}};for(var Te in K.tokenizer)ke(Te);z.tokenizer=pe}(),K.walkTokens){var le=ue.defaults.walkTokens;z.walkTokens=function(pe){var ke=[];return ke.push(K.walkTokens.call(this,pe)),le&&(ke=ke.concat(le.call(this,pe))),ke}}H&&(z.extensions=q),ue.setOptions(z)})},ue.walkTokens=function($,Y){for(var ee=[],z=function(){var le=H.value;switch(ee=ee.concat(Y.call(ue,le)),le.type){case"table":{for(var pe=C(le.header),ke;!(ke=pe()).done;){var Te=ke.value;ee=ee.concat(ue.walkTokens(Te.tokens,Y))}for(var Ne=C(le.rows),Le;!(Le=Ne()).done;)for(var me=Le.value,be=C(me),ye;!(ye=be()).done;){var Me=ye.value;ee=ee.concat(ue.walkTokens(Me.tokens,Y))}break}case"list":{ee=ee.concat(ue.walkTokens(le.items,Y));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[le.type]?ue.defaults.extensions.childTokens[le.type].forEach(function(Oe){ee=ee.concat(ue.walkTokens(le[Oe],Y))}):le.tokens&&(ee=ee.concat(ue.walkTokens(le.tokens,Y)))}},q=C($),H;!(H=q()).done;)z();return ee},ue.parseInline=function($,Y){if(typeof $>"u"||$===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof $!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call($)+", string expected");Y=l({},ue.defaults,Y||{}),B(Y);try{var ee=X.lexInline($,Y);return Y.walkTokens&&ue.walkTokens(ee,Y.walkTokens),ae.parseInline(ee,Y)}catch(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+h(z.message+"",!0)+"</pre>";throw z}},ue.Parser=ae,ue.parser=ae.parse,ue.Renderer=O,ue.TextRenderer=U,ue.Lexer=X,ue.lexer=X.lex,ue.Tokenizer=te,ue.Slugger=x,ue.parse=ue;var Q=ue.options,re=ue.setOptions,F=ue.use,M=ue.walkTokens,G=ue.parseInline,ie=ue,he=ae.parse,Ee=X.lex;oe.Lexer=X,oe.Parser=ae,oe.Renderer=O,oe.Slugger=x,oe.TextRenderer=U,oe.Tokenizer=te,oe.getDefaults=T,oe.lexer=Ee,oe.marked=ue,oe.options=Q,oe.parse=ie,oe.parseInline=G,oe.parser=he,oe.setOptions=re,oe.use=F,oe.walkTokens=M,Object.defineProperty(oe,"__esModule",{value:!0})}),function(){function oe(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function T(p){C.push(p,Date.now())}function P(){const p=[];for(let b=0;b<C.length;b+=2)p.push({name:C[b],startTime:C[b+1]});return p}return{mark:T,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))C.push({name:T.name,startTime:Math.round(D+T.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=v(t))}(),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var t in v)(typeof exports=="object"?exports:oe)[t]=v[t]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function v(t){if(e[t])return e[t].exports;var D=e[t]={i:t,l:!1,exports:{}};return oe[t].call(D.exports,D,D.exports,v),D.l=!0,D.exports}return v.m=oe,v.c=e,v.d=function(t,D,C){v.o(t,D)||Object.defineProperty(t,D,{enumerable:!0,get:C})},v.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},v.t=function(t,D){if(1&D&&(t=v(t)),8&D||4&D&&typeof t=="object"&&t&&t.__esModule)return t;var C=Object.create(null);if(v.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:t}),2&D&&typeof t!="string")for(var T in t)v.d(C,T,function(P){return t[P]}.bind(null,T));return C},v.n=function(t){var D=t&&t.__esModule?function(){return t.default}:function(){return t};return v.d(D,"a",D),D},v.o=function(t,D){return Object.prototype.hasOwnProperty.call(t,D)},v.p="",v(v.s=0)}([function(oe,e,v){(function(t){var D;e=oe.exports=F,D=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],p=e.src=[],b=0,R=b++;p[R]="0|[1-9]\\d*";var k=b++;p[k]="[0-9]+";var S=b++;p[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=b++;p[y]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var h=b++;p[h]="("+p[k]+")\\.("+p[k]+")\\.("+p[k]+")";var w=b++;p[w]="(?:"+p[R]+"|"+p[S]+")";var E=b++;p[E]="(?:"+p[k]+"|"+p[S]+")";var g=b++;p[g]="(?:-("+p[w]+"(?:\\."+p[w]+")*))";var m=b++;p[m]="(?:-?("+p[E]+"(?:\\."+p[E]+")*))";var f=b++;p[f]="[0-9A-Za-z-]+";var c=b++;p[c]="(?:\\+("+p[f]+"(?:\\."+p[f]+")*))";var u=b++,r="v?"+p[y]+p[g]+"?"+p[c]+"?";p[u]="^"+r+"$";var o="[v=\\s]*"+p[h]+p[m]+"?"+p[c]+"?",n=b++;p[n]="^"+o+"$";var i=b++;p[i]="((?:<|>)?=?)";var s=b++;p[s]=p[k]+"|x|X|\\*";var a=b++;p[a]=p[R]+"|x|X|\\*";var l=b++;p[l]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[g]+")?"+p[c]+"?)?)?";var d=b++;p[d]="[v=\\s]*("+p[s]+")(?:\\.("+p[s]+")(?:\\.("+p[s]+")(?:"+p[m]+")?"+p[c]+"?)?)?";var I=b++;p[I]="^"+p[i]+"\\s*"+p[l]+"$";var L=b++;p[L]="^"+p[i]+"\\s*"+p[d]+"$";var B=b++;p[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var J=b++;p[J]="(?:~>?)";var Z=b++;p[Z]="(\\s*)"+p[J]+"\\s+",P[Z]=new RegExp(p[Z],"g");var _=b++;p[_]="^"+p[J]+p[l]+"$";var te=b++;p[te]="^"+p[J]+p[d]+"$";var se=b++;p[se]="(?:\\^)";var W=b++;p[W]="(\\s*)"+p[se]+"\\s+",P[W]=new RegExp(p[W],"g");var fe=b++;p[fe]="^"+p[se]+p[l]+"$";var j=b++;p[j]="^"+p[se]+p[d]+"$";var X=b++;p[X]="^"+p[i]+"\\s*("+o+")$|^$";var O=b++;p[O]="^"+p[i]+"\\s*("+r+")$|^$";var U=b++;p[U]="(\\s*)"+p[i]+"\\s*("+o+"|"+p[l]+")",P[U]=new RegExp(p[U],"g");var x=b++;p[x]="^\\s*("+p[l]+")\\s+-\\s+("+p[l]+")\\s*$";var ae=b++;p[ae]="^\\s*("+p[d]+")\\s+-\\s+("+p[d]+")\\s*$";var ue=b++;p[ue]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)D(Q,p[Q]),P[Q]||(P[Q]=new RegExp(p[Q]));function re(me,be){if(me instanceof F)return me;if(typeof me!="string"||me.length>C||!(be?P[n]:P[u]).test(me))return null;try{return new F(me,be)}catch{return null}}function F(me,be){if(me instanceof F){if(me.loose===be)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof F))return new F(me,be);D("SemVer",me,be),this.loose=be;var ye=me.trim().match(be?P[n]:P[u]);if(!ye)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Oe=+Me;if(Oe>=0&&Oe<T)return Oe}return Me}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=re,e.valid=function(me,be){var ye=re(me,be);return ye?ye.version:null},e.clean=function(me,be){var ye=re(me.trim().replace(/^[=v]+/,""),be);return ye?ye.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(me){return D("SemVer.compare",this.version,this.loose,me),me instanceof F||(me=new F(me,this.loose)),this.compareMain(me)||this.comparePre(me)},F.prototype.compareMain=function(me){return me instanceof F||(me=new F(me,this.loose)),G(this.major,me.major)||G(this.minor,me.minor)||G(this.patch,me.patch)},F.prototype.comparePre=function(me){if(me instanceof F||(me=new F(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var be=0;do{var ye=this.prerelease[be],Me=me.prerelease[be];if(D("prerelease compare",be,ye,Me),ye===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ye===void 0)return-1;if(ye!==Me)return G(ye,Me)}while(++be)},F.prototype.inc=function(me,be){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,be,ye,Me){typeof ye=="string"&&(Me=ye,ye=void 0);try{return new F(me,ye).inc(be,Me).version}catch{return null}},e.diff=function(me,be){if($(me,be))return null;var ye=re(me),Me=re(be);if(ye.prerelease.length||Me.prerelease.length){for(var Oe in ye)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ye[Oe]!==Me[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in ye)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ye[Oe]!==Me[Oe])return Oe},e.compareIdentifiers=G;var M=/^[0-9]+$/;function G(me,be){var ye=M.test(me),Me=M.test(be);return ye&&Me&&(me=+me,be=+be),ye&&!Me?-1:Me&&!ye?1:me<be?-1:me>be?1:0}function ie(me,be,ye){return new F(me,ye).compare(new F(be,ye))}function he(me,be,ye){return ie(me,be,ye)>0}function Ee(me,be,ye){return ie(me,be,ye)<0}function $(me,be,ye){return ie(me,be,ye)===0}function Y(me,be,ye){return ie(me,be,ye)!==0}function ee(me,be,ye){return ie(me,be,ye)>=0}function z(me,be,ye){return ie(me,be,ye)<=0}function q(me,be,ye,Me){var Oe;switch(be){case"===":typeof me=="object"&&(me=me.version),typeof ye=="object"&&(ye=ye.version),Oe=me===ye;break;case"!==":typeof me=="object"&&(me=me.version),typeof ye=="object"&&(ye=ye.version),Oe=me!==ye;break;case"":case"=":case"==":Oe=$(me,ye,Me);break;case"!=":Oe=Y(me,ye,Me);break;case">":Oe=he(me,ye,Me);break;case">=":Oe=ee(me,ye,Me);break;case"<":Oe=Ee(me,ye,Me);break;case"<=":Oe=z(me,ye,Me);break;default:throw new TypeError("Invalid operator: "+be)}return Oe}function H(me,be){if(me instanceof H){if(me.loose===be)return me;me=me.value}if(!(this instanceof H))return new H(me,be);D("comparator",me,be),this.loose=be,this.parse(me),this.semver===K?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(me,be){return G(be,me)},e.major=function(me,be){return new F(me,be).major},e.minor=function(me,be){return new F(me,be).minor},e.patch=function(me,be){return new F(me,be).patch},e.compare=ie,e.compareLoose=function(me,be){return ie(me,be,!0)},e.rcompare=function(me,be,ye){return ie(be,me,ye)},e.sort=function(me,be){return me.sort(function(ye,Me){return e.compare(ye,Me,be)})},e.rsort=function(me,be){return me.sort(function(ye,Me){return e.rcompare(ye,Me,be)})},e.gt=he,e.lt=Ee,e.eq=$,e.neq=Y,e.gte=ee,e.lte=z,e.cmp=q,e.Comparator=H;var K={};function le(me,be){if(me instanceof le)return me.loose===be?me:new le(me.raw,be);if(me instanceof H)return new le(me.value,be);if(!(this instanceof le))return new le(me,be);if(this.loose=be,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function pe(me){return!me||me.toLowerCase()==="x"||me==="*"}function ke(me,be,ye,Me,Oe,Qe,je,qe,Ve,xe,Ye,$e,Ke){return((be=pe(ye)?"":pe(Me)?">="+ye+".0.0":pe(Oe)?">="+ye+"."+Me+".0":">="+be)+" "+(qe=pe(Ve)?"":pe(xe)?"<"+(+Ve+1)+".0.0":pe(Ye)?"<"+Ve+"."+(+xe+1)+".0":$e?"<="+Ve+"."+xe+"."+Ye+"-"+$e:"<="+qe)).trim()}function Te(me,be){for(var ye=0;ye<me.length;ye++)if(!me[ye].test(be))return!1;if(be.prerelease.length){for(ye=0;ye<me.length;ye++)if(D(me[ye].semver),me[ye].semver!==K&&me[ye].semver.prerelease.length>0){var Me=me[ye].semver;if(Me.major===be.major&&Me.minor===be.minor&&Me.patch===be.patch)return!0}return!1}return!0}function Ne(me,be,ye){try{be=new le(be,ye)}catch{return!1}return be.test(me)}function Le(me,be,ye,Me){var Oe,Qe,je,qe,Ve;switch(me=new F(me,Me),be=new le(be,Me),ye){case">":Oe=he,Qe=z,je=Ee,qe=">",Ve=">=";break;case"<":Oe=Ee,Qe=ee,je=he,qe="<",Ve="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(me,be,Me))return!1;for(var xe=0;xe<be.set.length;++xe){var Ye=be.set[xe],$e=null,Ke=null;if(Ye.forEach(function(ce){ce.semver===K&&(ce=new H(">=0.0.0")),$e=$e||ce,Ke=Ke||ce,Oe(ce.semver,$e.semver,Me)?$e=ce:je(ce.semver,Ke.semver,Me)&&(Ke=ce)}),$e.operator===qe||$e.operator===Ve||(!Ke.operator||Ke.operator===qe)&&Qe(me,Ke.semver)||Ke.operator===Ve&&je(me,Ke.semver))return!1}return!0}H.prototype.parse=function(me){var be=this.loose?P[X]:P[O],ye=me.match(be);if(!ye)throw new TypeError("Invalid comparator: "+me);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new F(ye[2],this.loose):this.semver=K},H.prototype.toString=function(){return this.value},H.prototype.test=function(me){return D("Comparator.test",me,this.loose),this.semver===K||(typeof me=="string"&&(me=new F(me,this.loose)),q(me,this.operator,this.semver,this.loose))},H.prototype.intersects=function(me,be){if(!(me instanceof H))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new le(me.value,be),Ne(this.value,ye,be);if(me.operator==="")return ye=new le(this.value,be),Ne(me.semver,ye,be);var Me=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),Qe=this.semver.version===me.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),qe=q(this.semver,"<",me.semver,be)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Ve=q(this.semver,">",me.semver,be)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Me||Oe||Qe&&je||qe||Ve},e.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(me){var be=this.loose;me=me.trim(),D("range",me,be);var ye=be?P[ae]:P[x];me=me.replace(ye,ke),D("hyphen replace",me),me=me.replace(P[U],"$1$2$3"),D("comparator trim",me,P[U]),me=(me=(me=me.replace(P[Z],"$1~")).replace(P[W],"$1^")).split(/\s+/).join(" ");var Me=be?P[X]:P[O],Oe=me.split(" ").map(function(Qe){return function(je,qe){return D("comp",je),je=function(Ve,xe){return Ve.trim().split(/\s+/).map(function(Ye){return function($e,Ke){D("caret",$e,Ke);var ce=Ke?P[j]:P[fe];return $e.replace(ce,function(Ce,De,Re,Be,We){var Ge;return D("caret",$e,Ce,De,Re,Be,We),pe(De)?Ge="":pe(Re)?Ge=">="+De+".0.0 <"+(+De+1)+".0.0":pe(Be)?Ge=De==="0"?">="+De+"."+Re+".0 <"+De+"."+(+Re+1)+".0":">="+De+"."+Re+".0 <"+(+De+1)+".0.0":We?(D("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),Ge=De==="0"?Re==="0"?">="+De+"."+Re+"."+Be+We+" <"+De+"."+Re+"."+(+Be+1):">="+De+"."+Re+"."+Be+We+" <"+De+"."+(+Re+1)+".0":">="+De+"."+Re+"."+Be+We+" <"+(+De+1)+".0.0"):(D("no pr"),Ge=De==="0"?Re==="0"?">="+De+"."+Re+"."+Be+" <"+De+"."+Re+"."+(+Be+1):">="+De+"."+Re+"."+Be+" <"+De+"."+(+Re+1)+".0":">="+De+"."+Re+"."+Be+" <"+(+De+1)+".0.0"),D("caret return",Ge),Ge})}(Ye,xe)}).join(" ")}(je,qe),D("caret",je),je=function(Ve,xe){return Ve.trim().split(/\s+/).map(function(Ye){return function($e,Ke){var ce=Ke?P[te]:P[_];return $e.replace(ce,function(Ce,De,Re,Be,We){var Ge;return D("tilde",$e,Ce,De,Re,Be,We),pe(De)?Ge="":pe(Re)?Ge=">="+De+".0.0 <"+(+De+1)+".0.0":pe(Be)?Ge=">="+De+"."+Re+".0 <"+De+"."+(+Re+1)+".0":We?(D("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),Ge=">="+De+"."+Re+"."+Be+We+" <"+De+"."+(+Re+1)+".0"):Ge=">="+De+"."+Re+"."+Be+" <"+De+"."+(+Re+1)+".0",D("tilde return",Ge),Ge})}(Ye,xe)}).join(" ")}(je,qe),D("tildes",je),je=function(Ve,xe){return D("replaceXRanges",Ve,xe),Ve.split(/\s+/).map(function(Ye){return function($e,Ke){$e=$e.trim();var ce=Ke?P[L]:P[I];return $e.replace(ce,function(Ce,De,Re,Be,We,Ge){D("xRange",$e,Ce,De,Re,Be,We,Ge);var rt=pe(Re),it=rt||pe(Be),et=it||pe(We);return De==="="&&et&&(De=""),rt?Ce=De===">"||De==="<"?"<0.0.0":"*":De&&et?(it&&(Be=0),et&&(We=0),De===">"?(De=">=",it?(Re=+Re+1,Be=0,We=0):et&&(Be=+Be+1,We=0)):De==="<="&&(De="<",it?Re=+Re+1:Be=+Be+1),Ce=De+Re+"."+Be+"."+We):it?Ce=">="+Re+".0.0 <"+(+Re+1)+".0.0":et&&(Ce=">="+Re+"."+Be+".0 <"+Re+"."+(+Be+1)+".0"),D("xRange return",Ce),Ce})}(Ye,xe)}).join(" ")}(je,qe),D("xrange",je),je=function(Ve,xe){return D("replaceStars",Ve,xe),Ve.trim().replace(P[ue],"")}(je,qe),D("stars",je),je}(Qe,be)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Qe){return!!Qe.match(Me)})),Oe=Oe.map(function(Qe){return new H(Qe,be)})},le.prototype.intersects=function(me,be){if(!(me instanceof le))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Me){return me.set.some(function(Oe){return Oe.every(function(Qe){return Me.intersects(Qe,be)})})})})},e.toComparators=function(me,be){return new le(me,be).set.map(function(ye){return ye.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},le.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new F(me,this.loose));for(var be=0;be<this.set.length;be++)if(Te(this.set[be],me))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(me,be,ye){var Me=null,Oe=null;try{var Qe=new le(be,ye)}catch{return null}return me.forEach(function(je){Qe.test(je)&&(Me&&Oe.compare(je)!==-1||(Oe=new F(Me=je,ye)))}),Me},e.minSatisfying=function(me,be,ye){var Me=null,Oe=null;try{var Qe=new le(be,ye)}catch{return null}return me.forEach(function(je){Qe.test(je)&&(Me&&Oe.compare(je)!==1||(Oe=new F(Me=je,ye)))}),Me},e.validRange=function(me,be){try{return new le(me,be).range||"*"}catch{return null}},e.ltr=function(me,be,ye){return Le(me,be,"<",ye)},e.gtr=function(me,be,ye){return Le(me,be,">",ye)},e.outside=Le,e.prerelease=function(me,be){var ye=re(me,be);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(me,be,ye){return me=new le(me,ye),be=new le(be,ye),me.intersects(be)},e.coerce=function(me){if(me instanceof F)return me;if(typeof me!="string")return null;var be=me.match(P[B]);return be==null?null:re((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,v(1))},function(oe,e){var v,t,D=oe.exports={};function C(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function P(E){if(v===setTimeout)return setTimeout(E,0);if((v===C||!v)&&setTimeout)return v=setTimeout,setTimeout(E,0);try{return v(E,0)}catch{try{return v.call(null,E,0)}catch{return v.call(this,E,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:C}catch{v=C}try{t=typeof clearTimeout=="function"?clearTimeout:T}catch{t=T}})();var p,b=[],R=!1,k=-1;function S(){R&&p&&(R=!1,p.length?b=p.concat(b):k=-1,b.length&&y())}function y(){if(!R){var E=P(S);R=!0;for(var g=b.length;g;){for(p=b,b=[];++k<g;)p&&p[k].run();k=-1,g=b.length}p=null,R=!1,function(m){if(t===clearTimeout)return clearTimeout(m);if((t===T||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(m);try{t(m)}catch{try{return t.call(null,m)}catch{return t.call(this,m)}}}(E)}}function h(E,g){this.fun=E,this.array=g}function w(){}D.nextTick=function(E){var g=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)g[m-1]=arguments[m];b.push(new h(E,g)),b.length!==1||R||P(y)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=w,D.addListener=w,D.once=w,D.off=w,D.removeListener=w,D.removeAllListeners=w,D.emit=w,D.prependListener=w,D.prependOnceListener=w,D.listeners=function(E){return[]},D.binding=function(E){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(E){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ve[137],we([1,0]),function(oe,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(P,p,b){this.level=P,this.key=p,this.value=b,this.forward=[]}}const D=void 0;class C{constructor(P,p=2**16){this.comparator=P,this[v]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(p)|0),this._header=new t(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,D,D)}has(P){return Boolean(C._search(this,P,this.comparator))}get(P){return C._search(this,P,this.comparator)?.value}set(P,p){return C._insert(this,P,p,this.comparator)&&(this._size+=1),this}delete(P){const p=C._delete(this,P,this.comparator);return p&&(this._size-=1),p}forEach(P,p){let b=this._header.forward[0];for(;b;)P.call(p,b.value,b.key,this),b=b.forward[0]}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",p=this._header.forward[0];for(;p;)P+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return P}static _search(P,p,b){let R=P._header;for(let k=P._level-1;k>=0;k--)for(;R.forward[k]&&b(R.forward[k].key,p)<0;)R=R.forward[k];if(R=R.forward[0],R&&b(R.key,p)===0)return R}static _insert(P,p,b,R){const k=[];let S=P._header;for(let y=P._level-1;y>=0;y--){for(;S.forward[y]&&R(S.forward[y].key,p)<0;)S=S.forward[y];k[y]=S}if(S=S.forward[0],S&&R(S.key,p)===0)return S.value=b,!1;{const y=C._randomLevel(P);if(y>P._level){for(let h=P._level;h<y;h++)k[h]=P._header;P._level=y}S=new t(y,p,b);for(let h=0;h<y;h++)S.forward[h]=k[h].forward[h],k[h].forward[h]=S;return!0}}static _randomLevel(P,p=.5){let b=1;for(;Math.random()<p&&b<P._maxLevel;)b+=1;return b}static _delete(P,p,b){const R=[];let k=P._header;for(let S=P._level-1;S>=0;S--){for(;k.forward[S]&&b(k.forward[S].key,p)<0;)k=k.forward[S];R[S]=k}if(k=k.forward[0],!k||b(k.key,p)!==0)return!1;for(let S=0;S<P._level&&R[S].forward[S]===k;S++)R[S].forward[S]=k.forward[S];for(;P._level>0&&P._header.forward[P._level-1]===D;)P._level-=1;return!0}}e.SkipList=C}),define(ve[45],we([1,0,10,2]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(c){const u=c;return u?typeof u.read=="function":!1}e.isReadable=D;function C(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=C;function T(c){const u=c;return u?C(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=T;function P(c,u){return new p(c,u)}e.newWriteableStream=P;class p{constructor(u,r){this.reducer=u,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u<"u"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(r=>r(u))}emitError(u){this.listeners.error.length===0?(0,v.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(r=>r(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,r){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(u,r){if(this.state.destroyed)return;let o;switch(u){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(r);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(c,u){const r=[];let o;for(;(o=c.read())!==null;)r.push(o);return u(r)}e.consumeReadable=b;function R(c,u,r){const o=[];let n;for(;(n=c.read())!==null&&o.length<r;)o.push(n);return n===null&&o.length>0?u(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return c.read()}}}e.peekReadable=R;function k(c,u){return new Promise((r,o)=>{const n=[];S(c,{onData:i=>{u&&n.push(i)},onError:i=>{u?o(i):r(void 0)},onEnd:()=>{r(u?u(n):void 0)}})})}e.consumeStream=k;function S(c,u){let r=!1;return c.on("error",o=>{r||u.onError(o)}),c.on("end",()=>{r||u.onEnd()}),c.on("data",o=>{r||u.onData(o)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=S;function y(c,u){return new Promise((r,o)=>{const n=new t.DisposableStore,i=[],s=d=>{if(i.push(d),i.length>u)return n.dispose(),c.pause(),r({stream:c,buffer:i,ended:!1})},a=d=>o(d),l=()=>r({stream:c,buffer:i,ended:!0});n.add((0,t.toDisposable)(()=>c.removeListener("error",a))),c.on("error",a),n.add((0,t.toDisposable)(()=>c.removeListener("end",l))),c.on("end",l),n.add((0,t.toDisposable)(()=>c.removeListener("data",s))),c.on("data",s)})}e.peekStream=y;function h(c,u){const r=P(u);return r.end(c),r}e.toStream=h;function w(){const c=P(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=w;function E(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}e.toReadable=E;function g(c,u,r){const o=P(r);return S(c,{onData:n=>o.write(u.data(n)),onError:n=>o.error(u.error?u.error(n):n),onEnd:()=>o.end()}),o}e.transform=g;function m(c,u,r){let o=!1;return{read:()=>{const n=u.read();return o?n:(o=!0,n!==null?r([c,n]):c)}}}e.prefixedReadable=m;function f(c,u,r){let o=!1;const n=P(r);return S(u,{onData:i=>o?n.write(i):(o=!0,n.write(r([c,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}e.prefixedStream=f}),define(ve[16],we([1,0,45]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let D,C;class T{static alloc(d){return t?new T(Buffer.allocUnsafe(d)):new T(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new T(d)}static fromString(d,I){return!(I?.dontUseNodeBuffer||!1)&&t?new T(Buffer.from(d)):(D||(D=new TextEncoder),new T(D.encode(d)))}static fromByteArray(d){const I=T.alloc(d.length);for(let L=0,B=d.length;L<B;L++)I.buffer[L]=d[L];return I}static concat(d,I){if(typeof I>"u"){I=0;for(let J=0,Z=d.length;J<Z;J++)I+=d[J].byteLength}const L=T.alloc(I);let B=0;for(let J=0,Z=d.length;J<Z;J++){const _=d[J];L.set(_,B),B+=_.byteLength}return L}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=T.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(d,I){return new T(this.buffer.subarray(d,I))}set(d,I){if(d instanceof T)this.buffer.set(d.buffer,I);else if(d instanceof Uint8Array)this.buffer.set(d,I);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),I);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return b(this.buffer,d)}writeUInt32BE(d,I){R(this.buffer,d,I)}readUInt32LE(d){return k(this.buffer,d)}writeUInt32LE(d,I){S(this.buffer,d,I)}readUInt8(d){return y(this.buffer,d)}writeUInt8(d,I){h(this.buffer,d,I)}}e.VSBuffer=T;function P(l,d){return l[d+0]<<0>>>0|l[d+1]<<8>>>0}e.readUInt16LE=P;function p(l,d,I){l[I+0]=d&255,d=d>>>8,l[I+1]=d&255}e.writeUInt16LE=p;function b(l,d){return l[d]*2**24+l[d+1]*2**16+l[d+2]*2**8+l[d+3]}e.readUInt32BE=b;function R(l,d,I){l[I+3]=d,d=d>>>8,l[I+2]=d,d=d>>>8,l[I+1]=d,d=d>>>8,l[I]=d}e.writeUInt32BE=R;function k(l,d){return l[d+0]<<0>>>0|l[d+1]<<8>>>0|l[d+2]<<16>>>0|l[d+3]<<24>>>0}e.readUInt32LE=k;function S(l,d,I){l[I+0]=d&255,d=d>>>8,l[I+1]=d&255,d=d>>>8,l[I+2]=d&255,d=d>>>8,l[I+3]=d&255}e.writeUInt32LE=S;function y(l,d){return l[d]}e.readUInt8=y;function h(l,d,I){l[I]=d}e.writeUInt8=h;function w(l){return v.consumeReadable(l,d=>T.concat(d))}e.readableToBuffer=w;function E(l){return v.toReadable(l)}e.bufferToReadable=E;function g(l){return v.consumeStream(l,d=>T.concat(d))}e.streamToBuffer=g;async function m(l){return l.ended?T.concat(l.buffer):T.concat([...l.buffer,await g(l.stream)])}e.bufferedStreamToBuffer=m;function f(l){return v.toStream(l,d=>T.concat(d))}e.bufferToStream=f;function c(l){return v.transform(l,{data:d=>typeof d=="string"?T.fromString(d):T.wrap(d)},d=>T.concat(d))}e.streamToBufferReadableStream=c;function u(l){return v.newWriteableStream(d=>T.concat(d),l)}e.newWriteableBufferStream=u;function r(l,d){return v.prefixedReadable(l,d,I=>T.concat(I))}e.prefixedBufferReadable=r;function o(l,d){return v.prefixedStream(l,d,I=>T.concat(I))}e.prefixedBufferStream=o;function n(l){let d=0,I=0,L=0;const B=new Uint8Array(Math.floor(l.length/4*3)),J=_=>{switch(I){case 3:B[L++]=d|_,I=0;break;case 2:B[L++]=d|_>>>2,d=_<<6,I=3;break;case 1:B[L++]=d|_>>>4,d=_<<4,I=2;break;default:d=_<<2,I=1}};for(let _=0;_<l.length;_++){const te=l.charCodeAt(_);if(te>=65&&te<=90)J(te-65);else if(te>=97&&te<=122)J(te-97+26);else if(te>=48&&te<=57)J(te-48+52);else if(te===43||te===45)J(62);else if(te===47||te===95)J(63);else{if(te===61)break;throw new SyntaxError(`Unexpected base64 character ${l[_]}`)}}const Z=L;for(;I>0;)J(0);return T.wrap(B).slice(0,Z)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:l},d=!0,I=!1){const L=I?s:i;let B="";const J=l.byteLength%3;let Z=0;for(;Z<l.byteLength-J;Z+=3){const _=l[Z+0],te=l[Z+1],se=l[Z+2];B+=L[_>>>2],B+=L[(_<<4|te>>>4)&63],B+=L[(te<<2|se>>>6)&63],B+=L[se&63]}if(J===1){const _=l[Z+0];B+=L[_>>>2],B+=L[_<<4&63],d&&(B+="==")}else if(J===2){const _=l[Z+0],te=l[Z+1];B+=L[_>>>2],B+=L[(_<<4|te>>>4)&63],B+=L[te<<2&63],d&&(B+="=")}return B}e.encodeBase64=a}),define(ve[11],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(o){return typeof o=="string"}e.isString=v;function t(o){return Array.isArray(o)&&o.every(n=>v(n))}e.isStringArray=t;function D(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=D;function C(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.isTypedArray=C;function T(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=T;function P(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=P;function p(o){return o===!0||o===!1}e.isBoolean=p;function b(o){return typeof o>"u"}e.isUndefined=b;function R(o){return!k(o)}e.isDefined=R;function k(o){return b(o)||o===null}e.isUndefinedOrNull=k;function S(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=S;function y(o){if(k(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=y;function h(...o){const n=[];for(let i=0;i<o.length;i++){const s=o[i];if(k(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(s)}return n}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function E(o){if(!D(o))return!1;for(const n in o)if(w.call(o,n))return!1;return!0}e.isEmptyObject=E;function g(o){return typeof o=="function"}e.isFunction=g;function m(...o){return o.length>0&&o.every(g)}e.areFunctions=m;function f(o,n){const i=Math.min(o.length,n.length);for(let s=0;s<i;s++)c(o[s],n[s])}e.validateConstraints=f;function c(o,n){if(v(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(g(n)){try{if(o instanceof n)return}catch{}if(!k(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function u(o){return o===null?void 0:o}e.withNullAsUndefined=u;function r(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=r}),define(ve[22],we([1,0,11]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const m=Array.isArray(g)?[]:{};return Object.keys(g).forEach(f=>{g[f]&&typeof g[f]=="object"?m[f]=t(g[f]):m[f]=g[f]}),m}e.deepClone=t;function D(g){if(!g||typeof g!="object")return g;const m=[g];for(;m.length>0;){const f=m.shift();Object.freeze(f);for(const c in f)if(C.call(f,c)){const u=f[c];typeof u=="object"&&!Object.isFrozen(u)&&!(0,v.isTypedArray)(u)&&m.push(u)}}return g}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function T(g,m){return P(g,m,new Set)}e.cloneAndChange=T;function P(g,m,f){if((0,v.isUndefinedOrNull)(g))return g;const c=m(g);if(typeof c<"u")return c;if(Array.isArray(g)){const u=[];for(const r of g)u.push(P(r,m,f));return u}if((0,v.isObject)(g)){if(f.has(g))throw new Error("Cannot clone recursive data-structure");f.add(g);const u={};for(const r in g)C.call(g,r)&&(u[r]=P(g[r],m,f));return f.delete(g),u}return g}function p(g,m,f=!0){return(0,v.isObject)(g)?((0,v.isObject)(m)&&Object.keys(m).forEach(c=>{c in g?f&&((0,v.isObject)(g[c])&&(0,v.isObject)(m[c])?p(g[c],m[c],f):g[c]=m[c]):g[c]=m[c]}),g):m}e.mixin=p;function b(g,m){if(g===m)return!0;if(g==null||m===null||m===void 0||typeof g!=typeof m||typeof g!="object"||Array.isArray(g)!==Array.isArray(m))return!1;let f,c;if(Array.isArray(g)){if(g.length!==m.length)return!1;for(f=0;f<g.length;f++)if(!b(g[f],m[f]))return!1}else{const u=[];for(c in g)u.push(c);u.sort();const r=[];for(c in m)r.push(c);if(r.sort(),!b(u,r))return!1;for(f=0;f<u.length;f++)if(!b(g[u[f]],m[u[f]]))return!1}return!0}e.equals=b;function R(g){const m=new Set;return JSON.stringify(g,(f,c)=>{if((0,v.isObject)(c)||Array.isArray(c)){if(m.has(c))return"[Circular]";m.add(c)}return c})}e.safeStringify=R;function k(g,m){const f=Object.create(null);return!g||!m||Object.keys(m).forEach(u=>{const r=g[u],o=m[u];b(r,o)||(f[u]=o)}),f}e.distinct=k;function S(g,m){const f=m.toLowerCase(),c=Object.keys(g).find(u=>u.toLowerCase()===f);return c?g[c]:g[m]}e.getCaseInsensitive=S;function y(g,m){const f=Object.create(null);for(const[c,u]of Object.entries(g))m(c,u)&&(f[c]=u);return f}e.filter=y;function h(g){let m=[],f=Object.getPrototypeOf(g);for(;Object.prototype!==f;)m=m.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return m}e.getAllPropertyNames=h;function w(g){const m=[];for(const f of h(g))typeof g[f]=="function"&&m.push(f);return m}e.getAllMethodNames=w;function E(g,m){const f=u=>function(){const r=Array.prototype.slice.call(arguments,0);return m(u,r)},c={};for(const u of g)c[u]=f(u);return c}e.createProxyObject=E}),define(ve[23],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return v.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(P){for(let p=0;p<P.length;p++)P[p]=Math.floor(Math.random()*256);return P};const C=new Uint8Array(16),T=[];for(let P=0;P<256;P++)T.push(P.toString(16).padStart(2,"0"));return function(){D(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let p=0,b="";return b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b+="-",b+=T[C[p++]],b+=T[C[p++]],b+="-",b+=T[C[p++]],b+=T[C[p++]],b+="-",b+=T[C[p++]],b+=T[C[p++]],b+="-",b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b+=T[C[p++]],b}}()}),function(){"use strict";function oe(e,v,t){function D(y){return new Promise(h=>v.exists(y,h))}function C(y){return new Promise((h,w)=>{const E=new Date;v.utimes(y,E,E,g=>g?w(g):h())})}function T(y){return new Promise((h,w)=>v.mkdir(y,{recursive:!0},E=>E&&E.code!=="EEXIST"?w(E):h(y)))}function P(y){return new Promise((h,w)=>v.rm(y,{recursive:!0,force:!0,maxRetries:3},E=>E?w(E):h()))}function p(y){return new Promise((h,w)=>v.readFile(y,"utf8",(E,g)=>E?w(E):h(g)))}function b(y,h){return new Promise((w,E)=>v.writeFile(y,h,"utf8",g=>g?E(g):w()))}async function R(y){const h=e.join(y,"languagepacks.json");try{return JSON.parse(await p(h))}catch{}}function k(y,h){try{for(;h;){if(y[h])return h;{const w=h.lastIndexOf("-");if(w>0)h=h.substring(0,w);else return}}}catch(w){console.error("Resolving language pack configuration failed.",w)}}function S(y,h,w,E){if(E==="pseudo")return Promise.resolve({locale:E,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:E,availableLanguages:{}});if(E&&(E==="en"||E==="en-us"))return Promise.resolve({locale:E,availableLanguages:{}});const g=E;t.mark("code/willGenerateNls");const m=function(f){return t.mark("code/didGenerateNls"),Promise.resolve({locale:f,availableLanguages:{}})};try{return y?R(h).then(f=>{if(!f||(E=k(f,E),!E))return m(g);const c=f[E];let u;return!c||typeof c.hash!="string"||!c.translations||typeof(u=c.translations.vscode)!="string"?m(g):D(u).then(r=>{if(!r)return m(g);const o=c.hash+"."+E,n=e.join(h,"clp",o),i=e.join(n,y),s=e.join(n,"tcf.json"),a=e.join(n,"corrupted.info"),l={locale:g,availableLanguages:{"*":E},_languagePackId:o,_translationsConfigFile:s,_cacheRoot:n,_resolvedLanguagePackCoreLocation:i,_corruptedFile:a};return D(a).then(d=>{let I;return d?I=P(n):I=Promise.resolve(void 0),I.then(()=>D(i).then(L=>L?(C(i).catch(()=>{}),t.mark("code/didGenerateNls"),l):T(i).then(()=>Promise.all([p(w),p(u)])).then(B=>{const J=JSON.parse(B[0]),Z=JSON.parse(B[1]).contents,_=Object.keys(J.bundles),te=[];for(const se of _){const W=J.bundles[se],fe=Object.create(null);for(const j of W){const X=J.keys[j],O=J.messages[j],U=Z[j];let x;if(U){x=[];for(let ae=0;ae<X.length;ae++){const ue=X[ae],Q=typeof ue=="string"?ue:ue.key;let re=U[Q];re===void 0&&(re=O[ae]),x.push(re)}}else x=O;fe[j]=x}te.push(b(e.join(i,se.replace(/\//g,"!")+".nls.json"),JSON.stringify(fe)))}return te.push(b(s,JSON.stringify(c.translations))),Promise.all(te)}).then(()=>(t.mark("code/didGenerateNls"),l)).catch(B=>(console.error("Generating translation files failed.",B),m(E)))))})})}):m(g)}catch(f){return console.error("Generating translation files failed.",f),m(E)}}return{getNLSConfiguration:S}}if(typeof define=="function")define(ve[138],we([84,29,46]),function(e,v,t){return oe(e,v,t)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),v=require("fs"),t=require("../common/performance");module.exports=oe(e,v,t)}else throw new Error("Unknown context")}(),define(ve[139],we([1,0,30]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(T){const P=T.replace(/\-/g,":").toLowerCase();return!t.has(P)}function C(){const T=(0,v.networkInterfaces)();for(const P in T){const p=T[P];if(p){for(const{mac:b}of p)if(D(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(ve[140],we([1,0,85]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(P,p,b,R=1){let k=!1;return new Promise(S=>{const y=setTimeout(()=>{if(!k)return k=!0,S(0)},b);D(P,p,R,h=>{if(!k)return k=!0,clearTimeout(y),S(h)})})}e.findFreePort=t;function D(P,p,b,R){if(p===0)return R(0);const k=new v.Socket;k.once("connect",()=>(T(k),D(P+b,p-1,b,R))),k.once("data",()=>{}),k.once("error",S=>(T(k),S.code!=="ECONNREFUSED"?D(P+b,p-1,b,R):R(P))),k.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(P,p,b){let R=!1,k,S=1;const y=v.createServer({pauseOnConnect:!0});function h(w,E){R||(R=!0,y.removeAllListeners(),y.close(),k&&clearTimeout(k),E(w))}return new Promise(w=>{k=setTimeout(()=>{h(0,w)},b),y.on("listening",()=>{h(P,w)}),y.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&S<p?(P++,S++,y.listen(P,"127.0.0.1")):h(0,w)}),y.on("close",()=>{h(0,w)}),y.listen(P,"127.0.0.1")})}e.findFreePortFaster=C;function T(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(p){console.error(p)}}}),define(ve[86],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(D,C){this.lineNumber=D,this.column=C}with(D=this.lineNumber,C=this.column){return D===this.lineNumber&&C===this.column?this:new v(D,C)}delta(D=0,C=0){return this.with(this.lineNumber+D,this.column+C)}equals(D){return v.equals(this,D)}static equals(D,C){return!D&&!C?!0:!!D&&!!C&&D.lineNumber===C.lineNumber&&D.column===C.column}isBefore(D){return v.isBefore(this,D)}static isBefore(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<C.column}isBeforeOrEqual(D){return v.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<=C.column}static compare(D,C){const T=D.lineNumber|0,P=C.lineNumber|0;if(T===P){const p=D.column|0,b=C.column|0;return p-b}return T-P}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new v(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=v}),define(ve[47],we([1,0,86]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(C,T,P,p){C>P||C===P&&T>p?(this.startLineNumber=P,this.startColumn=p,this.endLineNumber=C,this.endColumn=T):(this.startLineNumber=C,this.startColumn=T,this.endLineNumber=P,this.endColumn=p)}isEmpty(){return t.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return t.containsPosition(this,C)}static containsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<C.startColumn||T.lineNumber===C.endLineNumber&&T.column>C.endColumn)}static strictContainsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<=C.startColumn||T.lineNumber===C.endLineNumber&&T.column>=C.endColumn)}containsRange(C){return t.containsRange(this,C)}static containsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>C.endColumn)}strictContainsRange(C){return t.strictContainsRange(this,C)}static strictContainsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<=C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>=C.endColumn)}plusRange(C){return t.plusRange(this,C)}static plusRange(C,T){let P,p,b,R;return T.startLineNumber<C.startLineNumber?(P=T.startLineNumber,p=T.startColumn):T.startLineNumber===C.startLineNumber?(P=T.startLineNumber,p=Math.min(T.startColumn,C.startColumn)):(P=C.startLineNumber,p=C.startColumn),T.endLineNumber>C.endLineNumber?(b=T.endLineNumber,R=T.endColumn):T.endLineNumber===C.endLineNumber?(b=T.endLineNumber,R=Math.max(T.endColumn,C.endColumn)):(b=C.endLineNumber,R=C.endColumn),new t(P,p,b,R)}intersectRanges(C){return t.intersectRanges(this,C)}static intersectRanges(C,T){let P=C.startLineNumber,p=C.startColumn,b=C.endLineNumber,R=C.endColumn;const k=T.startLineNumber,S=T.startColumn,y=T.endLineNumber,h=T.endColumn;return P<k?(P=k,p=S):P===k&&(p=Math.max(p,S)),b>y?(b=y,R=h):b===y&&(R=Math.min(R,h)),P>b||P===b&&p>R?null:new t(P,p,b,R)}equalsRange(C){return t.equalsRange(this,C)}static equalsRange(C,T){return!!C&&!!T&&C.startLineNumber===T.startLineNumber&&C.startColumn===T.startColumn&&C.endLineNumber===T.endLineNumber&&C.endColumn===T.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(C){return new v.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(C){return new v.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,T){return new t(this.startLineNumber,this.startColumn,C,T)}setStartPosition(C,T){return new t(C,T,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(C){return new t(this.startLineNumber+C,this.startColumn,this.endLineNumber+C,this.endColumn)}static collapseToStart(C){return new t(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,T=C){return new t(C.lineNumber,C.column,T.lineNumber,T.column)}static lift(C){return C?new t(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn)}static areIntersecting(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,T){if(C&&T){const b=C.startLineNumber|0,R=T.startLineNumber|0;if(b===R){const k=C.startColumn|0,S=T.startColumn|0;if(k===S){const y=C.endLineNumber|0,h=T.endLineNumber|0;if(y===h){const w=C.endColumn|0,E=T.endColumn|0;return w-E}return y-h}return k-S}return b-R}return(C?1:0)-(T?1:0)}static compareRangesUsingEnds(C,T){return C.endLineNumber===T.endLineNumber?C.endColumn===T.endColumn?C.startLineNumber===T.startLineNumber?C.startColumn-T.startColumn:C.startLineNumber-T.startLineNumber:C.endColumn-T.endColumn:C.endLineNumber-T.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}toJSON(){return this}}e.Range=t}),define(ve[141],we([8,9]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(ve[142],we([1,0,141]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,C=D*24,T=C*7,P=C*30,p=C*365;function b(k,S,y){typeof k!="number"&&(k=k.getTime());const h=Math.round((new Date().getTime()-k)/1e3);if(h<-30)return(0,v.localize)(0,null,b(new Date().getTime()+h*1e3,!1));if(h<30)return(0,v.localize)(1,null);let w;return h<t?(w=h,S?w===1?y?(0,v.localize)(2,null,w):(0,v.localize)(3,null,w):y?(0,v.localize)(4,null,w):(0,v.localize)(5,null,w):w===1?y?(0,v.localize)(6,null,w):(0,v.localize)(7,null,w):y?(0,v.localize)(8,null,w):(0,v.localize)(9,null,w)):h<D?(w=Math.floor(h/t),S?w===1?y?(0,v.localize)(10,null,w):(0,v.localize)(11,null,w):y?(0,v.localize)(12,null,w):(0,v.localize)(13,null,w):w===1?y?(0,v.localize)(14,null,w):(0,v.localize)(15,null,w):y?(0,v.localize)(16,null,w):(0,v.localize)(17,null,w)):h<C?(w=Math.floor(h/D),S?w===1?y?(0,v.localize)(18,null,w):(0,v.localize)(19,null,w):y?(0,v.localize)(20,null,w):(0,v.localize)(21,null,w):w===1?y?(0,v.localize)(22,null,w):(0,v.localize)(23,null,w):y?(0,v.localize)(24,null,w):(0,v.localize)(25,null,w)):h<T?(w=Math.floor(h/C),S?w===1?(0,v.localize)(26,null,w):(0,v.localize)(27,null,w):w===1?(0,v.localize)(28,null,w):(0,v.localize)(29,null,w)):h<P?(w=Math.floor(h/T),S?w===1?y?(0,v.localize)(30,null,w):(0,v.localize)(31,null,w):y?(0,v.localize)(32,null,w):(0,v.localize)(33,null,w):w===1?y?(0,v.localize)(34,null,w):(0,v.localize)(35,null,w):y?(0,v.localize)(36,null,w):(0,v.localize)(37,null,w)):h<p?(w=Math.floor(h/P),S?w===1?y?(0,v.localize)(38,null,w):(0,v.localize)(39,null,w):y?(0,v.localize)(40,null,w):(0,v.localize)(41,null,w):w===1?y?(0,v.localize)(42,null,w):(0,v.localize)(43,null,w):y?(0,v.localize)(44,null,w):(0,v.localize)(45,null,w)):(w=Math.floor(h/p),S?w===1?y?(0,v.localize)(46,null,w):(0,v.localize)(47,null,w):y?(0,v.localize)(48,null,w):(0,v.localize)(49,null,w):w===1?y?(0,v.localize)(50,null,w):(0,v.localize)(51,null,w):y?(0,v.localize)(52,null,w):(0,v.localize)(53,null,w))}e.fromNow=b;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ve[143],we([8,9]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(ve[38],we([1,0,18,11,143]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(k,S){return S&&(k.stack||k.stacktrace)?D.localize(0,null,P(k),T(k.stack)||T(k.stacktrace)):P(k)}function T(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function p(k=null,S=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const y=v.coalesce(k),h=p(y[0],S);return y.length>1?D.localize(4,null,h,y.length):h}if(t.isString(k))return k;if(k.detail){const y=k.detail;if(y.error)return C(y.error,S);if(y.exception)return C(y.exception,S)}return k.stack?C(k,S):k.message?k.message:D.localize(5,null)}e.toErrorMessage=p;function b(k){const S=k;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=b;function R(k,S){let y;return typeof k=="string"?y=new Error(k):y=k,y.actions=S,y}e.createErrorWithActions=R}),define(ve[144],we([8,9]),function(oe,e){return oe.create("vs/base/common/jsonErrorMessages",e)}),define(ve[145],we([1,0,144]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(D){switch(D){case 1:return(0,v.localize)(0,null);case 2:return(0,v.localize)(1,null);case 3:return(0,v.localize)(2,null);case 4:return(0,v.localize)(3,null);case 5:return(0,v.localize)(4,null);case 6:return(0,v.localize)(5,null);case 7:return(0,v.localize)(6,null);case 8:return(0,v.localize)(7,null);case 9:return(0,v.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ve[146],we([8,9]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(ve[3],we([1,0,146]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,D=!1,C=!1,T=!1,P=!1,p=!1,b=!1,R=!1,k=!1,S=!1,y,h=e.LANGUAGE_DEFAULT,w,E;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?g=e.globals.vscode.process:typeof process<"u"&&(g=process);const m=typeof g?.versions?.electron=="string",f=m&&g?.type==="renderer";if(typeof navigator=="object"&&!f)E=navigator.userAgent,t=E.indexOf("Windows")>=0,D=E.indexOf("Macintosh")>=0,R=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=E.indexOf("Linux")>=0,S=E?.indexOf("Mobi")>=0,p=!0,y=v.getConfiguredDefaultLocale(v.localize(0,null))||e.LANGUAGE_DEFAULT,h=y;else if(typeof g=="object"){t=g.platform==="win32",D=g.platform==="darwin",C=g.platform==="linux",T=C&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,b=m,k=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const l=g.env.VSCODE_NLS_CONFIG;if(l)try{const d=JSON.parse(l),I=d.availableLanguages["*"];y=d.locale,h=I||e.LANGUAGE_DEFAULT,w=d._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var c;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function u(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let r=0;D?r=1:t?r=3:C&&(r=2),e.isWindows=t,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=T,e.isNative=P,e.isElectron=b,e.isWeb=p,e.isWebWorker=p&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isMobile=S,e.isCI=k,e.platform=r,e.userAgent=E,e.language=h;var o;(function(l){function d(){return e.language}l.value=d;function I(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=I;function L(){return e.language==="en"}l.isDefault=L})(o=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let L=0,B=l.length;L<B;L++){const J=l[L];if(J.id===I.data.vscodeScheduleAsyncWork){l.splice(L,1),J.callback();return}}});let d=0;return I=>{const L=++d;l.push({id:L,callback:I}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return l=>setTimeout(l)})();var n;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||R?2:t?1:3;let i=!0,s=!1;function a(){if(!s){s=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,i=new Uint16Array(l.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[28],we([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const D=v.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ve[6],we([1,0,28]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,C=90,T=122,P=46,p=47,b=92,R=58,k=63;class S extends Error{constructor(c,u,r){let o;typeof u=="string"&&u.indexOf("not ")===0?(o="must not be",u=u.replace(/^not /,"")):o="must be";const n=c.indexOf(".")!==-1?"property":"argument";let i=`The "${c}" ${n} ${o} of type ${u}`;i+=`. Received type ${typeof r}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function y(f,c){if(typeof f!="string")throw new S(c,"string",f)}function h(f){return f===p||f===b}function w(f){return f===p}function E(f){return f>=t&&f<=C||f>=D&&f<=T}function g(f,c,u,r){let o="",n=0,i=-1,s=0,a=0;for(let l=0;l<=f.length;++l){if(l<f.length)a=f.charCodeAt(l);else{if(r(a))break;a=p}if(r(a)){if(!(i===l-1||s===1))if(s===2){if(o.length<2||n!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const d=o.lastIndexOf(u);d===-1?(o="",n=0):(o=o.slice(0,d),n=o.length-1-o.lastIndexOf(u)),i=l,s=0;continue}else if(o.length!==0){o="",n=0,i=l,s=0;continue}}c&&(o+=o.length>0?`${u}..`:"..",n=2)}else o.length>0?o+=`${u}${f.slice(i+1,l)}`:o=f.slice(i+1,l),n=l-i-1;i=l,s=0}else a===P&&s!==-1?++s:s=-1}return o}function m(f,c){if(c===null||typeof c!="object")throw new S("pathObject","Object",c);const u=c.dir||c.root,r=c.base||`${c.name||""}${c.ext||""}`;return u?u===c.root?`${u}${r}`:`${u}${f}${r}`:r}e.win32={resolve(...f){let c="",u="",r=!1;for(let o=f.length-1;o>=-1;o--){let n;if(o>=0){if(n=f[o],y(n,"path"),n.length===0)continue}else c.length===0?n=v.cwd():(n=v.env[`=${c}`]||v.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==c.toLowerCase()&&n.charCodeAt(2)===b)&&(n=`${c}\\`));const i=n.length;let s=0,a="",l=!1;const d=n.charCodeAt(0);if(i===1)h(d)&&(s=1,l=!0);else if(h(d))if(l=!0,h(n.charCodeAt(1))){let I=2,L=I;for(;I<i&&!h(n.charCodeAt(I));)I++;if(I<i&&I!==L){const B=n.slice(L,I);for(L=I;I<i&&h(n.charCodeAt(I));)I++;if(I<i&&I!==L){for(L=I;I<i&&!h(n.charCodeAt(I));)I++;(I===i||I!==L)&&(a=`\\\\${B}\\${n.slice(L,I)}`,s=I)}}}else s=1;else E(d)&&n.charCodeAt(1)===R&&(a=n.slice(0,2),s=2,i>2&&h(n.charCodeAt(2))&&(l=!0,s=3));if(a.length>0)if(c.length>0){if(a.toLowerCase()!==c.toLowerCase())continue}else c=a;if(r){if(c.length>0)break}else if(u=`${n.slice(s)}\\${u}`,r=l,l&&c.length>0)break}return u=g(u,!r,"\\",h),r?`${c}\\${u}`:`${c}${u}`||"."},normalize(f){y(f,"path");const c=f.length;if(c===0)return".";let u=0,r,o=!1;const n=f.charCodeAt(0);if(c===1)return w(n)?"\\":f;if(h(n))if(o=!0,h(f.charCodeAt(1))){let s=2,a=s;for(;s<c&&!h(f.charCodeAt(s));)s++;if(s<c&&s!==a){const l=f.slice(a,s);for(a=s;s<c&&h(f.charCodeAt(s));)s++;if(s<c&&s!==a){for(a=s;s<c&&!h(f.charCodeAt(s));)s++;if(s===c)return`\\\\${l}\\${f.slice(a)}\\`;s!==a&&(r=`\\\\${l}\\${f.slice(a,s)}`,u=s)}}}else u=1;else E(n)&&f.charCodeAt(1)===R&&(r=f.slice(0,2),u=2,c>2&&h(f.charCodeAt(2))&&(o=!0,u=3));let i=u<c?g(f.slice(u),!o,"\\",h):"";return i.length===0&&!o&&(i="."),i.length>0&&h(f.charCodeAt(c-1))&&(i+="\\"),r===void 0?o?`\\${i}`:i:o?`${r}\\${i}`:`${r}${i}`},isAbsolute(f){y(f,"path");const c=f.length;if(c===0)return!1;const u=f.charCodeAt(0);return h(u)||c>2&&E(u)&&f.charCodeAt(1)===R&&h(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let c,u;for(let n=0;n<f.length;++n){const i=f[n];y(i,"path"),i.length>0&&(c===void 0?c=u=i:c+=`\\${i}`)}if(c===void 0)return".";let r=!0,o=0;if(typeof u=="string"&&h(u.charCodeAt(0))){++o;const n=u.length;n>1&&h(u.charCodeAt(1))&&(++o,n>2&&(h(u.charCodeAt(2))?++o:r=!1))}if(r){for(;o<c.length&&h(c.charCodeAt(o));)o++;o>=2&&(c=`\\${c.slice(o)}`)}return e.win32.normalize(c)},relative(f,c){if(y(f,"from"),y(c,"to"),f===c)return"";const u=e.win32.resolve(f),r=e.win32.resolve(c);if(u===r||(f=u.toLowerCase(),c=r.toLowerCase(),f===c))return"";let o=0;for(;o<f.length&&f.charCodeAt(o)===b;)o++;let n=f.length;for(;n-1>o&&f.charCodeAt(n-1)===b;)n--;const i=n-o;let s=0;for(;s<c.length&&c.charCodeAt(s)===b;)s++;let a=c.length;for(;a-1>s&&c.charCodeAt(a-1)===b;)a--;const l=a-s,d=i<l?i:l;let I=-1,L=0;for(;L<d;L++){const J=f.charCodeAt(o+L);if(J!==c.charCodeAt(s+L))break;J===b&&(I=L)}if(L!==d){if(I===-1)return r}else{if(l>d){if(c.charCodeAt(s+L)===b)return r.slice(s+L+1);if(L===2)return r.slice(s+L)}i>d&&(f.charCodeAt(o+L)===b?I=L:L===2&&(I=3)),I===-1&&(I=0)}let B="";for(L=o+I+1;L<=n;++L)(L===n||f.charCodeAt(L)===b)&&(B+=B.length===0?"..":"\\..");return s+=I,B.length>0?`${B}${r.slice(s,a)}`:(r.charCodeAt(s)===b&&++s,r.slice(s,a))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const c=e.win32.resolve(f);if(c.length<=2)return f;if(c.charCodeAt(0)===b){if(c.charCodeAt(1)===b){const u=c.charCodeAt(2);if(u!==k&&u!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(E(c.charCodeAt(0))&&c.charCodeAt(1)===R&&c.charCodeAt(2)===b)return`\\\\?\\${c}`;return f},dirname(f){y(f,"path");const c=f.length;if(c===0)return".";let u=-1,r=0;const o=f.charCodeAt(0);if(c===1)return h(o)?f:".";if(h(o)){if(u=r=1,h(f.charCodeAt(1))){let s=2,a=s;for(;s<c&&!h(f.charCodeAt(s));)s++;if(s<c&&s!==a){for(a=s;s<c&&h(f.charCodeAt(s));)s++;if(s<c&&s!==a){for(a=s;s<c&&!h(f.charCodeAt(s));)s++;if(s===c)return f;s!==a&&(u=r=s+1)}}}}else E(o)&&f.charCodeAt(1)===R&&(u=c>2&&h(f.charCodeAt(2))?3:2,r=u);let n=-1,i=!0;for(let s=c-1;s>=r;--s)if(h(f.charCodeAt(s))){if(!i){n=s;break}}else i=!1;if(n===-1){if(u===-1)return".";n=u}return f.slice(0,n)},basename(f,c){c!==void 0&&y(c,"ext"),y(f,"path");let u=0,r=-1,o=!0,n;if(f.length>=2&&E(f.charCodeAt(0))&&f.charCodeAt(1)===R&&(u=2),c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let i=c.length-1,s=-1;for(n=f.length-1;n>=u;--n){const a=f.charCodeAt(n);if(h(a)){if(!o){u=n+1;break}}else s===-1&&(o=!1,s=n+1),i>=0&&(a===c.charCodeAt(i)?--i===-1&&(r=n):(i=-1,r=s))}return u===r?r=s:r===-1&&(r=f.length),f.slice(u,r)}for(n=f.length-1;n>=u;--n)if(h(f.charCodeAt(n))){if(!o){u=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":f.slice(u,r)},extname(f){y(f,"path");let c=0,u=-1,r=0,o=-1,n=!0,i=0;f.length>=2&&f.charCodeAt(1)===R&&E(f.charCodeAt(0))&&(c=r=2);for(let s=f.length-1;s>=c;--s){const a=f.charCodeAt(s);if(h(a)){if(!n){r=s+1;break}continue}o===-1&&(n=!1,o=s+1),a===P?u===-1?u=s:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||o===-1||i===0||i===1&&u===o-1&&u===r+1?"":f.slice(u,o)},format:m.bind(null,"\\"),parse(f){y(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const u=f.length;let r=0,o=f.charCodeAt(0);if(u===1)return h(o)?(c.root=c.dir=f,c):(c.base=c.name=f,c);if(h(o)){if(r=1,h(f.charCodeAt(1))){let I=2,L=I;for(;I<u&&!h(f.charCodeAt(I));)I++;if(I<u&&I!==L){for(L=I;I<u&&h(f.charCodeAt(I));)I++;if(I<u&&I!==L){for(L=I;I<u&&!h(f.charCodeAt(I));)I++;I===u?r=I:I!==L&&(r=I+1)}}}}else if(E(o)&&f.charCodeAt(1)===R){if(u<=2)return c.root=c.dir=f,c;if(r=2,h(f.charCodeAt(2))){if(u===3)return c.root=c.dir=f,c;r=3}}r>0&&(c.root=f.slice(0,r));let n=-1,i=r,s=-1,a=!0,l=f.length-1,d=0;for(;l>=r;--l){if(o=f.charCodeAt(l),h(o)){if(!a){i=l+1;break}continue}s===-1&&(a=!1,s=l+1),o===P?n===-1?n=l:d!==1&&(d=1):n!==-1&&(d=-1)}return s!==-1&&(n===-1||d===0||d===1&&n===s-1&&n===i+1?c.base=c.name=f.slice(i,s):(c.name=f.slice(i,n),c.base=f.slice(i,s),c.ext=f.slice(n,s))),i>0&&i!==r?c.dir=f.slice(0,i-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let c="",u=!1;for(let r=f.length-1;r>=-1&&!u;r--){const o=r>=0?f[r]:v.cwd();y(o,"path"),o.length!==0&&(c=`${o}/${c}`,u=o.charCodeAt(0)===p)}return c=g(c,!u,"/",w),u?`/${c}`:c.length>0?c:"."},normalize(f){if(y(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===p,u=f.charCodeAt(f.length-1)===p;return f=g(f,!c,"/",w),f.length===0?c?"/":u?"./":".":(u&&(f+="/"),c?`/${f}`:f)},isAbsolute(f){return y(f,"path"),f.length>0&&f.charCodeAt(0)===p},join(...f){if(f.length===0)return".";let c;for(let u=0;u<f.length;++u){const r=f[u];y(r,"path"),r.length>0&&(c===void 0?c=r:c+=`/${r}`)}return c===void 0?".":e.posix.normalize(c)},relative(f,c){if(y(f,"from"),y(c,"to"),f===c||(f=e.posix.resolve(f),c=e.posix.resolve(c),f===c))return"";const u=1,r=f.length,o=r-u,n=1,i=c.length-n,s=o<i?o:i;let a=-1,l=0;for(;l<s;l++){const I=f.charCodeAt(u+l);if(I!==c.charCodeAt(n+l))break;I===p&&(a=l)}if(l===s)if(i>s){if(c.charCodeAt(n+l)===p)return c.slice(n+l+1);if(l===0)return c.slice(n+l)}else o>s&&(f.charCodeAt(u+l)===p?a=l:l===0&&(a=0));let d="";for(l=u+a+1;l<=r;++l)(l===r||f.charCodeAt(l)===p)&&(d+=d.length===0?"..":"/..");return`${d}${c.slice(n+a)}`},toNamespacedPath(f){return f},dirname(f){if(y(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===p;let u=-1,r=!0;for(let o=f.length-1;o>=1;--o)if(f.charCodeAt(o)===p){if(!r){u=o;break}}else r=!1;return u===-1?c?"/":".":c&&u===1?"//":f.slice(0,u)},basename(f,c){c!==void 0&&y(c,"ext"),y(f,"path");let u=0,r=-1,o=!0,n;if(c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let i=c.length-1,s=-1;for(n=f.length-1;n>=0;--n){const a=f.charCodeAt(n);if(a===p){if(!o){u=n+1;break}}else s===-1&&(o=!1,s=n+1),i>=0&&(a===c.charCodeAt(i)?--i===-1&&(r=n):(i=-1,r=s))}return u===r?r=s:r===-1&&(r=f.length),f.slice(u,r)}for(n=f.length-1;n>=0;--n)if(f.charCodeAt(n)===p){if(!o){u=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":f.slice(u,r)},extname(f){y(f,"path");let c=-1,u=0,r=-1,o=!0,n=0;for(let i=f.length-1;i>=0;--i){const s=f.charCodeAt(i);if(s===p){if(!o){u=i+1;break}continue}r===-1&&(o=!1,r=i+1),s===P?c===-1?c=i:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||r===-1||n===0||n===1&&c===r-1&&c===u+1?"":f.slice(c,r)},format:m.bind(null,"/"),parse(f){y(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const u=f.charCodeAt(0)===p;let r;u?(c.root="/",r=1):r=0;let o=-1,n=0,i=-1,s=!0,a=f.length-1,l=0;for(;a>=r;--a){const d=f.charCodeAt(a);if(d===p){if(!s){n=a+1;break}continue}i===-1&&(s=!1,i=a+1),d===P?o===-1?o=a:l!==1&&(l=1):o!==-1&&(l=-1)}if(i!==-1){const d=n===0&&u?1:n;o===-1||l===0||l===1&&o===i-1&&o===n+1?c.base=c.name=f.slice(d,i):(c.name=f.slice(d,o),c.base=f.slice(d,i),c.ext=f.slice(o,i))}return n>0?c.dir=f.slice(0,n-1):u&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[66],we([1,0,6]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(R){const k=(0,v.extname)(R),S=t[k.toLowerCase()];return S!==void 0?S:T(R)}e.getMediaOrTextMime=C;function T(R){const k=(0,v.extname)(R);return D[k.toLowerCase()]}e.getMediaMime=T;function P(R){for(const k in D)if(D[k]===R)return k}e.getExtensionForMimeType=P;const p=/^(.+)\/(.+?)(;.+)?$/;function b(R,k){const S=p.exec(R);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:k?void 0:R}e.normalizeMimeType=b}),define(ve[56],we([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(P,...p){const b=p.reduce((S,y)=>(S[y]=!0,S),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(S=>!b[S]).forEach(S=>{for(let y=0;y<R.length;y++)if(S.search(R[y])!==-1){delete P[S];break}})}e.sanitizeProcessEnvironment=C;function T(P){!P||(delete P.DEBUG,v.isMacintosh&&delete P.DYLD_LIBRARY_PATH,v.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ve[147],we([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=v.globals.performance&&typeof v.globals.performance.now=="function";class D{static create(T=!0){return new D(T)}constructor(T){this._highResolution=t&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ve[7],we([1,0,10,64,2,135,147]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,p=!1;var b;(function(a){a.None=()=>D.Disposable.None;function l(M){if(p){const{onListenerDidAdd:G}=M,ie=h.create();let he=0;M.onListenerDidAdd=()=>{++he===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),G?.()}}}function d(M){return(G,ie=null,he)=>{let Ee=!1,$;return $=M(Y=>{if(!Ee)return $?$.dispose():Ee=!0,G.call(ie,Y)},null,he),Ee&&$.dispose(),$}}a.once=d;function I(M,G,ie){return te((he,Ee=null,$)=>M(Y=>he.call(Ee,G(Y)),null,$),ie)}a.map=I;function L(M,G,ie){return te((he,Ee=null,$)=>M(Y=>{G(Y),he.call(Ee,Y)},null,$),ie)}a.forEach=L;function B(M,G,ie){return te((he,Ee=null,$)=>M(Y=>G(Y)&&he.call(Ee,Y),null,$),ie)}a.filter=B;function J(M){return M}a.signal=J;function Z(...M){return(G,ie=null,he)=>(0,D.combinedDisposable)(...M.map(Ee=>Ee($=>G.call(ie,$),null,he)))}a.any=Z;function _(M,G,ie,he){let Ee=ie;return I(M,$=>(Ee=G(Ee,$),Ee),he)}a.reduce=_;function te(M,G){let ie;const he={onFirstListenerAdd(){ie=M(Ee.fire,Ee)},onLastListenerRemove(){ie?.dispose()}};G||l(he);const Ee=new E(he);return G?.add(Ee),Ee.event}function se(M,G,ie=100,he=!1,Ee,$){let Y,ee,z,q=0;const H={leakWarningThreshold:Ee,onFirstListenerAdd(){Y=M(le=>{q++,ee=G(ee,le),he&&!z&&(K.fire(ee),ee=void 0),clearTimeout(z),z=setTimeout(()=>{const pe=ee;ee=void 0,z=void 0,(!he||q>1)&&K.fire(pe),q=0},ie)})},onLastListenerRemove(){Y.dispose()}};$||l(H);const K=new E(H);return $?.add(K),K.event}a.debounce=se;function W(M,G=(he,Ee)=>he===Ee,ie){let he=!0,Ee;return B(M,$=>{const Y=he||!G($,Ee);return he=!1,Ee=$,Y},ie)}a.latch=W;function fe(M,G,ie){return[a.filter(M,G,ie),a.filter(M,he=>!G(he),ie)]}a.split=fe;function j(M,G=!1,ie=[]){let he=ie.slice(),Ee=M(ee=>{he?he.push(ee):Y.fire(ee)});const $=()=>{he?.forEach(ee=>Y.fire(ee)),he=null},Y=new E({onFirstListenerAdd(){Ee||(Ee=M(ee=>Y.fire(ee)))},onFirstListenerDidAdd(){he&&(G?setTimeout($):$())},onLastListenerRemove(){Ee&&Ee.dispose(),Ee=null}});return Y.event}a.buffer=j;class X{constructor(G){this.event=G,this.disposables=new D.DisposableStore}map(G){return new X(I(this.event,G,this.disposables))}forEach(G){return new X(L(this.event,G,this.disposables))}filter(G){return new X(B(this.event,G,this.disposables))}reduce(G,ie){return new X(_(this.event,G,ie,this.disposables))}latch(){return new X(W(this.event,void 0,this.disposables))}debounce(G,ie=100,he=!1,Ee){return new X(se(this.event,G,ie,he,Ee,this.disposables))}on(G,ie,he){return this.event(G,ie,he)}once(G,ie,he){return d(this.event)(G,ie,he)}dispose(){this.disposables.dispose()}}function O(M){return new X(M)}a.chain=O;function U(M,G,ie=he=>he){const he=(...ee)=>Y.fire(ie(...ee)),Ee=()=>M.on(G,he),$=()=>M.removeListener(G,he),Y=new E({onFirstListenerAdd:Ee,onLastListenerRemove:$});return Y.event}a.fromNodeEventEmitter=U;function x(M,G,ie=he=>he){const he=(...ee)=>Y.fire(ie(...ee)),Ee=()=>M.addEventListener(G,he),$=()=>M.removeEventListener(G,he),Y=new E({onFirstListenerAdd:Ee,onLastListenerRemove:$});return Y.event}a.fromDOMEventEmitter=x;function ae(M){return new Promise(G=>d(M)(G))}a.toPromise=ae;function ue(M,G){return G(void 0),M(ie=>G(ie))}a.runAndSubscribe=ue;function Q(M,G){let ie=null;function he($){ie?.dispose(),ie=new D.DisposableStore,G($,ie)}he(void 0);const Ee=M($=>he($));return(0,D.toDisposable)(()=>{Ee.dispose(),ie?.dispose()})}a.runAndSubscribeWithStore=Q;class re{constructor(G,ie){this.obs=G,this._counter=0,this._hasChanged=!1;const he={onFirstListenerAdd:()=>{G.addObserver(this)},onLastListenerRemove:()=>{G.removeObserver(this)}};ie||l(he),this.emitter=new E(he),ie&&ie.add(this.emitter)}beginUpdate(G){this._counter++}handleChange(G,ie){this._hasChanged=!0}endUpdate(G){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function F(M,G){return new re(M,G).emitter.event}a.fromObservable=F})(b=e.Event||(e.Event={}));class R{constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${R._idPool++}`,R.all.add(this)}start(l){this._stopWatch=new T.StopWatch(!0),this.listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=R,R.all=new Set,R._idPool=0;let k=-1;function S(a){const l=k;return k=a,{dispose(){k=l}}}e.setGlobalLeakWarningThreshold=S;class y{constructor(l,d=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,d){let I=k;if(typeof this.customThreshold=="number"&&(I=this.customThreshold),I<=0||d<I)return;this._stacks||(this._stacks=new Map);const L=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,L+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=I*.5;let B,J=0;for(const[Z,_]of this._stacks)(!B||J<_)&&(B=Z,J=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${J}):`),console.warn(B)}return()=>{const B=this._stacks.get(l.value)||0;this._stacks.set(l.value,B-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(l,d,I){this.callback=l,this.callbackThis=d,this.stack=I,this.subscription=new D.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class E{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=k>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const d of l)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,d,I)=>{this._listeners||(this._listeners=new C.LinkedList);const L=this._listeners.isEmpty();L&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let B,J;this._leakageMon&&this._listeners.size>=30&&(J=h.create(),B=this._leakageMon.check(J,this._listeners.size+1)),P&&(J=J??h.create());const Z=new w(l,d,J),_=this._listeners.push(Z);L&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,d);const te=Z.subscription.set(()=>{B?.(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return I instanceof D.DisposableStore?I.add(te):Array.isArray(I)&&I.push(te),te}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new m);for(const d of this._listeners)this._deliveryQueue.push(this,d,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=E;class g{constructor(){this._queue=new C.LinkedList}get size(){return this._queue.size}push(l,d,I){this._queue.push(new f(l,d,I))}clear(l){const d=new C.LinkedList;for(const I of this._queue)I.emitter!==l&&d.push(I);this._queue=d}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(d){(0,v.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=g;class m extends g{clear(l){this._queue.clear()}}class f{constructor(l,d,I){this.emitter=l,this.listener=d,this.event=I}}class c extends E{async fireAsync(l,d,I){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const L of this._listeners)this._asyncDeliveryQueue.push([L,l]);for(;this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[L,B]=this._asyncDeliveryQueue.shift(),J=[],Z={...B,token:d,waitUntil:_=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");I&&(_=I(_,L.callback)),J.push(_)}};try{L.invoke(Z)}catch(_){(0,v.onUnexpectedError)(_);continue}Object.freeze(J),await Promise.allSettled(J).then(_=>{for(const te of _)te.status==="rejected"&&(0,v.onUnexpectedError)(te.reason)})}}}}e.AsyncEmitter=c;class u extends E{constructor(l){super(l),this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=u;class r extends u{constructor(l){super(l),this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=r;class o extends E{constructor(l){super(l),this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){!this.hasListeners()||(this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const d={event:l,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const I=()=>{this.hasListeners&&this.unhook(d);const L=this.events.indexOf(d);this.events.splice(L,1)};return(0,D.toDisposable)((0,t.once)(I))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(d=>this.emitter.fire(d))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class i{constructor(){this.buffers=[]}wrapEvent(l){return(d,I,L)=>l(B=>{const J=this.buffers[this.buffers.length-1];J?J.push(()=>d.call(I,B)):d.call(I,B)},void 0,L)}bufferEvents(l){const d=[];this.buffers.push(d);const I=l();return this.buffers.pop(),d.forEach(L=>L()),I}}e.EventBufferer=i;class s{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=D.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(ve[20],we([1,0,7]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,p){const b=setTimeout(P.bind(p),0);return{dispose(){clearTimeout(b)}}});var D;(function(P){function p(b){return b===P.None||b===P.Cancelled||b instanceof C?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=p,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=T}),define(ve[148],we([1,0,20]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new v.CancellationTokenSource,p=this.task(P.token);return this.result={promise:p,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=t;class D{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const p=JSON.stringify(P);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=D;class C{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const p=this.fn(P);return this._map.set(P,p),p}}e.CachedFunction=C}),define(ve[87],we([1,0,7,2]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=T=>({onDidChange:v.Event.None,value:T});e.staticObservableValue=D;class C extends t.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new v.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=C}),define(ve[15],we([1,0,148,134]),function(oe,e,v,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(ce){return!ce||typeof ce!="string"?!0:ce.trim().length===0}e.isFalsyOrWhitespace=C;const T=/{(\d+)}/g;function P(ce,...Ce){return Ce.length===0?ce:ce.replace(T,function(De,Re){const Be=parseInt(Re,10);return isNaN(Be)||Be<0||Be>=Ce.length?De:Ce[Be]})}e.format=P;const p=/{([^}]+)}/g;function b(ce,Ce){return ce.replace(p,(De,Re)=>Ce[Re]??De)}e.format2=b;function R(ce){return ce.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=R;function k(ce){return ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function S(ce,Ce){let De=0;const Re=Ce.charCodeAt(0);for(let Be=ce.length-1;Be>=0;Be--)ce.charCodeAt(Be)===Re&&De++;return De}e.count=S;function y(ce,Ce,De="\u2026"){return ce.length<=Ce?ce:`${ce.substr(0,Ce)}${De}`}e.truncate=y;function h(ce,Ce=" "){const De=w(ce,Ce);return E(De,Ce)}e.trim=h;function w(ce,Ce){if(!ce||!Ce)return ce;const De=Ce.length;if(De===0||ce.length===0)return ce;let Re=0;for(;ce.indexOf(Ce,Re)===Re;)Re=Re+De;return ce.substring(Re)}e.ltrim=w;function E(ce,Ce){if(!ce||!Ce)return ce;const De=Ce.length,Re=ce.length;if(De===0||Re===0)return ce;let Be=Re,We=-1;for(;We=ce.lastIndexOf(Ce,Be-1),!(We===-1||We+De!==Be);){if(We===0)return"";Be=We}return ce.substring(0,Be)}e.rtrim=E;function g(ce){return ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function m(ce){return ce.replace(/\*/g,"")}e.stripWildcards=m;function f(ce,Ce,De={}){if(!ce)throw new Error("Cannot create regex from empty string");Ce||(ce=k(ce)),De.wholeWord&&(/\B/.test(ce.charAt(0))||(ce="\\b"+ce),/\B/.test(ce.charAt(ce.length-1))||(ce=ce+"\\b"));let Re="";return De.global&&(Re+="g"),De.matchCase||(Re+="i"),De.multiline&&(Re+="m"),De.unicode&&(Re+="u"),new RegExp(ce,Re)}e.createRegExp=f;function c(ce){return ce.source==="^"||ce.source==="^$"||ce.source==="$"||ce.source==="^\\s*$"?!1:!!(ce.exec("")&&ce.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function u(ce){return!!ce.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function r(ce){return(ce.global?"g":"")+(ce.ignoreCase?"i":"")+(ce.multiline?"m":"")+(ce.unicode?"u":"")}e.regExpFlags=r;function o(ce){return ce.split(/\r\n|\r|\n/)}e.splitLines=o;function n(ce){for(let Ce=0,De=ce.length;Ce<De;Ce++){const Re=ce.charCodeAt(Ce);if(Re!==32&&Re!==9)return Ce}return-1}e.firstNonWhitespaceIndex=n;function i(ce,Ce=0,De=ce.length){for(let Re=Ce;Re<De;Re++){const Be=ce.charCodeAt(Re);if(Be!==32&&Be!==9)return ce.substring(Ce,Re)}return ce.substring(Ce,De)}e.getLeadingWhitespace=i;function s(ce,Ce=ce.length-1){for(let De=Ce;De>=0;De--){const Re=ce.charCodeAt(De);if(Re!==32&&Re!==9)return De}return-1}e.lastNonWhitespaceIndex=s;function a(ce,Ce,De){const Re=[];let Be=0;for(const We of ce.matchAll(Ce)){if(Re.push(ce.slice(Be,We.index)),We.index===void 0)throw new Error("match.index should be defined");Be=We.index+We[0].length,Re.push(De(We[0],...We.slice(1),We.index,ce,We.groups))}return Re.push(ce.slice(Be)),Promise.all(Re).then(We=>We.join(""))}e.replaceAsync=a;function l(ce,Ce){return ce<Ce?-1:ce>Ce?1:0}e.compare=l;function d(ce,Ce,De=0,Re=ce.length,Be=0,We=Ce.length){for(;De<Re&&Be<We;De++,Be++){const it=ce.charCodeAt(De),et=Ce.charCodeAt(Be);if(it<et)return-1;if(it>et)return 1}const Ge=Re-De,rt=We-Be;return Ge<rt?-1:Ge>rt?1:0}e.compareSubstring=d;function I(ce,Ce){return L(ce,Ce,0,ce.length,0,Ce.length)}e.compareIgnoreCase=I;function L(ce,Ce,De=0,Re=ce.length,Be=0,We=Ce.length){for(;De<Re&&Be<We;De++,Be++){let it=ce.charCodeAt(De),et=Ce.charCodeAt(Be);if(it===et)continue;if(it>=128||et>=128)return d(ce.toLowerCase(),Ce.toLowerCase(),De,Re,Be,We);J(it)&&(it-=32),J(et)&&(et-=32);const st=it-et;if(st!==0)return st}const Ge=Re-De,rt=We-Be;return Ge<rt?-1:Ge>rt?1:0}e.compareSubstringIgnoreCase=L;function B(ce){return ce>=48&&ce<=57}e.isAsciiDigit=B;function J(ce){return ce>=97&&ce<=122}e.isLowerAsciiLetter=J;function Z(ce){return ce>=65&&ce<=90}e.isUpperAsciiLetter=Z;function _(ce,Ce){return ce.length===Ce.length&&L(ce,Ce)===0}e.equalsIgnoreCase=_;function te(ce,Ce){const De=Ce.length;return Ce.length>ce.length?!1:L(ce,Ce,0,De)===0}e.startsWithIgnoreCase=te;function se(ce,Ce){const De=Math.min(ce.length,Ce.length);let Re;for(Re=0;Re<De;Re++)if(ce.charCodeAt(Re)!==Ce.charCodeAt(Re))return Re;return De}e.commonPrefixLength=se;function W(ce,Ce){const De=Math.min(ce.length,Ce.length);let Re;const Be=ce.length-1,We=Ce.length-1;for(Re=0;Re<De;Re++)if(ce.charCodeAt(Be-Re)!==Ce.charCodeAt(We-Re))return Re;return De}e.commonSuffixLength=W;function fe(ce){return 55296<=ce&&ce<=56319}e.isHighSurrogate=fe;function j(ce){return 56320<=ce&&ce<=57343}e.isLowSurrogate=j;function X(ce,Ce){return(ce-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=X;function O(ce,Ce,De){const Re=ce.charCodeAt(De);if(fe(Re)&&De+1<Ce){const Be=ce.charCodeAt(De+1);if(j(Be))return X(Re,Be)}return Re}e.getNextCodePoint=O;function U(ce,Ce){const De=ce.charCodeAt(Ce-1);if(j(De)&&Ce>1){const Re=ce.charCodeAt(Ce-2);if(fe(Re))return X(Re,De)}return De}class x{get offset(){return this._offset}constructor(Ce,De=0){this._str=Ce,this._len=Ce.length,this._offset=De}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=U(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=O(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class ae{get offset(){return this._iterator.offset}constructor(Ce,De=0){this._iterator=new x(Ce,De)}nextGraphemeLength(){const Ce=Qe.getInstance(),De=this._iterator,Re=De.offset;let Be=Ce.getGraphemeBreakType(De.nextCodePoint());for(;!De.eol();){const We=De.offset,Ge=Ce.getGraphemeBreakType(De.nextCodePoint());if(Me(Be,Ge)){De.setOffset(We);break}Be=Ge}return De.offset-Re}prevGraphemeLength(){const Ce=Qe.getInstance(),De=this._iterator,Re=De.offset;let Be=Ce.getGraphemeBreakType(De.prevCodePoint());for(;De.offset>0;){const We=De.offset,Ge=Ce.getGraphemeBreakType(De.prevCodePoint());if(Me(Ge,Be)){De.setOffset(We);break}Be=Ge}return Re-De.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ae;function ue(ce,Ce){return new ae(ce,Ce).nextGraphemeLength()}e.nextCharLength=ue;function Q(ce,Ce){return new ae(ce,Ce).prevGraphemeLength()}e.prevCharLength=Q;function re(ce,Ce){Ce>0&&j(ce.charCodeAt(Ce))&&Ce--;const De=Ce+ue(ce,Ce);return[De-Q(ce,De),De]}e.getCharContainingOffset=re;function F(ce){const Ce=new ae(ce);let De=0;for(;!Ce.eol();)De++,Ce.nextGraphemeLength();return De}e.charCount=F;let M;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(ce){return M||(M=G()),M.test(ce)}e.containsRTL=ie;const he=/^[\t\n\r\x20-\x7E]*$/;function Ee(ce){return he.test(ce)}e.isBasicASCII=Ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function $(ce){return e.UNUSUAL_LINE_TERMINATORS.test(ce)}e.containsUnusualLineTerminators=$;function Y(ce){return ce>=11904&&ce<=55215||ce>=63744&&ce<=64255||ce>=65281&&ce<=65374}e.isFullWidthCharacter=Y;function ee(ce){return ce>=127462&&ce<=127487||ce===8986||ce===8987||ce===9200||ce===9203||ce>=9728&&ce<=10175||ce===11088||ce===11093||ce>=127744&&ce<=128591||ce>=128640&&ce<=128764||ce>=128992&&ce<=129008||ce>=129280&&ce<=129535||ce>=129648&&ce<=129782}e.isEmojiImprecise=ee;function z(ce,Ce){if(ce.length<Ce)return ce;const De=/\b/g;let Re=0;for(;De.test(ce)&&!(ce.length-De.lastIndex<Ce);)Re=De.lastIndex,De.lastIndex+=1;return ce.substring(Re).replace(/^\s/,"")}e.lcut=z;const q=/\x1B\x5B[12]?K/g,H=/\x1b\[\d+m/g,K=/\x1b\[0?m/g;function le(ce){return ce&&(ce=ce.replace(q,""),ce=ce.replace(H,""),ce=ce.replace(K,"")),ce}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(ce){return!!(ce&&ce.length>0&&ce.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function ke(ce){return pe(ce)?ce.substr(1):ce}e.stripUTF8BOM=ke;function Te(ce,Ce){if(!ce||!Ce||ce.length<Ce.length)return!1;const De=Ce.length,Re=ce.toLowerCase();let Be=0,We=-1;for(;Be<De;){const Ge=Re.indexOf(Ce[Be],We+1);if(Ge<0)return!1;We=Ge,Be++}return!0}e.fuzzyContains=Te;function Ne(ce,Ce=!1){return ce?(Ce&&(ce=ce.replace(/\\./g,"")),ce.toLowerCase()!==ce):!1}e.containsUppercaseCharacter=Ne;function Le(ce){return ce.charAt(0).toUpperCase()+ce.slice(1)}e.uppercaseFirstLetter=Le;function me(ce,Ce=1){if(Ce===0)return"";let De=-1;do De=ce.indexOf(`
`,De+1),Ce--;while(Ce>0&&De>=0);return De===-1?ce:(ce[De-1]==="\r"&&De--,ce.substr(0,De))}e.getNLines=me;function be(ce){return ce=ce%(2*26),ce<26?String.fromCharCode(97+ce):String.fromCharCode(65+ce-26)}e.singleLetterHash=be;function ye(ce){return Qe.getInstance().getGraphemeBreakType(ce)}e.getGraphemeBreakType=ye;function Me(ce,Ce){return ce===0?Ce!==5&&Ce!==7:ce===2&&Ce===3?!1:ce===4||ce===2||ce===3||Ce===4||Ce===2||Ce===3?!0:!(ce===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(ce===11||ce===9)&&(Ce===9||Ce===10)||(ce===12||ce===10)&&Ce===10||Ce===5||Ce===13||Ce===7||ce===1||ce===13&&Ce===14||ce===6&&Ce===6)}var Oe;(function(ce){ce[ce.Other=0]="Other",ce[ce.Prepend=1]="Prepend",ce[ce.CR=2]="CR",ce[ce.LF=3]="LF",ce[ce.Control=4]="Control",ce[ce.Extend=5]="Extend",ce[ce.Regional_Indicator=6]="Regional_Indicator",ce[ce.SpacingMark=7]="SpacingMark",ce[ce.L=8]="L",ce[ce.V=9]="V",ce[ce.T=10]="T",ce[ce.LV=11]="LV",ce[ce.LVT=12]="LVT",ce[ce.ZWJ=13]="ZWJ",ce[ce.Extended_Pictographic=14]="Extended_Pictographic"})(Oe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Qe{static getInstance(){return Qe._INSTANCE||(Qe._INSTANCE=new Qe),Qe._INSTANCE}constructor(){this._data=je()}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const De=this._data,Re=De.length/3;let Be=1;for(;Be<=Re;)if(Ce<De[3*Be])Be=2*Be;else if(Ce>De[3*Be+1])Be=2*Be+1;else return De[3*Be+2];return 0}}Qe._INSTANCE=null;function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(ce,Ce){if(ce===0)return 0;const De=Ve(ce,Ce);if(De!==void 0)return De;const Re=new x(Ce,ce);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=qe;function Ve(ce,Ce){const De=new x(Ce,ce);let Re=De.prevCodePoint();for(;xe(Re)||Re===65039||Re===8419;){if(De.offset===0)return;Re=De.prevCodePoint()}if(!ee(Re))return;let Be=De.offset;return Be>0&&De.prevCodePoint()===8205&&(Be=De.offset),Be}function xe(ce){return 127995<=ce&&ce<=127999}var Ye;(function(ce){ce[ce.zwj=8205]="zwj",ce[ce.emojiVariantSelector=65039]="emojiVariantSelector",ce[ce.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.noBreakWhitespace="\xA0";class $e{static getInstance(Ce){return $e.cache.get(Array.from(Ce))}static getLocales(){return $e._locales.getValue()}constructor(Ce){this.confusableDictionary=Ce}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=$e,D=$e,$e.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.cache=new v.LRUCachedFunction(ce=>{function Ce(et){const st=new Map;for(let lt=0;lt<et.length;lt+=2)st.set(et[lt],et[lt+1]);return st}function De(et,st){const lt=new Map(et);for(const[ft,ht]of st)lt.set(ft,ht);return lt}function Re(et,st){if(!et)return st;const lt=new Map;for(const[ft,ht]of et)st.has(ft)&&lt.set(ft,ht);return lt}const Be=D.ambiguousCharacterData.getValue();let We=ce.filter(et=>!et.startsWith("_")&&et in Be);We.length===0&&(We=["_default"]);let Ge;for(const et of We){const st=Ce(Be[et]);Ge=Re(Ge,st)}const rt=Ce(Be._common),it=De(rt,Ge);return new $e(it)}),$e._locales=new t.Lazy(()=>Object.keys($e.ambiguousCharacterData.getValue()).filter(ce=>!ce.startsWith("_")));class Ke{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ke.getRawData())),this._data}static isInvisibleCharacter(Ce){return Ke.getData().has(Ce)}static get codePoints(){return Ke.getData()}}e.InvisibleCharacters=Ke,Ke._data=void 0}),define(ve[36],we([1,0,6,3,15,11]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function P(s){return s.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=P;function p(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=p;function b(s,a=v.posix.sep){if(!s)return"";const l=s.length,d=s.charCodeAt(0);if(T(d)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let L=3;const B=L;for(;L<l&&!T(s.charCodeAt(L));L++);if(B!==L&&!T(s.charCodeAt(L+1))){for(L+=1;L<l;L++)if(T(s.charCodeAt(L)))return s.slice(0,L+1).replace(/[\\/]/g,a)}}return a}else if(g(d)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let I=s.indexOf("://");if(I!==-1){for(I+=3;I<l;I++)if(T(s.charCodeAt(I)))return s.slice(0,I+1)}return""}e.getRoot=b;function R(s){if(!t.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let l=2;const d=l;for(;l<s.length&&(a=s.charCodeAt(l),a!==92);l++);return!(d===l||(a=s.charCodeAt(l+1),isNaN(a)||a===92))}e.isUNC=R;const k=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,a=t.isWindows){const l=a?k:S;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||a&&y.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function w(s,a,l){const d=s===a;return!l||d?d:!s||!a?!1:(0,D.equalsIgnoreCase)(s,a)}e.isEqual=w;function E(s,a,l,d=v.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(l){if(!(0,D.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let L=a.length;return a.charAt(a.length-1)===d&&L--,s.charAt(L)===d}return a.charAt(a.length-1)!==d&&(a+=d),s.indexOf(a)===0}e.isEqualOrParent=E;function g(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=g;function m(s,a){return t.isWindows&&s.endsWith(":")&&(s+=v.sep),(0,v.isAbsolute)(s)||(s=(0,v.join)(a,s)),s=(0,v.normalize)(s),t.isWindows?(s=(0,D.rtrim)(s,v.sep),s.endsWith(":")&&(s+=v.sep)):(s=(0,D.rtrim)(s,v.sep),s||(s=v.sep)),s}e.sanitizeFilePath=m;function f(s){const a=(0,v.normalize)(s);return t.isWindows?s.length>3?!1:c(a)&&(s.length===2||a.charCodeAt(2)===92):a===v.posix.sep}e.isRootOrDriveLetter=f;function c(s,a=t.isWindows){return a?g(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function u(s){return c(s)?s[0]:void 0}e.getDriveLetter=u;function r(s,a,l){return a.length>s.length?-1:s===a?0:(l&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=r;function o(s){const a=s.split(":");let l,d,I;for(const L of a){const B=Number(L);(0,C.isNumber)(B)?d===void 0?d=B:I===void 0&&(I=B):l=l?[l,L].join(":"):L}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:d!==void 0?d:void 0,column:I!==void 0?I:d!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,a,l=8){let d="";for(let L=0;L<l;L++)d+=n.charAt(Math.floor(Math.random()*n.length));let I;return a?I=`${a}-${d}`:I=d,s?(0,v.join)(s,I):I}e.randomPath=i}),define(ve[88],we([1,0,15]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(g){return D(g,0)}e.hash=t;function D(g,m){switch(typeof g){case"object":return g===null?C(349,m):Array.isArray(g)?p(g,m):b(g,m);case"string":return P(g,m);case"boolean":return T(g,m);case"number":return C(g,m);case"undefined":return C(937,m);default:return C(617,m)}}e.doHash=D;function C(g,m){return(m<<5)-m+g|0}e.numberHash=C;function T(g,m){return C(g?433:863,m)}function P(g,m){m=C(149417,m);for(let f=0,c=g.length;f<c;f++)m=C(g.charCodeAt(f),m);return m}e.stringHash=P;function p(g,m){return m=C(104579,m),g.reduce((f,c)=>D(c,f),m)}function b(g,m){return m=C(181387,m),Object.keys(g).sort().reduce((f,c)=>(f=P(c,f),D(g[c],f)),m)}class R{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=D(m,this._value),this._value}}e.Hasher=R;var k;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function S(g,m,f=32){const c=f-m,u=~((1<<c)-1);return(g<<m|(u&g)>>>c)>>>0}function y(g,m=0,f=g.byteLength,c=0){for(let u=0;u<f;u++)g[m+u]=c}function h(g,m,f="0"){for(;g.length<m;)g=f+g;return g}function w(g,m=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(f=>f.toString(16).padStart(2,"0")).join(""):h((g>>>0).toString(16),m/4)}e.toHexString=w;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const f=m.length;if(f===0)return;const c=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,o,n;for(r!==0?(o=r,n=-1,r=0):(o=m.charCodeAt(0),n=0);;){let i=o;if(v.isHighSurrogate(o))if(n+1<f){const s=m.charCodeAt(n+1);v.isLowSurrogate(s)?(n++,i=v.computeCodePoint(o,s)):i=65533}else{r=o;break}else v.isLowSurrogate(o)&&(i=65533);if(u=this._push(c,u,i),n++,n<f)o=m.charCodeAt(n);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(m,f,c){return c<128?m[f++]=c:c<2048?(m[f++]=192|(c&1984)>>>6,m[f++]=128|(c&63)>>>0):c<65536?(m[f++]=224|(c&61440)>>>12,m[f++]=128|(c&4032)>>>6,m[f++]=128|(c&63)>>>0):(m[f++]=240|(c&1835008)>>>18,m[f++]=128|(c&258048)>>>12,m[f++]=128|(c&4032)>>>6,m[f++]=128|(c&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=E._bigBlock32,f=this._buffDV;for(let l=0;l<64;l+=4)m.setUint32(l,f.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)m.setUint32(l,S(m.getUint32(l-12,!1)^m.getUint32(l-32,!1)^m.getUint32(l-56,!1)^m.getUint32(l-64,!1),1),!1);let c=this._h0,u=this._h1,r=this._h2,o=this._h3,n=this._h4,i,s,a;for(let l=0;l<80;l++)l<20?(i=u&r|~u&o,s=1518500249):l<40?(i=u^r^o,s=1859775393):l<60?(i=u&r|u&o|r&o,s=2400959708):(i=u^r^o,s=3395469782),a=S(c,5)+i+n+s+m.getUint32(l*4,!1)&4294967295,n=o,o=r,r=S(u,30),u=c,c=a;this._h0=this._h0+c&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ve[24],we([1,0,18,15]),function(oe,e,v,t){"use strict";var D,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(n,i,s){let a=n.get(i);return a===void 0&&(a=s,n.set(i,a)),a}e.getOrSet=P;function p(n){const i=[];return n.forEach((s,a)=>{i.push(`${a} => ${s}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=p;function b(n){const i=[];return n.forEach(s=>{i.push(s)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=b;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=R;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class S{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var y;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(y||(y={}));class h{constructor(i,s){this._ignorePathCasing=i,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(E||(E={}));class g{static forUris(i=()=>!1,s=()=>!1){return new g(new h(i,s))}static forPaths(i=!1){return new g(new S(void 0,!i))}static forStrings(){return new g(new R)}static forConfigKeys(){return new g(new k)}constructor(i){this._iter=i}clear(){this._root=void 0}fill(i,s){if(s){const a=s.slice(0);(0,v.shuffle)(a);for(const l of a)this.set(l,i)}else{const a=i.slice(0);(0,v.shuffle)(a);for(const l of a)this.set(l[0],l[1])}}set(i,s){const a=this._iter.reset(i);let l;this._root||(this._root=new w,this._root.segment=a.value());const d=[];for(l=this._root;;){const L=a.cmp(l.segment);if(L>0)l.left||(l.left=new w,l.left.segment=a.value()),d.push([-1,l]),l=l.left;else if(L<0)l.right||(l.right=new w,l.right.segment=a.value()),d.push([1,l]),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new w,l.mid.segment=a.value()),d.push([0,l]),l=l.mid;else break}const I=l.value;l.value=s,l.key=i;for(let L=d.length-1;L>=0;L--){const B=d[L][1];B.updateHeight();const J=B.balanceFactor();if(J<-1||J>1){const Z=d[L][0],_=d[L+1][0];if(Z===1&&_===1)d[L][1]=B.rotateLeft();else if(Z===-1&&_===-1)d[L][1]=B.rotateRight();else if(Z===1&&_===-1)B.right=d[L+1][1]=d[L+1][1].rotateRight(),d[L][1]=B.rotateLeft();else if(Z===-1&&_===1)B.left=d[L+1][1]=d[L+1][1].rotateLeft(),d[L][1]=B.rotateRight();else throw new Error;if(L>0)switch(d[L-1][0]){case-1:d[L-1][1].left=d[L][1];break;case 1:d[L-1][1].right=d[L][1];break;case 0:d[L-1][1].mid=d[L][1];break}else this._root=d[0][1]}}return I}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const l=s.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const a=this._iter.reset(i),l=[];let d=this._root;for(;d;){const I=a.cmp(d.segment);if(I>0)l.push([-1,d]),d=d.left;else if(I<0)l.push([1,d]),d=d.right;else if(a.hasNext())a.next(),l.push([0,d]),d=d.mid;else break}if(!!d){if(s?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const I=this._min(d.right);if(I.key){const{key:L,value:B,segment:J}=I;this._delete(I.key,!1),d.key=L,d.value=B,d.segment=J}}else{const I=d.left??d.right;if(l.length>0){const[L,B]=l[l.length-1];switch(L){case-1:B.left=I;break;case 0:B.mid=I;break;case 1:B.right=I;break}}else this._root=I}for(let I=l.length-1;I>=0;I--){const L=l[I][1];L.updateHeight();const B=L.balanceFactor();if(B>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),l[I][1]=L.rotateLeft()):B<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),l[I][1]=L.rotateRight()),I>0)switch(l[I-1][0]){case-1:l[I-1][1].left=l[I][1];break;case 1:l[I-1][1].right=l[I][1];break;case 0:l[I-1][1].mid=l[I][1];break}else this._root=l[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let a=this._root,l;for(;a;){const d=s.cmp(a.segment);if(d>0)a=a.left;else if(d<0)a=a.right;else if(s.hasNext())s.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const l=s.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[s,a]of this)i(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const s=[];return this._dfsEntries(i,s),s[Symbol.iterator]()}_dfsEntries(i,s){!i||(i.left&&this._dfsEntries(i.left,s),i.value&&s.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,s),i.right&&this._dfsEntries(i.right,s))}_isBalanced(){const i=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=g;class m{constructor(i,s){this.uri=i,this.value=s}}class f{constructor(i,s){this[D]="ResourceMap",i instanceof f?(this.map=new Map(i.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=i??f.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new m(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s<"u"&&(i=i.bind(s));for(const[a,l]of this.map)i(l.value,l.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=f,f.defaultToKey=n=>n.toString();class c{constructor(i,s){this[C]="ResourceSet",!i||typeof i=="function"?this._map=new f(i):(this._map=new f(s),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,s){this._map.forEach((a,l)=>i.call(s,l,l,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var u;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class r{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const a=this._map.get(i);if(!!a)return s!==0&&this.touch(a,s),a.value}set(i,s,a=0){let l=this._map.get(i);if(l)l.value=s,a!==0&&this.touch(l,a);else{switch(l={key:i,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const a=this._state;let l=this._head;for(;l;){if(s?i.bind(s)(l.value,l.key,this):i(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const d={value:a.key,done:!1};return a=a.next,d}else return{value:void 0,done:!0}}};return l}values(){const i=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const d={value:a.value,done:!1};return a=a.next,d}else return{value:void 0,done:!0}}};return l}entries(){const i=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const d={value:[a.key,a.value],done:!1};return a=a.next,d}else return{value:void 0,done:!0}}};return l}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>i;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,a=i.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const a=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const a=i.next,l=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,a)=>{i.push([a,s])}),i}fromJSON(i){this.clear();for(const[s,a]of i)this.set(s,a)}}e.LinkedMap=r;class o extends r{constructor(i,s=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(ve[149],we([1,0,24,15]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...H){return function(K,le){for(let pe=0,ke=H.length;pe<ke;pe++){const Te=H[pe](K,le);if(Te)return Te}return null}}e.or=D,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(H,K,le){if(!le||le.length<K.length)return null;let pe;return H?pe=t.startsWithIgnoreCase(le,K):pe=le.indexOf(K)===0,pe?K.length>0?[{start:0,end:K.length}]:[]:null}function T(H,K){const le=K.toLowerCase().indexOf(H.toLowerCase());return le===-1?null:[{start:le,end:le+H.length}]}e.matchesContiguousSubString=T;function P(H,K){return p(H.toLowerCase(),K.toLowerCase(),0,0)}e.matchesSubString=P;function p(H,K,le,pe){if(le===H.length)return[];if(pe===K.length)return null;if(H[le]===K[pe]){let ke=null;return(ke=p(H,K,le+1,pe+1))?g({start:pe,end:pe+1},ke):null}return p(H,K,le,pe+1)}function b(H){return 97<=H&&H<=122}function R(H){return 65<=H&&H<=90}e.isUpper=R;function k(H){return 48<=H&&H<=57}function S(H){return H===32||H===9||H===10||H===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(H=>y.add(H.charCodeAt(0)));function h(H){return S(H)||y.has(H)}function w(H,K){return H===K||h(H)&&h(K)}function E(H){return b(H)||R(H)||k(H)}function g(H,K){return K.length===0?K=[H]:H.end===K[0].start?K[0].start=H.start:K.unshift(H),K}function m(H,K){for(let le=K;le<H.length;le++){const pe=H.charCodeAt(le);if(R(pe)||k(pe)||le>0&&!E(H.charCodeAt(le-1)))return le}return H.length}function f(H,K,le,pe){if(le===H.length)return[];if(pe===K.length)return null;if(H[le]!==K[pe].toLowerCase())return null;{let ke=null,Te=pe+1;for(ke=f(H,K,le+1,pe+1);!ke&&(Te=m(K,Te))<K.length;)ke=f(H,K,le+1,Te),Te++;return ke===null?null:g({start:pe,end:pe+1},ke)}}function c(H){let K=0,le=0,pe=0,ke=0,Te=0;for(let ye=0;ye<H.length;ye++)Te=H.charCodeAt(ye),R(Te)&&K++,b(Te)&&le++,E(Te)&&pe++,k(Te)&&ke++;const Ne=K/H.length,Le=le/H.length,me=pe/H.length,be=ke/H.length;return{upperPercent:Ne,lowerPercent:Le,alphaPercent:me,numericPercent:be}}function u(H){const{upperPercent:K,lowerPercent:le}=H;return le===0&&K>.6}function r(H){const{upperPercent:K,lowerPercent:le,alphaPercent:pe,numericPercent:ke}=H;return le>.2&&K<.8&&pe>.6&&ke<.2}function o(H){let K=0,le=0,pe=0,ke=0;for(let Te=0;Te<H.length;Te++)pe=H.charCodeAt(Te),R(pe)&&K++,b(pe)&&le++,S(pe)&&ke++;return(K===0||le===0)&&ke===0?H.length<=30:K<=5}function n(H,K){if(!K||(K=K.trim(),K.length===0)||!o(H)||K.length>60)return null;const le=c(K);if(!r(le)){if(!u(le))return null;K=K.toLowerCase()}let pe=null,ke=0;for(H=H.toLowerCase();ke<K.length&&(pe=f(H,K,0,ke))===null;)ke=m(K,ke+1);return pe}e.matchesCamelCase=n;function i(H,K,le=!1){if(!K||K.length===0)return null;let pe=null,ke=0;for(H=H.toLowerCase(),K=K.toLowerCase();ke<K.length&&(pe=s(H,K,0,ke,le))===null;)ke=a(K,ke+1);return pe}e.matchesWords=i;function s(H,K,le,pe,ke){if(le===H.length)return[];if(pe===K.length)return null;if(w(H.charCodeAt(le),K.charCodeAt(pe))){let Te=null,Ne=pe+1;if(Te=s(H,K,le+1,pe+1,ke),!ke)for(;!Te&&(Ne=a(K,Ne))<K.length;)Te=s(H,K,le+1,Ne,ke),Ne++;return Te?H.charCodeAt(le)!==K.charCodeAt(pe)?Te:g({start:pe,end:pe+1},Te):null}else return null}function a(H,K){for(let le=K;le<H.length;le++)if(h(H.charCodeAt(le))||le>0&&h(H.charCodeAt(le-1)))return le;return H.length}const l=D(e.matchesPrefix,n,T),d=D(e.matchesPrefix,n,P),I=new v.LRUCache(1e4);function L(H,K,le=!1){if(typeof H!="string"||typeof K!="string")return null;let pe=I.get(H);pe||(pe=new RegExp(t.convertSimple2RegExpPattern(H),"i"),I.set(H,pe));const ke=pe.exec(K);return ke?[{start:ke.index,end:ke.index+ke[0].length}]:le?d(H,K):l(H,K)}e.matchesFuzzy=L;function B(H,K){const le=he(H,H.toLowerCase(),0,K,K.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return le?Z(le):null}e.matchesFuzzy2=B;function J(H,K,le,pe,ke,Te){const Ne=Math.min(13,H.length);for(;le<Ne;le++){const Le=he(H,K,le,pe,ke,Te,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Le)return Le}return[0,Te]}e.anyScore=J;function Z(H){if(typeof H>"u")return[];const K=[],le=H[1];for(let pe=H.length-1;pe>1;pe--){const ke=H[pe]+le,Te=K[K.length-1];Te&&Te.end===ke?Te.end=ke+1:K.push({start:ke,end:ke+1})}return K}e.createMatches=Z;const _=128;function te(){const H=[],K=[];for(let le=0;le<=_;le++)K[le]=0;for(let le=0;le<=_;le++)H.push(K.slice(0));return H}function se(H){const K=[];for(let le=0;le<=H;le++)K[le]=0;return K}const W=se(2*_),fe=se(2*_),j=te(),X=te(),O=te(),U=!1;function x(H,K,le,pe,ke){function Te(Le,me,be=" "){for(;Le.length<me;)Le=be+Le;return Le}let Ne=` |   |${pe.split("").map(Le=>Te(Le,3)).join("|")}
`;for(let Le=0;Le<=le;Le++)Le===0?Ne+=" |":Ne+=`${K[Le-1]}|`,Ne+=H[Le].slice(0,ke+1).map(me=>Te(me.toString(),3)).join("|")+`
`;return Ne}function ae(H,K,le,pe){H=H.substr(K),le=le.substr(pe),console.log(x(X,H,H.length,le,le.length)),console.log(x(O,H,H.length,le,le.length)),console.log(x(j,H,H.length,le,le.length))}function ue(H,K){if(K<0||K>=H.length)return!1;const le=H.codePointAt(K);switch(le){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(le)}}function Q(H,K){if(K<0||K>=H.length)return!1;switch(H.charCodeAt(K)){case 32:case 9:return!0;default:return!1}}function re(H,K,le){return K[H]!==le[H]}function F(H,K,le,pe,ke,Te,Ne=!1){for(;K<le&&ke<Te;)H[K]===pe[ke]&&(Ne&&(W[K]=ke),K+=1),ke+=1;return K===le}e.isPatternInWord=F;var M;(function(H){H[H.Diag=1]="Diag",H[H.Left=2]="Left",H[H.LeftLeft=3]="LeftLeft"})(M||(M={}));var G;(function(H){H.Default=[-100,0];function K(le){return!le||le.length===2&&le[0]===-100&&le[1]===0}H.isDefault=K})(G=e.FuzzyScore||(e.FuzzyScore={}));class ie{constructor(K,le){this.firstMatchCanBeWeak=K,this.boostFullMatch=le}}e.FuzzyScoreOptions=ie,ie.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function he(H,K,le,pe,ke,Te,Ne=ie.default){const Le=H.length>_?_:H.length,me=pe.length>_?_:pe.length;if(le>=Le||Te>=me||Le-le>me-Te||!F(K,le,Le,ke,Te,me,!0))return;Ee(Le,me,le,Te,K,ke);let be=1,ye=1,Me=le,Oe=Te;const Qe=[!1];for(be=1,Me=le;Me<Le;be++,Me++){const Ye=W[Me],$e=fe[Me],Ke=Me+1<Le?fe[Me+1]:me;for(ye=Ye-Te+1,Oe=Ye;Oe<Ke;ye++,Oe++){let ce=Number.MIN_SAFE_INTEGER,Ce=!1;Oe<=$e&&(ce=$(H,K,Me,le,pe,ke,Oe,me,Te,j[be-1][ye-1]===0,Qe));let De=0;ce!==Number.MAX_SAFE_INTEGER&&(Ce=!0,De=ce+X[be-1][ye-1]);const Re=Oe>Ye,Be=Re?X[be][ye-1]+(j[be][ye-1]>0?-5:0):0,We=Oe>Ye+1&&j[be][ye-1]>0,Ge=We?X[be][ye-2]+(j[be][ye-2]>0?-5:0):0;if(We&&(!Re||Ge>=Be)&&(!Ce||Ge>=De))X[be][ye]=Ge,O[be][ye]=3,j[be][ye]=0;else if(Re&&(!Ce||Be>=De))X[be][ye]=Be,O[be][ye]=2,j[be][ye]=0;else if(Ce)X[be][ye]=De,O[be][ye]=1,j[be][ye]=j[be-1][ye-1]+1;else throw new Error("not possible")}}if(U&&ae(H,le,pe,Te),!Qe[0]&&!Ne.firstMatchCanBeWeak)return;be--,ye--;const je=[X[be][ye],Te];let qe=0,Ve=0;for(;be>=1;){let Ye=ye;do{const $e=O[be][Ye];if($e===3)Ye=Ye-2;else if($e===2)Ye=Ye-1;else break}while(Ye>=1);qe>1&&K[le+be-1]===ke[Te+ye-1]&&!re(Ye+Te-1,pe,ke)&&qe+1>j[be][Ye]&&(Ye=ye),Ye===ye?qe++:qe=1,Ve||(Ve=Ye),be--,ye=Ye-1,je.push(ye)}me===Le&&Ne.boostFullMatch&&(je[0]+=2);const xe=Ve-Le;return je[0]-=xe,je}e.fuzzyScore=he;function Ee(H,K,le,pe,ke,Te){let Ne=H-1,Le=K-1;for(;Ne>=le&&Le>=pe;)ke[Ne]===Te[Le]&&(fe[Ne]=Le,Ne--),Le--}function $(H,K,le,pe,ke,Te,Ne,Le,me,be,ye){if(K[le]!==Te[Ne])return Number.MIN_SAFE_INTEGER;let Me=1,Oe=!1;return Ne===le-pe?Me=H[le]===ke[Ne]?7:5:re(Ne,ke,Te)&&(Ne===0||!re(Ne-1,ke,Te))?(Me=H[le]===ke[Ne]?7:5,Oe=!0):ue(Te,Ne)&&(Ne===0||!ue(Te,Ne-1))?Me=5:(ue(Te,Ne-1)||Q(Te,Ne-1))&&(Me=5,Oe=!0),Me>1&&le===pe&&(ye[0]=!0),Oe||(Oe=re(Ne,ke,Te)||ue(Te,Ne-1)||Q(Te,Ne-1)),le===pe?Ne>me&&(Me-=Oe?3:5):be?Me+=Oe?2:0:Me+=Oe?0:1,Ne+1===Le&&(Me-=Oe?3:5),Me}function Y(H,K,le,pe,ke,Te,Ne){return z(H,K,le,pe,ke,Te,!0,Ne)}e.fuzzyScoreGracefulAggressive=Y;function ee(H,K,le,pe,ke,Te,Ne){return z(H,K,le,pe,ke,Te,!1,Ne)}e.fuzzyScoreGraceful=ee;function z(H,K,le,pe,ke,Te,Ne,Le){let me=he(H,K,le,pe,ke,Te,Le);if(me&&!Ne)return me;if(H.length>=3){const be=Math.min(7,H.length-1);for(let ye=le+1;ye<be;ye++){const Me=q(H,ye);if(Me){const Oe=he(Me,Me.toLowerCase(),le,pe,ke,Te,Le);Oe&&(Oe[0]-=3,(!me||Oe[0]>me[0])&&(me=Oe))}}}return me}function q(H,K){if(K+1>=H.length)return;const le=H[K],pe=H[K+1];if(le!==pe)return H.slice(0,K)+pe+le+H.slice(K+2)}}),define(ve[150],we([1,0,40,149,15]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(v.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${C.source}`,"g");function p(E){return E.replace(P,(g,m)=>m?g:`\\${g}`)}e.escapeIcons=p;const b=new RegExp(`\\\\${C.source}`,"g");function R(E){return E.replace(b,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=R;const k=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function S(E){return E.indexOf(e.iconStartMarker)===-1?E:E.replace(k,(g,m,f,c)=>f?g:m||c||"")}e.stripIcons=S;function y(E){const g=E.indexOf(e.iconStartMarker);return g===-1?{text:E}:h(E,g)}e.parseLabelWithIcons=y;function h(E,g){const m=[];let f="";function c(l){if(l){f+=l;for(const d of l)m.push(o)}}let u=-1,r="",o=0,n,i,s=g;const a=E.length;for(c(E.substr(0,g));s<a;)n=E[s],i=E[s+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(u=s,c(r),r=e.iconStartMarker,s++):n===")"&&u!==-1?(o+=s-u+1,u=-1,r=""):u!==-1?T.test(n)?r+=n:(c(r),u=-1,r=""):c(n),s++;return c(r),{text:f,iconOffsets:m}}function w(E,g,m=!1){const{text:f,iconOffsets:c}=g;if(!c||c.length===0)return(0,t.matchesFuzzy)(E,f,m);const u=(0,D.ltrim)(f," "),r=f.length-u.length,o=(0,t.matchesFuzzy)(E,u,m);if(o)for(const n of o){const i=c[n.start+r]+r;n.start+=i,n.end+=i}return o}e.matchesFuzzyIconAware=w}),define(ve[89],we([1,0,24]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new v.LRUCache(1e4);function D(b){return p(b,"NFC",t)}e.normalizeNFC=D;const C=new v.LRUCache(1e4);function T(b){return p(b,"NFD",C)}e.normalizeNFD=T;const P=/[^\u0000-\u0080]/;function p(b,R,k){if(!b)return b;const S=k.get(b);if(S)return S;let y;return P.test(b)?y=b.normalize(R):y=b,k.set(b,y),y}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(R){return T(R).replace(b,"")}}()}),define(ve[67],we([1,0,15]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(t||(t={})),function(D){const C="error",T="warning",P="warn",p="info",b="ignore";function R(S){return S?v.equalsIgnoreCase(C,S)?D.Error:v.equalsIgnoreCase(T,S)||v.equalsIgnoreCase(P,S)?D.Warning:v.equalsIgnoreCase(p,S)?D.Info:D.Ignore:D.Ignore}D.fromValue=R;function k(S){switch(S){case D.Error:return C;case D.Warning:return T;case D.Info:return p;default:return b}}D.toString=k}(t||(t={})),e.default=t}),define(ve[4],we([1,0,6,3]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,T=/^\/\//;function P(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(n,i){return!n&&!i?"file":n}function b(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const R="",k="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(i){return i instanceof y?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,s,a,l,d,I=!1){typeof i=="object"?(this.scheme=i.scheme||R,this.authority=i.authority||R,this.path=i.path||R,this.query=i.query||R,this.fragment=i.fragment||R):(this.scheme=p(i,I),this.authority=s||R,this.path=b(this.scheme,a||R),this.query=l||R,this.fragment=d||R,P(this,I))}get fsPath(){return f(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:a,path:l,query:d,fragment:I}=i;return s===void 0?s=this.scheme:s===null&&(s=R),a===void 0?a=this.authority:a===null&&(a=R),l===void 0?l=this.path:l===null&&(l=R),d===void 0?d=this.query:d===null&&(d=R),I===void 0?I=this.fragment:I===null&&(I=R),s===this.scheme&&a===this.authority&&l===this.path&&d===this.query&&I===this.fragment?this:new w(s,a,l,d,I)}static parse(i,s=!1){const a=S.exec(i);return a?new w(a[2]||R,o(a[4]||R),o(a[5]||R),o(a[7]||R),o(a[9]||R),s):new w(R,R,R,R,R)}static file(i){let s=R;if(t.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const a=i.indexOf(k,2);a===-1?(s=i.substring(2),i=k):(s=i.substring(2,a),i=i.substring(a)||k)}return new w("file",s,i,R,R)}static from(i){const s=new w(i.scheme,i.authority,i.path,i.query,i.fragment);return P(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&i.scheme==="file"?a=y.file(v.win32.join(f(i,!0),...s)).path:a=v.posix.join(i.path,...s),i.with({path:a})}toString(i=!1){return c(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof y)return i;{const s=new w(i);return s._formatted=i.external,s._fsPath=i._sep===h?i.fsPath:null,s}}else return i}}e.URI=y;const h=t.isWindows?1:void 0;class w extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(i=!1){return i?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=h),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(n,i){let s,a=-1;for(let l=0;l<n.length;l++){const d=n.charCodeAt(l);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||i&&d===47)a!==-1&&(s+=encodeURIComponent(n.substring(a,l)),a=-1),s!==void 0&&(s+=n.charAt(l));else{s===void 0&&(s=n.substr(0,l));const I=E[d];I!==void 0?(a!==-1&&(s+=encodeURIComponent(n.substring(a,l)),a=-1),s+=I):a===-1&&(a=l)}}return a!==-1&&(s+=encodeURIComponent(n.substring(a))),s!==void 0?s:n}function m(n){let i;for(let s=0;s<n.length;s++){const a=n.charCodeAt(s);a===35||a===63?(i===void 0&&(i=n.substr(0,s)),i+=E[a]):i!==void 0&&(i+=n[s])}return i!==void 0?i:n}function f(n,i){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function c(n,i){const s=i?m:g;let a="",{scheme:l,authority:d,path:I,query:L,fragment:B}=n;if(l&&(a+=l,a+=":"),(d||l==="file")&&(a+=k,a+=k),d){let J=d.indexOf("@");if(J!==-1){const Z=d.substr(0,J);d=d.substr(J+1),J=Z.indexOf(":"),J===-1?a+=s(Z,!1):(a+=s(Z.substr(0,J),!1),a+=":",a+=s(Z.substr(J+1),!1)),a+="@"}d=d.toLowerCase(),J=d.indexOf(":"),J===-1?a+=s(d,!1):(a+=s(d.substr(0,J),!1),a+=d.substr(J))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const J=I.charCodeAt(1);J>=65&&J<=90&&(I=`/${String.fromCharCode(J+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const J=I.charCodeAt(0);J>=65&&J<=90&&(I=`${String.fromCharCode(J+32)}:${I.substr(2)}`)}a+=s(I,!0)}return L&&(a+="?",a+=s(L,!1)),B&&(a+="#",a+=i?B:g(B,!1)),a}function u(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+u(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(r)?n.replace(r,i=>u(i)):n}}),define(ve[151],we([1,0,4]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(b){const R=b;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=t;function D(b){const R=[];let k;try{const S=JSON.parse(b.arguments),y=S[S.length-1];y&&y.__$stack&&(S.pop(),k=y.__$stack),R.push(...S)}catch{R.push("Unable to log remote console arguments",b.arguments)}return{args:R,stack:k}}e.parse=D;function C(b){if(typeof b!="string")return C(D(b).stack);const R=b;if(R){const k=T(R),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(S&&S.length===4)return{uri:v.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=C;function T(b){if(!b)return b;const R=b.indexOf(`
`);return R===-1?b:b.substring(0,R)}function P(b,R){const{args:k,stack:S}=D(b),y=typeof k[0]=="string"&&k.length===1;let h=T(S);h&&(h=`(${h.trim()})`);let w=[];if(typeof k[0]=="string"?h&&y?w=[`%c[${R}] %c${k[0]} %c${h}`,p("blue"),p(""),p("grey")]:w=[`%c[${R}] %c${k[0]}`,p("blue"),p(""),...k.slice(1)]:w=[`%c[${R}]%`,p("blue"),...k],h&&!y&&w.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,w)}e.log=P;function p(b){return`color: ${b}`}}),define(ve[48],we([1,0,16,15,4]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(b){return JSON.stringify(b,P)}e.stringify=C;function T(b){let R=JSON.parse(b);return R=p(R),R}e.parse=T;function P(b,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function p(b,R=0){if(!b||R>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof v.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let k=0;k<b.length;++k)b[k]=p(b[k],R+1);else for(const k in b)Object.hasOwnProperty.call(b,k)&&(b[k]=p(b[k],R+1))}return b}e.revive=p}),define(ve[12],we([1,0,3,4]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebook="vscode-notebook",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractive="vscode-interactive",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${D.vscodeRemoteResource}`}set(b,R,k){this._hosts[b]=R,this._ports[b]=k}setConnectionToken(b,R){this._connectionTokens[b]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const R=b.authority;let k=this._hosts[R];k&&k.indexOf(":")!==-1&&k.indexOf("[")===-1&&(k=`[${k}]`);const S=this._ports[R],y=this._connectionTokens[R];let h=`path=${encodeURIComponent(b.path)}`;return typeof y=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),t.URI.from({scheme:v.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${k}:${S}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new C;class T{asBrowserUri(b,R){const k=this.toUri(b,R);return k.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===D.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${D.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?k.with({scheme:D.vscodeFileResource,authority:k.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(b,R){const k=this.toUri(b,R);return k.scheme===D.vscodeFileResource?k.with({scheme:D.file,authority:k.authority!==T.FALLBACK_AUTHORITY?k.authority:null,query:null,fragment:null}):k}toUri(b,R){return t.URI.isUri(b)?b:t.URI.parse(R.toUrl(b))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var P;(function(p){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(b.get("3"));const R="vscode-coi";function k(y){let h;typeof y=="string"?h=new URL(y).searchParams:y instanceof URL?h=y.searchParams:t.URI.isUri(y)&&(h=new URL(y.toString(!0)).searchParams);const w=h?.get(R);if(!!w)return b.get(w)}p.getHeadersFromQuery=k;function S(y,h,w){if(!globalThis.crossOriginIsolated)return;const E=h&&w?"3":w?"2":"1";y instanceof URLSearchParams?y.set(R,E):y[R]=E}p.addSearchParam=S})(P=e.COI||(e.COI={}))}),define(ve[19],we([1,0,36,12,6,3,15,4]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(y){return(0,P.uriToFsPath)(y,!0)}e.originalFSPath=p;class b{constructor(h){this._ignorePathCasing=h}compare(h,w,E=!1){return h===w?0:(0,T.compare)(this.getComparisonKey(h,E),this.getComparisonKey(w,E))}isEqual(h,w,E=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,E)===this.getComparisonKey(w,E)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,E=!1){if(h.scheme===w.scheme){if(h.scheme===t.Schemas.file)return v.isEqualOrParent(p(h),p(w),this._ignorePathCasing(h))&&h.query===w.query&&(E||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return v.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(E||h.fragment===w.fragment)}return!1}joinPath(h,...w){return P.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===t.Schemas.file?w=P.URI.file(D.dirname(p(h))).path:(w=D.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===t.Schemas.file?w=P.URI.file(D.normalize(p(h))).path:w=D.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))return;if(h.scheme===t.Schemas.file){const m=D.relative(p(h),p(w));return C.isWindows?v.toSlashes(m):m}let E=h.path||"/";const g=w.path||"/";if(this._ignorePathCasing(h)){let m=0;for(const f=Math.min(E.length,g.length);m<f&&!(E.charCodeAt(m)!==g.charCodeAt(m)&&E.charAt(m).toLowerCase()!==g.charAt(m).toLowerCase());m++);E=g.substr(0,m)+E.substr(m)}return D.posix.relative(E,g)}resolvePath(h,w){if(h.scheme===t.Schemas.file){const E=P.URI.file(D.resolve(p(h),w));return h.with({authority:E.authority,path:E.path})}return w=v.toPosixPath(w),h.with({path:D.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||h!==void 0&&w!==void 0&&(0,T.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=D.sep){if(h.scheme===t.Schemas.file){const E=p(h);return E.length>v.getRoot(E).length&&E[E.length-1]===w}else{const E=h.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=D.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=D.sep){let E=!1;if(h.scheme===t.Schemas.file){const g=p(h);E=g!==void 0&&g.length===v.getRoot(g).length&&g[g.length-1]===w}else{w="/";const g=h.path;E=g.length===1&&g.charCodeAt(g.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(y=>y.scheme===t.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new b(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(y,h){const w=[];for(let E=0;E<y.length;E++){const g=h(y[E]);y.some((m,f)=>f===E?!1:(0,e.isEqualOrParent)(g,h(m)))||w.push(y[E])}return w}e.distinctParents=R;var k;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function h(w){const E=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,u]=f.split(":");c&&u&&E.set(c,u)});const m=w.path.substring(0,w.path.indexOf(";"));return m&&E.set(y.META_DATA_MIME,m),E}y.parseMetaData=h})(k=e.DataUri||(e.DataUri={}));function S(y,h,w){if(h){let E=y.path;return E&&E[0]!==D.posix.sep&&(E=D.posix.sep+E),y.with({scheme:w,authority:h,path:E})}return y.with({scheme:w})}e.toLocalResource=S}),define(ve[14],we([1,0,20,10,7,2,19,3]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(re){return!!re&&typeof re.then=="function"}e.isThenable=p;function b(re){const F=new v.CancellationTokenSource,M=re(F.token),G=new Promise((ie,he)=>{const Ee=F.token.onCancellationRequested(()=>{Ee.dispose(),F.dispose(),he(new t.CancellationError)});Promise.resolve(M).then($=>{Ee.dispose(),F.dispose(),ie($)},$=>{Ee.dispose(),F.dispose(),he($)})});return new class{cancel(){F.cancel()}then(ie,he){return G.then(ie,he)}catch(ie){return this.then(void 0,ie)}finally(ie){return G.finally(ie)}}}e.createCancelablePromise=b;function R(re,F,M){return new Promise((G,ie)=>{const he=F.onCancellationRequested(()=>{he.dispose(),G(M)});re.then(G,ie).finally(()=>he.dispose())})}e.raceCancellation=R;function k(re,F){return new Promise((M,G)=>{const ie=F.onCancellationRequested(()=>{ie.dispose(),G(new t.CancellationError)});re.then(M,G).finally(()=>ie.dispose())})}e.raceCancellationError=k;async function S(re){let F=-1;const M=re.map((ie,he)=>ie.then(Ee=>(F=he,Ee))),G=await Promise.race(M);return re.forEach((ie,he)=>{he!==F&&ie.cancel()}),G}e.raceCancellablePromises=S;function y(re,F,M){let G;const ie=setTimeout(()=>{G?.(void 0),M?.()},F);return Promise.race([re.finally(()=>clearTimeout(ie)),new Promise(he=>G=he)])}e.raceTimeout=y;function h(re){return new Promise((F,M)=>{const G=re();p(G)?G.then(F,M):F(G)})}e.asPromise=h;class w{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(M,M).then(G)})}return new Promise((M,G)=>{this.queuedPromise.then(M,G)})}return this.activePromise=F(),new Promise((M,G)=>{this.activePromise.then(ie=>{this.activePromise=null,M(ie)},ie=>{this.activePromise=null,G(ie)})})}}e.Throttler=w;class E{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=E;class g{constructor(){this.promiseMap=new Map}queue(F,M){const ie=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===ie&&this.promiseMap.delete(F)});return this.promiseMap.set(F,ie),ie}}e.SequencerByKey=g;const m=(re,F)=>{let M=!0;const G=setTimeout(()=>{M=!1,F()},re);return{isTriggered:()=>M,dispose:()=>{clearTimeout(G),M=!1}}},f=re=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,re())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ie,he)=>{this.doResolve=ie,this.doReject=he}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ie=this.task;return this.task=null,ie()}}));const G=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?f(G):m(M,G),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class u{constructor(F){this.delayer=new c(F),this.throttler=new w}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class r{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class o extends r{constructor(F){super(),this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function n(re,F){return F?new Promise((M,G)=>{const ie=setTimeout(()=>{he.dispose(),M()},re),he=F.onCancellationRequested(()=>{clearTimeout(ie),he.dispose(),G(new t.CancellationError)})}):b(M=>n(re,M))}e.timeout=n;function i(re,F=0){const M=setTimeout(re,F);return(0,C.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=i;function s(re){const F=[];let M=0;const G=re.length;function ie(){return M<G?re[M++]():null}function he(Ee){Ee!=null&&F.push(Ee);const $=ie();return $?$.then(he):Promise.resolve(F)}return Promise.resolve(null).then(he)}e.sequence=s;function a(re,F=G=>!!G,M=null){let G=0;const ie=re.length,he=()=>{if(G>=ie)return Promise.resolve(M);const Ee=re[G++];return Promise.resolve(Ee()).then(Y=>F(Y)?Promise.resolve(Y):he())};return he()}e.first=a;function l(re,F=G=>!!G,M=null){if(re.length===0)return Promise.resolve(M);let G=re.length;const ie=()=>{G=-1;for(const he of re)he.cancel?.()};return new Promise((he,Ee)=>{for(const $ of re)$.then(Y=>{--G>=0&&F(Y)?(ie(),he(Y)):G===0&&he(M)}).catch(Y=>{--G>=0&&(ie(),Ee(Y))})})}e.firstParallel=l;class d{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,G)=>{this.outstandingPromises.push({factory:F,c:M,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class I extends d{constructor(){super(1)}}e.Queue=I;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new O;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,M=T.extUri){const G=M.getComparisonKey(F);let ie=this.queues.get(G);return ie||(ie=new I,D.Event.once(ie.onDrained)(()=>{ie?.dispose(),this.queues.delete(G),this.onDidQueueDrain()}),this.queues.set(G,ie)),ie}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class B{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=B;class J{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=J;class Z{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Z;class _{constructor(F,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=_;class te extends Z{constructor(F,M){super(F,M),this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner?.(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=te;class se extends C.Disposable{constructor(F,M){super(),this.options=F,this.handler=M,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.options.maxBufferedWork)return!1}else if(this.pending+F.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Z(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=re=>{(0,P.setTimeout0)(()=>{if(F)return;const M=Date.now()+15;re(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(re,F)=>{const M=requestIdleCallback(re,typeof F=="number"?{timeout:F}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(M))}}}}();class W{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=W;async function fe(re,F,M){let G;for(let ie=0;ie<M;ie++)try{return await re()}catch(he){G=he,await n(F)}throw G}e.retry=fe;class j{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(F,M,G){return this._pending={taskId:F,cancel:()=>G?.(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,G;const ie=new Promise((he,Ee)=>{M=he,G=Ee});this._next={run:F,promise:ie,promiseResolve:M,promiseReject:G}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=j;class X{constructor(F,M=()=>Date.now()){this.interval=F,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=X;class O{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback(new t.CancellationError),this.rejected=!0,F()})}}e.DeferredPromise=O;var U;(function(re){async function F(G){let ie;const he=await Promise.all(G.map(Ee=>Ee.then($=>$,$=>{ie||(ie=$)})));if(typeof ie<"u")throw ie;return he}re.settled=F;function M(G){return new Promise(async(ie,he)=>{try{await G(ie,he)}catch(Ee){he(Ee)}})}re.withAsyncBody=M})(U=e.Promises||(e.Promises={}));var x;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(x||(x={}));class ae{static fromArray(F){return new ae(M=>{M.emitMany(F)})}static fromPromise(F){return new ae(async M=>{M.emitMany(await F)})}static fromPromises(F){return new ae(async M=>{await Promise.all(F.map(async G=>M.emitOne(await G)))})}static merge(F){return new ae(async M=>{await Promise.all(F.map(async G=>{for await(const ie of G)M.emitOne(ie)}))})}constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const M={emitOne:G=>this.emitOne(G),emitMany:G=>this.emitMany(G),reject:G=>this.reject(G)};try{await Promise.resolve(F(M)),this.resolve()}catch(G){this.reject(G)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,M){return new ae(async G=>{for await(const ie of F)G.emitOne(M(ie))})}map(F){return ae.map(this,F)}static filter(F,M){return new ae(async G=>{for await(const ie of F)M(ie)&&G.emitOne(ie)})}filter(F){return ae.filter(this,F)}static coalesce(F){return ae.filter(F,M=>!!M)}coalesce(){return ae.coalesce(this)}static async toPromise(F){const M=[];for await(const G of F)M.push(G);return M}toPromise(){return ae.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=ae,ae.EMPTY=ae.fromArray([]);class ue extends ae{constructor(F,M){super(M),this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ue;function Q(re){const F=new v.CancellationTokenSource,M=re(F.token);return new ue(F,async G=>{const ie=F.token.onCancellationRequested(()=>{ie.dispose(),F.dispose(),G.reject(new t.CancellationError)});try{for await(const he of M){if(F.token.isCancellationRequested)return;G.emitOne(he)}ie.dispose(),F.dispose()}catch(he){ie.dispose(),F.dispose(),G.reject(he)}})}e.createCancelableAsyncIterable=Q}),define(ve[68],we([1,0,18,14,36,24,6,3,15]),function(oe,e,v,t,D,C,T,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",k="[^/\\\\]",S=/\//g;function y(O,U){switch(O){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${U?`|${R}${k}+`:""})*?`}}function h(O,U){if(!O)return[];const x=[];let ae=!1,ue=!1,Q="";for(const re of O){switch(re){case U:if(!ae&&!ue){x.push(Q),Q="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Q+=re}return Q&&x.push(Q),x}e.splitGlobAware=h;function w(O){if(!O)return"";let U="";const x=h(O,e.GLOB_SPLIT);if(x.every(ae=>ae===e.GLOBSTAR))U=".*";else{let ae=!1;x.forEach((ue,Q)=>{if(ue===e.GLOBSTAR){if(ae)return;U+=y(2,Q===x.length-1)}else{let re=!1,F="",M=!1,G="";for(const ie of ue){if(ie!=="}"&&re){F+=ie;continue}if(M&&(ie!=="]"||!G)){let he;ie==="-"?he=ie:(ie==="^"||ie==="!")&&!G?he="^":ie===e.GLOB_SPLIT?he="":he=(0,p.escapeRegExpCharacters)(ie),G+=he;continue}switch(ie){case"{":re=!0;continue;case"[":M=!0;continue;case"}":{U+=`(?:${h(F,",").map($=>w($)).join("|")})`,re=!1,F="";break}case"]":{U+="["+G+"]",M=!1,G="";break}case"?":U+=k;continue;case"*":U+=y(1);continue;default:U+=(0,p.escapeRegExpCharacters)(ie)}}Q<x.length-1&&(x[Q+1]!==e.GLOBSTAR||Q+2<x.length)&&(U+=R)}ae=ue===e.GLOBSTAR})}return U}const E=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new C.LRUCache(1e4),o=function(){return!1},n=function(){return null};function i(O,U){if(!O)return n;let x;typeof O!="string"?x=O.pattern:x=O,x=x.trim();const ae=`${x}_${!!U.trimForExclusions}`;let ue=r.get(ae);if(ue)return s(ue,O);let Q;return E.test(x)?ue=l(x.substr(4),x):(Q=g.exec(a(x,U)))?ue=d(Q[1],x):(U.trimForExclusions?f:m).test(x)?ue=I(x,U):(Q=c.exec(a(x,U)))?ue=L(Q[1].substr(1),x,!0):(Q=u.exec(a(x,U)))?ue=L(Q[1],x,!1):ue=B(x),r.set(ae,ue),s(ue,O)}function s(O,U){if(typeof U=="string")return O;const x=function(ae,ue){return(0,D.isEqualOrParent)(ae,U.base,!P.isLinux)?O(ae.substr(U.base.length+1),ue):null};return x.allBasenames=O.allBasenames,x.allPaths=O.allPaths,x.basenames=O.basenames,x.patterns=O.patterns,x}function a(O,U){return U.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function l(O,U){return function(x,ae){return typeof x=="string"&&x.endsWith(O)?U:null}}function d(O,U){const x=`/${O}`,ae=`\\${O}`,ue=function(re,F){return typeof re!="string"?null:F?F===O?U:null:re===O||re.endsWith(x)||re.endsWith(ae)?U:null},Q=[O];return ue.basenames=Q,ue.patterns=[U],ue.allBasenames=Q,ue}function I(O,U){const x=j(O.slice(1,-1).split(",").map(F=>i(F,U)).filter(F=>F!==n),O),ae=x.length;if(!ae)return n;if(ae===1)return x[0];const ue=function(F,M){for(let G=0,ie=x.length;G<ie;G++)if(x[G](F,M))return O;return null},Q=x.find(F=>!!F.allBasenames);Q&&(ue.allBasenames=Q.allBasenames);const re=x.reduce((F,M)=>M.allPaths?F.concat(M.allPaths):F,[]);return re.length&&(ue.allPaths=re),ue}function L(O,U,x){const ae=T.sep===T.posix.sep,ue=ae?O:O.replace(S,T.sep),Q=T.sep+ue,re=T.posix.sep+O;let F;return x?F=function(M,G){return typeof M=="string"&&(M===ue||M.endsWith(Q)||!ae&&(M===O||M.endsWith(re)))?U:null}:F=function(M,G){return typeof M=="string"&&(M===ue||!ae&&M===O)?U:null},F.allPaths=[(x?"*/":"./")+O],F}function B(O){try{const U=new RegExp(`^${w(O)}$`);return function(x){return U.lastIndex=0,typeof x=="string"&&U.test(x)?O:null}}catch{return n}}function J(O,U,x){return!O||typeof U!="string"?!1:Z(O)(U,void 0,x)}e.match=J;function Z(O,U={}){if(!O)return o;if(typeof O=="string"||_(O)){const x=i(O,U);if(x===n)return o;const ae=function(ue,Q){return!!x(ue,Q)};return x.allBasenames&&(ae.allBasenames=x.allBasenames),x.allPaths&&(ae.allPaths=x.allPaths),ae}return W(O,U)}e.parse=Z;function _(O){const U=O;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}e.isRelativePattern=_;function te(O){return O.allBasenames||[]}e.getBasenameTerms=te;function se(O){return O.allPaths||[]}e.getPathTerms=se;function W(O,U){const x=j(Object.getOwnPropertyNames(O).map(F=>fe(F,O[F],U)).filter(F=>F!==n)),ae=x.length;if(!ae)return n;if(!x.some(F=>!!F.requiresSiblings)){if(ae===1)return x[0];const F=function(ie,he){let Ee;for(let $=0,Y=x.length;$<Y;$++){const ee=x[$](ie,he);if(typeof ee=="string")return ee;(0,t.isThenable)(ee)&&(Ee||(Ee=[]),Ee.push(ee))}return Ee?(async()=>{for(const $ of Ee){const Y=await $;if(typeof Y=="string")return Y}return null})():null},M=x.find(ie=>!!ie.allBasenames);M&&(F.allBasenames=M.allBasenames);const G=x.reduce((ie,he)=>he.allPaths?ie.concat(he.allPaths):ie,[]);return G.length&&(F.allPaths=G),F}const ue=function(F,M,G){let ie,he;for(let Ee=0,$=x.length;Ee<$;Ee++){const Y=x[Ee];Y.requiresSiblings&&G&&(M||(M=(0,T.basename)(F)),ie||(ie=M.substr(0,M.length-(0,T.extname)(F).length)));const ee=Y(F,M,ie,G);if(typeof ee=="string")return ee;(0,t.isThenable)(ee)&&(he||(he=[]),he.push(ee))}return he?(async()=>{for(const Ee of he){const $=await Ee;if(typeof $=="string")return $}return null})():null},Q=x.find(F=>!!F.allBasenames);Q&&(ue.allBasenames=Q.allBasenames);const re=x.reduce((F,M)=>M.allPaths?F.concat(M.allPaths):F,[]);return re.length&&(ue.allPaths=re),ue}function fe(O,U,x){if(U===!1)return n;const ae=i(O,x);if(ae===n)return n;if(typeof U=="boolean")return ae;if(U){const ue=U.when;if(typeof ue=="string"){const Q=(re,F,M,G)=>{if(!G||!ae(re,F))return null;const ie=ue.replace("$(basename)",M),he=G(ie);return(0,t.isThenable)(he)?he.then(Ee=>Ee?O:null):he?O:null};return Q.requiresSiblings=!0,Q}}return ae}function j(O,U){const x=O.filter(F=>!!F.basenames);if(x.length<2)return O;const ae=x.reduce((F,M)=>{const G=M.basenames;return G?F.concat(G):F},[]);let ue;if(U){ue=[];for(let F=0,M=ae.length;F<M;F++)ue.push(U)}else ue=x.reduce((F,M)=>{const G=M.patterns;return G?F.concat(G):F},[]);const Q=function(F,M){if(typeof F!="string")return null;if(!M){let ie;for(ie=F.length;ie>0;ie--){const he=F.charCodeAt(ie-1);if(he===47||he===92)break}M=F.substr(ie)}const G=ae.indexOf(M);return G!==-1?ue[G]:null};Q.basenames=ae,Q.patterns=ue,Q.allBasenames=ae;const re=O.filter(F=>!F.basenames);return re.push(Q),re}function X(O,U){return(0,v.equals)(O,U,(x,ae)=>typeof x=="string"&&typeof ae=="string"?x===ae:typeof x!="string"&&typeof ae!="string"?x.base===ae.base&&x.pattern===ae.pattern:!1)}e.patternsEquals=X}),define(ve[90],we([1,0,10,150,19,15,4]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(E){E[E.Paragraph=0]="Paragraph",E[E.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class p{constructor(g="",m=!1){if(this.value=g,typeof this.value!="string")throw(0,v.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(g,m=0){return this.value+=S(this.supportThemeIcons?(0,t.escapeIcons)(g):g).replace(/([ \t]+)/g,(f,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,m){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(g,m,f){return this.value+="[",this.value+=this._escape(m,"]"),this.value+="](",this.value+=this._escape(String(g),")"),f&&(this.value+=` "${this._escape(this._escape(f,'"'),")")}"`),this.value+=")",this}_escape(g,m){const f=new RegExp((0,C.escapeRegExpCharacters)(m),"g");return g.replace(f,(c,u)=>g.charAt(u-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=p;function b(E){return R(E)?!E.value:Array.isArray(E)?E.every(b):!0}e.isEmptyMarkdownString=b;function R(E){return E instanceof p?!0:E&&typeof E=="object"?typeof E.value=="string"&&(typeof E.isTrusted=="boolean"||E.isTrusted===void 0)&&(typeof E.supportThemeIcons=="boolean"||E.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function k(E,g){return E===g?!0:!E||!g?!1:E.value===g.value&&E.isTrusted===g.isTrusted&&E.supportThemeIcons===g.supportThemeIcons&&E.supportHtml===g.supportHtml&&(E.baseUri===g.baseUri||!!E.baseUri&&!!g.baseUri&&(0,D.isEqual)(T.URI.from(E.baseUri),T.URI.from(g.baseUri)))}e.markdownStringEqual=k;function S(E){return E.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function y(E){return E.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=y;function h(E){return E&&E.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function w(E){const g=[],m=E.split("|").map(c=>c.trim());E=m[0];const f=m[1];if(f){const c=/height=(\d+)/.exec(f),u=/width=(\d+)/.exec(f),r=c?c[1]:"",o=u?u[1]:"",n=isFinite(parseInt(o)),i=isFinite(parseInt(r));n&&g.push(`width="${o}"`),i&&g.push(`height="${r}"`)}return{href:E,dimensions:g}}e.parseHrefAndDimensions=w}),define(ve[152],we([1,0,18,36,6,3,19,15]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function p(n,i){const{os:s,tildify:a,relative:l}=i;if(l){const L=b(n,l,s);if(typeof L=="string")return L}let d=n.fsPath;if(s===1&&!C.isWindows?d=d.replace(/\//g,"\\"):s!==1&&C.isWindows&&(d=d.replace(/\\/g,"/")),s!==1&&a?.userHome){const L=a.userHome.fsPath;let B;n.scheme!==a.userHome.scheme&&n.path.startsWith(D.posix.sep)?B=a.userHome.with({path:n.path}).fsPath:B=n.fsPath,d=S(B,L,s)}return(s===1?D.win32:D.posix).normalize(R(d,s===1))}e.getPathLabel=p;function b(n,i,s){const a=s===1?D.win32:D.posix,l=s===3?T.extUri:T.extUriIgnorePathCase,d=i.getWorkspace(),I=(0,v.firstOrDefault)(d.folders);if(!I)return;n.scheme!==I.uri.scheme&&n.path.startsWith(D.posix.sep)&&(n=I.uri.with({path:n.path}));const L=i.getWorkspaceFolder(n);if(!L)return;let B;if(l.isEqual(L.uri,n)?B="":B=l.relativePath(L.uri,n)??"",B&&(B=a.normalize(B)),d.folders.length>1&&!i.noPrefix){const J=L.name?L.name:l.basenameOrAuthority(L.uri);B=B?`${J} \u2022 ${B}`:J}return B}function R(n,i=C.isWindows){return(0,t.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=R;let k=Object.create(null);function S(n,i,s=C.OS){if(s===1||!n||!i)return n;let a=k.original===i?k.normalized:void 0;a||(a=i,C.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,P.rtrim)(a,D.posix.sep)}${D.posix.sep}`,k={original:i,normalized:a});let l=n;return C.isWindows&&(l=(0,t.toSlashes)(l)),(s===3?l.startsWith(a):(0,P.startsWithIgnoreCase)(l,a))?`~/${l.substr(a.length)}`:n}e.tildify=S;function y(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=y;const h="\u2026",w="\\\\",E="~";function g(n,i=D.sep){const s=new Array(n.length);let a=!1;for(let l=0;l<n.length;l++){const d=n[l];if(d===""){s[l]=`.${i}`;continue}if(!d){s[l]=d;continue}a=!0;let I="",L=d;L.indexOf(w)===0?(I=L.substr(0,L.indexOf(w)+w.length),L=L.substr(L.indexOf(w)+w.length)):L.indexOf(i)===0?(I=L.substr(0,L.indexOf(i)+i.length),L=L.substr(L.indexOf(i)+i.length)):L.indexOf(E)===0&&(I=L.substr(0,L.indexOf(E)+E.length),L=L.substr(L.indexOf(E)+E.length));const B=L.split(i);for(let J=1;a&&J<=B.length;J++)for(let Z=B.length-J;a&&Z>=0;Z--){a=!1;let _=B.slice(Z,Z+J).join(i);for(let te=0;!a&&te<n.length;te++)if(te!==l&&n[te]&&n[te].indexOf(_)>-1){const se=Z+J===B.length,W=Z>0&&n[te].indexOf(i)>-1?i+_:_,fe=n[te].endsWith(W);a=!se||fe}if(!a){let te="";(B[0].endsWith(":")||I!=="")&&(Z===1&&(Z=0,J++,_=B[0]+i+_),Z>0&&(te=B[0]+i),te=I+te),Z>0&&(te=te+h+i),te=te+_,Z+J<B.length&&(te=te+i+h),s[l]=te}}a&&(s[l]=d)}return s}e.shorten=g;var m;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function f(n,i=Object.create(null)){const s=[];let a=!1,l="";for(const d of n)if(d==="$"||a&&d==="{")l&&s.push({value:l,type:m.TEXT}),l="",a=!0;else if(d==="}"&&a){const I=i[l];if(typeof I=="string")I.length&&s.push({value:I,type:m.VARIABLE});else if(I){const L=s[s.length-1];(!L||L.type!==m.SEPARATOR)&&s.push({value:I.label,type:m.SEPARATOR})}l="",a=!1}else l+=d;return l&&!a&&s.push({value:l,type:m.TEXT}),s.filter((d,I)=>{if(d.type===m.SEPARATOR){const L=s[I-1],B=s[I+1];return[L,B].every(J=>J&&(J.type===m.VARIABLE||J.type===m.TEXT)&&J.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=f;function c(n,i){return C.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function u(n,i){return C.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):C.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=u;function r(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(n){const i=n.indexOf("/")!==-1?D.posix:D.win32,s=i.basename(n),a=i.dirname(n);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=o}),define(ve[69],we([1,0,4]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const S=this._uriTransformer.transformIncoming(k);return S===k?k:t(v.URI.from(S))}transformOutgoing(k){const S=this._uriTransformer.transformOutgoing(k);return S===k?k:t(v.URI.from(S))}transformOutgoingURI(k){const S=this._uriTransformer.transformOutgoing(k);return S===k?k:v.URI.from(S)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function C(R,k,S){if(!R||S>200)return null;if(typeof R=="object"){if(R instanceof v.URI)return k.transformOutgoing(R);for(const y in R)if(Object.hasOwnProperty.call(R,y)){const h=C(R[y],k,S+1);h!==null&&(R[y]=h)}}return null}function T(R,k){const S=C(R,k,0);return S===null?R:S}e.transformOutgoingURIs=T;function P(R,k,S,y){if(!R||y>200)return null;if(typeof R=="object"){if(R.$mid===1)return S?v.URI.revive(k.transformIncoming(R)):k.transformIncoming(R);for(const h in R)if(Object.hasOwnProperty.call(R,h)){const w=P(R[h],k,S,y+1);w!==null&&(R[h]=w)}}return null}function p(R,k){const S=P(R,k,!1,0);return S===null?R:S}e.transformIncomingURIs=p;function b(R,k){const S=P(R,k,!0,0);return S===null?R:S}e.transformAndReviveIncomingURIs=b}),define(ve[91],we([1,0,30,10,24,23,139]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,k=0;const S=(0,v.networkInterfaces)();for(const y in S){const h=S[y];if(h)for(const{mac:w,internal:E}of h)E||(k+=1,this._isVirtualMachineMacAddress(w.toUpperCase())&&(R+=1))}this._value=k>0?R/k:0}return this._value}};let P;async function p(){return P||(P=(async()=>await b()||C.generateUuid())()),P}e.getMachineId=p;async function b(){try{const R=await new Promise((S,y)=>{oe(["crypto"],S,y)}),k=(0,T.getMac)();return R.createHash("sha256").update(k,"utf8").digest("hex")}catch(R){t.onUnexpectedError(R);return}}}),define(ve[21],we([1,0,29,30,265,14,36,89,6,3,19,4]),function(oe,e,v,t,D,C,T,P,p,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function y(W,fe=S.UNLINK){if((0,T.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return fe===S.UNLINK?w(W):h(W)}async function h(W){try{const fe=(0,T.randomPath)((0,t.tmpdir)());try{await v.promises.rename(W,fe)}catch(j){return j.code==="ENOENT"?void 0:w(W)}w(fe).catch(j=>{})}catch(fe){if(fe.code!=="ENOENT")throw fe}}async function w(W){return(0,D.promisify)(v.rm)(W,{recursive:!0,force:!0,maxRetries:3})}function E(W){if((0,T.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=E;async function g(W,fe){return c(await(fe?m(W):(0,D.promisify)(v.readdir)(W)))}async function m(W){try{return await(0,D.promisify)(v.readdir)(W,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const fe=[],j=await g(W);for(const X of j){let O=!1,U=!1,x=!1;try{const ae=await e.Promises.lstat((0,p.join)(W,X));O=ae.isFile(),U=ae.isDirectory(),x=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}fe.push({name:X,isFile:()=>O,isDirectory:()=>U,isSymbolicLink:()=>x})}return fe}function f(W){return c(v.readdirSync(W))}e.readdirSync=f;function c(W){return W.map(fe=>typeof fe=="string"?b.isMacintosh?(0,P.normalizeNFC)(fe):fe:(fe.name=b.isMacintosh?(0,P.normalizeNFC)(fe.name):fe.name,fe))}async function u(W){const fe=await g(W),j=[];for(const X of fe)await o.existsDirectory((0,p.join)(W,X))&&j.push(X);return j}function r(W,fe=1e3){return new Promise(j=>{let X=!1;const O=setInterval(()=>{X||(X=!0,v.access(W,U=>{X=!1,U&&(clearInterval(O),j(void 0))}))},fe)})}e.whenDeleted=r;var o;(function(W){async function fe(O){let U;try{if(U=await e.Promises.lstat(O),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await e.Promises.stat(O),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(b.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(O)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw ae}throw x}}W.stat=fe;async function j(O){try{const{stat:U,symbolicLink:x}=await W.stat(O);return U.isFile()&&x?.dangling!==!0}catch{}return!1}W.existsFile=j;async function X(O){try{const{stat:U,symbolicLink:x}=await W.stat(O);return U.isDirectory()&&x?.dangling!==!0}catch{}return!1}W.existsDirectory=X})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new C.ResourceQueue;function i(W,fe,j){return n.queueFor(k.URI.file(W),R.extUriBiasedIgnorePathCase).queue(()=>{const X=I(j);return new Promise((O,U)=>l(W,fe,X,x=>x?U(x):O()))})}let s=!0;function a(W){s=W}e.configureFlushOnWrite=a;function l(W,fe,j,X){if(!s)return v.writeFile(W,fe,{mode:j.mode,flag:j.flag},X);v.open(W,j.flag,j.mode,(O,U)=>{if(O)return X(O);v.writeFile(U,fe,x=>{if(x)return v.close(U,()=>X(x));v.fdatasync(U,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),a(!1)),v.close(U,ue=>X(ue))))})})}function d(W,fe,j){const X=I(j);if(!s)return v.writeFileSync(W,fe,{mode:X.mode,flag:X.flag});const O=v.openSync(W,X.flag,X.mode);try{v.writeFileSync(O,fe);try{v.fdatasyncSync(O)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),a(!1)}}finally{v.closeSync(O)}}e.writeFileSync=d;function I(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function L(W,fe){if(W!==fe)try{await e.Promises.rename(W,fe)}catch(j){if(W.toLowerCase()!==fe.toLowerCase()&&j.code==="EXDEV"||W.endsWith("."))await B(W,fe,{preserveSymlinks:!1}),await y(W,S.MOVE);else throw j}}async function B(W,fe,j){return Z(W,fe,{root:{source:W,target:fe},options:j,handledSourcePaths:new Set})}const J=511;async function Z(W,fe,j){if(j.handledSourcePaths.has(W))return;j.handledSourcePaths.add(W);const{stat:X,symbolicLink:O}=await o.stat(W);if(O){if(j.options.preserveSymlinks)try{return await se(W,fe,j)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(O.dangling)return}return X.isDirectory()?_(W,fe,X.mode&J,j):te(W,fe,X.mode&J)}async function _(W,fe,j,X){await e.Promises.mkdir(fe,{recursive:!0,mode:j});const O=await g(W);for(const U of O)await Z((0,p.join)(W,U),(0,p.join)(fe,U),X)}async function te(W,fe,j){await e.Promises.copyFile(W,fe),await e.Promises.chmod(fe,j)}async function se(W,fe,j){let X=await e.Promises.readlink(W);(0,T.isEqualOrParent)(X,j.root.source,!b.isLinux)&&(X=(0,p.join)(j.root.target,X.substr(j.root.source.length+1))),await e.Promises.symlink(X,fe)}e.Promises=new class{get access(){return(0,D.promisify)(v.access)}get stat(){return(0,D.promisify)(v.stat)}get lstat(){return(0,D.promisify)(v.lstat)}get utimes(){return(0,D.promisify)(v.utimes)}get read(){return(W,fe,j,X,O)=>new Promise((U,x)=>{v.read(W,fe,j,X,O,(ae,ue,Q)=>ae?x(ae):U({bytesRead:ue,buffer:Q}))})}get readFile(){return(0,D.promisify)(v.readFile)}get write(){return(W,fe,j,X,O)=>new Promise((U,x)=>{v.write(W,fe,j,X,O,(ae,ue,Q)=>ae?x(ae):U({bytesWritten:ue,buffer:Q}))})}get appendFile(){return(0,D.promisify)(v.appendFile)}get fdatasync(){return(0,D.promisify)(v.fdatasync)}get truncate(){return(0,D.promisify)(v.truncate)}get rename(){return(0,D.promisify)(v.rename)}get copyFile(){return(0,D.promisify)(v.copyFile)}get open(){return(0,D.promisify)(v.open)}get close(){return(0,D.promisify)(v.close)}get symlink(){return(0,D.promisify)(v.symlink)}get readlink(){return(0,D.promisify)(v.readlink)}get chmod(){return(0,D.promisify)(v.chmod)}get mkdir(){return(0,D.promisify)(v.mkdir)}get unlink(){return(0,D.promisify)(v.unlink)}get rmdir(){return(0,D.promisify)(v.rmdir)}get realpath(){return(0,D.promisify)(v.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return y}get move(){return L}get copy(){return B}}}),define(ve[153],we([1,0,29,6,3,15,21]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(S){if(D.isLinux)return S;const y=(0,t.dirname)(S);if(S===y)return S;const h=((0,t.basename)(S)||S).toLowerCase();try{const E=(0,T.readdirSync)(y).filter(g=>g.toLowerCase()===h);if(E.length===1){const g=P(y);if(g)return(0,t.join)(g,E[0])}else if(E.length>1){const g=E.indexOf(h);if(g>=0){const m=P(y);if(m)return(0,t.join)(m,E[g])}}}catch{}return null}e.realcaseSync=P;async function p(S){if(D.isLinux)return S;const y=(0,t.dirname)(S);if(S===y)return S;const h=((0,t.basename)(S)||S).toLowerCase();try{const E=(await T.Promises.readdir(y)).filter(g=>g.toLowerCase()===h);if(E.length===1){const g=await p(y);if(g)return(0,t.join)(g,E[0])}else if(E.length>1){const g=E.indexOf(h);if(g>=0){const m=await p(y);if(m)return(0,t.join)(m,E[g])}}}catch{}return null}e.realcase=p;async function b(S){try{return await T.Promises.realpath(S)}catch{const h=k(S);return await T.Promises.access(h,v.constants.R_OK),h}}e.realpath=b;function R(S){try{return v.realpathSync(S)}catch{const h=k(S);return v.accessSync(h,v.constants.R_OK),h}}e.realpathSync=R;function k(S){return(0,C.rtrim)((0,t.normalize)(S),t.sep)}}),define(ve[92],we([1,0,30,6,21]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,T=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var p;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(p||(p={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class k{constructor(u,r,o){this.exePath=u,this.displayName=r,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:c=!1}={}){return c?b===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:c=!1,findPreview:u=!1}={}){const r=S({useAlternateBitness:c});if(!r)return null;const o=t.join(r,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let n=-1,i=null;for(const l of await D.Promises.readdir(o)){let d=-1;if(u){const L=l.indexOf("-");if(L<0)continue;const B=l.substring(0,L);if(!C.test(B)||l.substring(L+1)!=="preview")continue;d=parseInt(B,10)}else{if(!C.test(l))continue;d=parseInt(l,10)}if(d<=n)continue;const I=t.join(o,l,"pwsh.exe");!await D.SymlinkSupport.existsFile(I)||(i=I,n=d)}if(!i)return null;const s=r.includes("x86")?" (x86)":"",a=u?" Preview":"";return new k(i,`PowerShell${a}${s}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const u=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:r,pwshMsixName:o}=c?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(u))if(r.test(n)){const i=t.join(u,n,"pwsh.exe");return new k(i,o)}return null}function w(){const c=t.join(v.homedir(),".dotnet","tools","pwsh.exe");return new k(c,".NET Core PowerShell Global Tool")}function E(){const c=t.join(process.env.windir,b===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(c,"Windows PowerShell",!0)}async function*g(){let c=await y();c&&(yield c),c=await y({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=w(),c&&(yield c),c=await y({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await y({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=E(),c&&(yield c)}async function*m(){for await(const c of g())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=m;async function f(){for await(const c of m())return c;return null}e.getFirstAvailablePowerShellInstallation=f}),define(ve[93],we([1,0,6,3,28,56,11,21]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function p(k=D.env){return k.comspec||"cmd.exe"}e.getWindowsShell=p;function b(k){let S=[],y=!1;const h=function(w){if(y){S.push(w);return}(!k.send(w,g=>{if(g&&console.error(g),y=!1,S.length>0){const m=S.slice(0);S=[],m.forEach(f=>h(f))}})||t.isWindows)&&(y=!0)};return{send:h}}e.createQueuedSender=b;var R;(function(k){async function S(y,h,w){if(v.isAbsolute(y))return y;if(h===void 0&&(h=D.cwd()),v.dirname(y)!=="."||(w===void 0&&T.isString(D.env.PATH)&&(w=D.env.PATH.split(v.delimiter)),w===void 0||w.length===0))return v.join(h,y);async function g(m){if(await P.Promises.exists(m)){let f;try{f=await P.Promises.stat(m)}catch(c){c.message.startsWith("EACCES")&&(f=await P.Promises.lstat(m))}return f?!f.isDirectory():!1}return!1}for(const m of w){let f;if(v.isAbsolute(m)?f=v.join(m,y):f=v.join(h,m,y),await g(f))return f;let c=f+".com";if(await g(c)||(c=f+".exe",await g(c)))return c}return v.join(h,y)}k.findExecutable=S})(R=e.win32||(e.win32={}))}),define(ve[94],we([1,0,49,12]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(T){return new Promise((P,p)=>{let b;const R=new Map;function k(y,h,w,E,g){const m=R.get(h);if(y===T||m){const f={name:S(w),cmd:w,pid:y,ppid:h,load:E,mem:g};R.set(y,f),y===T&&(b=f),m&&(m.children||(m.children=[]),m.children.push(f),m.children.length>1&&(m.children=m.children.sort((c,u)=>c.pid-u.pid)))}}function S(y){const h=/--vscode-window-kind=shared-process/,w=/--vscode-window-kind=issue-reporter/,E=/--vscode-window-kind=process-explorer/,g=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,f=/--crashes-directory/,c=/\\pipe\\winpty-control/,u=/conhost\.exe/,r=/--type=([a-zA-Z-]+)/;if(f.exec(y))return"electron-crash-reporter";if(c.exec(y))return"winpty-process";if(u.exec(y))return"console-window-host (Windows internal process)";let o=r.exec(y);if(o&&o.length===2){if(o[1]==="renderer")return h.exec(y)?"shared-process":w.exec(y)?"issue-reporter":E.exec(y)?"process-explorer":"window";if(o[1]==="utility"){if(g.exec(y))return"utility-network-service";if(m.exec(y))return"extension-host"}return o[1]}const n=/[a-zA-Z-]+\.js/g;let i="";do o=n.exec(y),o&&(i+=o+" ");while(o);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,w)=>{oe(["windows-process-tree"],h,w)}).then(h=>{h.getProcessList(T,w=>{if(!w){p(new Error(`Root process ${T} not found`));return}h.getProcessCpuUsage(w,E=>{const g=new Map;E.forEach(m=>{const f=y(m.commandLine||"");g.set(m.pid,{name:S(f),cmd:f,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),b=g.get(T),b?(g.forEach(m=>{const f=g.get(m.ppid);f&&(f.children||(f.children=[]),f.children.push(m))}),g.forEach(m=>{m.children&&(m.children=m.children.sort((f,c)=>f.pid-c.pid))}),P(b)):p(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let y=function(){let h=[b];const w=[];for(;h.length;){const g=h.shift();g&&(w.push(g.pid),g.children&&(h=h.concat(g.children)))}let E=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",oe).fsPath);E+=" "+w.join(" "),(0,v.exec)(E,{},(g,m,f)=>{if(g||f)p(g||new Error(f.toString()));else{const c=m.toString().split(`
`);for(let u=0;u<w.length;u++){const r=R.get(w[u]);r.load=parseFloat(c[u])}if(!b){p(new Error(`Root process ${T} not found`));return}P(b)}})};(0,v.exec)("which ps",{},(h,w,E)=>{if(h||E)if(process.platform!=="linux")p(h||new Error(E.toString()));else{const g=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",oe).fsPath);(0,v.exec)(g,{},(m,f,c)=>{m||c?p(m||new Error(c.toString())):(C(f,k),y())})}else{const g=w.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${g} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,c,u)=>{f||u&&!u.includes("screen size is bogus")?p(f||new Error(u.toString())):(C(c,k),process.platform==="linux"?y():b?P(b):p(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=D;function C(T,P){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=T.toString().split(`
`);for(const R of b){const k=p.exec(R.trim());k&&k.length===6&&P(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(ve[154],we([1,0,30,3,92,93]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(y,h){return y===1?t.isWindows?k():C.getWindowsShell(h):b(y,h)}e.getSystemShell=T;function P(y,h){return y===1?t.isWindows?S(h):C.getWindowsShell(h):b(y,h)}e.getSystemShellSync=P;let p=null;function b(y,h){if(t.isLinux&&y===2||t.isMacintosh&&y===3)return"/bin/bash";if(!p){let w;if(t.isWindows)w="/bin/bash";else{if(w=h.SHELL,!w)try{w=(0,v.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}p=w}return p}let R=null;async function k(){return R||(R=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),R}function S(y){if(R)return R;const h=t.isWindows&&parseFloat((0,v.release)())>=10,w=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${y.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?E:C.getWindowsShell(y)}});var Ae=this&&this.__decorate||function(oe,e,v,t){var D=arguments.length,C=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,v):t,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(oe,e,v,t);else for(var P=oe.length-1;P>=0;P--)(T=oe[P])&&(C=(D<3?T(C):D>3?T(e,v,C):T(e,v))||C);return D>3&&C&&Object.defineProperty(e,v,C),C};define(ve[41],we([1,0,18,14,16,20,82,10,7,2,48,15,11]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function h(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function E(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(g||(g={}));class m{constructor(U){this.buffer=U,this.pos=0}read(U){const x=this.buffer.slice(this.pos,this.pos+U);return this.pos+=x.byteLength,x}}class f{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var c;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(c||(c={}));function u(O){const U=D.VSBuffer.alloc(4);return U.writeUInt32BE(O,0),U}function r(O){return O.read(4).readUInt32BE(0)}function o(O){const U=D.VSBuffer.alloc(1);return U.writeUInt8(O,0),U}const n={Undefined:o(c.Undefined),String:o(c.String),Buffer:o(c.Buffer),VSBuffer:o(c.VSBuffer),Array:o(c.Array),Object:o(c.Object)},i=typeof Buffer<"u";function s(O,U){if(typeof U>"u")O.write(n.Undefined);else if(typeof U=="string"){const x=D.VSBuffer.fromString(U);O.write(n.String),O.write(u(x.byteLength)),O.write(x)}else if(i&&Buffer.isBuffer(U)){const x=D.VSBuffer.wrap(U);O.write(n.Buffer),O.write(u(x.byteLength)),O.write(x)}else if(U instanceof D.VSBuffer)O.write(n.VSBuffer),O.write(u(U.byteLength)),O.write(U);else if(Array.isArray(U)){O.write(n.Array),O.write(u(U.length));for(const x of U)s(O,x)}else{const x=D.VSBuffer.fromString(JSON.stringify(U));O.write(n.Object),O.write(u(x.byteLength)),O.write(x)}}function a(O){switch(O.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return O.read(r(O)).toString();case c.Buffer:return O.read(r(O)).buffer;case c.VSBuffer:return O.read(r(O));case c.Array:{const x=r(O),ae=[];for(let ue=0;ue<x;ue++)ae.push(a(O));return ae}case c.Object:return JSON.parse(O.read(r(O)).toString())}}class l{constructor(U,x,ae=null,ue=1e3){this.protocol=U,this.ctx=x,this.logger=ae,this.timeoutDelay=ue,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(U,x){this.channels.set(U,x),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const x=this.send([U.type]);this.logger?.logOutgoing(x,0,1,E(U.type));return}case 201:case 202:case 204:case 203:{const x=this.send([U.type,U.id],U.data);this.logger?.logOutgoing(x,U.id,1,E(U.type),U.data);return}}}send(U,x=void 0){const ae=new f;return s(ae,U),s(ae,x),this.sendBuffer(ae.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onRawMessage(U){const x=new m(U),ae=a(x),ue=a(x),Q=ae[0];switch(Q){case 100:return this.logger?.logIncoming(U.byteLength,ae[1],1,`${h(Q)}: ${ae[2]}.${ae[3]}`,ue),this.onPromise({type:Q,id:ae[1],channelName:ae[2],name:ae[3],arg:ue});case 102:return this.logger?.logIncoming(U.byteLength,ae[1],1,`${h(Q)}: ${ae[2]}.${ae[3]}`,ue),this.onEventListen({type:Q,id:ae[1],channelName:ae[2],name:ae[3],arg:ue});case 101:return this.logger?.logIncoming(U.byteLength,ae[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:ae[1]});case 103:return this.logger?.logIncoming(U.byteLength,ae[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:ae[1]})}}onPromise(U){const x=this.channels.get(U.channelName);if(!x){this.collectPendingRequest(U);return}const ae=new C.CancellationTokenSource;let ue;try{ue=x.call(this.ctx,U.name,U.arg,ae.token)}catch(F){ue=Promise.reject(F)}const Q=U.id;ue.then(F=>{this.sendResponse({id:Q,data:F,type:201}),this.activeRequests.delete(U.id)},F=>{F instanceof Error?this.sendResponse({id:Q,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:Q,data:F,type:203}),this.activeRequests.delete(U.id)});const re=(0,b.toDisposable)(()=>ae.cancel());this.activeRequests.set(U.id,re)}onEventListen(U){const x=this.channels.get(U.channelName);if(!x){this.collectPendingRequest(U);return}const ae=U.id,Q=x.listen(this.ctx,U.name,U.arg)(re=>this.sendResponse({id:ae,data:re,type:204}));this.activeRequests.set(U.id,Q)}disposeActiveRequest(U){const x=this.activeRequests.get(U.id);x&&(x.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let x=this.pendingRequests.get(U.channelName);x||(x=[],this.pendingRequests.set(U.channelName,x));const ae=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:U,timeoutTimer:ae})}flushPendingRequests(U){const x=this.pendingRequests.get(U);if(x){for(const ae of x)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.onPromise(ae.request);break;case 102:this.onEventListen(ae.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var d;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class I{constructor(U,x=null){this.protocol=U,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ae=>this.onBuffer(ae)),this.logger=x}getChannel(U){const x=this;return{call(ae,ue,Q){return x.isDisposed?Promise.reject(new P.CancellationError):x.requestPromise(U,ae,ue,Q)},listen(ae,ue){return x.isDisposed?p.Event.None:x.requestEvent(U,ae,ue)}}}requestPromise(U,x,ae,ue=C.CancellationToken.None){const Q=this.lastRequestId++,F={id:Q,type:100,channelName:U,name:x,arg:ae};if(ue.isCancellationRequested)return Promise.reject(new P.CancellationError);let M;return new Promise((ie,he)=>{if(ue.isCancellationRequested)return he(new P.CancellationError);const Ee=()=>{const z=q=>{switch(q.type){case 201:this.handlers.delete(Q),ie(q.data);break;case 202:{this.handlers.delete(Q);const H=new Error(q.data.message);H.stack=q.data.stack,H.name=q.data.name,he(H);break}case 203:this.handlers.delete(Q),he(q.data);break}};this.handlers.set(Q,z),this.sendRequest(F)};let $=null;this.state===g.Idle?Ee():($=(0,t.createCancelablePromise)(z=>this.whenInitialized()),$.then(()=>{$=null,Ee()}));const Y=()=>{$?($.cancel(),$=null):this.sendRequest({id:Q,type:101}),he(new P.CancellationError)},ee=ue.onCancellationRequested(Y);M=(0,b.combinedDisposable)((0,b.toDisposable)(Y),ee),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(U,x,ae){const ue=this.lastRequestId++,re={id:ue,type:102,channelName:U,name:x,arg:ae};let F=null;const M=new p.Emitter({onFirstListenerAdd:()=>{F=(0,t.createCancelablePromise)(ie=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add(M),this.sendRequest(re)})},onLastListenerRemove:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete(M),this.sendRequest({id:ue,type:103}))}}),G=ie=>M.fire(ie.data);return this.handlers.set(ue,G),M.event}sendRequest(U){switch(U.type){case 100:case 102:{const x=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger?.logOutgoing(x,U.id,0,`${h(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const x=this.send([U.type,U.id]);this.logger?.logOutgoing(x,U.id,0,h(U.type));return}}}send(U,x=void 0){const ae=new f;return s(ae,U),s(ae,x),this.sendBuffer(ae.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onBuffer(U){const x=new m(U),ae=a(x),ue=a(x),Q=ae[0];switch(Q){case 200:return this.logger?.logIncoming(U.byteLength,0,0,E(Q)),this.onResponse({type:ae[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(U.byteLength,ae[1],0,E(Q),ue),this.onResponse({type:ae[0],id:ae[1],data:ue})}}onResponse(U){if(U.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(U.id)?.(U)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ae([T.memoize],I.prototype,"onDidInitializePromise",null),e.ChannelClient=I;class L{get connections(){const U=[];return this._connections.forEach(x=>U.push(x)),U}constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:x,onDidClientDisconnect:ae})=>{p.Event.once(x.onMessage)(Q=>{const re=new m(Q),F=a(re),M=new l(x,F),G=new I(x);this.channels.forEach((he,Ee)=>M.registerChannel(Ee,he));const ie={channelServer:M,channelClient:G,ctx:F};this._connections.add(ie),this._onDidAddConnection.fire(ie),ae(()=>{M.dispose(),G.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}getChannel(U,x){const ae=this;return{call(ue,Q,re){let F;if((0,S.isFunction)(x)){const G=(0,v.getRandomElement)(ae.connections.filter(x));F=G?Promise.resolve(G):p.Event.toPromise(p.Event.filter(ae.onDidAddConnection,x))}else F=x.routeCall(ae,ue,Q);const M=F.then(G=>G.channelClient.getChannel(U));return J(M).call(ue,Q,re)},listen(ue,Q){if((0,S.isFunction)(x))return ae.getMulticastEvent(U,x,ue,Q);const re=x.routeEvent(ae,ue,Q).then(F=>F.channelClient.getChannel(U));return J(re).listen(ue,Q)}}}getMulticastEvent(U,x,ae,ue){const Q=this;let re=new b.DisposableStore;const F=new p.Emitter({onFirstListenerAdd:()=>{re=new b.DisposableStore;const M=new p.EventMultiplexer,G=new Map,ie=Ee=>{const Y=Ee.channelClient.getChannel(U).listen(ae,ue),ee=M.add(Y);G.set(Ee,ee)},he=Ee=>{const $=G.get(Ee);!$||($.dispose(),G.delete(Ee))};Q.connections.filter(x).forEach(ie),p.Event.filter(Q.onDidAddConnection,x)(ie,void 0,re),Q.onDidRemoveConnection(he,void 0,re),M.event(F.fire,F,re),re.add(M)},onLastListenerRemove:()=>{re.dispose()}});return F.event}registerChannel(U,x){this.channels.set(U,x),this._connections.forEach(ae=>{ae.channelServer.registerChannel(U,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class B{constructor(U,x,ae=null){const ue=new f;s(ue,x),U.send(ue.buffer),this.channelClient=new I(U,ae),this.channelServer=new l(U,x,ae)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,x){this.channelServer.registerChannel(U,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=B;function J(O){return{call(U,x,ae){return O.then(ue=>ue.call(U,x,ae))},listen(U,x){const ae=new p.Relay;return O.then(ue=>ae.input=ue.listen(U,x)),ae.event}}}e.getDelayedChannel=J;function Z(O){let U=!1;return{call(x,ae,ue){return U?O.call(x,ae,ue):(0,t.timeout)(0).then(()=>U=!0).then(()=>O.call(x,ae,ue))},listen(x,ae){if(U)return O.listen(x,ae);const ue=new p.Relay;return(0,t.timeout)(0).then(()=>U=!0).then(()=>ue.input=O.listen(x,ae)),ue.event}}}e.getNextTickChannel=Z;class _{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const x of U.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await p.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=_;var te;(function(O){function U(Q,re){const F=Q,M=re&&re.disableMarshalling,G=new Map;for(const ie in F)ae(ie)&&G.set(ie,p.Event.buffer(F[ie],!0));return new class{listen(ie,he,Ee){const $=G.get(he);if($)return $;if(ue(he)){const Y=F[he];if(typeof Y=="function")return Y.call(F,Ee)}throw new Error(`Event not found: ${he}`)}call(ie,he,Ee){const $=F[he];if(typeof $=="function"){if(!M&&Array.isArray(Ee))for(let Y=0;Y<Ee.length;Y++)Ee[Y]=(0,R.revive)(Ee[Y]);return $.apply(F,Ee)}throw new Error(`Method not found: ${he}`)}}}O.fromService=U;function x(Q,re){const F=re&&re.disableMarshalling;return new Proxy({},{get(M,G){if(typeof G=="string")return re?.properties?.has(G)?re.properties.get(G):ue(G)?function(ie){return Q.listen(G,ie)}:ae(G)?Q.listen(G):async function(...ie){let he;re&&!(0,S.isUndefinedOrNull)(re.context)?he=[re.context,...ie]:he=ie;const Ee=await Q.call(G,he);return F?Ee:(0,R.revive)(Ee)};throw new Error(`Property not found: ${String(G)}`)}})}O.toService=x;function ae(Q){return Q[0]==="o"&&Q[1]==="n"&&k.isUpperAsciiLetter(Q.charCodeAt(2))}function ue(Q){return/^onDynamic/.test(Q)&&k.isUpperAsciiLetter(Q.charCodeAt(9))}})(te=e.ProxyChannel||(e.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){const U=O.toString();if(U!=="[object Object]")return U}return O}function fe(O){return Array.isArray(O)?O.map(W):W(O)}function j(O,U,x,ae,ue,Q,re){re=fe(re);const F=se[ue],M=F[ae%F.length];let G=[`%c[${O}]%c[${String(U).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(Q)?(G=G.concat(re),G.push(")")):G.push(re),console.log.apply(console,G)}e.logWithColors=j;class X{constructor(U,x){this._outgoingPrefix=U,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,x,ae,ue,Q){this._totalOutgoing+=U,j(this._outgoingPrefix,this._totalOutgoing,U,x,ae,ue,Q)}logIncoming(U,x,ae,ue,Q){this._totalIncoming+=U,j(this._incomingPrefix,this._totalIncoming,U,x,ae,ue,Q)}}e.IPCLogger=X}),define(ve[95],we([1,0,16,7,2,41]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let a=0;function l(I,L){if(!s.has(I)){const B=String(++a);s.set(I,B)}return s.get(I)}function d(I,L,B,J){if(!i.enableDiagnostics)return;const Z=l(I,L);if(J instanceof v.VSBuffer||J instanceof Uint8Array||J instanceof ArrayBuffer||ArrayBuffer.isView(J)){const _=v.VSBuffer.alloc(J.byteLength);_.set(J),i.records.push({timestamp:Date.now(),id:Z,label:L,type:B,buff:_})}else i.records.push({timestamp:Date.now(),id:Z,label:L,type:B,data:J})}i.traceSocketEvent=d})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var p;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function R(){return b||(b=v.VSBuffer.alloc(0)),b}class k{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return R();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const L=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),L}if(this._chunks[0].byteLength>s){const L=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),L}const l=v.VSBuffer.alloc(s);let d=0,I=0;for(;s>0;){const L=this._chunks[I];if(L.byteLength>s){const B=L.slice(0,s);l.set(B,d),d+=s,a&&(this._chunks[I]=L.slice(s),this._totalLength-=s),s-=s}else l.set(L,d),d+=L.byteLength,a?(this._chunks.shift(),this._totalLength-=L.byteLength):I++,s-=L.byteLength}return l}}e.ChunkStream=k;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(S||(S={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class w{constructor(s,a,l,d){this.type=s,this.id=a,this.ack=l,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends D.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,d=this._state.id,I=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new w(l,d,I,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=v.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(a,s.data)}_bufferAdd(s,a){const l=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,l}_bufferTake(){const s=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class m extends D.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new w(1,0,0,s))}}e.Protocol=m;class f extends C.IPCClient{static fromSocket(s,a){return new f(new m(s),a)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,a,l=null){super(s,a,l),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=f;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class u{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}length(){let s=0,a=this._first;for(;a;)a=a.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let a=0,l=this._first;for(;l;)s[a++]=l.data,l=l.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new u(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<o._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=o._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),a=(1+o._HISTORY_LENGTH)*1e3;let l=0;for(let d=0;d<o._HISTORY_LENGTH;d++)s-this.lastRuns[d]<=a&&l++;return 1-l/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,a=null,l=o.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),a&&this._socketReader.acceptChunk(a),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new w(5,0,0,R());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new w(7,0,0,R());this._socketWriter.write(s)}sendResume(){const s=new w(8,0,0,R());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new w(3,0,this._incomingAckId,R());this._socketWriter.write(s);const a=this._outgoingUnackMsg.toArray();for(let l=0,d=a.length;l<d;l++)this._socketWriter.write(a[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new w(6,0,0,R())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let l=0,d=a.length;l<d;l++)this._socketWriter.write(a[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new w(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(s){const a=new w(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime,l=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&l>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:l});return}const I=Math.max(2e4-a,2e4-l,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},I)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new w(3,0,this._incomingAckId,R());this._socketWriter.write(s)}_sendKeepAlive(){const s=new w(9,0,0,R());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(ve[96],we([1,0,49,14,16,20,151,10,7,2,22,93,56,41]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends y.ChannelServer{constructor(g){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",m=>D.VSBuffer.wrap(Buffer.from(m,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=h;class w{constructor(g,m){this.modulePath=g,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new t.Delayer(f),this.child=null,this._client=null}getChannel(g){const m=this;return{call(f,c,u){return m.requestPromise(g,f,c,u)},listen(f,c){return m.requestEvent(g,f,c)}}}requestPromise(g,m,f,c=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(g),r=(0,t.createCancelablePromise)(i=>u.call(m,f,i)),o=c.onCancellationRequested(()=>r.cancel()),n=(0,b.toDisposable)(()=>r.cancel());return this.activeRequests.add(n),r.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(g,m,f){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let c;const u=new p.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(g).listen(m,f)(u.fire,u),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,S.removeDangerousEnvVariables)(m.env),this.child=(0,v.fork)(this.modulePath,g,m);const f=new p.Emitter;p.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,T.isRemoteConsoleLog)(s)){(0,T.log)(s,`IPC Library: ${this.options.serverName}`);return}f.fire(D.VSBuffer.wrap(Buffer.from(s,"base64")))});const u=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,r=s=>this.child&&this.child.connected&&u.send(s.buffer.toString("base64")),o=f.event,n={send:r,onMessage:o};this._client=new y.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,a)=>{process.removeListener("exit",i),this.activeRequests.forEach(l=>(0,b.dispose)(l)),this.activeRequests.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:a})})}return this._client}getCachedChannel(g){let m=this.channels.get(g);return m||(m=this.client.getChannel(g),this.channels.set(g,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(ve[57],we([1,0,16,10,7,2,6,3,23,41,95]),function(oe,e,v,t,D,C,T,P,p,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:oe.__$__nodeRequire("crypto"),zlib:oe.__$__nodeRequire("zlib"),net:oe.__$__nodeRequire("net"),os:oe.__$__nodeRequire("os")}}class S{traceSocketEvent(l,d){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,d)}constructor(l,d=""){this._canWrite=!0,this.debugLabel=d,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,t.onUnexpectedError)(I)}},this.socket.on("error",this._errorListener),this._closeListener=I=>{this.traceSocketEvent("close",{hadError:I}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(l){const d=I=>{this.traceSocketEvent("read",I),l(v.VSBuffer.wrap(I))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(l){const d=I=>{l({type:0,hadError:I,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(l){const d=()=>{l()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(l){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.NodeSocket=S;var y;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var h;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(h||(h={}));class w extends C.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,d){this.socket.traceSocketEvent(l,d)}constructor(l,d,I,L){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:I?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new E(this,d,I,L,this._onData,(B,J)=>this._write(B,J))),this._register(this._flowManager.onError(B=>{console.error(B),(0,t.onUnexpectedError)(B),this._onClose.fire({type:0,hadError:!0,error:B})})),this._incomingData=new R.ChunkStream,this._register(this.socket.onData(B=>this._acceptChunk(B))),this._register(this.socket.onClose(B=>this._onClose.fire(B)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,d){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let I=2;l.byteLength<126?I+=0:l.byteLength<2**16?I+=2:I+=8;const L=v.VSBuffer.alloc(I);if(d?L.writeUInt8(194,0):L.writeUInt8(130,0),l.byteLength<126)L.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){L.writeUInt8(126,1);let B=1;L.writeUInt8(l.byteLength>>>8&255,++B),L.writeUInt8(l.byteLength>>>0&255,++B)}else{L.writeUInt8(127,1);let B=1;L.writeUInt8(0,++B),L.writeUInt8(0,++B),L.writeUInt8(0,++B),L.writeUInt8(0,++B),L.writeUInt8(l.byteLength>>>24&255,++B),L.writeUInt8(l.byteLength>>>16&255,++B),L.writeUInt8(l.byteLength>>>8&255,++B),L.writeUInt8(l.byteLength>>>0&255,++B)}this.socket.write(v.VSBuffer.concat([L,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),I=d.readUInt8(0),L=(I&128)>>>7,B=(I&64)>>>6,J=d.readUInt8(1),Z=(J&128)>>>7,_=J&127;this._state.state=2,this._state.readLen=2+(Z?4:0)+(_===126?2:0)+(_===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(B)),this._state.firstFrameOfMessage=Boolean(L),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),I=d.readUInt8(1),L=(I&128)>>>7;let B=I&127,J=1;B===126?B=d.readUInt8(++J)*2**8+d.readUInt8(++J):B===127&&(B=d.readUInt8(++J)*0+d.readUInt8(++J)*0+d.readUInt8(++J)*0+d.readUInt8(++J)*0+d.readUInt8(++J)*2**24+d.readUInt8(++J)*2**16+d.readUInt8(++J)*2**8+d.readUInt8(++J));let Z=0;L&&(Z=d.readUInt8(++J)*2**24+d.readUInt8(++J)*2**16+d.readUInt8(++J)*2**8+d.readUInt8(++J)),this._state.state=3,this._state.readLen=B,this._state.mask=Z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),f(d,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(d,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class E extends C.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:v.VSBuffer.alloc(0)}constructor(l,d,I,L,B,J){super(),this._tracer=l,this._onData=B,this._writeFn=J,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,d?(this._zlibInflateStream=this._register(new g(this._tracer,L,I,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Z=>this._onError.fire(Z))),this._register(this._zlibDeflateStream.onError(Z=>this._onError.fire(Z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const d=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(d,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,d){return new Promise((I,L)=>{l.write(d),l.flush(B=>I(B))})}acceptFrame(l,d,I){this._readQueue.push({data:l,isCompressed:d,isLastFrameOfMessage:I}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const d=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(d)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,d,I){return new Promise((L,B)=>{l.write(d),I&&l.write(v.VSBuffer.fromByteArray([0,0,255,255])),l.flush(J=>L(J))})}}class g extends C.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?v.VSBuffer.concat(this._recordedInflateBytes):v.VSBuffer.alloc(0)}constructor(l,d,I,L){super(),this._tracer=l,this._recordInflateBytes=d,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(L),this._zlibInflate.on("error",B=>{this._tracer.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this._onError.fire(B)}),this._zlibInflate.on("data",B=>{this._tracer.traceSocketEvent("zlibInflateData",B),this._pendingInflateData.push(v.VSBuffer.wrap(B))}),I&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this._zlibInflate.write(I.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const d=v.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(d)})}}class m extends C.Disposable{constructor(l,d){super(),this._tracer=l,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",I=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this._onError.fire(I)}),this._zlibDeflate.on("data",I=>{this._tracer.traceSocketEvent("zlibDeflateData",I),this._pendingDeflateData.push(v.VSBuffer.wrap(I))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let d=v.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.byteLength-4),l(d)})}}function f(a,l){if(l===0)return;const d=a.byteLength>>>2;for(let _=0;_<d;_++){const te=a.readUInt32BE(_*4);a.writeUInt32BE(te^l,_*4)}const I=d*4,L=a.byteLength-I,B=l>>>24&255,J=l>>>16&255,Z=l>>>8&255;L>=1&&a.writeUInt8(a.readUInt8(I)^B,I),L>=2&&a.writeUInt8(a.readUInt8(I+1)^J,I+1),L>=3&&a.writeUInt8(a.readUInt8(I+2)^Z,I+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const c={[2]:107,[1]:103};function u(){const a=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):l=(0,T.join)(k().os.tmpdir(),`vscode-ipc-${a}.sock`),o(l),l}e.createRandomIPCHandle=u;function r(a,l,d){const I=k().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${d}-${l}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${I.substr(0,8)}-${d}-${l}.sock`):L=(0,T.join)(a,`${d}-${l}.sock`),o(L),L}e.createStaticIPCHandle=r;function o(a){const l=c[P.platform];typeof l=="number"&&a.length>=l&&console.warn(`WARNING: IPC handle "${a}" is longer than ${l} chars, try a shorter --user-data-dir`)}class n extends b.IPCServer{static toClientConnectionEvent(l){const d=D.Event.fromNodeEventEmitter(l,"connection");return D.Event.map(d,I=>({protocol:new R.Protocol(new S(I,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(I,"close"))}))}constructor(l){super(n.toClientConnectionEvent(l)),this.server=l}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function i(a){return new Promise((l,d)=>{const I=k().net.createServer();I.on("error",d),I.listen(a,()=>{I.removeListener("error",d),l(new n(I))})})}e.serve=i;function s(a,l){return new Promise((d,I)=>{const L=k().net.createConnection(a,()=>{L.removeListener("error",I),d(R.Client.fromSocket(new S(L,`ipc-client${l}`),l))});L.once("error",I)})}e.connect=s}),define(ve[155],we([1,0,14,7,2,11]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function P(k){const S=k;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var p;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(p=e.StorageState||(e.StorageState={}));class b extends D.Disposable{constructor(S,y=Object.create(null)){super(),this.database=S,this.options=y,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=p.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((y,h)=>this.accept(h,y)),S.deleted?.forEach(y=>this.accept(y,void 0))}accept(S,y){if(this.state===p.Closed)return;let h=!1;(0,C.isUndefinedOrNull)(y)?h=this.cache.delete(S):this.cache.get(S)!==y&&(this.cache.set(S,y),h=!0),h&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===p.None&&(this.state=p.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,y){const h=this.cache.get(S);return(0,C.isUndefinedOrNull)(h)?y:h}getBoolean(S,y){const h=this.get(S);return(0,C.isUndefinedOrNull)(h)?y:h==="true"}getNumber(S,y){const h=this.get(S);return(0,C.isUndefinedOrNull)(h)?y:parseInt(h,10)}async set(S,y){if(this.state===p.Closed)return;if((0,C.isUndefinedOrNull)(y))return this.delete(S);const h=String(y);if(this.cache.get(S)!==h)return this.cache.set(S,h),this.pendingInserts.set(S,h),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===p.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=p.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class R{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((y,h)=>this.items.set(h,y)),S.delete?.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=R}),define(ve[156],we([1,0,7,2]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,p){return this._map.set(P,p),this.fire([P]),(0,t.toDisposable)(()=>{this._map.get(P)===p&&(this._map.delete(P),this.fire([P]))})}registerFactory(P,p){this._factories.get(P)?.dispose();const b=new C(this,P,p);return this._factories.set(P,b),(0,t.toDisposable)(()=>{const R=this._factories.get(P);!R||R!==b||(this._factories.delete(P),R.dispose())})}async getOrCreate(P){const p=this.get(P);if(p)return p;const b=this._factories.get(P);return!b||b.isResolved?null:(await b.resolve(),this.get(P))}get(P){return this._map.get(P)||null}isResolved(P){if(this.get(P))return!0;const b=this._factories.get(P);return!!(!b||b.isResolved)}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class C extends t.Disposable{get isResolved(){return this._isResolved}constructor(P,p,b){super(),this._registry=P,this._languageId=p,this._factory=b,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const P=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,P&&!this._isDisposed&&this._register(this._registry.register(this._languageId,P))}}}),define(ve[157],we([1,0,40,4,47,156]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class T{constructor(I,L,B){this._tokenBrand=void 0,this.offset=I,this.type=L,this.language=B}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=T;class P{constructor(I,L){this._tokenizationResultBrand=void 0,this.tokens=I,this.endState=L}}e.TokenizationResult=P;class p{constructor(I,L){this._encodedTokenizationResultBrand=void 0,this.tokens=I,this.endState=L}}e.EncodedTokenizationResult=p;var b;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(d){const I=new Map;I.set(0,v.Codicon.symbolMethod),I.set(1,v.Codicon.symbolFunction),I.set(2,v.Codicon.symbolConstructor),I.set(3,v.Codicon.symbolField),I.set(4,v.Codicon.symbolVariable),I.set(5,v.Codicon.symbolClass),I.set(6,v.Codicon.symbolStruct),I.set(7,v.Codicon.symbolInterface),I.set(8,v.Codicon.symbolModule),I.set(9,v.Codicon.symbolProperty),I.set(10,v.Codicon.symbolEvent),I.set(11,v.Codicon.symbolOperator),I.set(12,v.Codicon.symbolUnit),I.set(13,v.Codicon.symbolValue),I.set(15,v.Codicon.symbolEnum),I.set(14,v.Codicon.symbolConstant),I.set(15,v.Codicon.symbolEnum),I.set(16,v.Codicon.symbolEnumMember),I.set(17,v.Codicon.symbolKeyword),I.set(27,v.Codicon.symbolSnippet),I.set(18,v.Codicon.symbolText),I.set(19,v.Codicon.symbolColor),I.set(20,v.Codicon.symbolFile),I.set(21,v.Codicon.symbolReference),I.set(22,v.Codicon.symbolCustomColor),I.set(23,v.Codicon.symbolFolder),I.set(24,v.Codicon.symbolTypeParameter),I.set(25,v.Codicon.account),I.set(26,v.Codicon.issues);function L(Z){let _=I.get(Z);return _||(console.info("No codicon found for CompletionItemKind "+Z),_=v.Codicon.symbolProperty),_}d.toIcon=L;const B=new Map;B.set("method",0),B.set("function",1),B.set("constructor",2),B.set("field",3),B.set("variable",4),B.set("class",5),B.set("struct",6),B.set("interface",7),B.set("module",8),B.set("property",9),B.set("event",10),B.set("operator",11),B.set("unit",12),B.set("value",13),B.set("constant",14),B.set("enum",15),B.set("enum-member",16),B.set("enumMember",16),B.set("keyword",17),B.set("snippet",27),B.set("text",18),B.set("color",19),B.set("file",20),B.set("reference",21),B.set("customcolor",22),B.set("folder",23),B.set("type-parameter",24),B.set("typeParameter",24),B.set("account",25),B.set("issue",26);function J(Z,_){let te=B.get(Z);return typeof te>"u"&&!_&&(te=9),te}d.fromString=J})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(d){d[d.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var y;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var h;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(h=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var E;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(E=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function m(d){return d&&t.URI.isUri(d.uri)&&D.Range.isIRange(d.range)&&(D.Range.isIRange(d.originSelectionRange)||D.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=m;var f;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(f=e.SymbolKind||(e.SymbolKind={}));var c;(function(d){d[d.Deprecated=1]="Deprecated"})(c=e.SymbolTag||(e.SymbolTag={}));var u;(function(d){const I=new Map;I.set(0,v.Codicon.symbolFile),I.set(1,v.Codicon.symbolModule),I.set(2,v.Codicon.symbolNamespace),I.set(3,v.Codicon.symbolPackage),I.set(4,v.Codicon.symbolClass),I.set(5,v.Codicon.symbolMethod),I.set(6,v.Codicon.symbolProperty),I.set(7,v.Codicon.symbolField),I.set(8,v.Codicon.symbolConstructor),I.set(9,v.Codicon.symbolEnum),I.set(10,v.Codicon.symbolInterface),I.set(11,v.Codicon.symbolFunction),I.set(12,v.Codicon.symbolVariable),I.set(13,v.Codicon.symbolConstant),I.set(14,v.Codicon.symbolString),I.set(15,v.Codicon.symbolNumber),I.set(16,v.Codicon.symbolBoolean),I.set(17,v.Codicon.symbolArray),I.set(18,v.Codicon.symbolObject),I.set(19,v.Codicon.symbolKey),I.set(20,v.Codicon.symbolNull),I.set(21,v.Codicon.symbolEnumMember),I.set(22,v.Codicon.symbolStruct),I.set(23,v.Codicon.symbolEvent),I.set(24,v.Codicon.symbolOperator),I.set(25,v.Codicon.symbolTypeParameter);function L(B){let J=I.get(B);return J||(console.info("No codicon found for SymbolKind "+B),J=v.Codicon.symbolProperty),J}d.toIcon=L})(u=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(I){this.value=I}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var o;(function(d){function I(L){return!L||typeof L!="object"?!1:typeof L.id=="string"&&typeof L.title=="string"}d.is=I})(o=e.Command||(e.Command={}));var n;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(d){d[d.Unresolved=0]="Unresolved",d[d.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var s;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var a;(function(d){d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(a=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new C.TokenizationRegistry;var l;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(l=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[158],we([8,9]),function(oe,e){return oe.create("vs/base/node/zip",e)}),define(ve[159],we([8,9]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[160],we([8,9]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(ve[161],we([8,9]),function(oe,e){return oe.create("vs/platform/environment/node/argvHelper",e)}),define(ve[162],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ve[163],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[164],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ve[165],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ve[166],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ve[167],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ve[168],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ve[169],we([8,9]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[170],we([8,9]),function(oe,e){return oe.create("vs/platform/files/common/fileService",e)}),define(ve[171],we([8,9]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(ve[172],we([8,9]),function(oe,e){return oe.create("vs/platform/files/common/io",e)}),define(ve[173],we([8,9]),function(oe,e){return oe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ve[174],we([8,9]),function(oe,e){return oe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ve[175],we([8,9]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(ve[176],we([8,9]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(ve[177],we([8,9]),function(oe,e){return oe.create("vs/platform/shell/node/shellEnv",e)}),define(ve[178],we([8,9]),function(oe,e){return oe.create("vs/platform/telemetry/common/telemetryService",e)}),define(ve[179],we([8,9]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ve[180],we([8,9]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ve[181],we([8,9]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ve[182],we([8,9]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(ve[183],we([8,9]),function(oe,e){return oe.create("vs/server/node/serverEnvironmentService",e)}),define(ve[184],we([8,9]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(ve[185],we([8,9]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[186],we([8,9]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ve[187],we([1,0,7,2]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(P,p,b){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:b[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:b[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:b[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:b[0],port:b[1],subId:b[2]}))}throw new Error("Method not implemented.")}listen(P,p,b){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends t.Disposable{constructor(P){super(),this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,p,b){this.channel.call("attach",[P,p,b])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,p){this.channel.call("terminate",[P,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,p){return this.channel.call("openExtensionDevelopmentHostWindow",[P,p])}}e.ExtensionHostDebugChannelClient=C}),define(ve[188],we([1,0,4]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(T){this.service=T}listen(T,P,p){throw new Error("Invalid listen")}call(T,P,p){switch(P){case"download":return this.service.download(v.URI.revive(p[0]),v.URI.revive(p[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class D{constructor(T,P){this.channel=T,this.getUriTransformer=P}async download(T,P){const p=this.getUriTransformer();p&&(T=p.transformOutgoingURI(T),P=p.transformOutgoingURI(P)),await this.channel.call("download",[T,P])}}e.DownloadServiceChannelClient=D}),define(ve[189],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class v{constructor(D){this.machineId=D}encryption(){return new Promise((D,C)=>oe(["vscode-encrypt"],D,C))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch{return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch{return D}}}e.EncryptionMainService=v}),define(ve[97],we([1,0,142,82,12,6,28,19,4]),function(oe,e,v,t,D,C,T,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",oe).fsPath)}get userHome(){return p.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return p.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.paths.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const w=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",w)}return this.args.logsPath}get userDataSyncLogResource(){return p.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return p.URI.file((0,C.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(p.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,C.join)(w,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,C.resolve)(w):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",oe).fsPath,"..","extensions"))}get extensionsDownloadPath(){const w=this.args["extensions-download-dir"];return w?(0,C.resolve)(w):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,C.resolve)(w);const E=T.env.VSCODE_EXTENSIONS;if(E)return E;const g=T.env.VSCODE_PORTABLE;return g?(0,C.join)(g,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(E=>/^[^:/?#]+?:\/\//.test(E)?p.URI.parse(E):p.URI.file((0,C.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?p.URI.parse(w):p.URI.file((0,C.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return p.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return p.URI.file((0,C.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,C.join)(w,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this._args}constructor(w,E,g){this._args=w,this.paths=E,this.productService=g,this.editSessionId=this.args.editSessionId}}Ae([t.memoize],b.prototype,"appRoot",null),Ae([t.memoize],b.prototype,"userHome",null),Ae([t.memoize],b.prototype,"userDataPath",null),Ae([t.memoize],b.prototype,"appSettingsHome",null),Ae([t.memoize],b.prototype,"tmpDir",null),Ae([t.memoize],b.prototype,"cacheHome",null),Ae([t.memoize],b.prototype,"stateResource",null),Ae([t.memoize],b.prototype,"userRoamingDataHome",null),Ae([t.memoize],b.prototype,"userDataSyncHome",null),Ae([t.memoize],b.prototype,"userDataSyncLogResource",null),Ae([t.memoize],b.prototype,"editSessionsLogResource",null),Ae([t.memoize],b.prototype,"sync",null),Ae([t.memoize],b.prototype,"machineSettingsResource",null),Ae([t.memoize],b.prototype,"workspaceStorageHome",null),Ae([t.memoize],b.prototype,"localHistoryHome",null),Ae([t.memoize],b.prototype,"keyboardLayoutResource",null),Ae([t.memoize],b.prototype,"argvResource",null),Ae([t.memoize],b.prototype,"isExtensionDevelopment",null),Ae([t.memoize],b.prototype,"untitledWorkspacesHome",null),Ae([t.memoize],b.prototype,"installSourcePath",null),Ae([t.memoize],b.prototype,"builtinExtensionsPath",null),Ae([t.memoize],b.prototype,"extensionsPath",null),Ae([t.memoize],b.prototype,"extensionDevelopmentLocationURI",null),Ae([t.memoize],b.prototype,"extensionDevelopmentKind",null),Ae([t.memoize],b.prototype,"extensionTestsLocationURI",null),Ae([t.memoize],b.prototype,"debugExtensionHost",null),Ae([t.memoize],b.prototype,"serviceMachineIdResource",null),Ae([t.memoize],b.prototype,"telemetryLogResource",null),Ae([t.memoize],b.prototype,"disableWorkspaceTrust",null),Ae([t.memoize],b.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=b;function R(h,w){return y(h["inspect-extensions"],h["inspect-brk-extensions"],5870,w,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=R;function k(h,w){return y(h["inspect-search"],h["inspect-brk-search"],5876,w,h.extensionEnvironment)}e.parseSearchPort=k;function S(h,w){return y(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,w,h.extensionEnvironment)}e.parsePtyHostPort=S;function y(h,w,E,g,m,f){const u=Number(w||h)||(g?null:E),r=u?Boolean(!!w):!1;let o;if(f)try{o=JSON.parse(f)}catch{}return{port:u,break:r,debugId:m,env:o}}}),define(ve[58],we([1,0,266,3,160]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,D.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},category:{type:"string",cat:"e",description:(0,D.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(h,w,E=T){const g={},m=["_"],f=[];for(const o in w){const n=w[o];n.alias&&(g[o]=n.alias),n.type==="string"||n.type==="string[]"?(m.push(o),n.deprecates&&m.push(...n.deprecates)):n.type==="boolean"&&(f.push(o),n.deprecates&&f.push(...n.deprecates))}const c=v(h,{string:m,boolean:f,alias:g}),u={},r=c;u._=c._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(const o in w){const n=w[o];n.alias&&delete r[n.alias];let i=r[o];if(n.deprecates)for(const s of n.deprecates)r.hasOwnProperty(s)&&(i||(i=r[s],i&&E.onDeprecatedOption(s,n.deprecationMessage||(0,D.localize)(35,null,o))),delete r[s]);if(typeof i<"u"){if(n.type==="string[]"){if(Array.isArray(i)||(i=[i]),!n.allowEmptyValue){const s=i.filter(a=>a.length>0);s.length!==i.length&&(E.onEmptyValue(o),i=s.length>0?s:void 0)}}else n.type==="string"&&(Array.isArray(i)?(i=i.pop(),E.onMultipleValues(o,i)):!i&&!n.allowEmptyValue&&(E.onEmptyValue(o),i=void 0));u[o]=i,n.deprecationMessage&&E.onDeprecatedOption(o,n.deprecationMessage)}delete r[o]}for(const o in r)E.onUnknownOption(o);return u}e.parseArgs=P;function p(h,w){let E="";return w.args&&(Array.isArray(w.args)?E=` <${w.args.join("> <")}>`:E=` <${w.args}>`),w.alias?`-${w.alias} --${h}${E}`:`--${h}${E}`}function b(h,w){let E=0;const g=[];for(const u in h){const r=h[u],o=p(u,r);E=Math.max(E,o.length),g.push([o,r.description])}const m=E+2+1;if(w-m<25)return g.reduce((u,r)=>u.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const f=w-m-1,c=[];for(const u of g){const r=u[0],o=k(u[1],f),n=R(m-r.length-2);c.push("  "+r+n+o[0]);for(let i=1;i<o.length;i++)c.push(R(m)+o[i])}return c}e.formatOptions=b;function R(h){return" ".repeat(h)}function k(h,w){const E=[];for(;h.length;){const g=h.length<w?h.length:h.lastIndexOf(" ",w),m=h.slice(0,g).trim();h=h.slice(g),E.push(m)}return E}function S(h,w,E,g,m){const f=process.stdout.isTTY&&process.stdout.columns||80,c=m?.noInputFiles!==!0?`[${(0,D.localize)(36,null)}...]`:"",u=[`${h} ${E}`];u.push(""),u.push(`${(0,D.localize)(37,null)}: ${w} [${(0,D.localize)(38,null)}]${c}`),u.push(""),m?.noPipe!==!0&&(t.isWindows?u.push((0,D.localize)(39,null,w)):u.push((0,D.localize)(40,null,w)),u.push(""));const r={};for(const o in g){const n=g[o];if(n.description&&n.cat){let i=r[n.cat];i||(r[n.cat]=i={}),i[o]=n}}for(const o in r){const n=o,i=r[n];i&&(u.push(C[n]),u.push(...b(i,f)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=S;function y(h,w){return`${h||(0,D.localize)(41,null)}
${w||(0,D.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=y}),define(ve[190],we([1,0,267,161,58]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const C=2048;function T(S,y){const h={onUnknownOption:E=>{console.warn((0,t.localize)(0,null,E))},onMultipleValues:(E,g)=>{console.warn((0,t.localize)(1,null,E,g))},onEmptyValue:E=>{console.warn((0,t.localize)(2,null,E))},onDeprecatedOption:(E,g)=>{console.warn((0,t.localize)(3,null,E,g))}},w=(0,D.parseArgs)(S,D.OPTIONS,y?h:void 0);return w.goto&&w._.forEach(E=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,t.localize)(4,null))),w["max-memory"]&&v(parseInt(w["max-memory"])>=C,`The max-memory argument cannot be specified lower than ${C} MB.`),w}function P(S){const y=S.findIndex(h=>!/^-/.test(h));if(y>-1)return[...S.slice(0,y),...S.slice(y+1)]}function p(S){let[,...y]=S;process.env.VSCODE_DEV&&(y=P(y)||[]);const h=!k(process.env);return T(y,h)}e.parseMainProcessArgv=p;function b(S){const[,,...y]=S;return T(y,!0)}e.parseCLIProcessArgv=b;function R(S,...y){const h=S.indexOf("--");return h===-1?S.push(...y):S.splice(h,0,...y),S}e.addArg=R;function k(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),function(){"use strict";function oe(e,v,t){function D(T,P){const p=C(T,P),b=[p];return e.isAbsolute(p)||b.unshift(t),e.resolve(...b)}function C(T,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,P);const R=T["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(k,"AppData","Roaming")}break;case"darwin":b=e.join(v.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,P)}return{getUserDataPath:D}}if(typeof define=="function")define(ve[191],we([84,30,28]),function(e,v,t){return oe(e,v,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),v=require("os");module.exports=oe(e,v,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ve[192],we([1,0,30,97,191]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends t.AbstractNativeEnvironmentService{constructor(P,p){super(P,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P,p.nameShort)},p)}}e.NativeEnvironmentService=C}),define(ve[193],we([1,0,11,165]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(T,P,p){try{C(T,P,p)}catch{}return T}e.localizeManifest=D;function C(T,P,p){const b=(R,k,S)=>{const y=R[k];if((0,v.isString)(y)){const h=y,w=h.length;if(w>1&&h[0]==="%"&&h[w-1]==="%"){const E=h.substr(1,w-2);let g=P[E];g===void 0&&p&&(g=p[E]);const m=typeof g=="string"?g:g.message;if(m!==void 0){const f=p?.[E],c=typeof f=="string"?f:f?.message;if(S&&(k==="title"||k==="category")&&c&&c!==m){const u={value:m,original:c};R[k]=u}else R[k]=m}else console.warn(`[${T.name}]: ${(0,t.localize)(0,null,E)}`)}}else if((0,v.isObject)(y))for(const h in y)y.hasOwnProperty(h)&&(h==="commands"?b(y,h,!0):b(y,h,S));else if(Array.isArray(y))for(let h=0;h<y.length;h++)b(y,h,S)};for(const R in T)T.hasOwnProperty(R)&&b(T,R)}}),define(ve[70],we([1,0,19,67,169,50]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function p(g){return g=g.trim(),g==="*"||T.test(g)}e.isValidVersionStr=p;function b(g){if(!p(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=g.match(T);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=b;function R(g){if(!g)return null;const m=g.majorBase,f=g.majorMustEqual,c=g.minorBase;let u=g.minorMustEqual;const r=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(m===0||(u=!1),o=!1);let n=0;if(g.preRelease){const i=P.exec(g.preRelease);if(i){const[,s,a,l]=i;n=Date.UTC(Number(s),Number(a)-1,Number(l))}}return{majorBase:m,majorMustEqual:f,minorBase:c,minorMustEqual:u,patchBase:r,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:n}}e.normalizeVersion=R;function k(g,m,f){let c;typeof g=="string"?c=R(b(g)):c=g;let u;m instanceof Date?u=m.getTime():typeof m=="string"&&(u=new Date(m).getTime());let r;if(typeof f=="string"?r=R(b(f)):r=f,!c||!r)return!1;const o=c.majorBase,n=c.minorBase,i=c.patchBase;let s=r.majorBase,a=r.minorBase,l=r.patchBase;const d=r.notBefore;let I=r.majorMustEqual,L=r.minorMustEqual,B=r.patchMustEqual;return r.isMinimum?o>s?!0:o<s?!1:n>a?!0:n<a||u&&u<d?!1:i>=l:(o===1&&s===0&&(!I||!L||!B)&&(s=1,a=0,l=0,I=!0,L=!1,B=!1),o<s?!1:o>s?!I:n<a?!1:n>a?!L:i<l?!1:i>l?!B:!(u&&u<d))}e.isValidVersion=k;function S(g,m,f,c,u){const r=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return r.push([t.default.Error,D.localize(0,null)]),r;if(typeof c.name!="string")return r.push([t.default.Error,D.localize(1,null,"name")]),r;if(typeof c.version!="string")return r.push([t.default.Error,D.localize(2,null,"version")]),r;if(!c.engines)return r.push([t.default.Error,D.localize(3,null,"engines")]),r;if(typeof c.engines.vscode!="string")return r.push([t.default.Error,D.localize(4,null,"engines.vscode")]),r;if(typeof c.extensionDependencies<"u"&&!E(c.extensionDependencies))return r.push([t.default.Error,D.localize(5,null,"extensionDependencies")]),r;if(typeof c.activationEvents<"u"){if(!E(c.activationEvents))return r.push([t.default.Error,D.localize(6,null,"activationEvents")]),r;if(typeof c.main>"u"&&typeof c.browser>"u")return r.push([t.default.Error,D.localize(7,null,"activationEvents","main")]),r}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&r.push([t.default.Warning,D.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return r.push([t.default.Error,D.localize(9,null,"main")]),r;{const i=(0,v.joinPath)(f,c.main);(0,v.isEqualOrParent)(i,f)||r.push([t.default.Warning,D.localize(10,null,i.path,f.path)])}if(typeof c.activationEvents>"u")return r.push([t.default.Error,D.localize(11,null,"activationEvents","main")]),r}if(typeof c.browser<"u"){if(typeof c.browser!="string")return r.push([t.default.Error,D.localize(12,null,"browser")]),r;{const i=(0,v.joinPath)(f,c.browser);(0,v.isEqualOrParent)(i,f)||r.push([t.default.Warning,D.localize(13,null,i.path,f.path)])}if(typeof c.activationEvents>"u")return r.push([t.default.Error,D.localize(14,null,"activationEvents","browser")]),r}if(!C.valid(c.version))return r.push([t.default.Error,D.localize(15,null)]),r;const o=[];if(!y(g,m,c,u,o))for(const i of o)r.push([t.default.Error,i]);return r}e.validateExtensionManifest=S;function y(g,m,f,c,u){return c||typeof f.main>"u"&&typeof f.browser>"u"?!0:w(g,m,f.engines.vscode,u)}e.isValidExtensionVersion=y;function h(g,m,f){return g==="*"||w(m,f,g)}e.isEngineValid=h;function w(g,m,f,c=[]){const u=R(b(f));if(!u)return c.push(D.localize(16,null,f)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(D.localize(17,null,f)),!1}else if(!u.majorMustEqual)return c.push(D.localize(18,null,f)),!1;return k(g,m,u)?!0:(c.push(D.localize(19,null,g,f)),!1)}function E(g){if(!Array.isArray(g))return!1;for(let m=0,f=g.length;m<f;m++)if(typeof g[m]!="string")return!1;return!0}}),define(ve[194],we([1,0,16,23]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,T,P){let p=P&&P.get("storage.serviceMachineId",-1)||null;if(p)return p;try{const R=(await T.readFile(C.serviceMachineIdResource)).value.toString();p=(0,t.isUUID)(R)?R:null}catch{p=null}if(!p){p=(0,t.generateUuid)();try{await T.writeFile(C.serviceMachineIdResource,v.VSBuffer.fromString(p))}catch{}}return P?.store("storage.serviceMachineId",p,-1,1),p}e.getServiceMachineId=D}),define(ve[59],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(D,C=[],T=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=v}),define(ve[195],we([1,0,59]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var D;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function C(P,p,b){p instanceof v.SyncDescriptor||(p=new v.SyncDescriptor(p,[],Boolean(b))),t.push([P,p])}e.registerSingleton=C;function T(){return t}e.getSingletonServiceDescriptors=T}),define(ve[196],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(C,T){this.key=C,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=v;class t{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(const T of this._nodes.values())T.outgoing.size===0&&C.push(T);return C}insertEdge(C,T){const P=this.lookupOrInsertNode(C),p=this.lookupOrInsertNode(T);P.outgoing.set(p.key,p),p.incoming.set(P.key,P)}removeNode(C){const T=this._hashFn(C);this._nodes.delete(T);for(const P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(C){const T=this._hashFn(C);let P=this._nodes.get(T);return P||(P=new v(T,C),this._nodes.set(T,P)),P}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){const C=[];for(const[T,P]of this._nodes)C.push(`${T}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,T]of this._nodes){const P=new Set([C]),p=this._findCycle(T,P);if(p)return p}}_findCycle(C,T){for(const[P,p]of C.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const b=this._findCycle(p,T);if(b)return b;T.delete(P)}}}e.Graph=t}),define(ve[5],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function P(p){return p[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=P})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(T,P,p){P[v.DI_TARGET]===P?P[v.DI_DEPENDENCIES].push({id:T,index:p}):(P[v.DI_DEPENDENCIES]=[{id:T,index:p}],P[v.DI_TARGET]=P)}function D(T){if(v.serviceIds.has(T))return v.serviceIds.get(T);const P=function(p,b,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,p,R)};return P.toString=()=>T,v.serviceIds.set(T,P),P}e.createDecorator=D;function C(T){return T}e.refineServiceDecorator=C}),define(ve[25],we([1,0,11,4,5]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationOverrides=C;function T(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=T;var P;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function p(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=p;function b(g,m){const f=Object.create(null);for(const c in g)R(f,c,g[c],m);return f}e.toValuesTree=b;function R(g,m,f,c){const u=m.split("."),r=u.pop();let o=g;for(let n=0;n<u.length;n++){const i=u[n];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:c(`Ignoring ${m} as ${u.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[r]=f}catch{c(`Ignoring ${m} as ${u.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${m} as ${u.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=R;function k(g,m){const f=m.split(".");S(g,f)}e.removeFromValueTree=k;function S(g,m){const f=m.shift();if(m.length===0){delete g[f];return}if(Object.keys(g).indexOf(f)!==-1){const c=g[f];typeof c=="object"&&!Array.isArray(c)&&(S(c,m),Object.keys(c).length===0&&delete g[f])}}function y(g,m,f){function c(o,n){let i=o;for(const s of n){if(typeof i!="object"||i===null)return;i=i[s]}return i}const u=m.split("."),r=c(g,u);return typeof r>"u"?f:r}e.getConfigurationValue=y;function h(g,m,f){Object.keys(m).forEach(c=>{c!=="__proto__"&&(c in g?v.isObject(g[c])&&v.isObject(m[c])?h(g[c],m[c],f):f&&(g[c]=m[c]):g[c]=m[c])})}e.merge=h;function w(g,m,f){const c=g.inspect(m),u=g.inspect(f);return typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:typeof u.userValue<"u"||typeof u.workspaceValue<"u"||typeof u.workspaceFolderValue<"u"?u.value:c.defaultValue}e.getMigratedSettingValue=w;function E(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(ve[98],we([1,0,3,15,5]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",v.isMacintosh),C.set("isLinux",v.isLinux),C.set("isWindows",v.isWindows),C.set("isWeb",v.isWeb),C.set("isMacNative",v.isMacintosh&&!v.isWeb),C.set("isEdge",v.isEdge),C.set("isFirefox",v.isFirefox),C.set("isChrome",v.isChrome),C.set("isSafari",v.isSafari);const T=Object.prototype.hasOwnProperty;var P;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class p{static false(){return k.INSTANCE}static true(){return S.INSTANCE}static has(_){return y.create(_)}static equals(_,te){return h.create(_,te)}static notEquals(_,te){return g.create(_,te)}static regex(_,te){return n.create(_,te)}static in(_,te){return w.create(_,te)}static notIn(_,te){return E.create(_,te)}static not(_){return m.create(_)}static and(..._){return a.create(_,null)}static or(..._){return l.create(_,null,!0)}static greater(_,te){return c.create(_,te)}static greaterEquals(_,te){return u.create(_,te)}static smaller(_,te){return r.create(_,te)}static smallerEquals(_,te){return o.create(_,te)}static deserialize(_,te=!1){if(!!_)return this._deserializeOrExpression(_,te)}static _deserializeOrExpression(_,te){const se=_.split("||");return l.create(se.map(W=>this._deserializeAndExpression(W,te)),null,!0)}static _deserializeAndExpression(_,te){const se=_.split("&&");return a.create(se.map(W=>this._deserializeOne(W,te)),null)}static _deserializeOne(_,te){if(_=_.trim(),_.indexOf("!=")>=0){const se=_.split("!=");return g.create(se[0].trim(),this._deserializeValue(se[1],te))}if(_.indexOf("==")>=0){const se=_.split("==");return h.create(se[0].trim(),this._deserializeValue(se[1],te))}if(_.indexOf("=~")>=0){const se=_.split("=~");return n.create(se[0].trim(),this._deserializeRegexValue(se[1],te))}if(_.indexOf(" not in ")>=0){const se=_.split(" not in ");return E.create(se[0].trim(),se[1].trim())}if(_.indexOf(" in ")>=0){const se=_.split(" in ");return w.create(se[0].trim(),se[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const se=_.split(">=");return u.create(se[0].trim(),se[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const se=_.split(">");return c.create(se[0].trim(),se[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const se=_.split("<=");return o.create(se[0].trim(),se[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const se=_.split("<");return r.create(se[0].trim(),se[1].trim())}return/^\!\s*/.test(_)?m.create(_.substr(1).trim()):y.create(_)}static _deserializeValue(_,te){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;const se=/^'([^']*)'$/.exec(_);return se?se[1].trim():_}static _deserializeRegexValue(_,te){if((0,t.isFalsyOrWhitespace)(_)){if(te)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const se=_.indexOf("/"),W=_.lastIndexOf("/");if(se===W||se<0){if(te)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}const fe=_.slice(se+1,W),j=_[W+1]==="i"?"i":"";try{return new RegExp(fe,j)}catch(X){if(te)throw new Error(`bad regexp-value '${_}', parse error: ${X}`);return console.warn(`bad regexp-value '${_}', parse error: ${X}`),null}}}e.ContextKeyExpr=p;function b(Z,_){const te=Z?Z.substituteConstants():void 0,se=_?_.substituteConstants():void 0;return!te&&!se?!0:!te||!se?!1:te.equals(se)}e.expressionsAreEqualWithConstantSubstitution=b;function R(Z,_){return Z.cmp(_)}class k{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class S{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class y{static create(_,te=null){const se=C.get(_);return typeof se=="boolean"?se?S.INSTANCE:k.INSTANCE:new y(_,te)}constructor(_,te){this.key=_,this.negated=te,this.type=2}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=C.get(this.key);return typeof _=="boolean"?_?S.INSTANCE:k.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class h{static create(_,te,se=null){if(typeof te=="boolean")return te?y.create(_,se):m.create(_,se);const W=C.get(_);return typeof W=="boolean"?te===(W?"true":"false")?S.INSTANCE:k.INSTANCE:new h(_,te,se)}constructor(_,te,se){this.key=_,this.value=te,this.negated=se,this.type=4}cmp(_){return _.type!==this.type?this.type-_.type:L(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=C.get(this.key);if(typeof _=="boolean"){const te=_?"true":"false";return this.value===te?S.INSTANCE:k.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class w{static create(_,te){return new w(_,te)}constructor(_,te){this.key=_,this.valueKey=te,this.type=10,this.negated=null}cmp(_){return _.type!==this.type?this.type-_.type:L(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const te=_.getValue(this.valueKey),se=_.getValue(this.key);return Array.isArray(te)?te.includes(se):typeof se=="string"&&typeof te=="object"&&te!==null?T.call(te,se):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=E.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=w;class E{static create(_,te){return new E(_,te)}constructor(_,te){this.key=_,this.valueKey=te,this.type=11,this._negated=w.create(_,te)}cmp(_){return _.type!==this.type?this.type-_.type:this._negated.cmp(_._negated)}equals(_){return _.type===this.type?this._negated.equals(_._negated):!1}substituteConstants(){return this}evaluate(_){return!this._negated.evaluate(_)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(_){return _.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=E;class g{static create(_,te,se=null){if(typeof te=="boolean")return te?m.create(_,se):y.create(_,se);const W=C.get(_);return typeof W=="boolean"?te===(W?"true":"false")?k.INSTANCE:S.INSTANCE:new g(_,te,se)}constructor(_,te,se){this.key=_,this.value=te,this.negated=se,this.type=5}cmp(_){return _.type!==this.type?this.type-_.type:L(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=C.get(this.key);if(typeof _=="boolean"){const te=_?"true":"false";return this.value===te?k.INSTANCE:S.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class m{static create(_,te=null){const se=C.get(_);return typeof se=="boolean"?se?k.INSTANCE:S.INSTANCE:new m(_,te)}constructor(_,te){this.key=_,this.negated=te,this.type=3}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=C.get(this.key);return typeof _=="boolean"?_?k.INSTANCE:S.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function f(Z,_){if(typeof Z=="string"){const te=parseFloat(Z);isNaN(te)||(Z=te)}return typeof Z=="string"||typeof Z=="number"?_(Z):k.INSTANCE}class c{static create(_,te,se=null){return f(te,W=>new c(_,W,se))}constructor(_,te,se){this.key=_,this.value=te,this.negated=se,this.type=12}cmp(_){return _.type!==this.type?this.type-_.type:L(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class u{static create(_,te,se=null){return f(te,W=>new u(_,W,se))}constructor(_,te,se){this.key=_,this.value=te,this.negated=se,this.type=13}cmp(_){return _.type!==this.type?this.type-_.type:L(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class r{static create(_,te,se=null){return f(te,W=>new r(_,W,se))}constructor(_,te,se){this.key=_,this.value=te,this.negated=se,this.type=14}cmp(_){return _.type!==this.type?this.type-_.type:L(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class o{static create(_,te,se=null){return f(te,W=>new o(_,W,se))}constructor(_,te,se){this.key=_,this.value=te,this.negated=se,this.type=15}cmp(_){return _.type!==this.type?this.type-_.type:L(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class n{static create(_,te){return new n(_,te)}constructor(_,te){this.key=_,this.regexp=te,this.type=7,this.negated=null}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const te=this.regexp?this.regexp.source:"",se=_.regexp?_.regexp.source:"";return te<se?-1:te>se?1:0}equals(_){if(_.type===this.type){const te=this.regexp?this.regexp.source:"",se=_.regexp?_.regexp.source:"";return this.key===_.key&&te===se}return!1}substituteConstants(){return this}evaluate(_){const te=_.getValue(this.key);return this.regexp?this.regexp.test(te):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class i{static create(_){return new i(_)}constructor(_){this._actual=_,this.type=8}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new i(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function s(Z){let _=null;for(let te=0,se=Z.length;te<se;te++){const W=Z[te].substituteConstants();if(Z[te]!==W&&_===null){_=[];for(let fe=0;fe<te;fe++)_[fe]=Z[fe]}_!==null&&(_[te]=W)}return _===null?Z:_}class a{static create(_,te){return a._normalizeArr(_,te)}constructor(_,te){this.expr=_,this.negated=te,this.type=6}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let te=0,se=this.expr.length;te<se;te++){const W=R(this.expr[te],_.expr[te]);if(W!==0)return W}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let te=0,se=this.expr.length;te<se;te++)if(!this.expr[te].equals(_.expr[te]))return!1;return!0}return!1}substituteConstants(){const _=s(this.expr);return _===this.expr?this:a.create(_,this.negated)}evaluate(_){for(let te=0,se=this.expr.length;te<se;te++)if(!this.expr[te].evaluate(_))return!1;return!0}static _normalizeArr(_,te){const se=[];let W=!1;for(const fe of _)if(!!fe){if(fe.type===1){W=!0;continue}if(fe.type===0)return k.INSTANCE;if(fe.type===6){se.push(...fe.expr);continue}se.push(fe)}if(se.length===0&&W)return S.INSTANCE;if(se.length!==0){if(se.length===1)return se[0];se.sort(R);for(let fe=1;fe<se.length;fe++)se[fe-1].equals(se[fe])&&(se.splice(fe,1),fe--);if(se.length===1)return se[0];for(;se.length>1;){const fe=se[se.length-1];if(fe.type!==9)break;se.pop();const j=se.pop(),X=se.length===0,O=l.create(fe.expr.map(U=>a.create([U,j],null)),null,X);O&&(se.push(O),se.sort(R))}return se.length===1?se[0]:new a(se,te)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(const te of this.expr)_.push(...te.keys());return _}map(_){return new a(this.expr.map(te=>te.map(_)),null)}negate(){if(!this.negated){const _=[];for(const te of this.expr)_.push(te.negate());this.negated=l.create(_,this,!0)}return this.negated}}class l{static create(_,te,se){return l._normalizeArr(_,te,se)}constructor(_,te){this.expr=_,this.negated=te,this.type=9}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let te=0,se=this.expr.length;te<se;te++){const W=R(this.expr[te],_.expr[te]);if(W!==0)return W}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let te=0,se=this.expr.length;te<se;te++)if(!this.expr[te].equals(_.expr[te]))return!1;return!0}return!1}substituteConstants(){const _=s(this.expr);return _===this.expr?this:l.create(_,this.negated,!1)}evaluate(_){for(let te=0,se=this.expr.length;te<se;te++)if(this.expr[te].evaluate(_))return!0;return!1}static _normalizeArr(_,te,se){let W=[],fe=!1;if(_){for(let j=0,X=_.length;j<X;j++){const O=_[j];if(!!O){if(O.type===0){fe=!0;continue}if(O.type===1)return S.INSTANCE;if(O.type===9){W=W.concat(O.expr);continue}W.push(O)}}if(W.length===0&&fe)return k.INSTANCE;W.sort(R)}if(W.length!==0){if(W.length===1)return W[0];for(let j=1;j<W.length;j++)W[j-1].equals(W[j])&&(W.splice(j,1),j--);if(W.length===1)return W[0];if(se){for(let j=0;j<W.length;j++)for(let X=j+1;X<W.length;X++)B(W[j],W[X])&&(W.splice(X,1),X--);if(W.length===1)return W[0]}return new l(W,te)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(const te of this.expr)_.push(...te.keys());return _}map(_){return new l(this.expr.map(te=>te.map(_)),null)}negate(){if(!this.negated){const _=[];for(const te of this.expr)_.push(te.negate());for(;_.length>1;){const te=_.shift(),se=_.shift(),W=[];for(const j of J(te))for(const X of J(se))W.push(a.create([j,X],null));const fe=_.length===0;_.unshift(l.create(W,null,fe))}this.negated=_[0]}return this.negated}}class d extends y{static all(){return d._info.values()}constructor(_,te,se){super(_,null),this._defaultValue=te,typeof se=="object"?d._info.push({...se,key:_}):se!==!0&&d._info.push({key:_,description:se,type:te!=null?typeof te:void 0})}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return h.create(this.key,_)}notEqualsTo(_){return g.create(this.key,_)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I(Z,_){return Z<_?-1:Z>_?1:0}function L(Z,_,te,se){return Z<te?-1:Z>te?1:_<se?-1:_>se?1:0}function B(Z,_){if(_.type===6&&Z.type!==9&&Z.type!==6){for(const W of _.expr)if(Z.equals(W))return!0}const te=Z.negate(),se=J(te).concat(J(_));se.sort(R);for(let W=0;W<se.length;W++){const j=se[W].negate();for(let X=W+1;X<se.length;X++){const O=se[X];if(j.equals(O))return!0}}return!1}e.implies=B;function J(Z){return Z.type===9?Z.expr:[Z]}}),define(ve[71],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,v.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(C,T){return this.secretVault[C]?.[T]??null}async setPassword(C,T,P){this.secretVault[C]=this.secretVault[C]??{},this.secretVault[C][T]=P}async deletePassword(C,T){return this.secretVault[C]?.[T]?(delete this.secretVault[C][T],Object.keys(this.secretVault[C]).length===0&&delete this.secretVault[C],!0):!1}async findPassword(C){return JSON.stringify(this.secretVault[C])??null}async findCredentials(C){const T=[];for(const P of Object.keys(this.secretVault[C]||{}))T.push({account:P,password:this.secretVault[C][P]});return T}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(ve[197],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function t(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=t;class D{async getPerformanceInfo(T,P){return{}}async getSystemInfo(T,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,P){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=D}),define(ve[72],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,v.createDecorator)("downloadService")}),define(ve[198],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService")}),define(ve[26],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[31],we([1,0,163,5]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function C(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function T(g,m){switch(g){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function P(g,m){return m==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function p(g,m,f){return P(m,f)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===f?!0:b(f).includes(g)}e.isTargetPlatformCompatible=p;function b(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function R(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=R;var k;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var S;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var y;(function(g){g.Install="install",g.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var h;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var w;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(m,f){super(m),this.code=f,this.name=f}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ve[199],we([1,0,7,2,48,22,4,69,31]),function(oe,e,v,t,D,C,T,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(E,g){return T.URI.revive(g?g.transformIncoming(E):E)}function R(E,g){return g?g.transformOutgoingURI(E):E}function k(E,g){g=g||P.DefaultURITransformer;const m=E.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...E,manifest:void 0},g),manifest:m}}function S(E,g){return g?(0,C.cloneAndChange)(E,m=>m instanceof T.URI?g.transformOutgoingURI(m):void 0):E}class y{constructor(g,m){this.service=g,this.getUriTransformer=m,this.onInstallExtension=v.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=v.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=v.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=v.Event.buffer(g.onDidUninstallExtension,!0)}listen(g,m){const f=this.getUriTransformer(g);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return v.Event.map(this.onDidInstallExtensions,c=>c.map(u=>({...u,local:u.local?S(u.local,f):u.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(g,m,f){const c=this.getUriTransformer(g);switch(m){case"zip":return this.service.zip(k(f[0],c)).then(u=>R(u,c));case"unzip":return this.service.unzip(b(f[0],c));case"install":return this.service.install(b(f[0],c),(0,D.revive)(f[1]));case"getManifest":return this.service.getManifest(b(f[0],c));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(f[0]);case"installFromGallery":return this.service.installFromGallery(f[0],(0,D.revive)(f[1]));case"uninstall":return this.service.uninstall(k(f[0],c),(0,D.revive)(f[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(k(f[0],c));case"getInstalled":return this.service.getInstalled(f[0],T.URI.revive(f[1])).then(u=>u.map(r=>S(r,c)));case"getMetadata":return this.service.getMetadata(k(f[0],c));case"updateMetadata":return this.service.updateMetadata(k(f[0],c),f[1]).then(u=>S(u,c));case"updateExtensionScope":return this.service.updateExtensionScope(k(f[0],c),f[1]).then(u=>S(u,c));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class h extends t.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(g){super(),this.channel=g,this._onInstallExtension=this._register(new v.Emitter),this._onDidInstallExtensions=this._register(new v.Emitter),this._onUninstallExtension=this._register(new v.Emitter),this._onDidUninstallExtension=this._register(new v.Emitter),this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?T.URI.revive(m.source):m.source,profileLocation:T.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(f=>({...f,local:f.local?k(f.local,null):f.local,source:this.isUriComponents(f.source)?T.URI.revive(f.source):f.source,profileLocation:T.URI.revive(f.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire({identifier:m.identifier,profileLocation:T.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire({...m,profileLocation:T.URI.revive(m.profileLocation)})))}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const m=await this.getTargetPlatform();return g.allTargetPlatforms.some(f=>(0,p.isTargetPlatformCompatible)(f,g.allTargetPlatforms,m))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(m=>T.URI.revive(m)))}unzip(g){return Promise.resolve(this.channel.call("unzip",[g]))}install(g,m){return Promise.resolve(this.channel.call("install",[g,m])).then(f=>k(f,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,m){return Promise.resolve(this.channel.call("installFromGallery",[g,m])).then(f=>k(f,null))}uninstall(g,m){return Promise.resolve(this.channel.call("uninstall",[g,m]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g]))}getInstalled(g=null,m){return Promise.resolve(this.channel.call("getInstalled",[g,m])).then(f=>f.map(c=>k(c,null)))}getMetadata(g){return Promise.resolve(this.channel.call("getMetadata",[g]))}updateMetadata(g,m){return Promise.resolve(this.channel.call("updateMetadata",[g,m])).then(f=>k(f,null))}updateExtensionScope(g,m){return Promise.resolve(this.channel.call("updateExtensionScope",[g,m])).then(f=>k(f,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class w{constructor(g){this.service=g}listen(g,m){throw new Error("Invalid listen")}call(g,m,f){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=w}),define(ve[17],we([1,0,24,6,15,11,4,171,5]),function(oe,e,v,t,D,C,T,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function b(j){return j.create===!0}e.isFileOpenForWriteOptions=b;var R;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var k;(function(j){j[j.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var S;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=y;function h(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=h;function w(j){return!!(j.capabilities&32768)}e.hasFileCloneCapability=w;function E(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=E;function g(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=g;function m(j){return y(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var f;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(X,O){super(X),this.code=O}}e.FileSystemProviderError=c;function u(j,X){const O=new c(j.toString(),X);return o(O,X),O}e.createFileSystemProviderError=u;function r(j){return j||u((0,P.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=r;function o(j,X){return j.name=X?`${X} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=o;function n(j){if(!j)return f.Unknown;if(j instanceof c)return j.code;const X=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!X)return f.Unknown;switch(X[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=n;function i(j){if(j instanceof L)return j.fileOperationResult;switch(n(j)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(X,O,U){this.resource=X,this.operation=O,this.target=U}isOperation(X){return this.operation===X}}e.FileOperationEvent=a;var l;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class d{constructor(X,O){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=X;const U=new Map;for(const x of X){const ae=U.get(x.type);switch(ae?ae.push([x.resource,x]):U.set(x.type,[[x.resource,x]]),x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}}for(const[x,ae]of U)switch(x){case 1:this.added=v.TernarySearchTree.forUris(()=>O),this.added.fill(ae);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>O),this.updated.fill(ae);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>O),this.deleted.fill(ae);break}}contains(X,...O){return this.doContains(X,{includeChildren:!1},...O)}affects(X,...O){return this.doContains(X,{includeChildren:!0},...O)}doContains(X,O,...U){if(!X)return!1;const x=U.length>0;return!!((!x||U.includes(1))&&(this.added?.get(X)||O.includeChildren&&this.added?.findSuperstr(X))||(!x||U.includes(0))&&(this.updated?.get(X)||O.includeChildren&&this.updated?.findSuperstr(X))||(!x||U.includes(2))&&(this.deleted?.findSubstr(X)||O.includeChildren&&this.deleted?.findSuperstr(X)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function I(j,X,O){return!j||!X||j===X||X.length>j.length?!1:(X.charAt(X.length-1)!==t.sep&&(X+=t.sep),O?(0,D.startsWithIgnoreCase)(j,X):j.indexOf(X)===0)}e.isParent=I;class L extends Error{constructor(X,O,U){super(X),this.fileOperationResult=O,this.options=U}}e.FileOperationError=L;class B extends L{constructor(X,O,U){super(X,2,U),this.stat=O}}e.NotModifiedSinceFileOperationError=B;var J;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(J=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Z;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function _(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=_;async function te(j,X){if(!X.hasProvider(T.URI.from({scheme:j.scheme})))return new Promise(O=>{const U=X.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===j.scheme&&x.added&&(U.dispose(),O())})})}e.whenProviderRegistered=te,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(X){return(0,C.isNumber)(X)||(X=0),X<se.KB?(0,P.localize)(1,null,X.toFixed(0)):X<se.MB?(0,P.localize)(2,null,(X/se.KB).toFixed(2)):X<se.GB?(0,P.localize)(3,null,(X/se.MB).toFixed(2)):X<se.TB?(0,P.localize)(4,null,(X/se.GB).toFixed(2)):(0,P.localize)(5,null,(X/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var W;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(W=e.Arch||(e.Arch={}));function fe(j){return{maxFileSize:j===0?300*se.MB:16*se.GB,maxHeapSize:j===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=fe}),define(ve[200],we([1,0,16,38,10,7,2,45,4,23,17]),function(oe,e,v,t,D,C,T,P,p,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends T.Disposable{constructor(y,h){super(),this.channel=y,this.extraCapabilities=h,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,h){const{buffer:w}=await this.channel.call("readFile",[y,h]);return w}readFileStream(y,h,w){const E=(0,P.newWriteableStream)(m=>v.VSBuffer.concat(m.map(f=>v.VSBuffer.wrap(f))).buffer),g=this.channel.listen("readFileStream",[y,h])(m=>{if(m instanceof v.VSBuffer)E.write(m.buffer);else{if(m==="end")E.end();else{let f=m;f instanceof Error||(f=(0,R.createFileSystemProviderError)((0,t.toErrorMessage)(f),R.FileSystemProviderErrorCode.Unknown)),E.error(f),E.end()}g.dispose()}});return w.onCancellationRequested(()=>{E.error((0,D.canceled)()),E.end(),g.dispose()}),E}writeFile(y,h,w){return this.channel.call("writeFile",[y,v.VSBuffer.wrap(h),w])}open(y,h){return this.channel.call("open",[y,h])}close(y){return this.channel.call("close",[y])}async read(y,h,w,E,g){const[m,f]=await this.channel.call("read",[y,h,g]);return w.set(m.buffer.slice(0,f),E),f}write(y,h,w,E,g){return this.channel.call("write",[y,h,v.VSBuffer.wrap(w),E,g])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,h){return this.channel.call("delete",[y,h])}rename(y,h,w){return this.channel.call("rename",[y,h,w])}copy(y,h,w){return this.channel.call("copy",[y,h,w])}cloneFile(y,h){return this.channel.call("cloneFile",[y,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const h=y;this._onDidChange.fire(h.map(w=>({resource:p.URI.revive(w.resource),type:w.type})))}else{const h=y;this._onDidWatchError.fire(h)}}))}watch(y,h){const w=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,w,y,h]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,w]))}}e.DiskFileSystemProviderClient=k}),define(ve[99],we([1,0,16,10,172,17]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(R,k,S,y,h,w){let E;try{await P(R,k,S,y,h,w)}catch(g){E=g}finally{E&&h.errorTransformer&&(E=h.errorTransformer(E)),typeof E<"u"&&S.error(E),S.end()}}e.readFileIntoStream=T;async function P(R,k,S,y,h,w){p(w);const E=await R.open(k,{create:!1});try{p(w);let g=0,m=0,f=h&&typeof h.length=="number"?h.length:void 0,c=v.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),u=h&&typeof h.position=="number"?h.position:0,r=0;do m=await R.read(E,u,c.buffer,r,c.byteLength-r),u+=m,r+=m,g+=m,typeof f=="number"&&(f-=m),r===c.byteLength&&(await S.write(y(c)),c=v.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),r=0);while(m>0&&(typeof f!="number"||f>0)&&p(w)&&b(g,h));if(r>0){let o=r;typeof f=="number"&&(o=Math.min(r,f)),S.write(y(c.slice(0,o)))}}catch(g){throw(0,C.ensureFileSystemProviderError)(g)}finally{await R.close(E)}}function p(R){if(R.isCancellationRequested)throw(0,t.canceled)();return!0}function b(R,k){if(k?.limits){if(typeof k.limits.memory=="number"&&R>k.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&R>k.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ve[60],we([1,0,68,2,6,3,4,17]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function p(g){return g.recursive===!0}e.isRecursiveWatchRequest=p;class b extends t.Disposable{constructor(m,f,c,u){super(),this.onFileChanges=m,this.onLogMessage=f,this.verboseLogging=c,this.options=u,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new t.DisposableStore;this.watcherDisposables.value=m,this.watcher=this.createWatcher(m),this.watcher.setVerboseLogging(this.verboseLogging),m.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),m.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),m.add(this.watcher.onDidError(f=>this.onError(f)))}onError(m){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`):this.error(m)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.watcher?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.watcher?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${m}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class R extends b{constructor(m,f,c){super(m,f,c,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=R;class k extends b{constructor(m,f,c){super(m,f,c,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function S(g){return g.map(m=>({type:m.type,resource:T.URI.file(m.path)}))}e.toFileChanges=S;function y(g){const m=new E;for(const f of g)m.processEvent(f);return m.coalesce()}e.coalesceEvents=y;function h(g,m){return typeof m=="string"&&!m.startsWith(v.GLOBSTAR)&&!(0,D.isAbsolute)(m)?{base:g,pattern:m}:m}e.normalizeWatcherPattern=h;function w(g,m){const f=[];for(const c of m)f.push((0,v.parse)(h(g,c)));return f}e.parseWatcherPatterns=w;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return C.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const f=this.mapPathToChange.get(this.toKey(m));let c=!1;if(f){const u=f.type,r=m.type;f.path!==m.path&&(m.type===2||m.type===1)?c=!0:u===1&&r===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(f)):u===2&&r===1?f.type=0:u===1&&r===0||(f.type=r)}else c=!0;c&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],f=[];return Array.from(this.coalesced).filter(c=>c.type!==2?(m.push(c),!1):!0).sort((c,u)=>c.path.length-u.path.length).filter(c=>f.some(u=>(0,P.isParent)(c.path,u,!C.isLinux))?!1:(f.push(c.path),!0)).concat(m)}}}),define(ve[201],we([1,0,29,14,20,36,2,89,6,3,153,21,60]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends T.Disposable{constructor(E,g,m,f){super(),this.request=E,this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=f,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const E=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await k.Promises.stat(E);this._register(await this.doWatch(E,g.isDirectory()))}catch(E){E.code!=="ENOENT"?this.error(E):this.trace(E)}}async normalizePath(E){let g=E.path;try{g=await k.Promises.realpath(E.path),E.path===g&&(g=await(0,R.realcase)(E.path)??E.path),E.path!==g&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${E.path}, real: ${g})`)}catch{}return g}async doWatch(E,g){if(b.isMacintosh&&(0,C.isEqualOrParent)(E,"/Volumes/",!0))return this.error(`Refusing to watch ${E} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const m=new D.CancellationTokenSource(this.cts.token),f=new T.DisposableStore;try{const c=(0,p.basename)(E),u=(0,v.watch)(E);f.add((0,T.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${E}'`);const r=new Set;if(g)try{for(const n of await k.Promises.readdir(E))r.add(n)}catch(n){this.error(n)}const o=new Map;f.add((0,T.toDisposable)(()=>{for(const[,n]of o)n.dispose();o.clear()})),u.on("error",(n,i)=>{this.error(`Failed to watch ${E} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),u.on("change",(n,i)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${i}`);let s="";if(i&&(s=i.toString(),b.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(g)if(n==="rename"){o.get(s)?.dispose();const a=setTimeout(async()=>{if(o.delete(s),s===c&&!await k.Promises.exists(E)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,p.join)(E,s));if(m.token.isCancellationRequested)return;let d;l?r.has(s)?d=0:(d=1,r.add(s)):(r.delete(s),d=2),this.onFileChange({path:(0,p.join)(this.request.path,s),type:d})},y.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,T.toDisposable)(()=>clearTimeout(a)))}else{let a;r.has(s)?a=0:(a=1,r.add(s)),this.onFileChange({path:(0,p.join)(this.request.path,s),type:a})}else if(n==="rename"||s!==c){const a=setTimeout(async()=>{const l=await k.Promises.exists(E);m.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(E,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,T.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await k.Promises.exists(E)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${E} for changes using fs.watch() (${c.toString()})`)}return(0,T.toDisposable)(()=>{m.dispose(!0),f.dispose()})}async onFileChange(E,g=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),!g&&this.excludes.some(m=>m(E.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${E.path}`):!g&&this.includes&&this.includes.length>0&&!this.includes.some(m=>m(E.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${E.path}`):this.fileChangesBuffer.push(E);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,S.coalesceEvents)(m);if(f.length>0){if(this.verboseLogging)for(const u of f)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(E){if(b.isLinux)return k.Promises.exists(E);try{const g=(0,p.basename)(E);return(await k.Promises.readdir((0,p.dirname)(E))).some(f=>f===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(E){this.verboseLogging=E}error(E){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${E}`})}warn(E){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${E}`})}trace(E){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function h(w,E,g,m,f=512){const c=await k.Promises.open(w,"r"),u=Buffer.allocUnsafe(f),r=new D.CancellationTokenSource(m);let o,n=!1;const i={path:w,excludes:[],recursive:!1},s=new y(i,a=>{(async()=>{for(const{type:l}of a)if(l===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:d}=await k.Promises.read(c,u,0,f,null);if(!d||r.token.isCancellationRequested)break;E(u.slice(0,d))}}catch(d){o=new Error(d),r.dispose(!0)}finally{n=!1}}})()});return await s.ready,g(),new Promise((a,l)=>{r.token.onCancellationRequested(async()=>{s.dispose();try{await k.Promises.close(c)}catch(d){o=new Error(d)}o?l(o):a()})})}e.watchFileContents=h}),define(ve[202],we([1,0,7,68,2,3,201]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends D.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new v.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=v.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const R=this.normalizeRequests(b),k=R.filter(y=>{const h=this.watchers.get(y.path);return h?!(0,t.patternsEquals)(h.request.excludes,y.excludes)||!(0,t.patternsEquals)(h.request.includes,y.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:y})=>!R.find(h=>h.path===y.path&&(0,t.patternsEquals)(h.excludes,y.excludes)&&(0,t.patternsEquals)(h.includes,y.includes))).map(({request:y})=>y.path);k.length&&this.trace(`Request to start watching: ${k.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const y of S)this.stopWatching(y);for(const y of k)this.startWatching(y)}startWatching(b){const R=new T.NodeJSFileWatcherLibrary(b,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),k={request:b,instance:R};this.watchers.set(b.path,k)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const R=this.watchers.get(b);R&&(this.watchers.delete(b),R.instance.dispose())}normalizeRequests(b){const R=new Map;for(const k of b){const S=C.isLinux?k.path:k.path.toLowerCase();R.set(S,k)}return Array.from(R.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,R]of this.watchers)R.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,R){return R?`[File Watcher (node.js)] ${b} (path: ${R.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=P}),define(ve[203],we([1,0,60,202]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends v.AbstractNonRecursiveWatcherClient{constructor(T,P,p){super(T,P,p),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(ve[204],we([1,0,12,41,96,60]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends C.AbstractUniversalWatcherClient{constructor(p,b,R){super(p,b,R),this.init()}createWatcher(p){const b=p.add(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(b.onDidProcessExit(({code:R,signal:k})=>this.onError(`terminated by itself with code ${R}, signal: ${k}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ve[73],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(const[C,T]of D)this.set(C,T)}set(D,C){const T=this._entries.get(D);return this._entries.set(D,C),T}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(ve[100],we([1,0,14,10,59,196,5,73]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class b extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class R{constructor(h=new P.ServiceCollection,w=!1,E,g=p){this._services=h,this._strict=w,this._parent=E,this._enableTracing=g,this._activeInstantiations=new Set,this._services.set(T.IInstantiationService,this),this._globalGraph=g?E?._globalGraph??new C.Graph(m=>m):void 0}createChild(h){return new R(h,this._strict,this,this._enableTracing)}invokeFunction(h,...w){const E=S.traceInvocation(this._enableTracing,h);let g=!1;try{return h({get:f=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(f,E);if(!c)throw new Error(`[invokeFunction] unknown service '${f}'`);return c}},...w)}finally{g=!0,E.stop()}}createInstance(h,...w){let E,g;return h instanceof D.SyncDescriptor?(E=S.traceCreation(this._enableTracing,h.ctor),g=this._createInstance(h.ctor,h.staticArguments.concat(w),E)):(E=S.traceCreation(this._enableTracing,h),g=this._createInstance(h,w,E)),E.stop(),g}_createInstance(h,w=[],E){const g=T._util.getServiceDependencies(h).sort((c,u)=>c.index-u.index),m=[];for(const c of g){const u=this._getOrCreateServiceInstance(c.id,E);u||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`,!1),m.push(u)}const f=g.length>0?g[0].index:w.length;if(w.length!==f){console.trace(`[createInstance] First service dependency of ${h.name} at position ${f+1} conflicts with ${w.length} static arguments`);const c=f-w.length;c>0?w=w.concat(new Array(c)):w=w.slice(0,f)}return new h(...w,...m)}_setServiceInstance(h,w){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(h));const E=this._getServiceInstanceOrDescriptor(h);return E instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,E,w.branch(h,!0)):(w.branch(h,!1),E)}_safeCreateAndCacheServiceInstance(h,w,E){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,E)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,E){const g=new C.Graph(c=>c.id.toString());let m=0;const f=[{id:h,desc:w,_trace:E}];for(;f.length;){const c=f.pop();if(g.lookupOrInsertNode(c),m++>1e3)throw new b(g);for(const u of T._util.getServiceDependencies(c.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(u.id);if(r||this._throwIfStrict(`[createInstance] ${h} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(c.id),String(u.id)),r instanceof D.SyncDescriptor){const o={id:u.id,desc:r,_trace:c._trace.branch(u.id,!0)};g.insertEdge(c,o),f.push(o)}}}for(;;){const c=g.roots();if(c.length===0){if(!g.isEmpty())throw new b(g);break}for(const{data:u}of c){if(this._getServiceInstanceOrDescriptor(u.id)instanceof D.SyncDescriptor){const o=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,o)}g.removeNode(u)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,E=[],g,m){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(h,w,E,g,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,E,g,m);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w,E=[],g,m){if(g){const f=new R(void 0,this._strict,this,this._enableTracing);f._globalGraphImplicitDependency=String(h);const c=new v.IdleValue(()=>f._createInstance(w,E,m));return new Proxy(Object.create(null),{get(u,r){if(r in u)return u[r];const o=c.value;let n=o[r];return typeof n!="function"||(n=n.bind(o),u[r]=n),n},set(u,r,o){return c.value[r]=o,!0}})}else return this._createInstance(w,E,m)}_throwIfStrict(h,w){if(w&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=R;var k;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(k||(k={}));class S{static traceInvocation(h,w){return h?new S(1,w.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(h,w){return h?new S(0,w.name):S._None}constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}branch(h,w){const E=new S(2,h.toString());return this._dep.push([h,w,E]),E}stop(){const h=Date.now()-this._start;S._totals+=h;let w=!1;function E(m,f){const c=[],u=new Array(m+1).join("	");for(const[r,o,n]of f._dep)if(o&&n){w=!0,c.push(`${u}CREATES -> ${r}`);const i=E(m+1,n);i&&c.push(i)}else c.push(`${u}uses -> ${r}`);return c.join(`
`)}const g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(h>2||w)&&S.all.add(g.join(`
`))}}e.Trace=S,S.all=new Set,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(ve[205],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,v.createDecorator)("labelService")});var _e=this&&this.__param||function(oe,e){return function(v,t){e(v,t,oe)}};define(ve[74],we([1,0,20,2,3,174,31,5]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let p=class extends t.Disposable{constructor(R){super(),this.extensionGalleryService=R}async getAvailableLanguages(){const R=new v.CancellationTokenSource;setTimeout(()=>R.cancel(),1e3);let k;try{k=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},R.token)}catch{return[]}const y=k.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(w=>w.startsWith("lp-"))).map(h=>{const w=h.properties.localizedLanguages?.[0],E=this.getLocale(h);return{...this.createQuickPickItem(E,w,h),extensionId:h.identifier.id,galleryExtension:h}});return y.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),y}getLocale(R){return R.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(R,k,S){const y=k??R;let h;if(y!==R&&(h=`(${R})`),R.toLowerCase()===D.language.toLowerCase()&&(h??="",h+=(0,C.localize)(0,null)),S?.installCount){h??="";const w=S.installCount;let E;w>1e6?E=`${Math.floor(w/1e5)/10}M`:w>1e3?E=`${Math.floor(w/1e3)}K`:E=String(w),h+=` $(cloud-download) ${E}`}return{id:R,label:y,description:h}}};p=Ae([_e(0,T.IExtensionGalleryService)],p),e.LanguagePackBaseService=p}),define(ve[13],we([1,0,38,7,2,3,5]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function P(){return new Date().toISOString()}var p;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;function b(o,n,i){switch(n){case p.Trace:o.trace(i);break;case p.Debug:o.debug(i);break;case p.Info:o.info(i);break;case p.Warning:o.warn(i);break;case p.Error:o.error(i);break;case p.Critical:o.critical(i);break;default:throw new Error("Invalid log level")}}e.log=b;function R(o){let n="";for(let i=0;i<o.length;i++){let s=o[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(i>0?" ":"")+s}return n}e.format=R;class k extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class S extends k{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(p.Trace)&&this.log(p.Trace,R([n,...i]))}debug(n,...i){this.checkLogLevel(p.Debug)&&this.log(p.Debug,R([n,...i]))}info(n,...i){this.checkLogLevel(p.Info)&&this.log(p.Info,R([n,...i]))}warn(n,...i){this.checkLogLevel(p.Warning)&&this.log(p.Warning,R([n,...i]))}error(n,...i){if(this.checkLogLevel(p.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(p.Error,R(s))}else this.log(p.Error,R([n,...i]))}critical(n,...i){this.checkLogLevel(p.Critical)&&this.log(p.Critical,R([n,...i]))}flush(){}}e.AbstractMessageLogger=S;class y extends k{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!C.isWindows}trace(n,...i){this.getLevel()<=p.Trace&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,n,...i):console.log(`[main ${P()}]`,n,...i))}debug(n,...i){this.getLevel()<=p.Debug&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,n,...i):console.log(`[main ${P()}]`,n,...i))}info(n,...i){this.getLevel()<=p.Info&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,n,...i):console.log(`[main ${P()}]`,n,...i))}warn(n,...i){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,n,...i):console.warn(`[main ${P()}]`,n,...i))}error(n,...i){this.getLevel()<=p.Error&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,n,...i):console.error(`[main ${P()}]`,n,...i))}critical(n,...i){this.getLevel()<=p.Critical&&(this.useColors?console.error(`\x1B[90m[main ${P()}]\x1B[0m`,n,...i):console.error(`[main ${P()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class h extends k{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...i){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=h;class w extends k{constructor(n,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,v.toErrorMessage)(n,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class E extends k{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const s of this.logServices)s.trace(n,...i)}debug(n,...i){for(const s of this.logServices)s.debug(n,...i)}info(n,...i){for(const s of this.logServices)s.info(n,...i)}warn(n,...i){for(const s of this.logServices)s.warn(n,...i)}error(n,...i){for(const s of this.logServices)s.error(n,...i)}critical(n,...i){for(const s of this.logServices)s.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=E;class g extends D.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=g;class m extends D.Disposable{constructor(n,i){super(),this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,i?.always?p.Trace:this.logLevel,i),this.loggers.set(n.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=m;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return p.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=f;function c(o){if(o.verbose)return p.Trace;if(typeof o.logLevel=="string"){const n=u(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function u(o){switch(o){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=u;function r(o){switch(o){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=r}),define(ve[206],we([1,0,71,7,2,13,3,14]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let p=class Wt extends D.Disposable{constructor(R){super(),this.logService=R,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(R,k){this.logService.trace("Getting password from keytar:",R,k);let S;try{S=await this.withKeytar()}catch{return null}const y=await(0,P.retry)(()=>S.getPassword(R,k),50,3);if(!y)return this.logService.trace("Did not get a password from keytar for account:",k),y;let h,w;try{const E=JSON.parse(y);h=E.content,w=E.hasNextChunk}catch{}if(!h||!w)return this.logService.trace("Got password from keytar for account:",k),y;try{let E=1;for(;w;){const g=await(0,P.retry)(()=>S.getPassword(R,`${k}-${E}`),50,3),m=JSON.parse(g);h+=m.content,w=m.hasNextChunk,E++}return this.logService.trace(`Got ${E}-chunked password from keytar for account:`,k),h}catch(E){return this.logService.error(E),y}}async setPassword(R,k,S){this.logService.trace("Setting password using keytar:",R,k);let y;try{y=await this.withKeytar()}catch(h){throw this.surfaceKeytarLoadError?.(h),h}if(T.isWindows&&S.length>Wt.MAX_PASSWORD_LENGTH){let h=0,w=0,E=!0;for(;E;){const g=S.substring(h,h+Wt.PASSWORD_CHUNK_SIZE);h+=Wt.PASSWORD_CHUNK_SIZE,E=S.length-h>0;const m={content:g,hasNextChunk:E};await(0,P.retry)(()=>y.setPassword(R,w?`${k}-${w}`:k,JSON.stringify(m)),50,3),w++}this.logService.trace(`Got${w?` ${w}-chunked`:""} password from keytar for account:`,k)}else await(0,P.retry)(()=>y.setPassword(R,k,S),50,3),this.logService.trace("Got password from keytar for account:",k);this._onDidChangePassword.fire({service:R,account:k})}async deletePassword(R,k){this.logService.trace("Deleting password using keytar:",R,k);let S;try{S=await this.withKeytar()}catch(g){throw this.surfaceKeytarLoadError?.(g),g}const y=await S.getPassword(R,k);if(!y)return this.logService.trace("Did not get a password to delete from keytar for account:",k),!1;let h,w;try{const g=JSON.parse(y);h=g.content,w=g.hasNextChunk}catch{}let E=0;if(h&&w)try{for(E++;w;){const g=`${k}-${E}`,m=await S.getPassword(R,g);await S.deletePassword(R,g),w=JSON.parse(m).hasNextChunk,E++}}catch(g){this.logService.error(g)}return await S.deletePassword(R,k)?(this._onDidChangePassword.fire({service:R,account:k}),this.logService.trace(`Deleted${E?` ${E}-chunked`:""} password from keytar for account:`,k),!0):(this.logService.trace(`Keytar failed to delete${E?` ${E}-chunked`:""} password for account:`,k),!1)}async findPassword(R){let k;try{k=await this.withKeytar()}catch{return null}return await k.findPassword(R)}async findCredentials(R){let k;try{k=await this.withKeytar()}catch{return[]}return await k.findCredentials(R)}clear(){return this._keytarCache instanceof v.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};p.MAX_PASSWORD_LENGTH=2500,p.PASSWORD_CHUNK_SIZE=p.MAX_PASSWORD_LENGTH-100,p=Ae([_e(0,C.ILogService)],p),e.BaseCredentialsMainService=p}),define(ve[207],we([1,0,18,14,10,7,2,6,60,13]),function(oe,e,v,t,D,C,T,P,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends T.Disposable{constructor(S,y){super(),this.logService=S,this.options=y,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(S,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,y):this.watchNonRecursive(S,y)}watchUniversal(S,y){const h={path:this.toFilePath(S),excludes:y.excludes,includes:y.includes,recursive:y.recursive},w=(0,v.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,p.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const y of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const y of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(y)&&S.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,y){const h={path:this.toFilePath(S),excludes:y.excludes,includes:y.includes,recursive:!1},w=(0,v.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,p.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,P.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(ve[101],we([1,0,18,14,16,20,7,88,44,2,24,12,46,19,45,170,17,99,13]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let f=class extends b.Disposable{constructor(u){super(),this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(u,r){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${u}`);const o=new b.DisposableStore;return this.provider.set(u,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:r}),o.add(r.onDidChangeFile(n=>this._onDidFilesChange.fire(new E.FileChangesEvent(n,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&o.add(r.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),o.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:u}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:r}),this.provider.delete(u),(0,b.dispose)(o)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(o){r.push(o)}}),!this.provider.has(u)&&await t.Promises.settled(r)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,r){const o=this.provider.get(u.scheme);return!!(o&&o.capabilities&r)}listCapabilities(){return p.Iterable.map(this.provider,([u,r])=>({scheme:u,capabilities:r.capabilities}))}async withProvider(u){if(!(0,y.isAbsolutePath)(u))throw new E.FileOperationError((0,w.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const r=this.provider.get(u.scheme);if(!r){const o=new Error;throw o.name="ENOPRO",o.message=(0,w.localize)(1,null,u.toString()),o}return r}async withReadProvider(u){const r=await this.withProvider(u);if((0,E.hasOpenReadWriteCloseCapability)(r)||(0,E.hasReadWriteCapability)(r)||(0,E.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const r=await this.withProvider(u);if((0,E.hasOpenReadWriteCloseCapability)(r)||(0,E.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,r){try{return await this.doResolveFile(u,r)}catch(o){throw(0,E.toFileSystemProviderErrorCode)(o)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,w.localize)(2,null,this.resourceForError(u)),1):(0,E.ensureFileSystemProviderError)(o)}}async doResolveFile(u,r){const o=await this.withProvider(u),n=this.isPathCaseSensitive(o),i=r?.resolveTo,s=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,l=await o.stat(u);let d;return this.toFileStat(o,u,l,void 0,!!a,(I,L)=>(d||(d=R.TernarySearchTree.forUris(()=>!n),d.set(u,!0),i&&d.fill(!0,i)),d.get(I.resource)||d.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&s?L===1:!1))}async toFileStat(u,r,o,n,i,s){const{providerExtUri:a}=this.getExtUri(u),l={resource:r,name:a.basename(r),isFile:(o.type&E.FileType.File)!==0,isDirectory:(o.type&E.FileType.Directory)!==0,isSymbolicLink:(o.type&E.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&E.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,E.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(l.isDirectory&&s(l,n)){try{const d=await u.readdir(r),I=await t.Promises.settled(d.map(async([L,B])=>{try{const J=a.joinPath(r,L),Z=i?await u.stat(J):{type:B};return await this.toFileStat(u,J,Z,d.length,i,s)}catch(J){return this.logService.trace(J),null}}));l.children=(0,v.coalesce)(I)}catch(d){this.logService.trace(d),l.children=[]}return l}return l}async resolveAll(u){return t.Promises.settled(u.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(u){const r=await this.withProvider(u),o=await r.stat(u);return this.toFileStat(r,u,o,void 0,!0,()=>!1)}async exists(u){const r=await this.withProvider(u);try{return!!await r.stat(u)}catch{return!1}}async canCreateFile(u,r){try{await this.doValidateCreateFile(u,r)}catch(o){return o}return!0}async doValidateCreateFile(u,r){if(!r?.overwrite&&await this.exists(u))throw new E.FileOperationError((0,w.localize)(3,null,this.resourceForError(u)),3,r)}async createFile(u,r=D.VSBuffer.fromString(""),o){await this.doValidateCreateFile(u,o);const n=await this.writeFile(u,r);return this._onDidRunOperation.fire(new E.FileOperationEvent(u,0,n)),n}async writeFile(u,r,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,u,o)||await this.mkdirp(n,i.dirname(u));let a;if((0,E.hasReadWriteCapability)(n)&&!(r instanceof D.VSBuffer))if((0,h.isReadableStream)(r)){const l=await(0,h.peekStream)(r,3);l.ended?a=D.VSBuffer.concat(l.buffer):a=l}else a=(0,h.peekReadable)(r,l=>D.VSBuffer.concat(l),3);else a=r;!(0,E.hasOpenReadWriteCloseCapability)(n)||(0,E.hasReadWriteCapability)(n)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(n,u,o,a):await this.doWriteBuffered(n,u,o,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a),this._onDidRunOperation.fire(new E.FileOperationEvent(u,4))}catch(s){throw new E.FileOperationError((0,w.localize)(4,null,this.resourceForError(u),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),o)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,r,o){if(!!o?.unlock&&!(u.capabilities&8192))throw new Error((0,w.localize)(5,null,this.resourceForError(r)));let i;try{i=await u.stat(r)}catch{return}if((i.type&E.FileType.Directory)!==0)throw new E.FileOperationError((0,w.localize)(6,null,this.resourceForError(r)),0,o);if(this.throwIfFileIsReadonly(r,i),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==E.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&o.mtime<i.mtime&&o.etag!==(0,E.etag)({mtime:o.mtime,size:i.size}))throw new E.FileOperationError((0,w.localize)(7,null),3,o);return i}async readFile(u,r,o){const n=await this.withReadProvider(u);return r?.atomic?this.doReadFileAtomic(n,u,r,o):this.doReadFile(n,u,r,o)}async doReadFileAtomic(u,r,o,n){return new Promise((i,s)=>{this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(u,r,o,n);i(a)}catch(a){s(a)}})})}async doReadFile(u,r,o,n){const i=await this.doReadFileStream(u,r,{...o,preferUnbuffered:!0},n);return{...i,value:await(0,D.streamToBuffer)(i.value)}}async readFileStream(u,r,o){const n=await this.withReadProvider(u);return this.doReadFileStream(n,u,r,o)}async doReadFileStream(u,r,o,n){const i=new C.CancellationTokenSource(n),s=this.validateReadFile(r,o).then(l=>l,l=>{throw i.cancel(),l});let a;try{return typeof o?.etag=="string"&&o.etag!==E.ETAG_DISABLED&&await s,o?.atomic&&(0,E.hasFileAtomicReadCapability)(u)||!((0,E.hasOpenReadWriteCloseCapability)(u)||(0,E.hasFileReadStreamCapability)(u))||(0,E.hasReadWriteCapability)(u)&&o?.preferUnbuffered?a=this.readFileUnbuffered(u,r,o):(0,E.hasFileReadStreamCapability)(u)?a=this.readFileStreamed(u,r,i.token,o):a=this.readFileBuffered(u,r,i.token,o),{...await s,value:a}}catch(l){a&&await(0,h.consumeStream)(a);const d=(0,w.localize)(8,null,this.resourceForError(r),(0,E.ensureFileSystemProviderError)(l).toString());throw l instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(d,l.stat,o):new E.FileOperationError(d,(0,E.toFileOperationResult)(l),o)}}readFileStreamed(u,r,o,n=Object.create(null)){const i=u.readFileStream(r,n,o);return(0,h.transform)(i,{data:s=>s instanceof D.VSBuffer?s:D.VSBuffer.wrap(s),error:s=>new E.FileOperationError((0,w.localize)(9,null,this.resourceForError(r),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),n)},s=>D.VSBuffer.concat(s))}readFileBuffered(u,r,o,n=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,g.readFileIntoStream)(u,r,i,s=>s,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new E.FileOperationError((0,w.localize)(10,null,this.resourceForError(r),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),n)},o),i}readFileUnbuffered(u,r,o){const n=(0,h.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i;o?.atomic&&(0,E.hasFileAtomicReadCapability)(u)?i=await u.readFile(r,{atomic:!0}):i=await u.readFile(r),typeof o?.position=="number"&&(i=i.slice(o.position)),typeof o?.length=="number"&&(i=i.slice(0,o.length)),this.validateReadFileLimits(r,i.byteLength,o),n.end(D.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(u,r){const o=await this.resolve(u,{resolveMetadata:!0});if(o.isDirectory)throw new E.FileOperationError((0,w.localize)(11,null,this.resourceForError(u)),0,r);if(typeof r?.etag=="string"&&r.etag!==E.ETAG_DISABLED&&r.etag===o.etag)throw new E.NotModifiedSinceFileOperationError((0,w.localize)(12,null),o,r);return this.validateReadFileLimits(u,o.size,r),o}validateReadFileLimits(u,r,o){if(o?.limits){let n;if(typeof o.limits.memory=="number"&&r>o.limits.memory&&(n=9),typeof o.limits.size=="number"&&r>o.limits.size&&(n=7),typeof n=="number")throw new E.FileOperationError((0,w.localize)(13,null,this.resourceForError(u)),n)}}async canMove(u,r,o){return this.doCanMoveCopy(u,r,"move",o)}async canCopy(u,r,o){return this.doCanMoveCopy(u,r,"copy",o)}async doCanMoveCopy(u,r,o,n){if(u.toString()!==r.toString())try{const i=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(i,u,s,r,o,n)}catch(i){return i}return!0}async move(u,r,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(n,u,i,r,"move",!!o),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(u,s==="move"?2:3,a)),a}async copy(u,r,o){const n=await this.withReadProvider(u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(n,u,i,r,"copy",!!o),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(u,s==="copy"?3:2,a)),a}async doMoveCopy(u,r,o,n,i,s){if(r.toString()===n.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(u,r,o,n,i,s);if(a&&!l&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(n)),i==="copy"){if(u===o&&(0,E.hasFileFolderCopyCapability)(u))await u.copy(r,n,{overwrite:s});else{const d=await this.resolve(r);d.isDirectory?await this.doCopyFolder(u,d,o,n):await this.doCopyFile(u,r,o,n)}return i}else return u===o?(await u.rename(r,n,{overwrite:s}),i):(await this.doMoveCopy(u,r,o,n,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(u,r,o,n){if((0,E.hasOpenReadWriteCloseCapability)(u)&&(0,E.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(u,r,o,n);if((0,E.hasOpenReadWriteCloseCapability)(u)&&(0,E.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(u,r,o,n);if((0,E.hasReadWriteCapability)(u)&&(0,E.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(u,r,o,n);if((0,E.hasReadWriteCapability)(u)&&(0,E.hasReadWriteCapability)(o))return this.doPipeUnbuffered(u,r,o,n)}async doCopyFolder(u,r,o,n){await o.mkdir(n),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async i=>{const s=this.getExtUri(o).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(u,await this.resolve(i.resource),o,s):this.doCopyFile(u,i.resource,o,s)}))}async doValidateMoveCopy(u,r,o,n,i,s){let a=!1;if(u===o){const{providerExtUri:d,isPathCaseSensitive:I}=this.getExtUri(u);if(I||(a=d.isEqual(r,n)),a&&i==="copy")throw new Error((0,w.localize)(14,null,this.resourceForError(r),this.resourceForError(n)));if(!a&&d.isEqualOrParent(n,r))throw new Error((0,w.localize)(15,null,this.resourceForError(r),this.resourceForError(n)))}const l=await this.exists(n);if(l&&!a){if(!s)throw new E.FileOperationError((0,w.localize)(16,null,this.resourceForError(r),this.resourceForError(n)),4);if(u===o){const{providerExtUri:d}=this.getExtUri(u);if(d.isEqualOrParent(r,n))throw new Error((0,w.localize)(17,null,this.resourceForError(r),this.resourceForError(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(u){const r=this.isPathCaseSensitive(u);return{providerExtUri:r?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(r,u);const o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(u,0,o)),o}async mkdirp(u,r){const o=[],{providerExtUri:n}=this.getExtUri(u);for(;!n.isEqual(r,n.dirname(r));)try{if(((await u.stat(r)).type&E.FileType.Directory)===0)throw new Error((0,w.localize)(18,null,this.resourceForError(r)));break}catch(i){if((0,E.toFileSystemProviderErrorCode)(i)!==E.FileSystemProviderErrorCode.FileNotFound)throw i;o.push(n.basename(r)),r=n.dirname(r)}for(let i=o.length-1;i>=0;i--){r=n.joinPath(r,o[i]);try{await u.mkdir(r)}catch(s){if((0,E.toFileSystemProviderErrorCode)(s)!==E.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(u,r){try{await this.doValidateDelete(u,r)}catch(o){return o}return!0}async doValidateDelete(u,r){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!r?.useTrash&&!(o.capabilities&4096))throw new Error((0,w.localize)(19,null,this.resourceForError(u)));let i;try{i=await o.stat(u)}catch{}if(i)this.throwIfFileIsReadonly(u,i);else throw new E.FileOperationError((0,w.localize)(20,null,this.resourceForError(u)),1);if(!!!r?.recursive){const a=await this.resolve(u);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,w.localize)(21,null,this.resourceForError(u)))}return o}async del(u,r){const o=await this.doValidateDelete(u,r),n=!!r?.useTrash,i=!!r?.recursive;await o.delete(u,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new E.FileOperationEvent(u,1))}async cloneFile(u,r){const o=await this.withProvider(u),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(o===n&&this.getExtUri(o).providerExtUri.isEqual(u,r))return;if(o===n&&(0,E.hasFileCloneCapability)(o))return o.cloneFile(u,r);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(r));const i=this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri);return o===n&&(0,E.hasFileFolderCopyCapability)(o)?i.queue(()=>o.copy(u,r,{overwrite:!0})):i.queue(()=>this.doCopyFile(o,u,n,r))}watch(u,r={recursive:!1,excludes:[]}){const o=new b.DisposableStore;let n=!1,i=()=>{n=!0};return o.add((0,b.toDisposable)(()=>i())),(async()=>{try{const s=await this.doWatch(u,r);n?(0,b.dispose)(s):i=()=>(0,b.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(u,r){const o=await this.withProvider(u),n=(0,P.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(u),r]);let i=this.activeWatchers.get(n);return i||(i={count:0,disposable:o.watch(u,r)},this.activeWatchers.set(n,i)),i.count+=1,(0,b.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,b.dispose)(i.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,b.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,r,o,n){return this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(async()=>{const i=await u.open(r,{create:!0,unlock:o?.unlock??!1});try{(0,h.isReadableStream)(n)||(0,h.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(u,i,n):await this.doWriteReadableBufferedQueued(u,i,n)}catch(s){throw(0,E.ensureFileSystemProviderError)(s)}finally{await u.close(i)}})}async doWriteStreamBufferedQueued(u,r,o){let n=0,i;if((0,h.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=D.VSBuffer.concat(o.buffer);await this.doWriteBuffer(u,r,s,s.byteLength,n,0),n+=s.byteLength}if(o.ended)return;i=o.stream}else i=o;return new Promise((s,a)=>{(0,h.listenStream)(i,{onData:async l=>{i.pause();try{await this.doWriteBuffer(u,r,l,l.byteLength,n,0)}catch(d){return a(d)}n+=l.byteLength,setTimeout(()=>i.resume())},onError:l=>a(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(u,r,o){let n=0,i;for(;(i=o.read())!==null;)await this.doWriteBuffer(u,r,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(u,r,o,n,i,s){let a=0;for(;a<n;)a+=await u.write(r,i+a,o.buffer,s+a,n-a)}async doWriteUnbuffered(u,r,o,n){return this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,r,o,n))}async doWriteUnbufferedQueued(u,r,o,n){let i;n instanceof D.VSBuffer?i=n:(0,h.isReadableStream)(n)?i=await(0,D.streamToBuffer)(n):(0,h.isReadableBufferedStream)(n)?i=await(0,D.bufferedStreamToBuffer)(n):i=(0,D.readableToBuffer)(n),await u.writeFile(r,i.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(u,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,r,o,n))}async doPipeBufferedQueued(u,r,o,n){let i,s;try{i=await u.open(r,{create:!1}),s=await o.open(n,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,d=0,I=0;do I=await u.read(i,l,a.buffer,d,a.byteLength-d),await this.doWriteBuffer(o,s,a,I,l,d),l+=I,d+=I,d===a.byteLength&&(d=0);while(I>0)}catch(a){throw(0,E.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof i=="number"?u.close(i):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(u,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,r,o,n))}async doPipeUnbufferedQueued(u,r,o,n){return o.writeFile(n,await u.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,r,o,n))}async doPipeUnbufferedToBufferedQueued(u,r,o,n){const i=await o.open(n,{create:!0,unlock:!1});try{const s=await u.readFile(r);await this.doWriteBuffer(o,i,D.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,E.ensureFileSystemProviderError)(s)}finally{await o.close(i)}}async doPipeBufferedToUnbuffered(u,r,o,n){const i=await(0,D.streamToBuffer)(this.readFileBuffered(u,r,C.CancellationToken.None));await this.doWriteUnbuffered(o,n,void 0,i)}throwIfFileSystemIsReadonly(u,r){if(u.capabilities&2048)throw new E.FileOperationError((0,w.localize)(22,null,this.resourceForError(r)),6);return u}throwIfFileIsReadonly(u,r){if((r.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,w.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===k.Schemas.file?u.fsPath:u.toString(!0)}};f=Ae([_e(0,m.ILogService)],f),e.FileService=f}),define(ve[61],we([1,0,29,268,14,24,16,7,36,2,6,3,19,45,21,173,17,99,207,38,204,203]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(v)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(o)}`)}})();class r extends m.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new C.ResourceMap(s=>S.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(n){try{const i=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async a=>{try{let l;a.isSymbolicLink()?l=(await this.stat((0,S.joinPath)(n,a.name))).type:l=this.toType(a),s.push([a.name,l])}catch(l){this.logService.trace(l)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let s;return i?.dangling?s=E.FileType.Unknown:n.isFile()?s=E.FileType.File:n.isDirectory()?s=E.FileType.Directory:s=E.FileType.Unknown,i&&(s|=E.FileType.SymbolicLink),s}async createResourceLock(n){const i=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const a=new D.Barrier;return this.resourceLocks.set(n,a),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,b.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===a&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(n,i){let s;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const a=this.toFilePath(n);return await h.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{s?.dispose()}}traceLock(n){r.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,i,s){const a=(0,y.newWriteableStream)(l=>T.VSBuffer.concat(l.map(d=>T.VSBuffer.wrap(d))).buffer);return(0,g.readFileIntoStream)(this,n,a,l=>l.buffer,{...i,bufferSize:256*1024},s),a}async writeFile(n,i,s){let a;try{const l=this.toFilePath(n);if(!s.create||!s.overwrite){if(await h.Promises.exists(l)){if(!s.overwrite)throw(0,E.createFileSystemProviderError)((0,w.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,E.createFileSystemProviderError)((0,w.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(n,l)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(n){r.canFlush=n}async open(n,i){const s=this.toFilePath(n);let a;(0,E.isFileOpenForWriteOptions)(i)&&(a=await this.createResourceLock(n));let l;try{if((0,E.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:I}=await h.SymlinkSupport.stat(s);I.mode&128||await h.Promises.chmod(s,I.mode|128)}catch(I){this.logService.trace(I)}let d;if((0,E.isFileOpenForWriteOptions)(i)){if(k.isWindows)try{await h.Promises.truncate(s,0),d="r+"}catch(I){I.code!=="ENOENT"&&this.logService.trace(I)}d||(d="w")}else d="r";l=await h.Promises.open(s,d)}catch(d){throw a?.dispose(),(0,E.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(l,0),(0,E.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(l,n),a){const d=this.mapHandleToLock.get(l);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.mapHandleToLock.set(l,a),d&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),d.dispose())}return l}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&r.canFlush)try{await h.Promises.fdatasync(n)}catch(s){r.configureFlushOnWrite(!1),this.logService.error(s)}return await h.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,s,a,l){const d=this.normalizePos(n,i);let I=null;try{I=(await h.Promises.read(n,s,a,l,d)).bytesRead}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(n,d,I)}return I}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,s){const a=this.mapHandleToPos.get(n);typeof a=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,a+s):this.mapHandleToPos.delete(n)))}async write(n,i,s,a,l){return(0,D.retry)(()=>this.doWrite(n,i,s,a,l),100,3)}async doWrite(n,i,s,a,l){const d=this.normalizePos(n,i);let I=null;try{I=(await h.Promises.write(n,s,a,l,d)).bytesWritten}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),L)}finally{this.updatePos(n,d,I)}return I}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const s=this.toFilePath(n);i.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,i,s){const a=this.toFilePath(n),l=this.toFilePath(i);if(a!==l)try{await this.validateTargetDeleted(n,i,"move",s.overwrite),await h.Promises.move(a,l)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,w.localize)(2,null,(0,R.basename)(a),(0,R.basename)((0,R.dirname)(l)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(n,i,s){const a=this.toFilePath(n),l=this.toFilePath(i);if(a!==l)try{await this.validateTargetDeleted(n,i,"copy",s.overwrite),await h.Promises.copy(a,l,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,w.localize)(3,null,(0,R.basename)(a),(0,R.basename)((0,R.dirname)(l)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(n,i,s,a){const l=this.toFilePath(n),d=this.toFilePath(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,p.isEqual)(l,d,!0)),I&&s==="copy")throw(0,E.createFileSystemProviderError)((0,w.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!I&&await h.Promises.exists(d)){if(!a)throw(0,E.createFileSystemProviderError)((0,w.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,s){const a=this.toFilePath(n),l=this.toFilePath(i),d=!!(this.capabilities&1024);if((0,p.isEqual)(a,l,!d))return;const I=new b.DisposableStore;try{const[L,B]=await Promise.all([this.createResourceLock(n),this.createResourceLock(i)]);I.add(L),I.add(B),s&&await h.Promises.mkdir((0,R.dirname)(l),{recursive:!0}),await h.Promises.copyFile(a,l)}catch(L){if(L.code==="ENOENT"&&!s)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(L)}finally{I.dispose()}}createUniversalWatcher(n,i,s){return new c.UniversalWatcherClient(a=>n(a),a=>i(a),s)}createNonRecursiveWatcher(n,i,s){return new u.NodeJSWatcherClient(a=>n(a),a=>i(a),s)}toFileSystemProviderError(n){if(n instanceof E.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=E.FileSystemProviderErrorCode.NoPermissions;break;default:i=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(n,i)}async toFileSystemProviderWriteError(n,i){let s=this.toFileSystemProviderError(i);if(n&&s.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await h.SymlinkSupport.stat(this.toFilePath(n));a.mode&128||(s=(0,E.createFileSystemProviderError)(i,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return s}}e.DiskFileSystemProvider=r,r.TRACE_LOG_RESOURCE_LOCKS=!1,r.canFlush=!0}),define(ve[208],we([1,0,7,61,2,16,45,20]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class p extends D.Disposable{constructor(k,S){super(),this.provider=k,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(k,S,y){const h=this.getUriTransformer(k);switch(S){case"stat":return this.stat(h,y[0]);case"readdir":return this.readdir(h,y[0]);case"open":return this.open(h,y[0],y[1]);case"close":return this.close(y[0]);case"read":return this.read(y[0],y[1],y[2]);case"readFile":return this.readFile(h,y[0],y[1]);case"write":return this.write(y[0],y[1],y[2],y[3],y[4]);case"writeFile":return this.writeFile(h,y[0],y[1],y[2]);case"rename":return this.rename(h,y[0],y[1],y[2]);case"copy":return this.copy(h,y[0],y[1],y[2]);case"cloneFile":return this.cloneFile(h,y[0],y[1]);case"mkdir":return this.mkdir(h,y[0]);case"delete":return this.delete(h,y[0],y[1]);case"watch":return this.watch(h,y[0],y[1],y[2],y[3]);case"unwatch":return this.unwatch(y[0],y[1])}throw new Error(`IPC Command ${S} not found`)}listen(k,S,y){const h=this.getUriTransformer(k);switch(S){case"fileChange":return this.onFileChange(h,y[0]);case"readFileStream":return this.onReadFileStream(h,y[0],y[1])}throw new Error(`Unknown event ${S}`)}stat(k,S){const y=this.transformIncoming(k,S,!0);return this.provider.stat(y)}readdir(k,S){const y=this.transformIncoming(k,S);return this.provider.readdir(y)}async readFile(k,S,y){const h=this.transformIncoming(k,S,!0),w=await this.provider.readFile(h,y);return C.VSBuffer.wrap(w)}onReadFileStream(k,S,y){const h=this.transformIncoming(k,S,!0),w=new P.CancellationTokenSource,E=new v.Emitter({onLastListenerRemove:()=>{w.cancel()}}),g=this.provider.readFileStream(h,y,w.token);return(0,T.listenStream)(g,{onData:m=>E.fire(C.VSBuffer.wrap(m)),onError:m=>E.fire(m),onEnd:()=>{E.fire("end"),E.dispose(),w.dispose()}}),E.event}writeFile(k,S,y,h){const w=this.transformIncoming(k,S);return this.provider.writeFile(w,y.buffer,h)}open(k,S,y){const h=this.transformIncoming(k,S,!0);return this.provider.open(h,y)}close(k){return this.provider.close(k)}async read(k,S,y){const h=C.VSBuffer.alloc(y),w=0,E=await this.provider.read(k,S,h.buffer,w,y);return[h,E]}write(k,S,y,h,w){return this.provider.write(k,S,y.buffer,h,w)}mkdir(k,S){const y=this.transformIncoming(k,S);return this.provider.mkdir(y)}delete(k,S,y){const h=this.transformIncoming(k,S);return this.provider.delete(h,y)}rename(k,S,y,h){const w=this.transformIncoming(k,S),E=this.transformIncoming(k,y);return this.provider.rename(w,E,h)}copy(k,S,y,h){const w=this.transformIncoming(k,S),E=this.transformIncoming(k,y);return this.provider.copy(w,E,h)}cloneFile(k,S,y){const h=this.transformIncoming(k,S),w=this.transformIncoming(k,y);return this.provider.cloneFile(h,w)}onFileChange(k,S){const y=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(k,y))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return y.event}async watch(k,S,y,h,w){const E=this.sessionToWatcher.get(S);if(E){const g=this.transformIncoming(k,h),m=E.watch(y,g,w);this.watchRequests.set(S+y,m)}}async unwatch(k,S){const y=k+S,h=this.watchRequests.get(y);h&&((0,D.dispose)(h),this.watchRequests.delete(y))}dispose(){super.dispose();for(const[,k]of this.watchRequests)k.dispose();this.watchRequests.clear();for(const[,k]of this.sessionToWatcher)k.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=p;class b extends D.Disposable{constructor(k,S,y,h){super(),this.uriTransformer=k,this.logService=y,this.environmentService=h,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(k){const S=this._register(new v.Emitter);this._register(S.event(y=>{k.fire(y.map(h=>({resource:this.uriTransformer.transformOutgoingURI(h.resource),type:h.type})))})),this._register(this.fileWatcher.onDidChangeFile(y=>S.fire(y))),this._register(this.fileWatcher.onDidWatchError(y=>k.fire(y)))}getRecursiveWatcherOptions(k){}getExtraExcludes(k){}watch(k,S,y){const h=this.getExtraExcludes(this.environmentService);return Array.isArray(h)&&(y.excludes=[...y.excludes,...h]),this.watcherRequests.set(k,this.fileWatcher.watch(S,y)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(k)),this.watcherRequests.delete(k)})}dispose(){super.dispose();for(const[,k]of this.watcherRequests)k.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=b}),define(ve[102],we([1,0,7,4,13]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(S){this.service=S,this.onDidChangeLogLevel=v.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(S,y,h){switch(y){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=C;class T{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){T.setLevel(this.channel,S)}static setLevel(S,y){return S.call("setLevel",y)}}e.LogLevelChannelClient=T;class P{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,y){throw new Error(`Event not found: ${y}`)}async call(S,y,h){switch(y){case"createLogger":this.createLogger(t.URI.revive(h[0]),h[1]);return;case"log":return this.log(t.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${y}`)}createLogger(S,y){this.loggers.set(S.toString(),this.loggerService.createLogger(S,y))}consoleLog(S,y){let h=console.log;switch(S){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...y)}log(S,y){const h=this.loggers.get(S.toString());if(!h)throw new Error("Create the logger before logging");for(const[w,E]of y)(0,D.log)(h,w,E)}}e.LoggerChannel=P;class p extends D.AbstractLoggerService{constructor(S,y,h){super(S,y),this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(S,y)=>{this.channel.call("consoleLog",[S,y])}})}doCreateLogger(S,y,h){return new b(this.channel,S,y,h)}}e.LoggerChannelClient=p;class b extends D.AbstractMessageLogger{constructor(S,y,h,w){super(w?.always),this.channel=S,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[y,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,y){const h=[[S,y]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(S){this.channel.call("log",[this.file,S])}}class R extends D.LogService{constructor(S,y){super(y),this.parent=S,this._register(S.onDidChangeLogLevel(h=>y.setLevel(h)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=R}),define(ve[103],we([1,0,17,13]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(P,p,b,R,k){try{const S=await new Promise((h,w)=>{oe(["spdlog"],h,w)});S.setFlushOn(t.LogLevel.Trace);const y=await S.createAsyncRotatingLogger(P,p,b,R);return k&&y.clearFormatters(),y}catch(S){console.error(S)}return null}function C(P,p,b){switch(p){case t.LogLevel.Trace:P.trace(b);break;case t.LogLevel.Debug:P.debug(b);break;case t.LogLevel.Info:P.info(b);break;case t.LogLevel.Warning:P.warn(b);break;case t.LogLevel.Error:P.error(b);break;case t.LogLevel.Critical:P.critical(b);break;default:throw new Error("Invalid log level")}}class T extends t.AbstractMessageLogger{constructor(p,b,R,k,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(p,b,R,k),this._register(this.onDidChangeLogLevel(y=>{this._logger?.setLevel(y)}))}async _createSpdLogLogger(p,b,R,k){const S=R?6:1,y=30/S*v.ByteSize.MB,h=await D(p,b,y,S,k);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:w,message:E}of this.buffer)C(this._logger,w,E);this.buffer=[]}}log(p,b){this._logger?C(this._logger,p,b):this.getLevel()<=p&&this.buffer.push({level:p,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=T}),define(ve[209],we([1,0,67,175,5]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var T;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(p){function b(h,w){return w-h}p.compare=b;const R=Object.create(null);R[p.Error]=(0,t.localize)(0,null),R[p.Warning]=(0,t.localize)(1,null),R[p.Info]=(0,t.localize)(2,null);function k(h){return R[h]||""}p.toString=k;function S(h){switch(h){case v.default.Error:return p.Error;case v.default.Warning:return p.Warning;case v.default.Info:return p.Info;case v.default.Ignore:return p.Hint}}p.fromSeverity=S;function y(h){switch(h){case p.Error:return v.default.Error;case p.Warning:return v.default.Warning;case p.Info:return v.default.Info;case p.Hint:return v.default.Ignore}}p.toSeverity=y}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(p){const b="";function R(S){return k(S,!0)}p.makeKey=R;function k(S,y){const h=[b];return S.source?h.push(S.source.replace("\xA6","\\\xA6")):h.push(b),S.code?typeof S.code=="string"?h.push(S.code.replace("\xA6","\\\xA6")):h.push(S.code.value.replace("\xA6","\\\xA6")):h.push(b),S.severity!==void 0&&S.severity!==null?h.push(T.toString(S.severity)):h.push(b),S.message&&y?h.push(S.message.replace("\xA6","\\\xA6")):h.push(b),S.startLineNumber!==void 0&&S.startLineNumber!==null?h.push(S.startLineNumber.toString()):h.push(b),S.startColumn!==void 0&&S.startColumn!==null?h.push(S.startColumn.toString()):h.push(b),S.endLineNumber!==void 0&&S.endLineNumber!==null?h.push(S.endLineNumber.toString()):h.push(b),S.endColumn!==void 0&&S.endColumn!==null?h.push(S.endColumn.toString()):h.push(b),h.push(b),h.join("\xA6")}p.makeKeyOptionalMessage=k})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(ve[62],we([1,0,7,44,2,5]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class T extends D.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(b){const R=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...b,...this.policyDefinitions},R!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(b),t.Iterable.reduce(this.policies.entries(),(k,[S,y])=>({...k,[S]:y}),{})}getPolicyValue(b){return this.policies.get(b)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(b,[R,k])=>({...b,[R]:{definition:k,value:this.policies.get(R)}}),{})}}e.AbstractPolicyService=T;class P{constructor(){this.onDidChange=v.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ve[51],we([1,0,12,3,28,19]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const P=t.globals.vscode.context.configuration();if(P)T=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof oe?.__$__nodeRequire=="function"){const P=(0,C.dirname)(v.FileAccess.asFileUri("",oe));if(T=oe.__$__nodeRequire((0,C.joinPath)(P,"product.json").fsPath),D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const p=oe.__$__nodeRequire((0,C.joinPath)(P,"package.json").fsPath);Object.assign(T,{version:p.version})}}else T={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","ms-edgedevtools.vscode-edge-devtools":"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","xdebug.php-debug":"{**/*.php,**/php.ini}","rust-lang.rust-analyzer":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","stylelint.vscode-stylelint":"{**/.stylelintrc,**/stylelint.config.js}","ms-mssql.mssql":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","vue.volar":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}","ms-vscode.vscode-github-issue-notebooks":"{**/*.github-issues}","REditorSupport.r":"**/*.r"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools-extension-pack":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"vue.volar":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.makefile-tools":{name:"Makefile Tools",languages:["makefile"],pattern:"{**/makefile,**/Makefile}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"ms-azure-devops.azure-pipelines":{name:"Azure Pipelines",pattern:"{**/azure-pipelines.yaml}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"},"ms-vscode.vscode-github-issue-notebooks":{name:"GitHub Issue Notebooks",pattern:"{**/*.github-issues}"},"ms-playwright.playwright":{name:"Playwright",pattern:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}"},"vscjava.vscode-gradle":{name:"Gradle for Java",pattern:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}"},"REditorSupport.r":{name:"R",languages:["r"],pattern:"{**/*.r}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsNew","inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookContentProvider","notebookEditor","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","resolvers","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers","notebookEditor"],"ms-python.python":["quickPickSortByLabel","testObserver","localization"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider","localization"],"ms-vscode.remote-repositories":["contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","localization"],"ms-vscode-remote.remote-wsl":["resolvers","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers"],"ms-vscode.remote-explorer":["contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","tunnels","workspaceTrust","terminalDimensions","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","resolvers","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["tokenInformation","commentsResolvedState","contribShareMenu","contribCommentPeekContext","treeItemCheckbox","localization"],"GitHub.copilot":["inlineCompletionsNew","inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsNew","inlineCompletionsAdditions"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","localization"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-toolsai.jupyter":["notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow"],"dbaeumer.vscode-eslint":["notebookCellExecutionState","localization"],"ms-vscode.azure-sphere-tools-ui":["resolvers","tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"ms-vscode.vscode-github-issue-notebooks":["localization"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.72.1",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.17",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.72.1",commit:"129500ee4c8ab7263461ffe327268ba56b9f210d",date:"2022-10-10T17:07:32.953Z"},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ve[27],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ve[210],we([1,0,71,13,26,27,206]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let P=class extends T.BaseCredentialsMainService{constructor(b,R,k){super(b),this.environmentMainService=R,this.productService=k}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new v.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((b,R)=>{oe(["keytar"],b,R)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(b){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${b.message??b}`),this._keytarCache=new v.InMemoryCredentialsProvider}return this._keytarCache}};P=Ae([_e(0,t.ILogService),_e(1,D.INativeEnvironmentService),_e(2,C.IProductService)],P),e.CredentialsWebMainService=P}),define(ve[34],we([1,0,83,11]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(T,P){v.ok(t.isString(T)),v.ok(t.isObject(P)),v.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new D}),define(ve[211],we([1,0,7,34]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class C{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,b){this.schemasById[D(p)]=b,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new C;t.Registry.add(e.Extensions.JSONContribution,T)}),define(ve[52],we([1,0,18,7,11,159,25,211,34]),function(oe,e,v,t,D,C,T,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=p.Registry.as(P.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,o=!0){this.registerConfigurations([r],o)}registerConfigurations(r,o=!0){const n=this.doRegisterConfigurations(r,o);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(r){const o=this.doDeregisterConfigurations(r);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:r,remove:o}){const n=[];n.push(...this.doDeregisterConfigurations(o)),n.push(...this.doRegisterConfigurations(r,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(n)})}registerDefaultConfigurations(r){const o=[],n=[];for(const{overrides:i,source:s}of r)for(const a in i)if(o.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const l=this.configurationDefaultsOverrides.get(a),d=l?.valuesSources??new Map;if(s)for(const J of Object.keys(i[a]))d.set(J,s);const I={...l?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:I,valuesSources:d});const L=(0,T.getLanguageTagSettingPlainKey)(a),B={type:"object",default:I,description:C.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:I,source:D.isString(s)?void 0:s,defaultValueSource:s};n.push(...w(a)),this.configurationProperties[a]=B,this.defaultLanguageConfigurationOverridesNode.properties[a]=B}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:s});const l=this.configurationProperties[a];l&&(this.updatePropertyDefaultValue(a,l),this.updateSchema(a,l))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const o=[];for(const{overrides:n,source:i}of r)for(const s in n){const a=this.configurationDefaultsOverrides.get(s),l=D.isString(i)?i:i?.id,d=D.isString(a?.source)?a?.source:a?.source?.id;if(l===d)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const I=this.configurationProperties[s];I&&(this.updatePropertyDefaultValue(s,I),this.updateSchema(s,I))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const o of r)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,o){const n=[];return r.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(r){const o=[],n=i=>{if(i.properties)for(const s in i.properties){o.push(s);const a=this.configurationProperties[s];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,i.properties[s])}i.allOf?.forEach(s=>n(s))};for(const i of r){n(i);const s=this.configurationContributors.indexOf(i);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(r,o=!0,n,i,s=3){s=D.isUndefinedOrNull(r.scope)?s:r.scope;const a=[],l=r.properties;if(l)for(const I in l){const L=l[I];if(o&&f(I,L)){delete l[I];continue}if(L.source=n,L.defaultDefaultValue=l[I].default,this.updatePropertyDefaultValue(I,L),e.OVERRIDE_PROPERTY_REGEX.test(I)?L.scope=void 0:(L.scope=D.isUndefinedOrNull(L.scope)?s:L.scope,L.restricted=D.isUndefinedOrNull(L.restricted)?!!i?.includes(I):L.restricted),l[I].hasOwnProperty("included")&&!l[I].included){this.excludedConfigurationProperties[I]=l[I],delete l[I];continue}else this.configurationProperties[I]=l[I],l[I].policy?.name&&this.policyConfigurations.set(l[I].policy.name,I);!l[I].deprecationMessage&&l[I].markdownDeprecationMessage&&(l[I].deprecationMessage=l[I].markdownDeprecationMessage),a.push(I)}const d=r.allOf;if(d)for(const I of d)a.push(...this.validateAndRegisterProperties(I,o,n,i,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const o=n=>{const i=n.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);n.allOf?.forEach(o)};o(r)}updateSchema(r,o){switch(e.allSettings.properties[r]=o,o.scope){case 1:e.applicationSettings.properties[r]=o;break;case 2:e.machineSettings.properties[r]=o;break;case 6:e.machineOverridableSettings.properties[r]=o;break;case 3:e.windowSettings.properties[r]=o;break;case 4:e.resourceSettings.properties[r]=o;break;case 5:e.resourceSettings.properties[r]=o,this.resourceLanguageSettingsSchema.properties[r]=o;break}}removeFromSchema(r,o){switch(delete e.allSettings.properties[r],o.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const o=`[${r}]`,n={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,o){const n=this.configurationDefaultsOverrides.get(r);let i=n?.value,s=n?.source;D.isUndefined(i)&&(i=o.defaultDefaultValue,s=void 0),D.isUndefined(i)&&(i=g(o.type)),o.default=i,o.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",h=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(u){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let o=h.exec(u);for(;o?.length;){const n=o[1].trim();n&&r.push(n),o=h.exec(u)}}return(0,v.distinct)(r)}e.overrideIdentifiersFromKey=w;function E(u){return u.reduce((r,o)=>`${r}[${o}]`,"")}e.keyFromOverrideIdentifiers=E;function g(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const m=new S;p.Registry.add(e.Extensions.Configuration,m);function f(u,r){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?C.localize(7,null,u):m.getConfigurationProperties()[u]!==void 0?C.localize(8,null,u):r.policy?.name&&m.getPolicyConfigurations().get(r.policy?.name)!==void 0?C.localize(9,null,u,r.policy?.name,m.getPolicyConfigurations().get(r.policy?.name)):null:C.localize(6,null)}e.validateProperty=f;function c(){const u=[],r=m.getConfigurationProperties();for(const o of Object.keys(r))u.push([o,r[o].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=c}),define(ve[104],we([1,0,18,7,65,2,24,22,11,4,25,52,34]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(r={},o=[],n=[],i){this._contents=r,this._keys=o,this._overrides=n,this.raw=i,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(o=>{if(o instanceof y)return o;const n=new h("");return n.parseRaw(o),n.configurationModel});this._rawConfiguration=r.reduce((o,n)=>n===o?n:o.merge(n),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}inspect(r,o){const n=this.rawConfiguration.getValue(r),i=o?this.rawConfiguration.getOverrideValue(r,o):void 0,s=o?this.rawConfiguration.override(o).getValue(r):n;return{value:n,override:i,merged:s}}getOverrideValue(r,o){const n=this.getContentsForOverrideIdentifer(o);return n?r?(0,R.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const o=[];for(const n of this.overrides)n.identifiers.includes(r)&&o.push(...n.keys);return v.distinct(o)}getAllOverrideIdentifiers(){const r=[];for(const o of this.overrides)r.push(...o.identifiers);return v.distinct(r)}override(r){let o=this.overrideConfigurations.get(r);return o||(o=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,o)),o}merge(...r){const o=P.deepClone(this.contents),n=P.deepClone(this.overrides),i=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const a of r)if(s.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(o,a.contents);for(const l of a.overrides){const[d]=n.filter(I=>v.equals(I.identifiers,l.identifiers));d?(this.mergeContents(d.contents,l.contents),d.keys.push(...l.keys),d.keys=v.distinct(d.keys)):n.push(P.deepClone(l))}for(const l of a.keys)i.indexOf(l)===-1&&i.push(l)}return new y(o,i,n,s.every(a=>a instanceof y)?void 0:s)}freeze(){return this.frozen=!0,this}clone(){return new y(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(r){const o=this.getContentsForOverrideIdentifer(r);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const n={};for(const i of v.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[i];const a=o[i];a&&(typeof s=="object"&&typeof a=="object"?(s=P.deepClone(s),this.mergeContents(s,a)):s=a),n[i]=s}return new y(n,this.keys,this.overrides)}mergeContents(r,o){for(const n of Object.keys(o)){if(n in r&&p.isObject(r[n])&&p.isObject(o[n])){this.mergeContents(r[n],o[n]);continue}r[n]=P.deepClone(o[n])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let o=null,n=null;const i=s=>{s&&(n?this.mergeContents(n,s):n=P.deepClone(s))};for(const s of this.overrides)v.equals(s.identifiers,[r])?o=s.contents:s.identifiers.includes(r)&&i(s.contents);return i(o),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,o){this.addKey(r),(0,R.addToValueTree)(this.contents,r,o,n=>{throw new Error(n)})}removeValue(r){this.removeKey(r)&&(0,R.removeFromValueTree)(this.contents,r)}addKey(r){let o=this.keys.length;for(let n=0;n<o;n++)r.indexOf(this.keys[n])===0&&(o=n);this.keys.splice(o,1,r)}removeKey(r){const o=this.keys.indexOf(r);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=y;class h{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,o){if(!p.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,o)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,o){this._raw=r;const{contents:n,keys:i,overrides:s,restricted:a,hasExcludedProperties:l}=this.doParseRaw(r,o);this._configurationModel=new y(n,i,s,l?[r]:void 0),this._restrictedConfigurations=a||[]}doParseContent(r){let o={},n=null,i=[];const s=[],a=[];function l(I){Array.isArray(i)?i.push(I):n!==null&&(i[n]=I)}const d={onObjectBegin:()=>{const I={};l(I),s.push(i),i=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{const I=[];l(I),s.push(i),i=I,n=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:l,onError:(I,L,B)=>{a.push({error:I,offset:L,length:B})}};if(r)try{D.visit(r,d),o=i[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return o}doParseRaw(r,o){const n=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),i=this.filter(r,n,!0,o);r=i.raw;const s=(0,R.toValuesTree)(r,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),a=Object.keys(r),l=this.toOverrides(r,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:s,keys:a,overrides:l,restricted:i.restricted,hasExcludedProperties:i.hasExcludedProperties}}filter(r,o,n,i){let s=!1;if(!i?.scopes&&!i?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:s};const a={},l=[];for(const d in r)if(k.OVERRIDE_PROPERTY_REGEX.test(d)&&n){const I=this.filter(r[d],o,!1,i);a[d]=I.raw,s=s||I.hasExcludedProperties,l.push(...I.restricted)}else{const I=o[d],L=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&l.push(d),(L===void 0||i.scopes===void 0||i.scopes.includes(L))&&!(i.skipRestricted&&I?.restricted)?a[d]=r[d]:s=!0}return{raw:a,restricted:l,hasExcludedProperties:s}}toOverrides(r,o){const n=[];for(const i of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(i)){const s={};for(const a in r[i])s[a]=r[i][a];n.push({identifiers:(0,k.overrideIdentifiersFromKey)(i),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,o)})}return n}}e.ConfigurationModelParser=h;class w extends C.Disposable{constructor(r,o,n,i){super(),this.userSettingsResource=r,this.scopes=o,this.fileService=i,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&n.isEqual(s.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class E{constructor(r,o,n,i,s=new y,a=new y,l=new T.ResourceMap,d=new y,I=new T.ResourceMap,L=!0){this._defaultConfiguration=r,this._policyConfiguration=o,this._applicationConfiguration=n,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=l,this._memoryConfiguration=d,this._memoryConfigurationByResource=I,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(r,o,n){return this.getConsolidatedConfigurationModel(r,o,n).getValue(r)}updateValue(r,o,n={}){let i;n.resource?(i=this._memoryConfigurationByResource.get(n.resource),i||(i=new y,this._memoryConfigurationByResource.set(n.resource,i))):i=this._memoryConfiguration,o===void 0?i.removeValue(r):i.setValue(r,o),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,o,n){const i=this.getConsolidatedConfigurationModel(r,o,n),s=this.getFolderConfigurationModelForResource(o.resource,n),a=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,l=this._defaultConfiguration.inspect(r,o.overrideIdentifier),d=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(r),I=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(r),L=this.userConfiguration.freeze().inspect(r,o.overrideIdentifier),B=this.localUserConfiguration.freeze().inspect(r,o.overrideIdentifier),J=this.remoteUserConfiguration.freeze().inspect(r,o.overrideIdentifier),Z=n?this._workspaceConfiguration.freeze().inspect(r,o.overrideIdentifier):void 0,_=s?s.freeze().inspect(r,o.overrideIdentifier):void 0,te=a.inspect(r,o.overrideIdentifier),se=i.getValue(r),W=v.distinct(i.overrides.map(fe=>fe.identifiers).flat()).filter(fe=>i.getOverrideValue(r,fe)!==void 0);return{defaultValue:l?l.merged:void 0,policyValue:d?d.merged:void 0,applicationValue:I?I.merged:void 0,userValue:L?L.merged:void 0,userLocalValue:B?B.merged:void 0,userRemoteValue:J?J.merged:void 0,workspaceValue:Z?Z.merged:void 0,workspaceFolderValue:_?_.merged:void 0,memoryValue:te?te.merged:void 0,value:se,default:l.value!==void 0||l.override!==void 0?{value:l.value,override:l.override}:void 0,policy:d?.value!==void 0?{value:d.value}:void 0,application:I?.value!==void 0||I?.override!==void 0?{value:I.value,override:I.override}:void 0,user:L.value!==void 0||L.override!==void 0?{value:L.value,override:L.override}:void 0,userLocal:B.value!==void 0||B.override!==void 0?{value:B.value,override:B.override}:void 0,userRemote:J.value!==void 0||J.override!==void 0?{value:J.value,override:J.override}:void 0,workspace:Z?.value!==void 0||Z?.override!==void 0?{value:Z.value,override:Z.override}:void 0,workspaceFolder:_?.value!==void 0||_?.override!==void 0?{value:_.value,override:_.override}:void 0,memory:te.value!==void 0||te.override!==void 0?{value:te.value,override:te.override}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(r){const o=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,o){this._folderConfigurations.set(r,o),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,o){const n=[];if(!o){const{added:i,updated:s,removed:a}=f(this._defaultConfiguration,r);o=[...i,...s,...a]}for(const i of o)for(const s of(0,k.overrideIdentifiersFromKey)(i)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(s),l=r.getKeysForOverrideIdentifier(s),d=[...l.filter(I=>a.indexOf(I)===-1),...a.filter(I=>l.indexOf(I)===-1),...a.filter(I=>!P.equals(this._defaultConfiguration.override(s).getValue(I),r.override(s).getValue(I)))];n.push([s,d])}return this.updateDefaultConfiguration(r),{keys:o,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:o,updated:n,removed:i}=f(this._policyConfiguration,r),s=[...o,...n,...i];return s.length&&this.updatePolicyConfiguration(r),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:o,updated:n,removed:i,overrides:s}=f(this.applicationConfiguration,r),a=[...o,...n,...i];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:o,updated:n,removed:i,overrides:s}=f(this.localUserConfiguration,r),a=[...o,...n,...i];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:o,updated:n,removed:i,overrides:s}=f(this.remoteUserConfiguration,r),a=[...o,...n,...i];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:o,updated:n,removed:i,overrides:s}=f(this.workspaceConfiguration,r),a=[...o,...n,...i];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:s}}compareAndUpdateFolderConfiguration(r,o){const n=this.folderConfigurations.get(r),{added:i,updated:s,removed:a,overrides:l}=f(n,o),d=[...i,...s,...a];return(d.length||!n)&&this.updateFolderConfiguration(r,o),{keys:d,overrides:l}}compareAndDeleteFolderConfiguration(r){const o=this.folderConfigurations.get(r);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:i,removed:s,overrides:a}=f(o,void 0);return{keys:[...n,...i,...s],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,o,n){let i=this.getConsolidatedConfigurationModelForResource(o,n);return o.overrideIdentifier&&(i=i.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:r},o){let n=this.getWorkspaceConsolidatedConfiguration();if(o&&r){const i=o.getFolder(r);i&&(n=this.getFolderConsolidatedConfiguration(i.uri)||n);const s=this._memoryConfigurationByResource.get(r);s&&(n=n.merge(s))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let o=this._foldersConsolidatedConfigurations.get(r);if(!o){const n=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(r);i?(o=n.merge(i),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(r,o)):o=n}return o}getFolderConfigurationModelForResource(r,o){if(o&&r){const n=o.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,o)=>{const{contents:n,overrides:i,keys:s}=this._folderConfigurations.get(o);return r.push([o,{contents:n,overrides:i,keys:s}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>r.add(o)),this.userConfiguration.freeze().keys.forEach(o=>r.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>o.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>o.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(i=>o.add(i))),[...o.values()]}static parse(r){const o=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.policy),i=this.parseConfigurationModel(r.application),s=this.parseConfigurationModel(r.user),a=this.parseConfigurationModel(r.workspace),l=r.folders.reduce((d,I)=>(d.set(b.URI.revive(I[0]),this.parseConfigurationModel(I[1])),d),new T.ResourceMap);return new E(o,n,i,s,new y,a,l,new y,new T.ResourceMap,!1)}static parseConfigurationModel(r){return new y(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=E;function g(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,o=new Map;for(const i of u)i.keys.forEach(s=>r.add(s)),i.overrides.forEach(([s,a])=>{const l=(0,T.getOrSet)(o,s,new Set);a.forEach(d=>l.add(d))});const n=[];return o.forEach((i,s)=>n.push([s,[...i.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=g;class m{constructor(r,o,n,i){this.change=r,this.previous=o,this.currentConfiguraiton=n,this.currentWorkspace=i,this._previousConfiguration=void 0;const s=new Set;r.keys.forEach(l=>s.add(l)),r.overrides.forEach(([,l])=>l.forEach(d=>s.add(d))),this.affectedKeys=[...s.values()];const a=new y;this.affectedKeys.forEach(l=>a.setValue(l,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(o){const n=this.previousConfiguration?this.previousConfiguration.getValue(r,o,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(r,o,this.currentWorkspace);return!P.equals(n,i)}return!0}return!1}doesAffectedKeysTreeContains(r,o){let n=(0,R.toValuesTree)({[o]:!0},()=>{}),i;for(;typeof n=="object"&&(i=Object.keys(n)[0]);){if(r=r[i],!r)return!1;n=n[i]}return!0}}e.ConfigurationChangeEvent=m;function f(u,r){const{added:o,removed:n,updated:i}=c(r,u),s=[],a=u?.getAllOverrideIdentifiers()||[],l=r?.getAllOverrideIdentifiers()||[];if(r){const d=l.filter(I=>!a.includes(I));for(const I of d)s.push([I,r.getKeysForOverrideIdentifier(I)])}if(u){const d=a.filter(I=>!l.includes(I));for(const I of d)s.push([I,u.getKeysForOverrideIdentifier(I)])}if(r&&u){for(const d of a)if(l.includes(d)){const I=c({contents:u.getOverrideValue(void 0,d)||{},keys:u.getKeysForOverrideIdentifier(d)},{contents:r.getOverrideValue(void 0,d)||{},keys:r.getKeysForOverrideIdentifier(d)});s.push([d,[...I.added,...I.removed,...I.updated]])}}return{added:o,removed:n,updated:i,overrides:s}}function c(u,r){const o=u?r?u.keys.filter(s=>r.keys.indexOf(s)===-1):[...u.keys]:[],n=r?u?r.keys.filter(s=>u.keys.indexOf(s)===-1):[...r.keys]:[],i=[];if(u&&r){for(const s of r.keys)if(u.keys.indexOf(s)!==-1){const a=(0,R.getConfigurationValue)(r.contents,s),l=(0,R.getConfigurationValue)(u.contents,s);P.equals(a,l)||i.push(s)}}return{added:o,removed:n,updated:i}}}),define(ve[212],we([1,0,18,7,2,22,11,25,104,52,13,62,34]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends D.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:f})=>this.onDidUpdateConfiguration(m,f))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(m,f){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=y;class h extends p.ConfigurationModel{constructor(m={}){const f=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(f),u=Object.create(null),r=[];for(const o in f){const n=m[o],i=n!==void 0?n:f[o].default;(0,P.addToValueTree)(u,o,i,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(u))b.OVERRIDE_PROPERTY_REGEX.test(o)&&r.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(u[o]),contents:(0,P.toValuesTree)(u[o],n=>console.error(`Conflict in default settings file: ${n}`))});super(u,c,r)}}e.DefaultConfigurationModel=h;class w{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new p.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=w;let E=class extends D.Disposable{get configurationModel(){return this._configurationModel}constructor(m,f,c){super(),this.defaultConfiguration=m,this.policyService=f,this.logService=c,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new p.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.registerPolicyDefinitions(m),!0))),this._configurationModel}async registerPolicyDefinitions(m){const f={},c=[],u=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const r of m){const o=u[r];if(!o){c.push(r);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}c.push(r),f[o.policy.name]={type:o.type}}}return(0,T.isEmptyObject)(f)||await this.policyService.registerPolicyDefinitions(f),c}onDidChangePolicies(m){const f=S.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),c=(0,v.coalesce)(m.map(u=>f.get(u)));this.update(c,!0)}update(m,f){const c=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),u=[],r=this._configurationModel.isEmpty();for(const o of m){const n=c[o]?.policy?.name;if(n){const i=this.policyService.getPolicyValue(n);(r?i!==void 0:!(0,C.equals)(this._configurationModel.getValue(o),i))&&u.push([o,i])}else this._configurationModel.getValue(o)!==void 0&&u.push([o,void 0])}if(u.length){const o=this._configurationModel;this._configurationModel=new p.ConfigurationModel;for(const n of o.keys)this._configurationModel.setValue(n,o.getValue(n));for(const[n,i]of u)i===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,i);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};E=Ae([_e(1,k.IPolicyService),_e(2,R.ILogService)],E),e.PolicyConfiguration=E}),define(ve[105],we([1,0,14,7,2,19,25,104,212,62]),function(oe,e,v,t,D,C,T,P,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends D.Disposable{constructor(S,y,h,w){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new p.DefaultConfiguration),this.policyConfiguration=h instanceof b.NullPolicyService?new p.NullPolicyConfiguration:this._register(new p.PolicyConfiguration(this.defaultConfiguration,h,w)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,y)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:E,properties:g})=>this.onDidDefaultConfigurationChange(E,g))),this._register(this.policyConfiguration.onDidChangeConfiguration(E=>this.onDidPolicyConfigurationChange(E))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,y,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(S,y,new P.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(S,y){const h=typeof S=="string"?S:void 0,w=(0,T.isConfigurationOverrides)(S)?S:(0,T.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(h,w,void 0)}updateValue(S,y,h,w){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(h,y,2)}onDidDefaultConfigurationChange(S,y){const h=this.configuration.toData(),w=this.configuration.compareAndUpdateDefaultConfiguration(S,y);this.trigger(w,h,7)}onDidPolicyConfigurationChange(S){const y=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(h,y,7)}trigger(S,y,h){const w=new P.ConfigurationChangeEvent(S,{data:y},this.configuration);w.source=h,w.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(ve[106],we([1,0,10,5]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends v.ErrorNoTelemetry{static isTemporarilyNotAvailable(P){return P instanceof C&&P._code===D.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof C&&P._code===D.NoResolverFound}static isHandled(P){return P instanceof C&&P.isHandled}constructor(P,p=D.Unknown,b){super(P),this._message=P,this._code=p,this._detail=b,this.isHandled=p===D.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}}e.RemoteAuthorityResolverError=C}),define(ve[75],we([1,0,12]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(b){return b.scheme===v.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=t;function D(b){if(!b)return;const R=b.indexOf("+");return R<0?b:b.substr(0,R)}e.getRemoteName=D;function C(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.getRemoteServerRootPath=C;function T(b){const{host:R,port:k}=p(b);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.parseAuthorityWithPort=T;function P(b,R){let{host:k,port:S}=p(b);return typeof S>"u"&&(S=R),{host:k,port:S}}e.parseAuthorityWithOptionalPort=P;function p(b){const R=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=b.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const S=b.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:b,port:void 0}}}),define(ve[35],we([1,0,15,5,75]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=C;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var p;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(p=e.TargetPlatform||(e.TargetPlatform={}));class b{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,E){if(typeof w>"u"||w===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof w=="string"||typeof E=="string"){const g=typeof w=="string"?w:w.value,m=typeof E=="string"?E:E.value;return v.equalsIgnoreCase(g,m)}return w._lower===E._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=b;function R(h){return k(h)}e.isApplicationScopedExtension=R;function k(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function S(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function y(h,w){if(w){const E=`onResolveRemoteAuthority:${(0,D.getRemoteName)(w)}`;return h.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[32],we([1,0,15,31,35,3,4,10,28]),function(oe,e,v,t,D,C,T,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,v.compareIgnoreCase)(o.id,n.id)===0}e.areSameExtensions=b;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(n){const i=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new k(n.identifier,i,s)}static parse(n){const i=R.exec(n);return i&&i[1]&&i[2]?new k({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,s="undefined"){this.version=i,this.targetPlatform=s,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof k?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=k;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(o){const n=S.exec(o);return n&&n[1]?[w(n[1]),n[2]]:[w(o),void 0]}e.getIdAndVersion=y;function h(o,n){return`${o}.${n}`}e.getExtensionId=h;function w(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=w;function E(o,n){return w(h(o,n))}e.getGalleryExtensionId=E;function g(o,n){const i=[],s=a=>{for(const l of i)if(l.some(d=>b(n(d),n(a))))return l;return null};for(const a of o){const l=s(a);l?l.push(a):i.push([a])}return i}e.groupByExtension=g;function m(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function f(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function c(o,n){const i=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&i.every(l=>!b(l.identifier,{id:a}))){const l=o.filter(d=>b(d.identifier,{id:a}));l.length===1&&(i.push(l[0]),s.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=c;async function u(o,n){if(!C.isLinux)return!1;let i;try{i=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=u;async function r(o,n){const i=await u(o,n),s=(0,t.getTargetPlatform)(i?"alpine":C.platform,p.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=r}),define(ve[107],we([1,0,20,10,12,19,50,4,164,31,32,35]),function(oe,e,v,t,D,C,T,P,p,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const S=E=>(0,p.localize)(0,null,E),y=(0,p.localize)(1,null,"ms-dotnettools.csharp");function h(E,g){return g?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let w=class{constructor(g,m){this.extensionManagementService=g,this.extensionGalleryService=m}get location(){}async listExtensions(g,m,f,c=console){let u=await this.extensionManagementService.getInstalled(1,f);const r=k.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(m&&m!==""){if(r.indexOf(m.toLowerCase())<0){c.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}u=u.filter(n=>n.manifest.categories?n.manifest.categories.map(s=>s.toLowerCase()).indexOf(m.toLowerCase())>-1:!1)}else if(m===""){c.log("Possible Categories: "),r.forEach(n=>{c.log(n)});return}this.location&&c.log((0,p.localize)(2,null,this.location)),u=u.sort((n,i)=>n.identifier.id.localeCompare(i.identifier.id));let o;for(const n of u)o!==n.identifier.id&&(o=n.identifier.id,c.log(h(n.manifest,g)))}async installExtensions(g,m,f,c,u=console){const r=[],o=[];g.length&&u.log(this.location?(0,p.localize)(3,null,this.location):(0,p.localize)(4,null));const n=await this.extensionManagementService.getInstalled(1,f.profileLocation),i=(d,I)=>{const L=n.find(B=>(0,R.areSameExtensions)(B.identifier,{id:d}));if(L){if(!c&&(!I||I==="prerelease"&&L.preRelease))return u.log((0,p.localize)(5,null,d,L.manifest.version,d)),!1;if(I&&L.manifest.version===I)return u.log((0,p.localize)(6,null,`${d}@${I}`)),!1}return!0},s=(d,I,L)=>{l.push({id:d,version:I!=="prerelease"?I:void 0,installOptions:{...f,isBuiltin:L,installPreReleaseVersion:I==="prerelease"||f.installPreReleaseVersion}})},a=[],l=[];for(const d of g)if(d instanceof P.URI)a.push(d);else{const[I,L]=(0,R.getIdAndVersion)(d);i(I,L)&&s(I,L,!1)}for(const d of m){const[I,L]=(0,R.getIdAndVersion)(d);i(I,L)&&s(I,L,!0)}if(a.length&&await Promise.all(a.map(async d=>{try{const I=await this.installVSIX(d,{...f,isBuiltin:!1},c,u);I&&o.push(I)}catch(I){u.error(I.message||I.stack||I),r.push(d.toString())}})),l.length){const d=await this.getGalleryExtensions(l);await Promise.all(l.map(async I=>{const L=d.get(I.id.toLowerCase());if(L)try{const B=await this.installFromGallery(I,L,n,c,u);B&&o.push(B)}catch(B){u.error(B.message||B.stack||B),r.push(I.id)}else u.error(`${S(I.version?`${I.id}@${I.version}`:I.id)}
${y}`),r.push(I.id)}))}if(r.length)throw new Error((0,p.localize)(7,null,r.join(", ")))}async installVSIX(g,m,f,c){const u=await this.extensionManagementService.getManifest(g);if(!u)throw new Error("Invalid vsix");if(await this.validateVSIX(u,f,m.profileLocation,c))try{return await this.extensionManagementService.install(g,m),c.log((0,p.localize)(8,null,(0,C.basename)(g))),u}catch(o){if((0,t.isCancellationError)(o))return c.log((0,p.localize)(9,null,(0,C.basename)(g))),null;throw o}return null}async getGalleryExtensions(g){const m=new Map,f=g.some(u=>u.installOptions.installPreReleaseVersion),c=await this.extensionGalleryService.getExtensions(g.map(u=>({...u,preRelease:f})),v.CancellationToken.None);for(const u of c)m.set(u.identifier.id.toLowerCase(),u);return m}async installFromGallery({id:g,version:m,installOptions:f},c,u,r,o){const n=await this.extensionGalleryService.getManifest(c,v.CancellationToken.None);if(n&&!this.validateExtensionKind(n,o))return null;const i=u.find(s=>(0,R.areSameExtensions)(s.identifier,c.identifier));if(i){if(c.version===i.manifest.version)return o.log((0,p.localize)(10,null,m?`${g}@${m}`:g)),null;o.log((0,p.localize)(11,null,g,c.version))}try{f.isBuiltin?o.log(m?(0,p.localize)(12,null,g,m):(0,p.localize)(13,null,g)):o.log(m?(0,p.localize)(14,null,g,m):(0,p.localize)(15,null,g));const s=await this.extensionManagementService.installFromGallery(c,{...f,installGivenVersion:!!m});return o.log((0,p.localize)(16,null,g,s.manifest.version)),n}catch(s){if((0,t.isCancellationError)(s))return o.log((0,p.localize)(17,null,g)),null;throw s}}validateExtensionKind(g,m){return!0}async validateVSIX(g,m,f,c){const u={id:(0,R.getGalleryExtensionId)(g.publisher,g.name)},o=(await this.extensionManagementService.getInstalled(1,f)).find(n=>(0,R.areSameExtensions)(u,n.identifier)&&(0,T.gt)(n.manifest.version,g.version));return o&&!m?(c.log((0,p.localize)(18,null,o.identifier.id,o.manifest.version,g.version)),!1):this.validateExtensionKind(g,c)}async uninstallExtensions(g,m,f,c=console){const u=async o=>{if(o instanceof P.URI){const n=await this.extensionManagementService.getManifest(o);return h(n)}return o},r=[];for(const o of g){const n=await u(o),s=(await this.extensionManagementService.getInstalled(void 0,f)).filter(a=>(0,R.areSameExtensions)(a.identifier,{id:n}));if(!s.length)throw new Error(`${this.notInstalled(n)}
${y}`);if(s.some(a=>a.type===0)){c.log((0,p.localize)(19,null,n));return}if(!m&&s.some(a=>a.isBuiltin)){c.log((0,p.localize)(20,null,n));return}c.log((0,p.localize)(21,null,n));for(const a of s)await this.extensionManagementService.uninstall(a,{profileLocation:f}),r.push(a);this.location?c.log((0,p.localize)(22,null,n,this.location)):c.log((0,p.localize)(23,null,n))}}async locateExtension(g,m=console){const f=await this.extensionManagementService.getInstalled();g.forEach(c=>{f.forEach(u=>{if(u.identifier.id===c&&u.location.scheme===D.Schemas.file){m.log(u.location.fsPath);return}})})}notInstalled(g){return this.location?(0,p.localize)(24,null,g,this.location):(0,p.localize)(25,null,g)}};w=Ae([_e(0,b.IExtensionManagementService),_e(1,b.IExtensionGalleryService)],w),e.ExtensionManagementCLI=w}),define(ve[53],we([1,0,14,16,2,24,4,32,17,5,13]),function(oe,e,v,t,D,C,T,P,p,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let k=class extends D.Disposable{constructor(y,h){super(),this.fileService=y,this.logService=h,this.resourcesAccessQueueMap=new C.ResourceMap}scanProfileExtensions(y){return this.withProfileExtensions(y)}addExtensionsToProfile(y,h){return this.withProfileExtensions(h,w=>(w=w.filter(E=>y.some(([g])=>!(0,P.areSameExtensions)(E.identifier,g.identifier))),w.push(...y.map(([E,g])=>({identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:g}))),w))}removeExtensionFromProfile(y,h){return this.withProfileExtensions(h,w=>w.filter(E=>!(0,P.areSameExtensions)(E.identifier,y)))}async withProfileExtensions(y,h){return this.getResourceAccessQueue(y).queue(async()=>{let w=[];try{const E=await this.fileService.readFile(y),g=JSON.parse(E.value.toString());for(const m of g){if(!m.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",m);continue}if(!m.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",m);continue}if(!m.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",m);continue}w.push({identifier:m.identifier,location:T.URI.revive(m.location),version:m.version,metadata:m.metadata})}}catch(E){E.fileOperationResult!==1&&this.logService.error(E)}if(h){w=h(w);const E=w.map(g=>({identifier:g.identifier,version:g.version,location:g.location.toJSON(),metadata:g.metadata}));await this.fileService.writeFile(y,t.VSBuffer.fromString(JSON.stringify(E)))}return w})}getResourceAccessQueue(y){let h=this.resourcesAccessQueueMap.get(y);return h||(h=new v.Queue,this.resourcesAccessQueueMap.set(y,h)),h}};k=Ae([_e(0,p.IFileService),_e(1,R.ILogService)],k),e.ExtensionsProfileScannerService=k}),define(ve[213],we([1,0,14,10,2,3,19,50,4,23,21,26,31,32,17,13]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let E=class extends D.Disposable{constructor(m,f,c,u){super(),this.fileService=f,this.extensionGalleryService=c,this.logService=u,this.extensionsDownloadDir=p.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,f){await this.cleanUpPromise;const c=this.getName(m),u=(0,T.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(u)){const r=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(m,r,f);try{await this.rename(r,u,Date.now()+2*60*1e3)}catch(o){try{await this.fileService.del(r)}catch{}if(o.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(o)}. Deleted the vsix from downloaded location`,r.path),o}}return u}async delete(m){await this.cleanUpPromise,await this.fileService.del(m)}async rename(m,f,c){try{await R.Promises.rename(m.fsPath,f.fsPath)}catch(u){if(C.isWindows&&u&&u.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${m} to ${f} with 'EPERM' error. Trying again...`),this.rename(m,f,c);throw u}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const f=[],c=[];for(const o of m.children){const n=y.ExtensionKey.parse(o.name);n&&c.push([n,o])}const u=(0,y.groupByExtension)(c,([o])=>o),r=[];for(const o of u)o.sort((n,i)=>P.rcompare(n[0].version,i[0].version)),f.push(...o.slice(1).map(n=>n[1].resource)),r.push(o[0][1]);r.sort((o,n)=>o.mtime-n.mtime),f.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(o=>o.resource)),await v.Promises.settled(f.map(o=>(this.logService.trace("Deleting vsix from cache",o.path),this.fileService.del(o))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?y.ExtensionKey.create(m).toString().toLowerCase():(0,b.generateUuid)()}};E=Ae([_e(0,k.INativeEnvironmentService),_e(1,h.IFileService),_e(2,S.IExtensionGalleryService),_e(3,w.ILogService)],E),e.ExtensionsDownloader=E}),define(ve[214],we([1,0,2,6,21,35]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends v.Disposable{constructor(p,b){super(),this.environmentService=p,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(R=>this.onDidInstallExtensions(R))),this._register(b.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtensions(p){p.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ve[108],we([1,0,109,18,14,2,12,6,21,26,31,32,13,74]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends y.LanguagePackBaseService{constructor(m,f,c,u){super(c),this.extensionManagementService=m,this.logService=u,this.cache=this._register(new w(f,u)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getInstalledLanguages(){const m=await this.cache.getLanguagePacks(),f=Object.keys(m).map(c=>{const u=m[c];return{...this.createQuickPickItem(c,u.label),extensionId:u.extensions[0].extensionIdentifier.id}});return f.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),f.sort((c,u)=>c.label.localeCompare(u.label)),f}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const f=await this.cache.getLanguagePacks();Object.keys(f).some(c=>f[c]&&f[c].extensions.some(u=>(0,k.areSameExtensions)(u.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,f]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),c=await this.cache.update(f);return!(0,t.equals)(Object.keys(m),Object.keys(c))}};h=Ae([_e(0,R.IExtensionManagementService),_e(1,b.INativeEnvironmentService),_e(2,R.IExtensionGalleryService),_e(3,S.ILogService)],h),e.NativeLanguagePackService=h;let w=class extends C.Disposable{constructor(m,f){super(),this.logService=f,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(f=>{Object.keys(f).forEach(c=>delete f[c]),this.createLanguagePacksFromExtensions(f,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...f){for(const c of f)c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,c);Object.keys(m).forEach(c=>this.updateHash(m[c]))}createLanguagePacksFromExtension(m,f){const c=f.identifier,u=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const r of u)if(f.location.scheme===T.Schemas.file&&E(r)){let o=m[r.languageId];o||(o={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=o);const n=o.extensions.filter(i=>(0,k.areSameExtensions)(i.extensionIdentifier,c))[0];n?n.version=f.manifest.version:o.extensions.push({extensionIdentifier:c,version:f.manifest.version});for(const i of r.translations)o.translations[i.id]=(0,P.join)(f.location.fsPath,i.path)}}updateHash(m){if(m){const f=(0,v.createHash)("md5");for(const c of m.extensions)f.update(c.extensionIdentifier.uuid||c.extensionIdentifier.id).update(c.version);m.hash=f.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let f=null;return p.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,c=>c.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(c)).then(c=>{try{return JSON.parse(c)}catch{return{}}}).then(c=>(f=m(c),c)).then(c=>{for(const r of Object.keys(c))c[r]||delete c[r];this.languagePacks=c,this.initializedCache=!0;const u=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",u),p.Promises.writeFile(this.languagePacksFilePath,u)}).then(()=>f,c=>this.logService.error(c))})}};w=Ae([_e(0,b.INativeEnvironmentService),_e(1,S.ILogService)],w);function E(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const m of g.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(ve[54],we([1,0,16,176,52,5,34]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function P(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.isSuccess=P;function p(w){return w.res.statusCode===204}async function b(w){return p(w)?null:(await(0,v.streamToBuffer)(w.stream)).toString()}e.asText=b;async function R(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);return b(w)}e.asTextOrError=R;async function k(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);if(p(w))return null;const g=(await(0,v.streamToBuffer)(w.stream)).toString();try{return JSON.parse(g)}catch(m){throw m.message+=`:
`+g,m}}e.asJson=k;function S(w){h(w)}e.updateProxyConfigurationsScope=S;let y;function h(w){const E=T.Registry.as(D.Extensions.Configuration),g=y;y={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[y],remove:g?[g]:[]})}h(2)}),define(ve[215],we([1,0,20,12,17,54]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(p,b){this.requestService=p,this.fileService=b}async download(p,b,R=v.CancellationToken.None){if(p.scheme===t.Schemas.file||p.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(p,b);return}const k={type:"GET",url:p.toString(!0)},S=await this.requestService.request(k,R);if(S.res.statusCode===200)await this.fileService.writeFile(b,S.stream);else{const y=await(0,C.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${y}`)}}};T=Ae([_e(0,C.IRequestService),_e(1,D.IFileService)],T),e.DownloadService=T}),define(ve[216],we([1,0,16,20]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(P){this.service=P}listen(P,p){throw new Error("Invalid listen")}call(P,p,b,R=t.CancellationToken.None){switch(p){case"request":return this.service.request(b[0],R).then(async({res:k,stream:S})=>{const y=await(0,v.streamToBuffer)(S);return[{statusCode:k.statusCode,headers:k.headers},y]});case"resolveProxy":return this.service.resolveProxy(b[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class C{constructor(P){this.channel=P}async request(P,p){const[b,R]=await this.channel.call("request",[P],p);return{res:b,stream:(0,v.bufferToStream)(R)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=C}),define(ve[217],we([1,0,76,11]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(T,P){return T.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:T.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function C(T,P,p={}){const b=(0,v.parse)(T),R=p.proxyUrl||D(b,P);if(!R)return null;const k=(0,v.parse)(R);if(!/^https?:$/.test(k.protocol||""))return null;const S={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,t.isBoolean)(p.strictSSL)?p.strictSSL:!0};return b.protocol==="http:"?new(await new Promise((y,h)=>{oe(["http-proxy-agent"],y,h)}))(S):new(await new Promise((y,h)=>{oe(["https-proxy-agent"],y,h)}))(S)}e.getProxyAgent=C}),define(ve[77],we([1,0,49,6,177,20,38,10,3,23,154,190,14]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let h;async function w(g,m,f){return m["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(f)&&!m["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(f)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=S.Promises.withAsyncBody(async(c,u)=>{const r=new C.CancellationTokenSource,o=setTimeout(()=>{r.dispose(!0),u(new Error((0,D.localize)(0,null)))},y);try{c(await E(g,r.token))}catch(n){!(0,P.isCancellationError)(n)&&!r.token.isCancellationRequested?u(new Error((0,D.localize)(1,null,(0,T.toErrorMessage)(n)))):c({})}finally{clearTimeout(o),r.dispose()}})),h)}e.getResolvedShellEnv=w;async function E(g,m){const f=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",f);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",c);const u=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(u+"(.*)"+u),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",o);const n=await(0,R.getSystemShell)(p.OS,o);return g.trace("getUnixShellEnvironment#shell",n),new Promise((i,s)=>{if(m.isCancellationRequested)return s((0,P.canceled)());const a=(0,t.basename)(n);let l,d;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(l=`& '${process.execPath}' ${I} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,d=["-Login","-Command"]):(l=`'${process.execPath}' ${I} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,a==="tcsh"?d=["-ic"]:d=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),l);const L=(0,v.spawn)(n,[...d,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});m.onCancellationRequested(()=>(L.kill(),s((0,P.canceled)()))),L.on("error",Z=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(Z)),s(Z)});const B=[];L.stdout.on("data",Z=>B.push(Z));const J=[];L.stderr.on("data",Z=>J.push(Z)),L.on("close",(Z,_)=>{const te=Buffer.concat(B).toString("utf8");g.trace("getUnixShellEnvironment#raw",te);const se=Buffer.concat(J).toString("utf8");if(se.trim()&&g.trace("getUnixShellEnvironment#stderr",se),Z||_)return s(new Error((0,D.localize)(2,null,Z,_)));const W=r.exec(te),fe=W?W[1]:"{}";try{const j=JSON.parse(fe);f?j.ELECTRON_RUN_AS_NODE=f:delete j.ELECTRON_RUN_AS_NODE,c?j.ELECTRON_NO_ATTACH_CONSOLE=c:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",j),i(j)}catch(j){g.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(j)),s(j)}})})}}),define(ve[110],we([1,0,3,28,4,23]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(b){if(v.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,R,k,S,y,h,w,E,g,m){const f=Object.create(null);f["common.machineId"]=w,f.sessionID=(0,C.generateUuid)()+Date.now(),f.commitHash=y,f.version=h,f["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,v.PlatformToString)(v.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=S,f["common.product"]=m||"desktop",E&&(f["common.msftInternal"]=E);let c=0;const u=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),v.isLinuxSnap&&(f["common.snap"]="true");const r=T(k);r&&(f["common.platformDetail"]=r);try{const o=await b.readFile(D.URI.file(g));f["common.source"]=o.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=P;function p(b){const R=t.env.USERDNSDOMAIN;if(!R)return!1;const k=R.toLowerCase();return b.some(S=>k===S)}e.verifyMicrosoftInternalDomain=p}),define(ve[218],we([1,0,18,10,2,22,17]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var P;(function(b){function R(k,S){return k.callstack<S.callstack?-1:k.callstack>S.callstack?1:0}b.compare=R})(P=e.ErrorEvent||(e.ErrorEvent={}));class p{constructor(R,k=p.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new D.DisposableStore,this._telemetryService=R,this._flushDelay=k;const S=t.errorHandler.addListener(y=>this._onErrorEvent(y));this._disposables.add((0,D.toDisposable)(S)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(R){if(!R||(R.detail&&R.detail.stack&&(R=R.detail),t.ErrorNoTelemetry.isErrorNoTelemetry(R)||R instanceof T.FileOperationError))return;const k=Array.isArray(R.stack)?R.stack.join(`
`):R.stack,S=R.message?R.message:(0,C.safeStringify)(R);!k||this._enqueue({msg:S,callstack:k})}_enqueue(R){const k=(0,v.binarySearch)(this._buffer,R,P.compare);k<0?(R.count=1,this._buffer.splice(~k,0,R)):(this._buffer[k].count||(this._buffer[k].count=0),this._buffer[k].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(const R of this._buffer)this._telemetryService.publicLogError2("UnhandledError",R);this._buffer.length=0}}e.default=p,p.ERROR_FLUSH_TIMEOUT=5*1e3}),define(ve[219],we([1,0,2]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends v.Disposable{constructor(C,T){super(),this.telemetryService=C,this.telemetryAppender=T}async call(C,T,P){switch(T){case"updateTelemetryLevel":{const{telemetryLevel:p}=P;return this.telemetryService.updateInjectedTelemetryLevel(p)}case"logTelemetry":{const{eventName:p,data:b}=P;return this.telemetryAppender?this.telemetryAppender.log(p,b):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${T} not found`)}listen(C,T,P){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(ve[33],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ve[220],we([1,0,30,44,14,65,12,6,3,4,91,21,94,197,17,27,33]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const g=new Map;async function m(o,n){const i=`${o}::${n.join(":")}`,s=g.get(i);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,d=new Map,I=2e4;function L(J,Z,_,te){const se=Z.substring(J.length+1);return D.Promises.withAsyncBody(async W=>{let fe;try{fe=await k.Promises.readdir(Z,{withFileTypes:!0})}catch{W();return}if(te.count>=I){te.count+=fe.length,te.maxReached=!0,W();return}let j=fe.length;if(j===0){W();return}let X=fe;te.count+fe.length>I&&(te.maxReached=!0,j=I-te.count,X=fe.slice(0,j)),te.count+=fe.length;for(const O of X)if(O.isDirectory()){if(_.includes(O.name)||await L(J,(0,P.join)(Z,O.name),_,te),--j===0){W();return}}else{const U=O.name.lastIndexOf(".");if(U>=0){const x=O.name.substring(U+1);x&&l.set(x,(l.get(x)??0)+1)}for(const x of a)x.relativePathPattern?.test(se)!==!1&&x.filePattern.test(O.name)&&d.set(x.tag,(d.get(x.tag)??0)+1);if(--j===0){W();return}}})}const B=D.Promises.withAsyncBody(async J=>{const Z={count:0,maxReached:!1};await L(o,o,n,Z);const _=await u(o);J({configFiles:f(d),fileTypes:f(l),fileCount:Z.count,maxFilesReached:Z.maxReached,launchConfigFiles:_})});return g.set(i,B),B}e.collectWorkspaceStats=m;function f(o){return[...t.Iterable.map(o.entries(),([n,i])=>({name:n,count:i}))].sort((n,i)=>i.count-n.count)}function c(){const o={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},n=v.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}e.getMachineInfo=c;async function u(o){try{const n=new Map,i=(0,P.join)(o,".vscode","launch.json"),s=await k.Promises.readFile(i),a=[],l=(0,C.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${i}`),[];if((0,C.getNodeType)(l)==="object"&&l.configurations)for(const d of l.configurations){const I=d.type;I&&(n.has(I)?n.set(I,n.get(I)+1):n.set(I,1))}return f(n)}catch{return[]}}e.collectLaunchConfigs=u;let r=class{constructor(n,i){this.telemetryService=n,this.productService=i}formatMachineInfo(n){const i=[];return i.push(`OS Version:       ${n.os}`),i.push(`CPUs:             ${n.cpus}`),i.push(`Memory (System):  ${n.memory}`),i.push(`VM:               ${n.vmHint}`),i.join(`
`)}formatEnvironment(n){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const s=v.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(v.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),p.isWindows||i.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),i.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${n.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(n,i){return Promise.all([(0,S.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async s=>{let[a,l]=s,d=this.formatProcessList(n,a);return i.forEach(I=>{if((0,y.isRemoteDiagnosticError)(I))d+=`
${I.errorMessage}`,l+=`
${I.errorMessage}`;else if(d+=`

Remote: ${I.hostName}`,I.processes&&(d+=`
${this.formatProcessList(n,I.processes)}`),I.workspaceMetadata){l+=`
|  Remote: ${I.hostName}`;for(const L of Object.keys(I.workspaceMetadata)){const B=I.workspaceMetadata[L];let J=`${B.fileCount} files`;B.maxFilesReached&&(J=`more than ${J}`),l+=`|    Folder (${L}): ${J}`,l+=this.formatWorkspaceStats(B)}}}),{processInfo:d,workspaceInfo:l}})}async getSystemInfo(n,i){const{memory:s,vmHint:a,os:l,cpus:d}=c(),I={os:l,memory:s,cpus:d,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:i};return p.isWindows||(I.load=`${v.loadavg().map(L=>Math.round(L)).join(", ")}`),p.isLinux&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(n,i){const s=[];return(0,S.listProcesses)(n.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(n)),s.push(""),s.push(this.formatProcessList(n,a)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(n))),i.forEach(l=>{if((0,y.isRemoteDiagnosticError)(l))s.push(`
${l.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${l.hostName}`),s.push(this.formatMachineInfo(l.machineInfo)),l.processes&&s.push(this.formatProcessList(n,l.processes)),l.workspaceMetadata)for(const d of Object.keys(l.workspaceMetadata)){const I=l.workspaceMetadata[d];let L=`${I.fileCount} files`;I.maxFilesReached&&(L=`more than ${L}`),s.push(`Folder (${d}): ${L}`),s.push(this.formatWorkspaceStats(I))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(n){const i=[];let a=0;const l=(B,J)=>{const Z=` ${B}(${J})`;a+Z.length>60?(i.push(d),d="|                 ",a=d.length):a+=Z.length,d+=Z};let d="|      File types:";const I=10,L=n.fileTypes.length>I?I:n.fileTypes.length;for(let B=0;B<L;B++){const J=n.fileTypes[B];l(J.name,J.count)}if(i.push(d),n.configFiles.length>=0&&(d="|      Conf files:",a=0,n.configFiles.forEach(B=>{l(B.name,B.count)}),i.push(d)),n.launchConfigFiles.length>0){let B="|      Launch Configs:";n.launchConfigFiles.forEach(J=>{B+=J.count>1?` ${J.name}(${J.count})`:` ${J.name}`}),i.push(B)}return i.join(`
`)}expandGPUFeatures(n){const i=Math.max(...Object.keys(n).map(s=>s.length));return Object.keys(n).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${n[s]}`).join(`
                  `)}formatWorkspaceMetadata(n){const i=[],s=[];return n.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(i.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const d=b.URI.revive(l);if(d.scheme===T.Schemas.file){const I=d.fsPath;s.push(m(I,["node_modules",".git"]).then(L=>{let B=`${L.fileCount} files`;L.maxFilesReached&&(B=`more than ${B}`),i.push(`|    Folder (${(0,P.basename)(I)}): ${B}`),i.push(this.formatWorkspaceStats(L))}).catch(L=>{i.push(`|      Error: Unable to collect workspace stats for folder ${I} (${L.toString()})`)}))}else i.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>i.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(n,i){const s=new Map;n.windows.forEach(l=>s.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(n.mainPID,s,a,i,0),a.join(`
`)}formatProcessItem(n,i,s,a,l){const d=l===0;let I;d?I=a.pid===n?`${this.productService.applicationName} main`:"remote agent":(I=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(I=`${I} (${i.get(a.pid)})`));const L=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(L/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(a.children)&&a.children.forEach(B=>this.formatProcessItem(n,i,s,B,l+1))}async getWorkspaceFileExtensions(n){const i=new Set;for(const{uri:s}of n.folders){const a=b.URI.revive(s);if(a.scheme!==T.Schemas.file)continue;const l=a.fsPath;try{(await m(l,["node_modules",".git"])).fileTypes.forEach(I=>i.add(I.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(n){for(const{uri:i}of n.folders){const s=b.URI.revive(i);if(s.scheme!==T.Schemas.file)continue;const a=s.fsPath;try{const l=await m(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})}),l.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})}),l.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};r=Ae([_e(0,E.ITelemetryService),_e(1,w.IProductService)],r),e.DiagnosticsService=r}),define(ve[42],we([1,0,22,87,11,25,110,33]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class p{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(r,o){return Promise.resolve(void 0)}publicLog2(r,o){return this.publicLog(r,o)}publicLogError(r,o){return Promise.resolve(void 0)}publicLogError2(r,o){return this.publicLogError(r,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class b{async publicLog(r,o,n){}async publicLogError(r,o,n){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function R(u,r){return r.onDidChangeConfiguration(o=>{o.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(o.source),configurationKeys:g(o.sourceConfig)})})}e.configurationTelemetry=R;function k(u,r){return!(r.disableTelemetry||!u.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=k;function S(u){const r=u.getValue(P.TELEMETRY_SETTING_ID),o=u.getValue("telemetry.enableCrashReporter");if(u.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function y(u){const r={},o={},n={};E(u,n);for(let i in n){i=i.length>150?i.substr(i.length-149):i;const s=n[i];typeof s=="number"?o[i]=s:typeof s=="boolean"?o[i]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${s.length}`),r[i]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(r[i]=s)}return{properties:r,measurements:o}}e.validateTelemetryData=y;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function w(u){if(!u)return"none";for(const r of h)if(u.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=w;function E(u,r,o=0,n){if(!!u)for(const i of Object.getOwnPropertyNames(u)){const s=u[i],a=n?n+i:i;Array.isArray(s)?r[a]=(0,v.safeStringify)(s):s instanceof Date?r[a]=s.toISOString():(0,D.isObject)(s)?o<2?E(s,r,o+1,a+"."):r[a]=(0,v.safeStringify)(s):r[a]=s}}function g(u){if(!u)return[];const r=[];return m(r,"",u),r}function m(u,r,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(n=>m(u,r?`${r}.${n}`:n,o[n])):u.push(r)}function f(u,r){const o=u.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(o)||n}e.isInternalTelemetry=f;function c(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=c}),define(ve[221],we([1,0,194,42]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(C,T,P,p,b,R,k){const S={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${T.nameShort})`};if((0,t.supportsTelemetry)(T,P)&&(0,t.getTelemetryLevel)(p)===3){const y=await(0,v.getServiceMachineId)(P,b,R),{sessionId:h}=await k.getTelemetryInfo();S["X-Market-User-Id"]=y,S["VSCode-SessionId"]=h}return S}e.resolveMarketplaceHeaders=D}),define(ve[222],we([1,0,10,22,42]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(p,b,R){const k=await new Promise((E,g)=>{oe(["@microsoft/1ds-core-js"],E,g)}),S=await new Promise((E,g)=>{oe(["@microsoft/1ds-post-js"],E,g)}),y=new k.AppInsightsCore,h=new S.PostChannel,w={instrumentationKey:p,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(R){w.extensionConfig={};const E={alwaysUseXhrOverride:!0,httpXHROverride:R};w.extensionConfig[h.identifier]=E}return y.initialize(w,[]),y.addTelemetryInitializer(E=>{b&&(E.ext=E.ext??{},E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),y}class P{constructor(b,R,k,S,y){this._isInternalTelemetry=b,this._eventPrefix=R,this._defaultData=k,this._xhrOverride=y,this.endPointUrl=C,this._defaultData||(this._defaultData={}),typeof S=="function"?this._aiCoreOrKey=S():this._aiCoreOrKey=S,this._asyncAiCore=null}_withAIClient(b){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){b(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(R=>{b(R)},R=>{(0,v.onUnexpectedError)(R),console.error(R)})}}log(b,R){if(!this._aiCoreOrKey)return;R=(0,t.mixin)(R,this._defaultData),R=(0,D.validateTelemetryData)(R);const k=this._eventPrefix+"/"+b;try{this._withAIClient(S=>{S.pluginVersionString=R?.properties.version??"Unknown",S.track({name:k,baseData:{name:k,properties:R?.properties,measurements:R?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(b=>{this._withAIClient(R=>{R.unload(!0,()=>{this._aiCoreOrKey=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(ve[223],we([1,0,2,22,87,3,15,178,25,52,51,27,34,33,42]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(m,f,c){this._configurationService=f,this._productService=c,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(u),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(m,f){this._experimentProperties[m]=f}_updateTelemetryLevel(){let m=(0,h.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const c=f.usage?3:f.error?2:0;m=Math.min(m,c)}this.telemetryLevel.value=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const m=await this._commonProperties,f=m.sessionID,c=m["common.machineId"],u=m["common.firstSessionDate"],r=m["common.msftInternal"];return{sessionId:f,machineId:c,firstSessionDate:u,msftInternal:r}}dispose(){this._disposables.dispose()}_log(m,f,c,u){return this.telemetryLevel.value<f?Promise.resolve(void 0):this._commonProperties.then(r=>{c=(0,t.mixin)(c,r),c=(0,t.mixin)(c,this._experimentProperties),c=(0,t.cloneAndChange)(c,o=>{if(typeof o=="string")return this._cleanupInfo(o,u)}),this._appenders.forEach(o=>o.log(m,c))},r=>{console.error(r)})}publicLog(m,f,c){return this._log(m,3,f,c)}publicLog2(m,f,c){return this.publicLog(m,f,c)}publicLogError(m,f){return this._sendErrorTelemetry?this._log(m,2,f,!0):Promise.resolve(void 0)}publicLogError2(m,f){return this.publicLogError(m,f)}_anonymizeFilePaths(m){let f=m;const c=[];for(const n of this._cleanupPatterns)for(;;){const i=n.exec(m);if(!i)break;c.push([i.index,n.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(f="";;){const n=r.exec(m);if(!n)break;!u.test(n[0])&&c.every(([i,s])=>n.index<i||n.index>=s)&&(f+=m.substring(o,n.index)+"<REDACTED: user-file-path>",o=r.lastIndex)}return o<m.length&&(f+=m.substr(o)),f}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const f=m.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const u of c)if(u.regex.test(f))return`<REDACTED: ${u.label}>`;return m}_cleanupInfo(m,f){let c=m;f&&(c=this._anonymizeFilePaths(c));for(const u of this._cleanupPatterns)c=c.replace(u,"");return c=this._removePropertiesWithPossibleUserInfo(c),c}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=Ae([_e(1,p.IConfigurationService),_e(2,k.IProductService)],w),e.TelemetryService=w;function E(){const g=(0,P.localize)(0,null,R.default.nameLong),m=R.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",R.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=C.isWeb?"":(0,P.localize)(3,null),c=(0,P.localize)(4,null),u=(0,P.localize)(5,null),r=(0,P.localize)(6,null),o=(0,P.localize)(7,null),n=`
|       | ${c} | ${u} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,P.localize)(8,null);return`
${g} ${m} ${f}

&nbsp;

${o}
${n}

&nbsp;

${i}
`}S.Registry.as(b.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(b.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:R.default.privacyStatementUrl?(0,P.localize)(16,null,R.default.nameLong,R.default.privacyStatementUrl):(0,P.localize)(15,null,R.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ve[224],we([1,0,25,5,27,33,223,42]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let p=class extends T.TelemetryService{constructor(R,k,S,y){super(R,S,y),this._injectedTelemetryLevel=k}publicLog(R,k,S){return this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(R,k,S)}publicLog2(R,k,S){return this.publicLog(R,k,S)}publicLogError(R,k){return this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(R,k)}publicLogError2(R,k){return this.publicLogError(R,k)}async updateInjectedTelemetryLevel(R){if(R===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,R):R,this._injectedTelemetryLevel===0&&this.dispose()}};p=Ae([_e(2,v.IConfigurationService),_e(3,D.IProductService)],p),e.ServerTelemetryService=p,e.ServerNullTelemetryService=new class extends P.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(C.ITelemetryService)}),define(ve[225],we([1,0,269,222]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends t.AbstractOneDataSystemAppender{constructor(T,P,p,b){const R={sendPOST:(k,S)=>{const y={method:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data)}};try{const h=v.request(k.urlString,y,w=>{w.on("data",function(E){S(w.statusCode??200,w.headers,E.toString())}),w.on("error",function(E){S(0,{})})});h.write(k.data),h.end()}catch{S(0,{})}}};super(T,P,p,b,R)}}e.OneDataSystemAppender=D}),define(ve[226],we([1,0,10,218]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class D extends t.default{installErrorListeners(){(0,v.setUnexpectedErrorHandler)(P=>console.error(P));const T=[];process.on("unhandledRejection",(P,p)=>{T.push(p),setTimeout(()=>{const b=T.indexOf(p);b>=0&&p.catch(R=>{T.splice(b,1),(0,v.isCancellationError)(R)||(console.warn(`rejected promise not handled within 1 second: ${R}`),R.stack&&console.warn(`stack trace: ${R.stack}`),P&&(0,v.onUnexpectedError)(P))})},1e3)}),process.on("rejectionHandled",P=>{const p=T.indexOf(P);p>=0&&T.splice(p,1)}),process.on("uncaughtException",P=>{(0,v.onUnexpectedError)(P)})}}e.default=D}),define(ve[227],we([1,0,14,20,7,2,13]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends C.Disposable{constructor(b,R){super(),this._logService=R,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((R,k)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,R),this._onCreateRequest.fire({requestId:S,...b});const y=new t.CancellationTokenSource;(0,v.timeout)(this._timeout,y.token).then(()=>k(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,C.toDisposable)(()=>y.cancel())])})}acceptReply(b,R){const k=this._pendingRequests.get(b);k?(this._pendingRequests.delete(b),(0,C.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),k(R)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=Ae([_e(1,T.ILogService)],P),e.RequestStore=P}),define(ve[111],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsDefaultColor="terminal.integrated.tabs.defaultColor",f.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",f.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var C;(function(f){f.FileName="ptyhost"})(C=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var P;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var p;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(p=e.TitleEventSource||(e.TitleEventSource={}));var b;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(b=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,v.createDecorator)("ptyService");var R;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation",f.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(R=e.ProcessPropertyType||(e.ProcessPropertyType={}));var k;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k=e.HeartbeatConstants||(e.HeartbeatConstants={}));var S;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(S=e.TerminalLocation||(e.TerminalLocation={}));var y;(function(f){f.TerminalView="view",f.Editor="editor"})(y=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var w;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(w=e.FlowControlConstants||(e.FlowControlConstants={}));var E;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(E=e.ProfileSource||(e.ProfileSource={}));var g;(function(f){f[f.Off=0]="Off",f[f.FinalTerm=1]="FinalTerm",f[f.VSCode=2]="VSCode"})(g=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var m;(function(f){f[f.Unknown=0]="Unknown",f[f.Shutdown=1]="Shutdown",f[f.Process=2]="Process",f[f.User=3]="User",f[f.Extension=4]="Extension"})(m=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ve[228],we([1,0,30,12,22,6,3,28,15,11,21]),function(oe,e,v,t,D,C,T,P,p,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function k(){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());let u=0;return c&&c.length===4&&(u=parseInt(c[3])),u}e.getWindowsBuildNumber=k;async function S(c,u,r,o=P.env,n=R.Promises.exists){if(C.isAbsolute(c))return await n(c)?c:void 0;if(u===void 0&&(u=P.cwd()),C.dirname(c)!=="."){const l=C.join(u,c);return await n(l)?l:void 0}const s=(0,D.getCaseInsensitive)(o,"PATH");if(r===void 0&&(0,b.isString)(s)&&(r=s.split(C.delimiter)),r===void 0||r.length===0){const l=C.join(u,c);return await n(l)?l:void 0}for(const l of r){let d;if(C.isAbsolute(l)?d=C.join(l,c):d=C.join(u,l,c),await n(d))return d;if(T.isWindows){let I=d+".com";if(await n(I)||(I=d+".exe",await n(I)))return I}}const a=C.join(u,c);return await n(a)?a:void 0}e.findExecutable=S;function y(c,u,r,o,n){if(!u.shellIntegration.enabled||!c.executable||c.isFeatureTerminal||c.hideFromUser||c.ignoreShellIntegration||T.isWindows&&!u.windowsEnableConpty)return;const i=c.args,s=P.platform==="win32"?C.basename(c.executable).toLowerCase():C.basename(c.executable),a=C.dirname(t.FileAccess.asFileUri("",oe).fsPath);let l;const d={VSCODE_INJECTION:"1"};if(T.isWindows){if(s==="pwsh.exe")return!i||m(i)?l=e.shellIntegrationArgs.get(h.WindowsPwsh):g(i)&&(l=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),l?(l=[...l],l[l.length-1]=(0,p.format)(l[l.length-1],a,""),{newArgs:l,envMixin:d}):void 0;o.warn(`Shell integration cannot be enabled for executable "${c.executable}" and args`,c.args);return}switch(s){case"bash":return!i||i.length===0?l=e.shellIntegrationArgs.get(h.Bash):f(i)&&(d.VSCODE_SHELL_LOGIN="1",l=e.shellIntegrationArgs.get(h.Bash)),l?(l=[...l],l[l.length-1]=(0,p.format)(l[l.length-1],a),{newArgs:l,envMixin:d}):void 0;case"pwsh":return!i||m(i)?l=e.shellIntegrationArgs.get(h.Pwsh):g(i)&&(l=e.shellIntegrationArgs.get(h.PwshLogin)),l?(l=[...l],l[l.length-1]=(0,p.format)(l[l.length-1],a,""),{newArgs:l,envMixin:d}):void 0;case"zsh":{if(!i||i.length===0?l=e.shellIntegrationArgs.get(h.Zsh):f(i)?l=e.shellIntegrationArgs.get(h.ZshLogin):(i===e.shellIntegrationArgs.get(h.Zsh)||i===e.shellIntegrationArgs.get(h.ZshLogin))&&(l=i),!l)return;l=[...l],l[l.length-1]=(0,p.format)(l[l.length-1],a);const I=C.join(v.tmpdir(),`${v.userInfo().username}-${n.applicationName}-zsh`);d.ZDOTDIR=I;const L=r?.ZDOTDIR??v.homedir()??"~";d.USER_ZDOTDIR=L;const B=[];return B.push({source:C.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:C.join(I,".zshrc")}),B.push({source:C.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:C.join(I,".zprofile")}),B.push({source:C.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:C.join(I,".zshenv")}),B.push({source:C.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:C.join(I,".zlogin")}),{newArgs:l,envMixin:d,filesToCopy:B}}}o.warn(`Shell integration cannot be enabled for executable "${c.executable}" and args`,c.args)}e.getShellIntegrationInjection=y;var h;(function(c){c.WindowsPwsh="windows-pwsh",c.WindowsPwshLogin="windows-pwsh-login",c.Pwsh="pwsh",c.PwshLogin="pwsh-login",c.Zsh="zsh",c.ZshLogin="zsh-login",c.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],E=["-nol","-nologo"];function g(c){return typeof c=="string"?w.includes(c.toLowerCase()):c.length===1&&w.includes(c[0].toLowerCase())||c.length===2&&(w.includes(c[0].toLowerCase())||w.includes(c[1].toLowerCase()))&&(E.includes(c[0].toLowerCase())||E.includes(c[1].toLowerCase()))}function m(c){return typeof c=="string"?E.includes(c.toLowerCase()):c.length===0||c?.length===1&&E.includes(c[0].toLowerCase())}function f(c){return c==="string"&&w.includes(c.toLowerCase())||typeof c!="string"&&c.length===1&&w.includes(c[0].toLowerCase())}}),define(ve[229],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var v;(function(C){C.DARK="dark",C.LIGHT="light",C.HIGH_CONTRAST_DARK="hcDark",C.HIGH_CONTRAST_LIGHT="hcLight"})(v=e.ColorScheme||(e.ColorScheme={}));function t(C){return C===v.HIGH_CONTRAST_DARK||C===v.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(C){return C===v.DARK||C===v.HIGH_CONTRAST_DARK}e.isDark=D}),define(ve[112],we([1,0,40,7,2,5,34,229]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var p;(function(E){function g(m){return m&&typeof m=="object"&&typeof m.id=="string"}E.isThemeColor=g})(p=e.ThemeColor||(e.ThemeColor={}));function b(E){return{id:E}}e.themeColorFromId=b;var R;(function(E){function g(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||p.isThemeColor(i.color))}E.isThemeIcon=g;const m=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function f(i){const s=m.exec(i);if(!s)return;const[,a]=s;return{id:a}}E.fromString=f;function c(i){return{id:i}}E.fromId=c;function u(i,s){let a=i.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),s&&(a=`${a}~${s}`),{id:a}}E.modify=u;function r(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}E.getModifier=r;function o(i,s){return i.id===s.id&&i.color?.id===s.color?.id}E.isEqual=o;function n(i,s){return{id:i.id,color:s?b(s):void 0}}E.asThemeIcon=n,E.asClassNameArray=v.CSSIcon.asClassNameArray,E.asClassName=v.CSSIcon.asClassName,E.asCSSSelector=v.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function k(E){switch(E){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,D.toDisposable)(()=>{const m=this.themingParticipants.indexOf(g);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const y=new S;T.Registry.add(e.Extensions.ThemingContribution,y);function h(E){return y.onColorThemeChange(E)}e.registerThemingParticipant=h;class w extends D.Disposable{constructor(g){super(),this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,m){let f=this.theme.getColor(g);return f&&m&&(f=m(f,this.theme)),f?f.toString():null}}e.Themable=w}),define(ve[230],we([1,0,40,4,180,112]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(S,y){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...S.map(w=>({name:w.profileName,description:P(w)}))),y&&h.push(...y.map(w=>({name:w.title,description:p(w)}))),{values:h.map(w=>w.name),markdownDescriptions:h.map(w=>w.description)}}e.createProfileSchemaEnums=T;function P(S){let y=`$(${C.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:v.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?y+=`
- args: "${S.args}"`:y+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(y+=`
- overrideName: ${S.overrideName}`),S.color&&(y+=`
- color: ${S.color}`),S.env&&(y+=`
- env: ${JSON.stringify(S.env)}`),y}function p(S){return`$(${C.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:v.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function b(S,y){if(!S&&!y)return!0;if(typeof S=="string"&&typeof y=="string")return S===y;if(Array.isArray(S)&&Array.isArray(y)){if(S.length!==y.length)return!1;for(let h=0;h<S.length;h++)if(S[h]!==y[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function R(S,y){if(!S&&!y)return!0;if(!S||!y)return!1;if(C.ThemeIcon.isThemeIcon(S)&&C.ThemeIcon.isThemeIcon(y))return S.id===y.id&&S.color===y.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof y=="object"&&"light"in y&&"dark"in y){const h=S,w=y;if((t.URI.isUri(h.light)||k(h.light))&&(t.URI.isUri(h.dark)||k(h.dark))&&(t.URI.isUri(w.light)||k(w.light))&&(t.URI.isUri(w.dark)||k(w.dark)))return h.light.path===w.light.path&&h.dark.path===w.dark.path}if(t.URI.isUri(S)&&t.URI.isUri(y)||k(S)||k(y)){const h=S,w=y;return h.path===w.path&&h.scheme===w.scheme}return!1}e.terminalIconsEqual=R;function k(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=k}),define(ve[231],we([1,0,40,179,52,34,230]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(v.Codicon.getAll(),c=>c.id),markdownEnumDescriptions:Array.from(v.Codicon.getAll(),c=>`$(${c.id})`)};const P={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),...e.terminalIconSchema},color:{description:(0,t.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...P}},R=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),k=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),S=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),w=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),E={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:k},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:k},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:S},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){C.Registry.as(D.Extensions.Configuration).registerConfiguration(E),f()}e.registerTerminalPlatformConfiguration=g;let m;function f(c,u){const r=C.Registry.as(D.Extensions.Configuration);let o;c&&(o=(0,T.createProfileSchemaEnums)(c?.profiles,u));const n=m;m={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:c?.os===3?o?.values:void 0,markdownEnumDescriptions:c?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:c?.os===2?o?.values:void 0,markdownEnumDescriptions:c?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:c?.os===1?o?.values:void 0,markdownEnumDescriptions:c?.os===1?o?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[m],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=f}),define(ve[232],we([1,0,49,40,6,3,21,92,228,112]),function(oe,e,v,t,D,C,T,P,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let R,k=!0;function S(o,n,i,s,a=process.env,l,d,I,L){return l=l||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},C.isWindows?y(i,l,a,d,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),L,I):c(l,d,i,o&&typeof o=="object"?{...o}:s.getValue(C.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(C.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),L,I,a)}e.detectAvailableProfiles=S;async function y(o,n,i,s,a,l,d,I,L){const B=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),J=`${process.env.windir}\\${B?"Sysnative":"System32"}`;let Z=!1;(0,p.getWindowsBuildNumber)()>=16299&&(Z=!0),await E(I);const _=new Map;o&&(_.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Windows PowerShell",{path:`${J}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),_.set("Command Prompt",{path:`${J}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),u(l,_);const te=await h(_.entries(),d,n,i,s,L);if(o||a)try{const se=await m(`${J}\\${Z?"wsl":"bash"}.exe`,d);for(const W of se)(!l||!(W.profileName in l))&&te.push(W)}catch{k&&(s?.info("WSL is not installed, so could not detect WSL profiles"),k=!1)}return te}async function h(o,n,i,s=process.env,a,l){const d=[];for(const[I,L]of o){if(L===null)continue;let B,J,Z;if("source"in L){const se=R?.get(L.source);if(!se)continue;B=se.paths,J=L.args||se.args,L.icon?Z=w(L.icon):se.icon&&(Z=se.icon)}else B=Array.isArray(L.path)?L.path:[L.path],J=C.isWindows||Array.isArray(L.args)?L.args:void 0,Z=w(L.icon);const _=await l?.(B)||B.slice(),te=await r(I,n,_,i,s,J,L.env,L.overrideName,L.isAutoDetected,a);te?(te.isAutoDetected=L.isAutoDetected,te.icon=Z,te.color=L.color,d.push(te)):a?.debug("Terminal profile not validated",I,B)}return a?.debug("Validated terminal profiles",d),d}function w(o){return typeof o=="string"?{id:o}:o}async function E(o){R&&!o||(R=new Map,R.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),R.set("PowerShell",{profileName:"PowerShell",paths:o||await g(),icon:b.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function g(){const o=[];for await(const n of(0,P.enumeratePowerShellInstallations)())o.push(n.exePath);return o}async function m(o,n){const i=[],s=await new Promise((d,I)=>{v.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(L,B)=>{if(L)return I("Problem occurred when getting wsl distros");d(B)})});if(!s)return[];const a=new RegExp(/[\r?\n]/),l=s.split(a).filter(d=>d.trim().length>0&&d!=="");for(const d of l){if(d===""||d.startsWith("docker-desktop"))continue;const I=`${d} (WSL)`,L={profileName:I,path:o,args:["-d",`${d}`],isDefault:I===n,icon:f(d),isAutoDetected:!1};i.push(L)}return i}function f(o){return o.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):o.includes("Debian")?b.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function c(o,n,i,s,a,l,d,I){const L=new Map;if(i){const B=(await o.readFile("/etc/shells")).toString(),J=l||B.split(`
`).filter(_=>_.trim().indexOf("#")!==0&&_.trim().length>0),Z=new Map;for(const _ of J){let te=(0,D.basename)(_),se=Z.get(te)||0;se++,se>1&&(te=`${te} (${se})`),Z.set(te,se),L.set(te,{path:_,isAutoDetected:!0})}}return u(s,L),await h(L.entries(),a,o,I,n,d)}function u(o,n){if(!!o)for(const[i,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?n.delete(i):(s.icon=s.icon||n.get(i)?.icon,n.set(i,s))}async function r(o,n,i,s,a,l,d,I,L,B){if(i.length===0)return Promise.resolve(void 0);const J=i.shift();if(J==="")return r(o,n,i,s,a,l,d,I,L);const Z={profileName:o,path:J,args:l,env:d,overrideName:I,isAutoDetected:L,isDefault:o===n};if((0,D.basename)(J)===J){const te=a.PATH?a.PATH.split(D.delimiter):void 0,se=await(0,p.findExecutable)(J,void 0,te,void 0,s.existsFile);return se?(Z.path=se,Z.isFromPath=!0,Z):r(o,n,i,s,a,l)}return await s.existsFile((0,D.normalize)(J))?Z:r(o,n,i,s,a,l,d,I,L)}}),define(ve[233],we([1,0,7,2,12,3,41,96,25,26,97,77,13,102,227,111,231,232]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let f=0,c=class extends t.Disposable{constructor(r,o,n,i){super(),this._reconnectConstants=r,this._configurationService=o,this._environmentService=n,this._logService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new v.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new v.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new v.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new v.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new v.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new v.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new v.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new v.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new v.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new v.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new v.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new v.Emitter),this.onProcessExit=this._onProcessExit.event,(0,E.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(C.isWindows)return process.env;try{return await(0,k.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(r){return this._logService.error("ptyHost was unable to resolve shell environment",r),{}}}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:f,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,R.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?r.debugBrk=o.port:!o.break&&o.port&&(r.debug=o.port));const n=new P.Client(D.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,r);this._onPtyHostStart.fire(),T.ProxyChannel.toService(n.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(l=>{this._onPtyHostExit.fire(l.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${l.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const s=n.getChannel(w.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const a=T.ProxyChannel.toService(n.getChannel(w.TerminalIpcChannels.PtyHost));return this._register(a.onProcessData(l=>this._onProcessData.fire(l))),this._register(a.onProcessReady(l=>this._onProcessReady.fire(l))),this._register(a.onProcessExit(l=>this._onProcessExit.fire(l))),this._register(a.onDidChangeProperty(l=>this._onDidChangeProperty.fire(l))),this._register(a.onProcessReplay(l=>this._onProcessReplay.fire(l))),this._register(a.onProcessOrphanQuestion(l=>this._onProcessOrphanQuestion.fire(l))),this._register(a.onDidRequestDetach(l=>this._onDidRequestDetach.fire(l))),[n,a]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,o,n,i,s,a,l,d,I,L,B){const J=setTimeout(()=>this._handleUnresponsiveCreateProcess(),w.HeartbeatConstants.CreateProcessTimeout),Z=await this._proxy.createProcess(r,o,n,i,s,a,l,d,I,L,B);return clearTimeout(J),f=Math.max(f,Z),Z}updateTitle(r,o,n){return this._proxy.updateTitle(r,o,n)}updateIcon(r,o,n,i){return this._proxy.updateIcon(r,o,n,i)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r,o){return this._proxy.detachFromProcess(r,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,o){return this._proxy.shutdown(r,o)}input(r,o){return this._proxy.input(r,o)}processBinary(r,o){return this._proxy.processBinary(r,o)}resize(r,o,n){return this._proxy.resize(r,o,n)}acknowledgeDataEvent(r,o){return this._proxy.acknowledgeDataEvent(r,o)}setUnicodeVersion(r,o){return this._proxy.setUnicodeVersion(r,o)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}installAutoReply(r,o){return this._proxy.installAutoReply(r,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(r){return this._proxy.uninstallAutoReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,o,n,i=!1){const s=await this._shellEnv;return(0,g.detectAvailableProfiles)(o,n,i,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}getRevivedPtyNewId(r){return this._proxy.getRevivedPtyNewId(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,o){return this._proxy.requestDetachInstance(r,o)}async acceptDetachInstanceReply(r,o){return this._proxy.acceptDetachInstanceReply(r,o)}async freePortKillProcess(r,o){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(r,o)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r,o){return this._proxy.reviveTerminalProcesses(r,o)}async refreshProperty(r,o){return this._proxy.refreshProperty(r,o)}async updateProperty(r,o,n){return this._proxy.updateProperty(r,o,n)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:o})}async acceptPtyHostResolvedVariables(r,o){this._resolveVariablesRequestStore.acceptReply(r,o)}};c=Ae([_e(1,p.IConfigurationService),_e(2,b.IEnvironmentService),_e(3,S.ILogService)],c),e.PtyHostService=c}),define(ve[39],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,v.createDecorator)("IUriIdentityService")}),define(ve[234],we([1,0,7,2,4,26,32,17,13,39]),function(oe,e,v,t,D,C,T,P,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let R=class extends t.Disposable{constructor(S,y,h,w,E){super(),this.extensionsManagementService=S,this.logService=w,this.uriIdentityService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new v.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(m=>{this.installedExtensions=m.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(S.onInstallExtension(m=>this.onInstallExtension(m))),this._register(S.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(S.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const g=D.URI.file(h.extensionsPath);this._register(y.watch(g)),this._register(v.Event.filter(y.onDidFilesChange,m=>m.rawChanges.some(f=>this.doesChangeAffects(f,g)))(()=>this.onDidChange()))}doesChangeAffects(S,y){return S.type!==1&&S.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(S.resource),y)?!1:this.uriIdentityService.extUri.isEqual(S.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(S.resource).startsWith(".")}onInstallExtension(S){this.addInstallingExtension(S.identifier)}onDidInstallExtensions(S){for(const y of S)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(S){S.error||this.removeInstalledExtension(S.identifier)}addInstallingExtension(S){this.removeInstallingExtension(S),this.installingExtensions.push(S)}removeInstallingExtension(S){this.installingExtensions=this.installingExtensions.filter(y=>!(0,T.areSameExtensions)(y,S))}addInstalledExtension(S){this.installedExtensions&&(this.removeInstalledExtension(S),this.installedExtensions.push(S))}removeInstalledExtension(S){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,T.areSameExtensions)(y,S)))}async onDidChange(){if(this.installedExtensions){const S=await this.extensionsManagementService.getInstalled(),y=S.filter(w=>[...this.installingExtensions,...this.installedExtensions].some(E=>(0,T.areSameExtensions)(E,w.identifier))?!1:w.installedTimestamp&&w.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",w.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",w.identifier.id),!1)),h=this.installedExtensions.filter(w=>this.installingExtensions.some(E=>(0,T.areSameExtensions)(E,w))?!1:S.every(E=>!(0,T.areSameExtensions)(E.identifier,w))?(this.logService.info("Detected extension removed from another source",w.id),!0):!1);this.installedExtensions=S.map(w=>w.identifier),(y.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:h})}}};R=Ae([_e(1,P.IFileService),_e(2,C.INativeEnvironmentService),_e(3,p.ILogService),_e(4,b.IUriIdentityService)],R),e.ExtensionsWatcher=R}),define(ve[113],we([1,0,39,195,17,19,137,7,2]),function(oe,e,v,t,D,C,T,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(S){this.uri=S,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let R=class{constructor(S){this._fileService=S,this._dispooables=new p.DisposableStore,this._limit=2**16;const y=new Map,h=w=>{let E=y.get(w.scheme);return E===void 0&&(E=S.hasProvider(w)&&!this._fileService.hasCapability(w,1024),y.set(w.scheme,E)),E};this._dispooables.add(P.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(w=>{y.delete(w.scheme)})),this.extUri=new C.ExtUri(h),this._canonicalUris=new T.SkipList((w,E)=>this.extUri.compare(w,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,C.normalizePath)(S));const y=this._canonicalUris.get(S);return y?y.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new b(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((h,w)=>h[1].touch<w[1].touch?1:h[1].touch>w[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let h=0;h<y;h++)this._canonicalUris.set(S[h][0],S[h][1].touch())}};R=Ae([_e(0,D.IFileService)],R),e.UriIdentityService=R,(0,t.registerSingleton)(v.IUriIdentityService,R,!0)}),define(ve[78],we([1,0,182,6,24,19,4,5,12]),function(oe,e,v,t,D,C,T,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function b(o){const n=o;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(o,n){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const i=o;if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=R;function k(o){const n=o;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=k;function S(o){const n=o;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const i=o;if(i?.configPath)return{id:i.id,configPath:T.URI.revive(i.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=S;var y;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function h(o){const n=o;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=h;function w(o){const n=o;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=w;class E{constructor(n,i,s,a,l){this._id=n,this._transient=s,this._configuration=a,this._ignorePathCasing=l,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=E;class g{constructor(n,i){this.raw=i,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,C.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function m(o){return new g({uri:o,index:0,name:(0,C.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(o,n){return C.extUriBiasedIgnorePathCase.isEqualOrParent(o,n.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function c(o){let n;return T.URI.isUri(o)?n=o:n=o.configuration,n?.scheme===p.Schemas.tmp}e.isTemporaryWorkspace=c;function u(o,n){return!f(o,n)&&!c(o)}e.isSavedWorkspace=u;function r(o){return(typeof o=="string"?(0,t.extname)(o):(0,C.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(ve[37],we([1,0,88,7,2,19,11,4,181,26,17,5,13,78,24,39,14,23,15]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function f(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&P.URI.isUri(i.location)&&P.URI.isUri(i.globalStorageHome)&&P.URI.isUri(i.settingsResource)&&P.URI.isUri(i.keybindingsResource)&&P.URI.isUri(i.tasksResource)&&P.URI.isUri(i.snippetsHome)&&((0,T.isUndefined)(i.extensionsResource)||P.URI.isUri(i.extensionsResource)))}e.isUserDataProfile=f,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,k.createDecorator)("IUserDataProfilesService");function c(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:P.URI.revive(n.location).with({scheme:i}),globalStorageHome:P.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:P.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:P.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:P.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:P.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:P.URI.revive(n.extensionsResource)?.with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=c,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function u(n,i,s,a){return{id:n,name:i,location:s,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,C.joinPath)(s,"globalStorage"),settingsResource:(0,C.joinPath)(s,"settings.json"),keybindingsResource:(0,C.joinPath)(s,"keybindings.json"),tasksResource:(0,C.joinPath)(s,"tasks.json"),snippetsHome:(0,C.joinPath)(s,"snippets"),extensionsResource:(0,C.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=u;let r=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,s,a,l){super(),this.environmentService=i,this.fileService=s,this.uriIdentityService=a,this.logService=l,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,C.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}get profilesObject(){if(!this._profilesObject){const i=this.enabled?this.getStoredProfiles().map(d=>u((0,C.basename)(d.location),d.name,d.location,{shortName:d.shortName,useDefaultFlags:d.useDefaultFlags})):[];let s;const a=new h.ResourceMap,l=u((0,v.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,p.localize)(0,null),this.environmentService.userRoamingDataHome);if(i.unshift({...l,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||i.length>0||this.transientProfilesObject.profiles.length>0?l.extensionsResource:void 0}),i.length){const d=this.getStoredProfileAssociations();if(d.workspaces)for(const[I,L]of Object.entries(d.workspaces)){const B=P.URI.parse(I),J=P.URI.parse(L),Z=i.find(_=>this.uriIdentityService.extUri.isEqual(_.location,J));Z&&a.set(B,Z)}if(d.emptyWindow){const I=P.URI.parse(d.emptyWindow);s=i.find(L=>this.uriIdentityService.extUri.isEqual(L.location,I))}}this._profilesObject={profiles:i,workspaces:a,emptyWindow:s}}return this._profilesObject}async createTransientProfile(i){const s="Temp",a=new RegExp(`${(0,m.escapeRegExpCharacters)(s)}\\s(\\d+)`);let l=0;for(const I of this.profiles){const L=a.exec(I.name),B=L?parseInt(L[1]):0;l=B>l?B:l}const d=`${s} ${l+1}`;return this.createProfile((0,v.hash)((0,g.generateUuid)()).toString(16),d,{transient:!0},i)}async createNamedProfile(i,s,a){return this.createProfile((0,v.hash)((0,g.generateUuid)()).toString(16),i,s,a)}async createProfile(i,s,a,l){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const d=await this.doCreateProfile(i,s,a);return l&&await this.setProfileForWorkspace(l,d),d}async doCreateProfile(i,s,a){let l=this.profileCreationPromises.get(s);return l||(l=(async()=>{try{const d=this.profiles.find(B=>B.name===s||B.id===i);if(d)return d;const I=u(i,s,(0,C.joinPath)(this.profilesHome,i),a);await this.fileService.createFolder(I.location);const L=[];return this._onWillCreateProfile.fire({profile:I,join(B){L.push(B)}}),await E.Promises.settled(L),this.updateProfiles([I],[],[]),I}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,l)),l}async updateProfile(i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(l=>l.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=u(a.id,s.name??a.name,a.location,{shortName:s.shortName??a.shortName,transient:s.transient??a.isTransient,useDefaultFlags:s.useDefaultFlags??a.useDefaultFlags}),this.updateProfiles([],[],[a]),a}async removeProfile(i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(l=>l.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:s,join(l){a.push(l)}});try{await Promise.allSettled(a)}catch(l){this.logService.error(l)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const l of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(l)?.id&&this.profilesObject.workspaces.delete(l);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(l){this.logService.error(l)}}getOrSetProfileForWorkspace(i,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let a=this.getProfileForWorkspace(i);return a||(a=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,a)),a}async setProfileForWorkspace(i,s){this.setProfileForWorkspaceSync(i,s)}setProfileForWorkspaceSync(i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=this.profiles.find(l=>l.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(i,a)}unsetWorkspace(i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(i,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(s=>s.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(i.map(s=>this.removeProfile(s)))}getProfileForWorkspace(i){const s=this.getWorkspace(i);return P.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(i){return(0,y.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,y.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}isProfileAssociatedToWorkspace(i){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,i.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,i.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,i.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,i.location)))}updateProfiles(i,s,a){const l=[...this.profiles,...i],d=[];this.transientProfilesObject.profiles=[];for(let I of l)I.isDefault||s.some(L=>I.id===L.id)||(I=a.find(L=>I.id===L.id)??I,I.isTransient?this.transientProfilesObject.profiles.push(I):d.push({location:I.location,name:I.name,shortName:I.shortName,useDefaultFlags:I.useDefaultFlags}));this.saveStoredProfiles(d),this._profilesObject=void 0,this.triggerProfilesChanges(i,s,a)}triggerProfilesChanges(i,s,a){this._onDidChangeProfiles.fire({added:i,removed:s,updated:a,all:this.profiles})}updateWorkspaceAssociation(i,s,a){a=s?.isTransient?!0:a,a||this.updateWorkspaceAssociation(i,void 0,!0);const l=this.getWorkspace(i),d=a?this.transientProfilesObject:this.profilesObject;P.URI.isUri(l)?(d.workspaces.delete(l),s&&d.workspaces.set(l,s)):d.emptyWindow=s,a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[a,l]of this.profilesObject.workspaces.entries())i[a.toString()]=l.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:i,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}};r.PROFILES_KEY="userDataProfiles",r.PROFILE_ASSOCIATIONS_KEY="profileAssociations",r=Ae([_e(0,b.IEnvironmentService),_e(1,R.IFileService),_e(2,w.IUriIdentityService),_e(3,S.ILogService)],r),e.UserDataProfilesService=r;class o extends r{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=o}),define(ve[235],we([1,0,18,14,20,10,7,2,3,4,162,31,32,35,13,27,33,37]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends P.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(n,i,s,a,l){super(),this.galleryService=n,this.telemetryService=i,this.logService=s,this.productService=a,this.userDataProfilesService=l,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:d})=>d.cancel()),this.uninstallingExtensions.forEach(d=>d.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const i=await this.getTargetPlatform();return n.allTargetPlatforms.some(s=>(0,k.isTargetPlatformCompatible)(s,n.allTargetPlatforms,i))}async installFromGallery(n,i={}){try{if(!this.galleryService.isEnabled())throw new k.ExtensionManagementError(R.localize(0,null),k.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(n,!!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,i)}catch(s){throw u(this.telemetryService,"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(n),error:s}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(s),c(s)}}async uninstall(n,i={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,i)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(R.localize(1,null));const i=await this.getTargetPlatform(),[s]=await this.galleryService.getExtensions([{...n.identifier,preRelease:n.preRelease}],{targetPlatform:i,compatible:!0},D.CancellationToken.None);if(!s)throw new Error(R.localize(2,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,i,s){const a=J=>`${S.ExtensionKey.create(J).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!b.URI.isUri(i)){const J=this.installingExtensions.get(a(i));if(J){this.logService.info("Extensions is already requested to install",i.identifier.id);const{local:Z}=await J.task.waitUntilTaskIsFinished();return Z}s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const l=[],d=[],I=[],L=this.createInstallExtensionTask(n,i,s);b.URI.isUri(i)||this.installingExtensions.set(a(i),{task:L,waitingTasks:[]}),this._onInstallExtension.fire({identifier:L.identifier,source:i,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",L.identifier.id),l.push({task:L,manifest:n});let B=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",L.identifier.id);else try{const Z=await this.getAllDepsAndPackExtensions(L.identifier,n,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),_=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:te,manifest:se}of Z){B=B||!!se.extensionDependencies?.some(j=>(0,S.areSameExtensions)({id:j},L.identifier));const W=a(te),fe=this.installingExtensions.get(W);if(fe){if(this.canWaitForTask(L,fe.task)){this.logService.info("Waiting for already requested installing extension",te.identifier.id,L.identifier.id),fe.waitingTasks.push(L);const j=fe.task.identifier;d.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,X=>X.some(O=>(0,S.areSameExtensions)(O.identifier,j)))).then(X=>{if(!X.find(U=>(0,S.areSameExtensions)(U.identifier,j))?.local)throw new Error(`Extension ${j.id} is not installed`)}))}}else if(!_.some(({identifier:j})=>(0,S.areSameExtensions)(j,te.identifier))){const j=this.createInstallExtensionTask(se,te,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(W,{task:j,waitingTasks:[L]}),this._onInstallExtension.fire({identifier:j.identifier,source:te,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",j.identifier.id,L.identifier.id),l.push({task:j,manifest:se})}}}catch(Z){if(b.URI.isUri(L.source))(0,v.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",L.identifier.id,Z.message),(0,v.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",L.identifier.id,Z.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",L.identifier.id),Z}const J=l.reduce((Z,{task:_,manifest:te})=>(Z.set(_.identifier.id.toLowerCase(),{task:_,manifest:te}),Z),new Map);for(;J.size;){let Z;const _=[...J.values()].filter(({manifest:te})=>!te.extensionDependencies?.some(se=>J.has(se.toLowerCase())));_.length?Z=J.size===1?_:_.filter(({task:te})=>!(te===L&&!B)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:te})=>te.identifier.id)),Z=[...J.values()]),await this.joinAllSettled(Z.map(async({task:te})=>{const se=new Date().getTime();try{const{local:W}=await te.run();if(await this.joinAllSettled(this.participants.map(fe=>fe.postInstall(W,te.source,s,D.CancellationToken.None))),!b.URI.isUri(te.source)){const fe=te.operation===3,j=fe?void 0:(new Date().getTime()-te.source.lastUpdated)/1e3;if(u(this.telemetryService,fe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(te.source),duration:new Date().getTime()-se,durationSinceUpdate:j}),p.isWeb&&te.operation!==3)try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}I.push({local:W,identifier:te.identifier,operation:te.operation,source:te.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw b.URI.isUri(te.source)||u(this.telemetryService,te.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(te.source),duration:new Date().getTime()-se,error:W}),this.logService.error("Error while installing the extension:",te.identifier.id),W}finally{J.delete(te.identifier.id.toLowerCase())}}))}return d.length&&await this.joinAllSettled(d),I.forEach(({identifier:Z})=>this.logService.info("Extension installed successfully:",Z.id)),this._onDidInstallExtensions.fire(I),I.filter(({identifier:Z})=>(0,S.areSameExtensions)(Z,L.identifier))[0].local}catch(J){if(l.forEach(({task:Z})=>Z.cancel()),I.length)try{const Z=await Promise.allSettled(I.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let _=0;_<Z.length;_++){const te=Z[_],{identifier:se}=I[_];te.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",se.id):this.logService.warn("Rollback: Error while uninstalling extension",se.id,(0,C.getErrorMessage)(te.reason))}}catch(Z){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(Z),I.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(l.map(({task:Z})=>({identifier:Z.identifier,operation:2,source:Z.source,context:s.context,profileLocation:s.profileLocation}))),J}finally{for(const[J,{task:Z,waitingTasks:_}]of this.installingExtensions.entries()){const te=_.indexOf(L);te!==-1&&_.splice(te,1),_.length===0&&(Z===L||te!==-1)&&this.installingExtensions.delete(J)}}}canWaitForTask(n,i){for(const[,{task:s,waitingTasks:a}]of this.installingExtensions.entries())if(s===n&&(a.includes(i)||a.some(l=>this.canWaitForTask(l,i)))||s===i&&a[0]&&!this.canWaitForTask(n,a[0]))return!1;return!0}async joinAllSettled(n){const i=[],s=[],a=await Promise.allSettled(n);for(const l of a)l.status==="fulfilled"?i.push(l.value):s.push(l.reason);if(s.length)throw f(s);return i}async getAllDepsAndPackExtensions(n,i,s,a,l){if(!this.galleryService.isEnabled())return[];const d=await this.getInstalled(void 0,l),I=[n],L=[],B=async(J,Z)=>{const _=Z.extensionDependencies||[],te=[..._];if(Z.extensionPack){const se=s?d.find(W=>(0,S.areSameExtensions)(W.identifier,J)):void 0;for(const W of Z.extensionPack)se&&se.manifest.extensionPack&&se.manifest.extensionPack.some(fe=>(0,S.areSameExtensions)({id:fe},{id:W}))||te.every(fe=>!(0,S.areSameExtensions)({id:fe},{id:W}))&&te.push(W)}if(te.length){const se=[...I,...L.map(fe=>fe.gallery.identifier)],W=te.filter(fe=>se.every(j=>!(0,S.areSameExtensions)(j,{id:fe})));if(W.length){const fe=await this.galleryService.getExtensions(W.map(j=>({id:j,preRelease:a})),D.CancellationToken.None);for(const j of fe){if(se.find(U=>(0,S.areSameExtensions)(U,j.identifier)))continue;const X=_.some(U=>(0,S.areSameExtensions)({id:U},j.identifier));let O;try{O=await this.checkAndGetCompatibleVersion(j,!1,a)}catch(U){if(U instanceof k.ExtensionManagementError&&U.code===k.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!X){this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}else throw U}L.push({gallery:O.extension,manifest:O.manifest}),await B(O.extension.identifier,O.manifest)}}}};return await B(n,i),L}async checkAndGetCompatibleVersion(n,i,s){if((await this.getExtensionsControlManifest()).malicious.some(I=>(0,S.areSameExtensions)(n.identifier,I)))throw new k.ExtensionManagementError(R.localize(3,null,n.identifier.id),k.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const I=await this.getTargetPlatform();throw new k.ExtensionManagementError(R.localize(4,null,n.identifier.id,this.productService.nameLong,(0,k.TargetPlatformToString)(I)),k.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.getCompatibleVersion(n,i,s);if(l){if(s&&!i&&n.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new k.ExtensionManagementError(R.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),k.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],D.CancellationToken.None))[0]?new k.ExtensionManagementError(R.localize(6,null,n.identifier.id),k.ExtensionManagementErrorCode.ReleaseVersionNotFound):new k.ExtensionManagementError(R.localize(7,null,n.identifier.id,this.productService.nameLong,this.productService.version),k.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",l.identifier.id);const d=await this.galleryService.getManifest(l,D.CancellationToken.None);if(d===null)throw new k.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,k.ExtensionManagementErrorCode.Invalid);if(d.version!==l.version)throw new k.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,k.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:d}}async getCompatibleVersion(n,i,s){const a=await this.getTargetPlatform();let l=null;return!i&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==s&&(l=(await this.galleryService.getExtensions([{...n.identifier,preRelease:s}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null),!l&&await this.galleryService.isExtensionCompatible(n,s,a)&&(l=n),l||(i?l=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null:l=await this.galleryService.getCompatibleExtension(n,s,a)),l}async uninstallExtension(n,i){const s=B=>`${B.id.toLowerCase()}${i.versionOnly?`-${n.manifest.version}`:""}${i.profileLocation?`@${i.profileLocation.toString()}`:""}`,a=this.uninstallingExtensions.get(s(n.identifier));if(a)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),a.waitUntilTaskIsFinished();const l=(B,J)=>{const Z=this.createUninstallExtensionTask(B,J);return this.uninstallingExtensions.set(s(Z.extension.identifier),Z),i.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,i.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${B.identifier.id}@${B.manifest.version}`),this._onUninstallExtension.fire({identifier:B.identifier,profileLocation:i.profileLocation,applicationScoped:B.isApplicationScoped}),Z},d=(B,J)=>{J?i.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,i.profileLocation.toString(),J.message):this.logService.error("Failed to uninstall extension:",`${B.identifier.id}@${B.manifest.version}`,J.message):i.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${B.identifier.id}@${B.manifest.version}`,i.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${B.identifier.id}@${B.manifest.version}`),u(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,S.getLocalExtensionTelemetryData)(B),error:J}),this._onDidUninstallExtension.fire({identifier:B.identifier,version:B.manifest.version,error:J?.code,profileLocation:i.profileLocation,applicationScoped:B.isApplicationScoped})},I=[],L=[];try{I.push(l(n,i));const B=await this.getInstalled(1,i.profileLocation);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const J=this.getAllPackExtensionsToUninstall(n,B);for(const Z of J)this.uninstallingExtensions.has(s(Z.identifier))?this.logService.info("Extensions is already requested to uninstall",Z.identifier.id):I.push(l(Z,i))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(I.map(J=>J.extension),B,n),await this.joinAllSettled(I.map(async J=>{try{if(await J.run(),await this.joinAllSettled(this.participants.map(Z=>Z.postUninstall(J.extension,i,D.CancellationToken.None))),J.extension.identifier.uuid)try{await this.galleryService.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}d(J.extension)}catch(Z){const _=Z instanceof k.ExtensionManagementError?Z:new k.ExtensionManagementError((0,C.getErrorMessage)(Z),k.ExtensionManagementErrorCode.Internal);throw d(J.extension,_),_}finally{L.push(J)}}))}catch(B){const J=B instanceof k.ExtensionManagementError?B:new k.ExtensionManagementError((0,C.getErrorMessage)(B),k.ExtensionManagementErrorCode.Internal);for(const Z of I){try{Z.cancel()}catch{}L.includes(Z)||d(Z.extension,J)}throw J}finally{for(const B of I)this.uninstallingExtensions.delete(s(B.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",B.extension.identifier.id)}}checkForDependents(n,i,s){for(const a of n){const l=this.getDependents(a,i);if(l.length){const d=l.filter(I=>!n.some(L=>(0,S.areSameExtensions)(L.identifier,I.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(a,d,s))}}}getDependentsErrorMessage(n,i,s){return s===n?i.length===1?R.localize(8,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?R.localize(9,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):R.localize(10,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?R.localize(11,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?R.localize(12,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):R.localize(13,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(n,i,s=[]){if(s.indexOf(n)!==-1)return[];s.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const l=i.filter(I=>!I.isBuiltin&&a.some(L=>(0,S.areSameExtensions)({id:L},I.identifier))),d=[];for(const I of l)d.push(...this.getAllPackExtensionsToUninstall(I,i,s));return[...l,...d]}return[]}getDependents(n,i){return i.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(a=>(0,S.areSameExtensions)({id:a},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(n,i,s){return s.profileLocation&&(0,y.isApplicationScopedExtension)(n)&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(n,i,s)}createUninstallExtensionTask(n,i){return i.profileLocation&&n.isApplicationScoped&&(i={...i,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(n,i)}};m=Ae([_e(0,k.IExtensionGalleryService),_e(1,E.ITelemetryService),_e(2,h.ILogService),_e(3,w.IProductService),_e(4,g.IUserDataProfilesService)],m),e.AbstractExtensionManagementService=m;function f(o){const n=Array.isArray(o)?o:[o];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((i,s)=>new Error(`${i.message}${i.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=f;function c(o){if(o instanceof k.ExtensionManagementError)return o;const n=new k.ExtensionManagementError(o.message,k.ExtensionManagementErrorCode.Internal);return n.stack=o.stack,n}function u(o,n,{extensionData:i,duration:s,error:a,durationSinceUpdate:l}){const d=a?a instanceof k.ExtensionManagementError?a.code:k.ExtensionManagementErrorCode.Internal:void 0;o.publicLog(n,{...i,success:!a,duration:s,errorcode:d,durationSinceUpdate:l})}e.reportTelemetry=u;class r{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>new Promise((i,s)=>{const a=n.onCancellationRequested(()=>{a.dispose(),s(new C.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=r}),define(ve[55],we([1,0,18,14,22,16,10,65,145,2,12,6,3,19,50,67,11,4,166,26,32,35,70,17,5,13,27,7,48,53,37,39,193]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m,f,c,u,r,o,n,i,s,a,l,d,I,L,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var J;(function(j){function X(O,U){if(O===U)return!0;const x=Object.keys(O),ae=new Set;for(const ue of Object.keys(U))ae.add(ue);if(x.length!==ae.size)return!1;for(const ue of x){if(O[ue]!==U[ue])return!1;ae.delete(ue)}return ae.size===0}j.equals=X})(J=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let Z=class extends b.Disposable{constructor(X,O,U,x,ae,ue,Q,re,F,M,G){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=O,this.extensionsControlLocation=U,this.cacheLocation=x,this.userDataProfilesService=ae,this.extensionsProfileScannerService=ue,this.fileService=Q,this.logService=re,this.environmentService=F,this.productService=M,this.instantiationService=G,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,(0,y.joinPath)(this.cacheLocation,u.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,(0,y.joinPath)(this.cacheLocation,u.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(te,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(X,O,U){const[x,ae]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(O)]),ue=U?await this.scanExtensionsUnderDevelopment(X,[...x,...ae]):[];return this.dedupExtensions(x,ae,ue,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const O=[];O.push(this.scanDefaultSystemExtensions(!!X.useCache,X.language)),O.push(this.scanDevSystemExtensions(X.language,!!X.checkControlFile));const[U,x]=await Promise.all(O);return this.applyScanOptions([...U,...x],0,X,!1)}async scanUserExtensions(X){this.logService.trace("Started scanning user extensions");const O=await this.createExtensionScannerInput(X.profileLocation??this.userExtensionsLocation,!!X.profileLocation,1,!X.includeUninstalled,X.language);let x=await(X.useCache&&!O.devMode&&O.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(O);return x=await this.applyScanOptions(x,1,X,!0),this.logService.trace("Scanned user extensions:",x.length),x}async scanExtensionsUnderDevelopment(X,O){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const U=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(x=>x.scheme===R.Schemas.file).map(async x=>{const ae=await this.createExtensionScannerInput(x,!1,1,!0,X.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ae)).map(Q=>(Q.type=O.find(re=>(0,c.areSameExtensions)(re.identifier,Q.identifier))?.type??Q.type,this.extensionsScanner.validate(Q,ae)))}))).flat();return this.applyScanOptions(U,"development",X,!0)}return[]}async scanExistingExtension(X,O,U){const x=await this.createExtensionScannerInput(X,!1,O,!0,U.language),ae=await this.extensionsScanner.scanExtension(x);return!ae||!U.includeInvalid&&!ae.isValid?null:ae}async scanOneOrMultipleExtensions(X,O,U){const x=await this.createExtensionScannerInput(X,!1,O,!0,U.language),ae=await this.extensionsScanner.scanOneOrMultipleExtensions(x);return this.applyScanOptions(ae,O,U,!0)}async scanMetadata(X){const O=(0,y.joinPath)(X,"package.json"),U=(await this.fileService.readFile(O)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(X,O){const U=(0,y.joinPath)(X,"package.json"),x=(await this.fileService.readFile(U)).value.toString(),ae=JSON.parse(x);O.isMachineScoped=O.isMachineScoped||void 0,O.isBuiltin=O.isBuiltin||void 0,O.installedTimestamp=O.installedTimestamp||void 0,ae.__metadata={...ae.__metadata,...O},await this.fileService.writeFile((0,y.joinPath)(X,"package.json"),C.VSBuffer.fromString(JSON.stringify(ae,null,"	")))}async applyScanOptions(X,O,U,x){return U.includeAllVersions||(X=this.dedupExtensions(O===0?X:void 0,O===1?X:void 0,O==="development"?X:void 0,await this.getTargetPlatform(),x)),U.includeInvalid||(X=X.filter(ae=>ae.isValid)),X.sort((ae,ue)=>{const Q=k.basename(ae.location.fsPath),re=k.basename(ue.location.fsPath);return Q<re?-1:Q>re?1:0})}dedupExtensions(X,O,U,x,ae){const ue=(re,F,M)=>{if(re.isValid&&!F.isValid)return!1;if(re.isValid===F.isValid){if(ae&&h.gt(re.manifest.version,F.manifest.version))return this.logService.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(h.eq(re.manifest.version,F.manifest.version)){if(re.type===0)return this.logService.debug(`Skipping extension ${F.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===x)return this.logService.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return M?this.logService.warn(`Overwriting user extension ${re.location.path} with ${F.location.path}.`):this.logService.debug(`Overwriting user extension ${re.location.path} with ${F.location.path}.`),!0},Q=new Map;return X?.forEach(re=>{const F=u.ExtensionIdentifier.toKey(re.identifier.id),M=Q.get(F);(!M||ue(M,re,!1))&&Q.set(F,re)}),O?.forEach(re=>{const F=u.ExtensionIdentifier.toKey(re.identifier.id),M=Q.get(F);if(!M&&X&&re.type===0){this.logService.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!M||ue(M,re,!1))&&Q.set(F,re)}),U?.forEach(re=>{const F=u.ExtensionIdentifier.toKey(re.identifier.id),M=Q.get(F);(!M||ue(M,re,!0))&&Q.set(F,re),Q.set(F,re)}),[...Q.values()]}async scanDefaultSystemExtensions(X,O){this.logService.trace("Started scanning system extensions");const U=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,O),ae=await(X&&!U.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(U);return this.logService.trace("Scanned system extensions:",ae.length),ae}async scanDevSystemExtensions(X,O){const U=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!U?.length)return[];this.logService.trace("Started scanning dev system extensions");const x=O?await this.getBuiltInExtensionControl():{},ae=[],ue=g.URI.file(k.normalize(k.join(R.FileAccess.asFileUri("",oe).fsPath,"..",".build","builtInExtensions")));for(const re of U){const F=x[re.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":ae.push((0,y.joinPath)(ue,re.name));break;default:ae.push(g.URI.file(F));break}}const Q=await Promise.all(ae.map(async re=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(re,!1,0,!0,X))));return this.logService.trace("Scanned dev system extensions:",Q.length),(0,v.coalesce)(Q)}async getBuiltInExtensionControl(){try{const X=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(X.value.toString())}catch{return{}}}async createExtensionScannerInput(X,O,U,x,ae,ue=!0){const Q=await this.getTranslations(ae??S.language),re=await this.getMtime(X),F=O?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,M=F?await this.getMtime(F):void 0;return new _(X,re,F,M,O,U,x,ue,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ae,Q)}async getMtime(X){try{const O=await this.fileService.stat(X);if(typeof O.mtime=="number")return O.mtime}catch{}}};Z=Ae([_e(4,I.IUserDataProfilesService),_e(5,d.IExtensionsProfileScannerService),_e(6,o.IFileService),_e(7,i.ILogService),_e(8,f.IEnvironmentService),_e(9,s.IProductService),_e(10,n.IInstantiationService)],Z),e.AbstractExtensionsScannerService=Z;class _{constructor(X,O,U,x,ae,ue,Q,re,F,M,G,ie,he,Ee){this.location=X,this.mtime=O,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=x,this.profile=ae,this.type=ue,this.excludeObsolete=Q,this.validate=re,this.productVersion=F,this.productDate=M,this.productCommit=G,this.devMode=ie,this.language=he,this.translations=Ee}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,O){return(0,y.isEqual)(X.location,O.location)&&X.mtime===O.mtime&&(0,y.isEqual)(X.applicationExtensionslocation,O.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===O.applicationExtensionslocationMtime&&X.profile===O.profile&&X.type===O.type&&X.excludeObsolete===O.excludeObsolete&&X.validate===O.validate&&X.productVersion===O.productVersion&&X.productDate===O.productDate&&X.productCommit===O.productCommit&&X.devMode===O.devMode&&X.language===O.language&&J.equals(X.translations,O.translations)}}let te=class extends b.Disposable{constructor(X,O,U,x,ae){super(),this.obsoleteFile=X,this.extensionsProfileScannerService=O,this.uriIdentityService=U,this.fileService=x,this.logService=ae}async scanExtensions(X){const O=X.profile?await this.scanExtensionsFromProfile(X):await this.scanExtensionsFromLocation(X);let U={};if(X.excludeObsolete&&X.type===1)try{const x=(await this.fileService.readFile(this.obsoleteFile)).value.toString();U=JSON.parse(x)}catch{}return(0,E.isEmptyObject)(U)?O:O.filter(x=>!U[c.ExtensionKey.create(x).toString()])}async scanExtensionsFromLocation(X){const O=await this.fileService.resolve(X.location);if(!O.children?.length)return[];const U=await Promise.all(O.children.map(async x=>{if(!x.isDirectory||X.type===1&&(0,y.basename)(x.resource).indexOf(".")===0)return null;const ae=new _(x.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(ae)}));return(0,v.coalesce)(U).sort((x,ae)=>x.location.path<ae.location.path?-1:1)}async scanExtensionsFromProfile(X){let O=await this.scanExtensionsFromProfileResource(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(X.location,X.applicationExtensionslocation)){O=O.filter(x=>!x.metadata?.isApplicationScoped);const U=await this.scanExtensionsFromProfileResource(X.applicationExtensionslocation,x=>!!x.metadata?.isApplicationScoped,X);O.push(...U)}return O}async scanExtensionsFromProfileResource(X,O,U){const x=await this.extensionsProfileScannerService.scanProfileExtensions(X);if(!x.length)return[];const ae=await Promise.all(x.map(async ue=>{if(O(ue)){const Q=new _(ue.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(Q,ue.metadata)}return null}));return(0,v.coalesce)(ae)}async scanOneOrMultipleExtensions(X){try{if(await this.fileService.exists((0,y.joinPath)(X.location,"package.json"))){const O=await this.scanExtension(X);return O?[O]:[]}else return await this.scanExtensions(X)}catch(O){return this.logService.error(`Error scanning extensions at ${X.location.path}:`,(0,T.getErrorMessage)(O)),[]}}async scanExtension(X,O){try{let U=await this.scanExtensionManifest(X.location);if(U){U.publisher||(U.publisher=u.UNDEFINED_PUBLISHER),O=O??U.__metadata,delete U.__metadata;const x=(0,c.getGalleryExtensionId)(U.publisher,U.name),ae=O?.id?{id:x,uuid:O.id}:{id:x},ue=O?.isSystem?0:X.type,Q=ue===0||!!O?.isBuiltin;U=await this.translateManifest(X.location,U,_.createNlsConfiguration(X));const re={type:ue,identifier:ae,manifest:U,location:X.location,isBuiltin:Q,targetPlatform:O?.targetPlatform??"undefined",metadata:O,isValid:!0,validations:[]};return X.validate?this.validate(re,X):re}}catch(U){X.type!==0&&this.logService.error(U)}return null}validate(X,O){let U=!0;const x=(0,r.validateExtensionManifest)(O.productVersion,O.productDate,O.location,X.manifest,X.isBuiltin);for(const[ae,ue]of x)ae===w.default.Error&&(U=!1,this.logService.error(this.formatMessage(O.location,ue)));return X.isValid=U,X.validations=x,X}async scanExtensionManifest(X){const O=(0,y.joinPath)(X,"package.json");let U;try{U=(await this.fileService.readFile(O)).value.toString()}catch(ae){return(0,o.toFileOperationResult)(ae)!==1&&this.logService.error(this.formatMessage(X,(0,m.localize)(0,null,O.path,ae.message))),null}let x;try{x=JSON.parse(U)}catch{const ue=[];(0,P.parse)(U,ue);for(const Q of ue)this.logService.error(this.formatMessage(X,(0,m.localize)(1,null,O.path,Q.offset,Q.length,(0,p.getParseErrorMessage)(Q.error))));return null}return(0,P.getNodeType)(x)!=="object"?(this.logService.error(this.formatMessage(X,(0,m.localize)(2,null,O.path))),null):x}async translateManifest(X,O,U){const x=await this.getLocalizedMessages(X,O,U);if(x)try{const ae=[],ue=await this.resolveOriginalMessageBundle(x.default,ae);if(ae.length>0)return ae.forEach(re=>{this.logService.error(this.formatMessage(X,(0,m.localize)(3,null,x.default?.path,(0,p.getParseErrorMessage)(re.error))))}),O;if((0,P.getNodeType)(x)!=="object")return this.logService.error(this.formatMessage(X,(0,m.localize)(4,null,x.default?.path))),O;const Q=x.values||Object.create(null);return(0,B.localizeManifest)(O,Q,ue)}catch{}return O}async getLocalizedMessages(X,O,U){const x=(0,y.joinPath)(X,"package.nls.json"),ae=(F,M)=>{M.forEach(G=>{this.logService.error(this.formatMessage(X,(0,m.localize)(5,null,F?.path,(0,p.getParseErrorMessage)(G.error))))})},ue=F=>{this.logService.error(this.formatMessage(X,(0,m.localize)(6,null,F?.path)))},Q=`${O.publisher}.${O.name}`,re=U.translations[Q];if(re)try{const F=g.URI.file(re),M=(await this.fileService.readFile(F)).value.toString(),G=[],ie=(0,P.parse)(M,G);return G.length>0?(ae(F,G),{values:void 0,default:x}):(0,P.getNodeType)(ie)!=="object"?(ue(F),{values:void 0,default:x}):{values:ie.contents?ie.contents.package:void 0,default:x}}catch{return{values:void 0,default:x}}else{if(!await this.fileService.exists(x))return;let M;try{M=await this.findMessageBundles(X,U)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const G=(await this.fileService.readFile(M.localized)).value.toString(),ie=[],he=(0,P.parse)(G,ie);return ie.length>0?(ae(M.localized,ie),{values:void 0,default:M.original}):(0,P.getNodeType)(he)!=="object"?(ue(M.localized),{values:void 0,default:M.original}):{values:he,default:M.original}}catch{return{values:void 0,default:M.original}}}}async resolveOriginalMessageBundle(X,O){if(X)try{const U=(await this.fileService.readFile(X)).value.toString();return(0,P.parse)(U,O)}catch{}}findMessageBundles(X,O){return new Promise((U,x)=>{const ae=ue=>{const Q=(0,y.joinPath)(X,`package.nls.${ue}.json`);this.fileService.exists(Q).then(re=>{re&&U({localized:Q,original:(0,y.joinPath)(X,"package.nls.json")});const F=ue.lastIndexOf("-");F===-1?U({localized:(0,y.joinPath)(X,"package.nls.json"),original:null}):(ue=ue.substring(0,F),ae(ue))})};if(O.devMode||O.pseudo||!O.language)return U({localized:(0,y.joinPath)(X,"package.nls.json"),original:null});ae(O.language)})}formatMessage(X,O){return`[${X.path}]: ${O}`}};te=Ae([_e(1,d.IExtensionsProfileScannerService),_e(2,L.IUriIdentityService),_e(3,o.IFileService),_e(4,i.ILogService)],te);let se=class extends te{constructor(X,O,U,x,ae,ue){super(O,U,x,ae,ue),this.cacheFile=X,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(X){const O=await this.readExtensionCache();if(this.input=X,O&&O.input&&_.equals(O.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),O.result.map(x=>(x.location=g.URI.revive(x.location),x));const U=await super.scanExtensions(X);return await this.writeExtensionCache({input:X,result:U}),U}async readExtensionCache(){try{const X=await this.fileService.readFile(this.cacheFile),O=JSON.parse(X.value.toString());return{result:O.result,input:(0,l.revive)(O.input)}}catch(X){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(X))}return null}async writeExtensionCache(X){try{await this.fileService.writeFile(this.cacheFile,C.VSBuffer.fromString(JSON.stringify(X)))}catch(O){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(O))}}async validateCache(){if(!this.input)return;const X=await this.readExtensionCache();if(!X)return;const O=X.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(U,O))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(x){this.logService.error(x)}}};se=Ae([_e(2,d.IExtensionsProfileScannerService),_e(3,L.IUriIdentityService),_e(4,o.IFileService),_e(5,i.ILogService)],se);function W(j,X){const O=(0,c.getExtensionId)(j.manifest.publisher,j.manifest.name);return{id:O,identifier:new u.ExtensionIdentifier(O),isBuiltin:j.type===0,isUserBuiltin:j.type===1&&j.isBuiltin,isUnderDevelopment:X,extensionLocation:j.location,uuid:j.identifier.uuid,targetPlatform:j.targetPlatform,...j.manifest}}e.toExtensionDescription=W;class fe extends Z{constructor(X,O,U,x,ae,ue,Q,re,F,M,G){super(X,O,(0,y.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(x,u.MANIFEST_CACHE_FOLDER),ae,ue,Q,re,F,M,G),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const ie=await this.fileService.readFile(g.URI.file(S.translationsConfigFile));return JSON.parse(ie.value.toString())}catch{}return Object.create(null)})()}getTranslations(X){return this.translationsPromise}}e.NativeExtensionsScannerService=fe}),define(ve[236],we([1,0,49,14,38,7,2,12,6,21,13,37]),function(oe,e,v,t,D,C,T,P,p,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=class extends T.Disposable{constructor(h,w){super(),this.userDataProfilesService=h,this.logService=w,this.processesLimiter=new t.Limiter(5)}async postUninstall(h){const w=this.parseScript(h,"uninstall");return w&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(w.script,"uninstall",w.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),E=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${E}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,E=>this.logService.error("Error while removing extension storage path",E))}parseScript(h,w){const E=`vscode:${w}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[E]=="string"){const g=h.manifest.scripts[E].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${E} should be a node script`),null):{script:(0,p.join)(h.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(h,w,E,g,m){return new Promise((f,c)=>{const u=this.start(h,w,E,m);let r;const o=n=>{r&&(clearTimeout(r),r=null),n?c(n):f(void 0)};u.on("error",n=>{o((0,D.toErrorMessage)(n)||"Unknown")}),u.on("exit",(n,i)=>{o(n?`post-${w} process exited with code ${n}`:void 0)}),g&&(r=setTimeout(()=>{r=null,u.kill(),c("timed out")},5e3))})}start(h,w,E,g){const m={silent:!0,execArgv:void 0},f=(0,v.fork)(h,[`--type=extension-post-${w}`,...E],m);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const c=C.Event.fromNodeEventEmitter(f.stdout,"data"),u=C.Event.fromNodeEventEmitter(f.stderr,"data");c(n=>this.logService.info(g.identifier.id,g.manifest.version,`post-${w}`,n)),u(n=>this.logService.error(g.identifier.id,g.manifest.version,`post-${w}`,n));const r=C.Event.any(C.Event.map(c,n=>({data:`%c${n}`,format:[""]})),C.Event.map(u,n=>({data:`%c${n}`,format:["color: red"]})));return C.Event.debounce(r,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(g.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(h){return(0,p.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};S=Ae([_e(0,k.IUserDataProfilesService),_e(1,R.ILogService)],S),e.ExtensionsLifecycle=S}),define(ve[237],we([1,0,14,7,2,46,11,155,5,37]),function(oe,e,v,t,D,C,T,P,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var R;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(R=e.WillSaveStateReason||(e.WillSaveStateReason={}));var k;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(k=e.StorageScope||(e.StorageScope={}));var S;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));function y(m){const f=m.get(e.TARGET_KEY);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.loadKeyTargets=y;class h extends D.Disposable{constructor(f={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=f,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,c){if(c===e.TARGET_KEY){switch(f){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:f})}else this._onDidChangeValue.fire({scope:f,key:c,target:this.getKeyTargets(f)[c]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,c,u){return this.getStorage(c)?.get(f,u)}getBoolean(f,c,u){return this.getStorage(c)?.getBoolean(f,u)}getNumber(f,c,u){return this.getStorage(c)?.getNumber(f,u)}store(f,c,u,r){if((0,T.isUndefinedOrNull)(c)){this.remove(f,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,u,r),this.getStorage(u)?.set(f,c)})}remove(f,c){this.withPausedEmitters(()=>{this.updateKeyTarget(f,c,void 0),this.getStorage(c)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,c){const u=[],r=this.getKeyTargets(f);for(const o of Object.keys(r))r[o]===c&&u.push(o);return u}updateKeyTarget(f,c,u){const r=this.getKeyTargets(c);typeof u=="number"?r[f]!==u&&(r[f]=u,this.getStorage(c)?.set(e.TARGET_KEY,JSON.stringify(r))):typeof r[f]=="number"&&(delete r[f],this.getStorage(c)?.set(e.TARGET_KEY,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(f){switch(f){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(f){const c=this.getStorage(f);return c?y(c):Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=R.NONE){this._onWillSaveState.fire({reason:f});const c=this.getStorage(-1),u=this.getStorage(0),r=this.getStorage(1);switch(f){case R.NONE:await v.Promises.settled([c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await v.Promises.settled([c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.getStorage(-1)?.items??new Map,c=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return g(f,c,u,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(f,c){return this.emitWillSaveState(R.NONE),(0,b.isUserDataProfile)(f)?this.switchToProfile(f,c):this.switchToWorkspace(f,c)}canSwitchProfile(f,c){return!(f.id===c.id||w(c)&&w(f))}switchData(f,c,u,r){this.withPausedEmitters(()=>{if(r)for(const[o,n]of f)c.set(o,n);else{const o=new Set;for(const[n,i]of f)o.add(n),c.get(n)!==i&&this.emitDidChangeValue(u,n);for(const[n]of c.items)o.has(n)||this.emitDidChangeValue(u,n)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function w(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class E extends h{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.profileStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),this._register(this.applicationStorage.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f)))}getStorage(f){switch(f){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(f){return!1}}e.InMemoryStorageService=E;async function g(m,f,c,u,r,o){const n=J=>{try{return JSON.parse(J)}catch{return J}},i=new Map,s=new Map;m.forEach((J,Z)=>{i.set(Z,J),s.set(Z,n(J))});const a=new Map,l=new Map;f.forEach((J,Z)=>{a.set(Z,J),l.set(Z,n(J))});const d=new Map,I=new Map;c.forEach((J,Z)=>{d.set(Z,J),I.set(Z,n(J))}),console.group(u!==r?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const L=[];if(i.forEach((J,Z)=>{L.push({key:Z,value:J})}),console.table(L),console.groupEnd(),console.log(s),u!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const J=[];a.forEach((Z,_)=>{J.push({key:_,value:Z})}),console.table(J),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const B=[];d.forEach((J,Z)=>{B.push({key:Z,value:J})}),console.table(B),console.groupEnd(),console.log(I)}e.logStorage=g}),define(ve[114],we([1,0,18,20,10,3,28,11,4,25,26,31,32,70,17,13,27,54,221,237,33]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const u=C.isWeb?"web":(0,k.getTargetPlatform)(C.platform,T.arch);var r;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function o(...F){return String(F.reduce((M,G)=>M|G,0))}var n;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class d{constructor(M=l){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(M,G=this.state.pageSize){return new d({...this.state,pageNumber:M,pageSize:G})}withFilter(M,...G){const ie=[...this.state.criteria,...G.length?G.map(he=>({filterType:M,value:he})):[{filterType:M}]];return new d({...this.state,criteria:ie})}withSortBy(M){return new d({...this.state,sortBy:M})}withSortOrder(M){return new d({...this.state,sortOrder:M})}withFlags(...M){return new d({...this.state,flags:M.reduce((G,ie)=>G|ie,0)})}withAssetTypes(...M){return new d({...this.state,assetTypes:M})}withSource(M){return new d({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:G,pageSize:ie,sortBy:he,sortOrder:Ee,flags:$,assetTypes:Y}=this.state;return{filters:[{criteria:M,pageNumber:G,pageSize:ie,sortBy:he,sortOrder:Ee}],assetTypes:Y,flags:$}}get searchText(){const M=this.state.criteria.filter(G=>G.filterType===n.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function I(F,M){const G=(F||[]).filter(ie=>ie.statisticName===M)[0];return G?G.value:0}function L(F){const M="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(ie=>ie.assetType.indexOf(M)===0).reduce((ie,he)=>{const Ee=Z(F,he.assetType);return Ee&&ie.push([he.assetType.substring(M.length),Ee]),ie},[])}function B(F){if(F.properties){const M=F.properties.filter(he=>he.key===i.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=M.filter(he=>G.test(he.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return Z(F,i.Repository)}function J(F){return{uri:`${F.fallbackAssetUri}/${i.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${i.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function Z(F,M){return F.files.filter(ie=>ie.assetType===M)[0]?{uri:`${F.assetUri}/${M}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${M}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function _(F,M){const G=F.properties?F.properties.filter(he=>he.key===M):[],ie=G.length>0&&G[0].value;return ie?ie.split(",").map(he=>(0,S.adoptToGalleryExtensionId)(he)):[]}function te(F){const M=F.properties?F.properties.filter(G=>G.key===s.Engine):[];return M.length>0&&M[0].value||""}function se(F){const M=F.properties?F.properties.filter(G=>G.key===s.PreRelease):[];return M.length>0&&M[0].value==="true"}function W(F){const M=F.properties?F.properties.filter(ie=>ie.key===s.LocalizedLanguages):[],G=M.length>0&&M[0].value||"";return G?G.split(","):[]}function fe(F){return F.properties?.find(M=>M.key===s.SponsorLink)?.value}function j(F){return F.indexOf("preview")!==-1}function X(F){return F.targetPlatform?(0,k.toTargetPlatform)(F.targetPlatform):"undefined"}function O(F){const M=(0,v.distinct)(F.versions.map(X)),G=!!F.tags?.includes(k.WEB_EXTENSION_TAG),ie=M.indexOf("web");return G?ie===-1&&M.push("web"):ie!==-1&&M.splice(ie,1),M}function U(F,M){const G=(0,k.getFallbackTargetPlarforms)(M);for(let ie=0;ie<F.length;ie++){const he=F[ie];if(he.version===F[ie-1]?.version){let Ee=ie;const $=X(he);if($===M)for(;Ee>0&&F[Ee-1].version===he.version;)Ee--;else if(G.includes($))for(;Ee>0&&F[Ee-1].version===he.version&&X(F[Ee-1])!==M;)Ee--;Ee!==ie&&(F.splice(ie,1),F.splice(Ee,0,he))}}return F}e.sortExtensionVersions=U;function x(F,M,G){F.telemetryData={index:M,querySource:G}}function ae(F,M,G){const ie=F.versions[0],he={manifest:Z(M,i.Manifest),readme:Z(M,i.Details),changelog:Z(M,i.Changelog),license:Z(M,i.License),repository:B(M),download:J(M),icon:Z(M,i.Icon),coreTranslations:L(M)};return{identifier:{id:(0,S.getGalleryExtensionId)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:M.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:fe(ie),description:F.shortDescription||"",installCount:I(F.statistics,"install"),rating:I(F.statistics,"averagerating"),ratingCount:I(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:G,assets:he,properties:{dependencies:_(M,s.Dependency),extensionPack:_(M,s.ExtensionPack),engine:te(M),localizedLanguages:W(M),targetPlatform:X(M),isPreReleaseVersion:se(M)},hasPreReleaseVersion:se(ie),hasReleaseVersion:!0,preview:j(F.flags)}}let ue=class{constructor(M,G,ie,he,Ee,$,Y,ee){this.requestService=G,this.logService=ie,this.environmentService=he,this.telemetryService=Ee,this.fileService=$,this.productService=Y,this.configurationService=ee;const z=Y.extensionsGallery;this.extensionsGalleryUrl=z?.serviceUrl,this.extensionsGallerySearchUrl=z?.searchUrl,this.extensionsControlUrl=z?.controlUrl,this.commonHeadersPromise=(0,m.resolveMarketplaceHeaders)(Y.version,Y,this.environmentService,this.configurationService,this.fileService,M,this.telemetryService)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,G,ie){const he=t.CancellationToken.isCancellationToken(G)?{}:G,Ee=t.CancellationToken.isCancellationToken(G)?G:ie,$=[],Y=[],ee=[],z=[];let q=!0;for(const le of M){le.uuid?Y.push(le.uuid):$.push(le.id);const pe=!!(le.version||le.preRelease);ee.push({id:le.id,uuid:le.uuid,includePreRelease:pe}),le.version&&z.push({id:le.id,uuid:le.uuid,version:le.version}),q=q&&!!le.hasPreRelease&&!pe}if(!Y.length&&!$.length)return[];let H=new d().withPage(1,M.length);Y.length&&(H=H.withFilter(n.ExtensionId,...Y)),$.length&&(H=H.withFilter(n.ExtensionName,...$)),(he.queryAllVersions||q)&&(H=H.withFlags(H.flags,r.IncludeVersions)),he.source&&(H=H.withSource(he.source));const{extensions:K}=await this.queryGalleryExtensions(H,{targetPlatform:he.targetPlatform??u,includePreRelease:ee,versions:z,compatible:!!he.compatible},Ee);return he.source&&K.forEach((le,pe)=>x(le,pe,he.source)),K}async getCompatibleExtension(M,G,ie){if((0,k.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(M,G,ie))return M;const he=new d().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,M.identifier.uuid),{extensions:Ee}=await this.queryGalleryExtensions(he,{targetPlatform:ie,compatible:!0,includePreRelease:G},t.CancellationToken.None);return Ee[0]||null}async isExtensionCompatible(M,G,ie){if(!(0,k.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,ie)||!G&&M.properties.isPreReleaseVersion)return!1;let he=M.properties.engine;if(!he){const Ee=await this.getManifest(M,t.CancellationToken.None);if(!Ee)throw new Error("Manifest was not found");he=Ee.engines.vscode}return(0,y.isEngineValid)(he,this.productService.version,this.productService.date)}async isValidVersion(M,G,ie,he,Ee){if(!(0,k.isTargetPlatformCompatible)(X(M),he,Ee)||G!=="any"&&se(M)!==(G==="prerelease"))return!1;if(ie)try{const $=await this.getEngine(M);if(!(0,y.isEngineValid)($,this.productService.version,this.productService.date))return!1}catch($){return this.logService.error(`Error while getting the engine for the version ${M.version}.`,(0,D.getErrorMessage)($)),!1}return!0}async query(M,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ie=M.text||"";const he=M.pageSize??50;let Ee=new d().withPage(1,he);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(q,H,K)=>(Ee=Ee.withFilter(n.Category,K||H),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(q,H,K)=>(Ee=Ee.withFilter(n.Tag,K||H),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(Ee=Ee.withFilter(n.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),Ee=Ee.withFilter(n.SearchText,ie)),Ee=Ee.withSortBy(0)):M.ids?Ee=Ee.withFilter(n.ExtensionId,...M.ids):M.names?Ee=Ee.withFilter(n.ExtensionName,...M.names):Ee=Ee.withSortBy(4),typeof M.sortBy=="number"&&(Ee=Ee.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(Ee=Ee.withSortOrder(M.sortOrder)),M.source&&(Ee=Ee.withSource(M.source));const $=async(q,H)=>{const{extensions:K,total:le}=await this.queryGalleryExtensions(q,{targetPlatform:u,compatible:!1,includePreRelease:!!M.includePreRelease},H);return K.forEach((pe,ke)=>x(pe,(q.pageNumber-1)*q.pageSize+ke,M.source)),{extensions:K,total:le}},{extensions:Y,total:ee}=await $(Ee,G),z=async(q,H)=>{if(H.isCancellationRequested)throw new D.CancellationError;const{extensions:K}=await $(Ee.withPage(q+1),H);return K};return{firstPage:Y,total:ee,pageSize:Ee.pageSize,getPage:z}}async queryGalleryExtensions(M,G,ie){const he=M.flags;!!(M.flags&r.IncludeLatestVersionOnly)&&!!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(M.flags&r.IncludeLatestVersionOnly)&&!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags,r.IncludeLatestVersionOnly)),G.versions?.length&&(M=M.withFlags(M.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),M=M.withFlags(M.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:Ee,total:$}=await this.queryRawGalleryExtensions(M,ie);if(!(M.flags&r.IncludeLatestVersionOnly)){const q=[];for(const H of Ee){const K=await this.toGalleryExtensionWithCriteria(H,G);K&&q.push(K)}return{extensions:q,total:$}}const ee=[],z=new Map;for(let q=0;q<Ee.length;q++){const H=Ee[q],K={id:(0,S.getGalleryExtensionId)(H.publisher.publisherName,H.extensionName),uuid:H.extensionId},le=(0,P.isBoolean)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(ke=>(0,S.areSameExtensions)(ke,K))?.includePreRelease;if(G.compatible&&(0,k.isNotWebExtensionInWebTargetPlatform)(O(H),G.targetPlatform))continue;const pe=await this.toGalleryExtensionWithCriteria(H,G);!pe||pe.properties.isPreReleaseVersion&&(!le||!pe.hasReleaseVersion)||!pe.properties.isPreReleaseVersion&&pe.properties.targetPlatform!==G.targetPlatform&&pe.hasPreReleaseVersion?z.set(H.extensionId,q):ee.push([q,pe])}if(z.size){const q=new Date().getTime(),H=new d().withFlags(he&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,z.size).withFilter(n.ExtensionId,...z.keys()),{extensions:K}=await this.queryGalleryExtensions(H,G,ie);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-q,count:z.size});for(const le of K){const pe=z.get(le.identifier.uuid);ee.push([pe,le])}}return{extensions:ee.sort((q,H)=>q[0]-H[0]).map(([,q])=>q),total:$}}async toGalleryExtensionWithCriteria(M,G){const ie={id:(0,S.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},he=G.versions?.find(ee=>(0,S.areSameExtensions)(ee,ie))?.version,Ee=(0,P.isBoolean)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(ee=>(0,S.areSameExtensions)(ee,ie))?.includePreRelease,$=O(M),Y=U(M.versions,G.targetPlatform);if(G.compatible&&(0,k.isNotWebExtensionInWebTargetPlatform)($,G.targetPlatform))return null;for(let ee=0;ee<Y.length;ee++){const z=Y[ee];if(!(he&&z.version!==he)){if(await this.isValidVersion(z,Ee?"any":"release",G.compatible,$,G.targetPlatform))return ae(M,z,$);if(he&&z.version===he)return null}}return he||G.compatible?null:ae(M,M.versions[0],$)}async queryRawGalleryExtensions(M,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,o(r.Unpublished));const ie=await this.commonHeadersPromise,he=JSON.stringify(M.raw),Ee={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},$=new Date().getTime();let Y,ee,z=0;try{if(Y=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&M.criteria.some(H=>H.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:he,headers:Ee},G),Y.res.statusCode&&Y.res.statusCode>=400&&Y.res.statusCode<500)return{galleryExtensions:[],total:z};const q=await(0,g.asJson)(Y);if(q){const H=q.results[0],K=H.extensions,le=H.resultMetadata&&H.resultMetadata.filter(pe=>pe.metadataType==="ResultCount")[0];return z=le&&le.metadataItems.filter(pe=>pe.name==="TotalCount")[0].count||0,{galleryExtensions:K,total:z}}return{galleryExtensions:[],total:z}}catch(q){throw ee=q,q}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-$,success:!!Y&&(0,g.isSuccess)(Y),responseBodySize:Y?.res.headers["Content-Length"],statusCode:Y?String(Y.res.statusCode):void 0,errorCode:ee?(0,D.isCancellationError)(ee)?"canceled":(0,D.getErrorMessage)(ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(z)})}}async reportStatistic(M,G,ie,he){if(!this.isEnabled())return;const Ee=C.isWeb?this.api(`/itemName/${M}.${G}/version/${ie}/statType/${he==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${G}/${ie}/stats?statType=${he}`),$=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ee={...await this.commonHeadersPromise,Accept:$};try{await this.requestService.request({type:"POST",url:Ee,headers:ee},t.CancellationToken.None)}catch{}}async download(M,G,ie){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const he=(0,S.getGalleryExtensionTelemetryData)(M),Ee=new Date().getTime(),$=q=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...he,duration:q}),Y=ie===2?"install":ie===3?"update":"",ee=Y?{uri:`${M.assets.download.uri}${p.URI.parse(M.assets.download.uri).query?"&":"?"}${Y}=true`,fallbackUri:`${M.assets.download.fallbackUri}${p.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${Y}=true`}:M.assets.download,z=await this.getAsset(ee);await this.fileService.writeFile(G,z.stream),$(new Date().getTime()-Ee)}async getReadme(M,G){if(M.assets.readme){const ie=await this.getAsset(M.assets.readme,{},G);return await(0,g.asTextOrError)(ie)||""}return""}async getManifest(M,G){if(M.assets.manifest){const ie=await this.getAsset(M.assets.manifest,{},G),he=await(0,g.asTextOrError)(ie);return he?JSON.parse(he):null}return null}async getManifestFromRawExtensionVersion(M,G){const ie=Z(M,i.Manifest);if(!ie)throw new Error("Manifest was not found");const he={"Accept-Encoding":"gzip"},Ee=await this.getAsset(ie,{headers:he});return await(0,g.asJson)(Ee)}async getCoreTranslation(M,G){const ie=M.assets.coreTranslations.filter(he=>he[0]===G.toUpperCase())[0];if(ie){const he=await this.getAsset(ie[1]),Ee=await(0,g.asTextOrError)(he);return Ee?JSON.parse(Ee):null}return null}async getChangelog(M,G){if(M.assets.changelog){const ie=await this.getAsset(M.assets.changelog,{},G);return await(0,g.asTextOrError)(ie)||""}return""}async getAllCompatibleVersions(M,G,ie){let he=new d().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?he=he.withFilter(n.ExtensionId,M.identifier.uuid):he=he.withFilter(n.ExtensionName,M.identifier.id);const{galleryExtensions:Ee}=await this.queryRawGalleryExtensions(he,t.CancellationToken.None);if(!Ee.length)return[];const $=O(Ee[0]);if((0,k.isNotWebExtensionInWebTargetPlatform)($,ie))return[];const Y=[];await Promise.all(Ee[0].versions.map(async q=>{try{await this.isValidVersion(q,G?"any":"release",!0,$,ie)&&Y.push(q)}catch{}}));const ee=[],z=new Set;for(const q of U(Y,ie))z.has(q.version)||(z.add(q.version),ee.push({version:q.version,date:q.lastUpdated,isPreReleaseVersion:se(q)}));return ee}async getAsset(M,G={},ie=t.CancellationToken.None){const he=await this.commonHeadersPromise,Ee={type:"GET"},$={...he,...G.headers||{}};G={...G,...Ee,headers:$};const Y=M.uri,ee=M.fallbackUri,z={...G,url:Y};try{const q=await this.requestService.request(z,ie);if(q.res.statusCode===200)return q;const H=await(0,g.asTextOrError)(q);throw new Error(`Expected 200, got back ${q.res.statusCode} instead.

${H}`)}catch(q){if((0,D.isCancellationError)(q))throw q;const H=(0,D.getErrorMessage)(q);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Y,message:H});const K={...G,url:ee};return this.requestService.request(K,ie)}}async getEngine(M){let G=te(M);if(!G){const ie=await this.getManifestFromRawExtensionVersion(M,t.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");G=ie.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,g.asJson)(M),ie=[],he={};if(G){for(const Ee of G.malicious)ie.push({id:Ee});if(G.migrateToPreRelease)for(const[Ee,$]of Object.entries(G.migrateToPreRelease))(!$.engine||(0,y.isEngineValid)($.engine,this.productService.version,this.productService.date))&&(he[Ee.toLowerCase()]={disallowInstall:!0,extension:{id:$.id,displayName:$.displayName,autoMigrate:{storage:!!$.migrateStorage},preRelease:!0}});if(G.deprecated)for(const[Ee,$]of Object.entries(G.deprecated))$&&(he[Ee.toLowerCase()]=(0,P.isBoolean)($)?{}:$)}return{malicious:ie,deprecated:he}}};ue=Ae([_e(1,g.IRequestService),_e(2,w.ILogService),_e(3,R.IEnvironmentService),_e(4,c.ITelemetryService),_e(5,h.IFileService),_e(6,E.IProductService),_e(7,b.IConfigurationService)],ue);let Q=class extends ue{constructor(M,G,ie,he,Ee,$,Y,ee){super(M,G,ie,he,Ee,$,Y,ee)}};Q=Ae([_e(0,f.IStorageService),_e(1,g.IRequestService),_e(2,w.ILogService),_e(3,R.IEnvironmentService),_e(4,c.ITelemetryService),_e(5,h.IFileService),_e(6,E.IProductService),_e(7,b.IConfigurationService)],Q),e.ExtensionGalleryService=Q;let re=class extends ue{constructor(M,G,ie,he,Ee,$,Y){super(void 0,M,G,ie,he,Ee,$,Y)}};re=Ae([_e(0,g.IRequestService),_e(1,w.ILogService),_e(2,R.IEnvironmentService),_e(3,c.ITelemetryService),_e(4,h.IFileService),_e(5,E.IProductService),_e(6,b.IConfigurationService)],re),e.ExtensionGalleryServiceWithNoStorageService=re}),define(ve[115],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,v.createDecorator)("extensionHostStatusService");class t{constructor(){this._exitInfo=new Map}setExitInfo(C,T){this._exitInfo.set(C,T)}getExitInfo(C){return this._exitInfo.get(C)||null}}e.ExtensionHostStatusService=t}),define(ve[238],we([1,0,7,14]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function D(T){let P=0,p=0,b=0;T>=1e3&&(b=Math.floor(T/1e3),T-=b*1e3),b>=60&&(p=Math.floor(b/60),b-=p*60),p>=60&&(P=Math.floor(p/60),p-=P*60);const R=P?`${P}h`:"",k=p?`${p}m`:"",S=b?`${b}s`:"",y=T?`${T}ms`:"";return`${R}${k}${S}${y}`}e.printTime=D;class C{constructor(P,p,b,R){this._logService=P,this._reconnectionToken=p,this._onClose=new v.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=b,this.protocol=R,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${D(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${D(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${D(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(P){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${P}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${D(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const P=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),P.end(),this._onClose.fire(void 0)}acceptReconnection(P,p,b){this._remoteAddress=P,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(p,b),this.protocol.endAcceptReconnection()}}e.ManagementConnection=C}),define(ve[116],we([1,0,29,12,6,138,51]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const P=D.join(t.FileAccess.asFileUri("",oe).fsPath,"nls.metadata.json"),p=new Map;function b(S){return new Promise(y=>v.exists(S,y))}function R(S,y){return b(P).then(h=>{if(!h||!T.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const w=`${S}||${y}`;let E=p.get(w);return E||(E=C.getNLSConfiguration(T.default.commit,y,P,S).then(g=>(k.is(g)&&(g._languagePackSupport=!0),g)),p.set(w,E)),E})}e.getNLSConfiguration=R;var k;(function(S){function y(h){const w=h;return w&&typeof w._languagePackId=="string"}S.is=y})(k=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(ve[117],we([1,0,19,4,26,53,55,35,17,5,13,27,37,116]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let h=class extends T.AbstractExtensionsScannerService{constructor(E,g,m,f,c,u,r){super(t.URI.file(c.builtinExtensionsPath),t.URI.file(c.extensionsPath),(0,v.joinPath)(c.userHome,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(t.URI.file(c.userDataPath),P.MANIFEST_CACHE_FOLDER),E,g,m,f,c,u,r),this.nativeEnvironmentService=c}async getTranslations(E){const g=await(0,y.getNLSConfiguration)(E,this.nativeEnvironmentService.userDataPath);if(y.InternalNLSConfiguration.is(g))try{const m=await this.fileService.readFile(t.URI.file(g._translationsConfigFile));return JSON.parse(m.value.toString())}catch{}return Object.create(null)}};h=Ae([_e(0,S.IUserDataProfilesService),_e(1,C.IExtensionsProfileScannerService),_e(2,p.IFileService),_e(3,R.ILogService),_e(4,D.INativeEnvironmentService),_e(5,k.IProductService),_e(6,b.IInstantiationService)],h),e.ExtensionsScannerService=h}),define(ve[239],we([1,0,240,29,6,23,12,21]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const p=/^[0-9A-Za-z-]+$/;var b;(function(g){g[g.None=0]="None",g[g.Optional=1]="Optional",g[g.Mandatory=2]="Mandatory"})(b=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class R{constructor(){this.type=0}validate(m){return!0}}e.NoneServerConnectionToken=R;class k{constructor(m){this.value=m,this.type=1}validate(m){return m===this.value}}e.OptionalServerConnectionToken=k;class S{constructor(m){this.value=m,this.type=2}validate(m){return m===this.value}}e.MandatoryServerConnectionToken=S;class y{constructor(m){this.message=m}}e.ServerConnectionTokenParseError=y;async function h(g,m){const f=g["without-connection-token"],c=g["connection-token"],u=g["connection-token-file"],r=g.compatibility==="1.63";if(f)return typeof c<"u"||typeof u<"u"?new y("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new R;if(typeof u<"u"){if(typeof c<"u")return new y("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let o;try{o=t.readFileSync(u).toString().replace(/\r?\n$/,"")}catch{return new y(`Unable to read the connection token file at '${u}'.`)}return p.test(o)?new S(o):new y(`The connection token defined in '${u} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof c<"u"?p.test(c)?r?new k(c):new S(c):new y(`The connection token '${c} does not adhere to the characters 0-9, a-z, A-Z or -.`):r?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new k(await m())):new S(await m())}e.parseServerConnectionToken=h;async function w(g){return h(g,async()=>{if(!g["user-data-dir"])return(0,C.generateUuid)();const f=D.join(g["user-data-dir"],"token");try{const r=(await P.Promises.readFile(f)).toString().replace(/\r?\n$/,"");if(p.test(r))return r}catch{}const c=(0,C.generateUuid)();try{await P.Promises.writeFile(f,c,{mode:384})}catch{}return c})}e.determineServerConnectionToken=w;function E(g,m,f){if(g.validate(f.query[T.connectionTokenQueryName]))return!0;const c=v.parse(m.headers.cookie||"");return g.validate(c[T.connectionTokenCookieName])}e.requestHasValidConnectionToken=E}),define(ve[43],we([1,0,183,192,58,5,26]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:v.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:v.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:v.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:v.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:v.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:v.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:v.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:v.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:v.localize(8,null)},"user-data-dir":D.OPTIONS["user-data-dir"],"enable-smoke-test-driver":D.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":D.OPTIONS["disable-telemetry"],"disable-workspace-trust":D.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:D.OPTIONS.log,logsPath:D.OPTIONS.logsPath,"force-disable-user-env":D.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:v.localize(9,null)},"default-workspace":{type:"string",description:v.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":D.OPTIONS["extensions-dir"],"extensions-download-dir":D.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":D.OPTIONS["builtin-extensions-dir"],"install-extension":D.OPTIONS["install-extension"],"install-builtin-extension":D.OPTIONS["install-builtin-extension"],"uninstall-extension":D.OPTIONS["uninstall-extension"],"list-extensions":D.OPTIONS["list-extensions"],"locate-extension":D.OPTIONS["locate-extension"],"show-versions":D.OPTIONS["show-versions"],category:D.OPTIONS.category,force:D.OPTIONS.force,"do-not-sync":D.OPTIONS["do-not-sync"],"pre-release":D.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:v.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:D.OPTIONS.help,version:D.OPTIONS.version,"locate-shell-integration-path":D.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:D.OPTIONS._},e.IServerEnvironmentService=(0,C.refineServiceDecorator)(T.IEnvironmentService);class P extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=P}),define(ve[241],we([1,0,29,84,76,240,109,36,66,3,13,43,6,12,23,27,54,20,4,16,11,75]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const r={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function o(l,d,I,L){d.writeHead(I,{"Content-Type":"text/plain"}),d.end(L)}e.serveError=o;var n;(function(l){l[l.NO_CACHING=0]="NO_CACHING",l[l.ETAG=1]="ETAG",l[l.NO_EXPIRY=2]="NO_EXPIRY"})(n=e.CacheControl||(e.CacheControl={}));async function i(l,d,I,L,B,J){try{const Z=await v.promises.stat(l);if(d===1){const _=`W/"${[Z.ino,Z.size,Z.mtime.getTime()].join("-")}"`;if(L.headers["if-none-match"]===_)return B.writeHead(304),B.end();J.Etag=_}else d===2?J["Cache-Control"]="public, max-age=31536000":d===0&&(J["Cache-Control"]="no-store");J["Content-Type"]=r[(0,S.extname)(l)]||(0,p.getMediaMime)(l)||"text/plain",B.writeHead(200,J),(0,v.createReadStream)(l).pipe(B)}catch(Z){return Z.code!=="ENOENT"?(I.error(Z),console.error(Z.toString())):console.error(`File not found: ${l}`),B.writeHead(404,{"Content-Type":"text/plain"}),B.end("Not found")}}e.serveFile=i;const s=(0,S.dirname)(y.FileAccess.asFileUri("",oe).fsPath);let a=class{constructor(d,I,L,B,J){this._connectionToken=d,this._environmentService=I,this._logService=L,this._requestService=B,this._productService=J,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?m.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0;const Z=(0,u.getRemoteServerRootPath)(J);this._staticRoute=`${Z}/static`,this._callbackRoute=`${Z}/callback`,this._webExtensionRoute=`${Z}/web-extension-resource`}async handle(d,I,L){try{const B=L.pathname;return B.startsWith(this._staticRoute)&&B.charCodeAt(this._staticRoute.length)===47?this._handleStatic(d,I,L):B==="/"?this._handleRoot(d,I,L):B===this._callbackRoute?this._handleCallback(I):B.startsWith(this._webExtensionRoute)&&B.charCodeAt(this._webExtensionRoute.length)===47?this._handleWebExtensionResource(d,I,L):o(d,I,404,"Not found.")}catch(B){return this._logService.error(B),console.error(B.toString()),o(d,I,500,"Internal Server Error.")}}async _handleStatic(d,I,L){const B=Object.create(null),Z=decodeURIComponent(L.pathname).substring(this._staticRoute.length+1),_=(0,S.join)(s,Z);return(0,P.isEqualOrParent)(_,s,!b.isLinux)?i(_,this._environmentService.isBuilt?2:1,this._logService,d,I,B):o(d,I,400,"Bad request.")}_getResourceURLTemplateAuthority(d){const I=d.authority.indexOf(".");return I!==-1?d.authority.substring(I+1):void 0}async _handleWebExtensionResource(d,I,L){if(!this._webExtensionResourceUrlTemplate)return o(d,I,500,"No extension gallery service configured.");const B=decodeURIComponent(L.pathname),J=(0,S.normalize)(B.substring(this._webExtensionRoute.length+1)),Z=m.URI.parse(J).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:J.substring(0,J.indexOf("/")),path:J.substring(J.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(Z))return o(d,I,403,"Request Forbidden");const _={},te=O=>{const U=d.headers[O];U&&((0,c.isString)(U)||U[0])?_[O]=(0,c.isString)(U)?U:U[0]:O!==O.toLowerCase()&&te(O.toLowerCase())};te("X-Client-Name"),te("X-Client-Version"),te("X-Machine-Id"),te("X-Client-Commit");const se=await this._requestService.request({type:"GET",url:Z.toString(!0),headers:_},g.CancellationToken.None),W=se.res.statusCode||500;if(W!==200){let O=null;try{O=await(0,E.asTextOrError)(se)}catch{}return o(d,I,W,O||`Request failed with status ${W}`)}const fe=Object.create(null),j=O=>{const U=se.res.headers[O];U?fe[O]=U:O!==O.toLowerCase()&&j(O.toLowerCase())};j("Cache-Control"),j("Content-Type"),I.writeHead(200,fe);const X=await(0,f.streamToBuffer)(se.stream);return I.end(X.buffer)}async _handleRoot(d,I,L){const B=L.query[y.connectionTokenQueryName];if(typeof B=="string"){const ue=Object.create(null);ue["Set-Cookie"]=C.serialize(y.connectionTokenCookieName,B,{sameSite:"lax",maxAge:60*60*24*7});const Q=Object.create(null);for(const F in L.query)F!==y.connectionTokenQueryName&&(Q[F]=L.query[F]);const re=D.format({pathname:"/",query:Q});return ue.Location=re,I.writeHead(302,ue),I.end()}const J=ue=>{const Q=d.headers[ue];return Array.isArray(Q)?Q[0]:Q},Z=J("x-original-host")||J("x-forwarded-host")||d.headers.host;if(!Z)return o(d,I,400,"Bad request.");function _(ue){return JSON.stringify(ue).replace(/"/g,"&quot;")}let te;this._environmentService.args["enable-smoke-test-driver"]&&(te=!1);const se=ue=>ue&&m.URI.file(t.resolve(ue)).with({scheme:y.Schemas.vscodeRemote,authority:Z}),W=y.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",oe).fsPath,fe=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,h.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,j={remoteAuthority:Z,_wrapWebWorkerExtHostInIframe:te,developmentOptions:{enableSmokeTestDriver:this._environmentService.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this._logService.getLevel()},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:se(this._environmentService.args["default-folder"]),workspaceUri:se(this._environmentService.args["default-workspace"]),productConfiguration:{embedderIdentifier:"server-distro",extensionsGallery:this._webExtensionResourceUrlTemplate?{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:Z,path:`${this._webExtensionRoute}/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0)}:void 0},callbackRoute:this._callbackRoute},X=this._productService.extensionsGallery?.nlsBaseUrl,O={WORKBENCH_WEB_CONFIGURATION:_(j),WORKBENCH_AUTH_SESSION:fe?_(fe):"",WORKBENCH_WEB_BASE_URL:this._staticRoute,WORKBENCH_NLS_BASE_URL:X?`${X}${X.endsWith("/")?"":"/"}${this._productService.commit}/${this._productService.version}/`:""};let U;try{U=(await v.promises.readFile(W)).toString().replace(/\{\{([^}]+)\}\}/g,(Q,re)=>O[re]??"undefined")}catch{return I.writeHead(404,{"Content-Type":"text/plain"}),I.end("Not found")}const x=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(U).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${Z};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),ae={"Content-Type":"text/html","Content-Security-Policy":x};return this._connectionToken.type!==0&&(ae["Set-Cookie"]=C.serialize(y.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),I.writeHead(200,ae),I.end(U)}_getScriptCspHashes(d){const I=/<script>([\s\S]+?)<\/script>/img,L=[];let B;for(;B=I.exec(d);){const J=T.createHash("sha256"),Z=B[1].replace(/\r\n/g,`
`),_=J.update(Buffer.from(Z)).digest().toString("base64");L.push(`'sha256-${_}'`)}return L}async _handleCallback(d){const I=y.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",oe).fsPath,L=(await v.promises.readFile(I)).toString(),B=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(L).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return d.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":B}),d.end(L)}};a=Ae([_e(1,k.IServerEnvironmentService),_e(2,R.ILogService),_e(3,E.IRequestService),_e(4,w.IProductService)],a),e.WebClientServer=a}),define(ve[242],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,v.createDecorator)("IExtHostRpcService");class t{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.dispose=C.dispose.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=t}),define(ve[63],we([1,0,69]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(C){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:C,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function D(C){return new v.URITransformer(t(C))}e.createURITransformer=D}),define(ve[243],we([1,0,4,63,61,6,208]),function(oe,e,v,t,D,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class P extends T.AbstractDiskFileSystemProviderChannel{constructor(R,k){super(new D.DiskFileSystemProvider(R),R),this.environmentService=k,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(R){let k=this.uriTransformerCache.get(R.remoteAuthority);return k||(k=(0,t.createURITransformer)(R.remoteAuthority),this.uriTransformerCache.set(R.remoteAuthority,k)),k}transformIncoming(R,k,S=!1){if(S&&k.path==="/vscode-resource"&&k.query){const y=JSON.parse(k.query).requestResourcePath;return v.URI.from({scheme:"file",path:y})}return v.URI.revive(R.transformIncoming(k))}createSessionFileWatcher(R,k){return new p(R,k,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=P;class p extends T.AbstractSessionFileWatcher{constructor(R,k,S,y){super(R,k,S,y)}getRecursiveWatcherOptions(R){const k=R.args["file-watcher-polling"];if(k){const S=k.split(C.delimiter),y=Number(S[0]);if(y>0)return{usePolling:S.length>1?S.slice(1):!0,pollingInterval:y}}}getExtraExcludes(R){if(R.extensionsPath)return[C.posix.join(R.extensionsPath,"**")]}}}),define(ve[79],we([1,0,184,11,4,2,5,34,17,12]),function(oe,e,v,t,D,C,T,P,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,v.localize)(0,null),providerDisplayName:(0,v.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(O){O[O.PROGRAMMATIC=1]="PROGRAMMATIC",O[O.USER=2]="USER",O[O.EDIT=3]="EDIT",O[O.NAVIGATION=4]="NAVIGATION",O[O.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var k;(function(O){O[O.IDENTICAL=1]="IDENTICAL",O[O.SIMILAR=2]="SIMILAR",O[O.DIFFERENT=3]="DIFFERENT"})(k=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function S(O){const U=O;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}e.isEditorPaneWithSelection=S;function y(O,U,x){for(const ae of x.visibleEditorPanes)if(ae.group.id===U&&O.matches(ae.input))return ae.getViewState()}e.findViewStateForEditor=y;function h(O){if(s(O))return!1;const U=O;return D.URI.isUri(U?.resource)}e.isResourceEditorInput=h;function w(O){if(s(O))return!1;const U=O;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=w;function E(O){if(s(O)||w(O))return!1;const U=O;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=E;function g(O){if(s(O))return!1;const U=O;return U?U.resource===void 0||U.resource.scheme===b.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;const m=/Untitled-\d+/;function f(O){return O.scheme===b.Schemas.untitled&&O.path.length>1&&!m.test(O.path)}e.isUntitledWithAssociatedResource=f;function c(O){if(s(O))return!1;const U=O;return D.URI.isUri(U?.base?.resource)&&D.URI.isUri(U?.input1?.resource)&&D.URI.isUri(U?.input2?.resource)&&D.URI.isUri(U?.result?.resource)}e.isResourceMergeEditorInput=c;var u;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(u=e.Verbosity||(e.Verbosity={}));var r;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.mapIdToSaveSource=new Map}registerSource(U,x){let ae=this.mapIdToSaveSource.get(U);return ae||(ae={source:U,label:x},this.mapIdToSaveSource.set(U,ae)),ae.source}getSourceLabel(U){return this.mapIdToSaveSource.get(U)?.label??U}}e.SaveSourceRegistry=new o;var n;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription",O[O.CanDropIntoEditor=128]="CanDropIntoEditor",O[O.MultipleEditors=256]="MultipleEditors"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends C.Disposable{}e.AbstractEditorInput=i;function s(O){return O instanceof i}e.isEditorInput=s;function a(O){const U=O;return D.URI.isUri(U?.preferredResource)}function l(O){const U=O;return s(U?.primary)&&s(U?.secondary)}e.isSideBySideEditorInput=l;function d(O){const U=O;return s(U?.modified)&&s(U?.original)}e.isDiffEditorInput=d;function I(O){return s(O?.editor)}e.isEditorInputWithOptions=I;function L(O){const U=O;return I(O)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=L;function B(O){const U=O;return typeof U?.groupId=="number"&&s(U.editor)}e.isEditorIdentifier=B;var J;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(J=e.EditorCloseContext||(e.EditorCloseContext={}));var Z;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(Z=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var _;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(_=e.SideBySideEditor||(e.SideBySideEditor={}));class te{getOriginalUri(U,x){if(!U)return;if(c(U))return e.EditorResourceAccessor.getOriginalUri(U.result,x);if(x?.supportSideBySide){const{primary:ue,secondary:Q}=this.getSideEditors(U);if(ue&&Q){if(x?.supportSideBySide===_.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===_.ANY)return this.getOriginalUri(ue,{filterByScheme:x.filterByScheme})??this.getOriginalUri(Q,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===_.PRIMARY?ue:Q}}if(w(U)||E(U)||c(U))return;const ae=a(U)?U.preferredResource:U.resource;return!ae||!x||!x.filterByScheme?ae:this.filterUri(ae,x.filterByScheme)}getSideEditors(U){return l(U)||E(U)?{primary:U.primary,secondary:U.secondary}:d(U)||w(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,x){if(!U)return;if(c(U))return e.EditorResourceAccessor.getCanonicalUri(U.result,x);if(x?.supportSideBySide){const{primary:ue,secondary:Q}=this.getSideEditors(U);if(ue&&Q){if(x?.supportSideBySide===_.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===_.ANY)return this.getCanonicalUri(ue,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(Q,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===_.PRIMARY?ue:Q}}if(w(U)||E(U)||c(U))return;const ae=U.resource;return!ae||!x||!x.filterByScheme?ae:this.filterUri(ae,x.filterByScheme)}filterUri(U,x){if(Array.isArray(x)){if(x.some(ae=>U.scheme===ae))return U}else if(x===U.scheme)return U}}e.EditorResourceAccessor=new te;var se;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(se=e.CloseDirection||(e.CloseDirection={}));class W{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const x=this.instantiationService=U.get(T.IInstantiationService);for(const[ae,ue]of this.editorSerializerConstructors)this.createEditorSerializer(ae,ue,x);this.editorSerializerConstructors.clear()}createEditorSerializer(U,x,ae){const ue=ae.createInstance(x);this.editorSerializerInstances.set(U,ue)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,x){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,x,this.instantiationService):this.editorSerializerConstructors.set(U,x),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new W);async function fe(O,U){return!O||!O.length?[]:await Promise.all(O.map(async x=>{const ae=D.URI.revive(x.fileUri);if(!ae||!await U.canHandleResource(ae))return;let Q=x.exists,re=x.type;if(typeof Q!="boolean"||typeof re!="number")try{re=(await U.stat(ae)).isDirectory?p.FileType.Directory:p.FileType.Unknown,Q=!0}catch{Q=!1}if(!Q&&x.openOnlyIfExists||re===p.FileType.Directory)return;const F={...x.options,pinned:!0};return Q?{resource:ae,options:F}:{resource:ae,options:F,forceUntitled:!0}}))}e.pathsToEditors=fe;var j;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(j=e.EditorsOrder||(e.EditorsOrder={}));function X(O){const U=O;if(!U)return!1;const x=U;if(x.modified)return X(x.modified);const ae=U;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}e.isTextEditorViewState=X}),define(ve[118],we([1,0,16,68,44,66,12,6,3,98]),function(oe,e,v,t,D,C,T,P,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(l){l[l.Markup=1]="Markup",l[l.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",C.Mimes.latex,C.Mimes.markdown,"image/png","image/jpeg",C.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[C.Mimes.latex,C.Mimes.markdown,"application/json",C.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(l){l[l.Running=1]="Running",l[l.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(l){l[l.Unconfirmed=1]="Unconfirmed",l[l.Pending=2]="Pending",l[l.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(l){l[l.WithHardKernelDependency=0]="WithHardKernelDependency",l[l.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",l[l.Pure=2]="Pure",l[l.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var h;(function(l){l.Always="always",l.Never="never",l.Optional="optional"})(h=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var w;(function(l){l[l.ModelChange=1]="ModelChange",l[l.Move=2]="Move",l[l.ChangeCellLanguage=5]="ChangeCellLanguage",l[l.Initialize=6]="Initialize",l[l.ChangeCellMetadata=7]="ChangeCellMetadata",l[l.Output=8]="Output",l[l.OutputItem=9]="OutputItem",l[l.ChangeCellContent=10]="ChangeCellContent",l[l.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",l[l.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",l[l.ChangeCellMime=13]="ChangeCellMime",l[l.Unknown=100]="Unknown"})(w=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var E;(function(l){l[l.Handle=0]="Handle",l[l.Index=1]="Index"})(E=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(l){l[l.Replace=1]="Replace",l[l.Output=2]="Output",l[l.Metadata=3]="Metadata",l[l.CellLanguage=4]="CellLanguage",l[l.DocumentMetadata=5]="DocumentMetadata",l[l.Move=6]="Move",l[l.OutputItems=7]="OutputItems",l[l.PartialMetadata=8]="PartialMetadata",l[l.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var m;(function(l){l.scheme=T.Schemas.vscodeNotebookCell;const d=["W","X","Y","Z","a","b","c","d","e","f"],I=new RegExp(`^[${d.join("")}]+`),L=7;function B(W,fe){const j=fe.toString(L),O=`${j.length<d.length?d[j.length-1]:"z"}${j}s${(0,v.encodeBase64)(v.VSBuffer.fromString(W.scheme),!0,!0)}`;return W.with({scheme:l.scheme,fragment:O})}l.generate=B;function J(W){if(W.scheme!==l.scheme)return;const fe=W.fragment.indexOf("s");if(fe<0)return;const j=parseInt(W.fragment.substring(0,fe).replace(I,""),L),X=(0,v.decodeBase64)(W.fragment.substring(fe+1)).toString();if(!isNaN(j))return{handle:j,notebook:W.with({scheme:X,fragment:null})}}l.parse=J;function Z(W,fe){return W.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${fe??""},${W.scheme!==T.Schemas.file?W.scheme:""}`})}l.generateCellOutputUri=Z;function _(W){if(W.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const fe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(W.fragment);if(!fe)return;const j=fe[1]&&fe[1]!==""?fe[1]:void 0,X=fe[2];return{outputId:j,notebook:W.with({scheme:X||T.Schemas.file,fragment:null})}}l.parseCellOutputUri=_;function te(W,fe,j){return l.generate(W,fe).with({scheme:j})}l.generateCellPropertyUri=te;function se(W,fe){if(W.scheme===fe)return l.parse(W.with({scheme:l.scheme}))}l.parseCellPropertyUri=se})(m=e.CellUri||(e.CellUri={}));const f=l=>p.isWindows?l.replace(/\//g,"\\"):l;class c{constructor(d=[],I=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=I,this.order=[...new Set(d)].map(L=>({pattern:L,matches:t.parse(f(L))}))}sort(d){const I=new Map(D.Iterable.map(d,B=>[B,f(B)]));let L=[];for(const{matches:B}of this.order)for(const[J,Z]of I)if(B(Z)){L.push(J),I.delete(J);break}return I.size&&(L=L.concat([...I.keys()].sort((B,J)=>this.defaultOrder.indexOf(B)-this.defaultOrder.indexOf(J)))),L}prioritize(d,I){const L=this.findIndex(d);if(L===-1){this.order.unshift({pattern:d,matches:t.parse(f(d))});return}const B=new Set(I.map(Z=>this.findIndex(Z,L)));B.delete(-1);const J=Array.from(B).sort();this.order.splice(L+1,0,...J.map(Z=>this.order[Z]));for(let Z=J.length-1;Z>=0;Z--)this.order.splice(J[Z],1)}toArray(){return this.order.map(d=>d.pattern)}findIndex(d,I=this.order.length){const L=f(d);for(let B=0;B<I;B++)if(this.order[B].matches(L))return B;return-1}}e.MimeTypeDisplayOrder=c;function u(l,d,I,L=(B,J)=>B===J){const B=[];function J(te,se,W){if(se===0&&W.length===0)return;const fe=B[B.length-1];fe&&fe.start+fe.deleteCount===te?(fe.deleteCount+=se,fe.toInsert.push(...W)):B.push({start:te,deleteCount:se,toInsert:W})}let Z=0,_=0;for(;;){if(Z===l.length){J(Z,0,d.slice(_));break}if(_===d.length){J(Z,l.length-Z,[]);break}const te=l[Z],se=d[_];if(L(te,se)){Z+=1,_+=1;continue}I(se)?(J(Z,1,[]),Z+=1):(J(Z,0,[se]),_+=1)}return B}e.diff=u,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new b.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(l){l.default="default",l.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(l){const d=l;return!!((typeof d.include=="string"||t.isRelativePattern(d.include))&&(typeof d.exclude=="string"||t.isRelativePattern(d.exclude)))}e.isDocumentExcludePattern=o;function n(l,d,I){if(Array.isArray(l.viewType)&&l.viewType.indexOf(d)>=0||l.viewType===d)return!0;if(l.filenamePattern){const L=o(l.filenamePattern)?l.filenamePattern.include:l.filenamePattern,B=o(l.filenamePattern)?l.filenamePattern.exclude:void 0;if(t.match(L,(0,P.basename)(I.fsPath).toLowerCase()))return!(B&&t.match(B,(0,P.basename)(I.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(l){l[l.Left=1]="Left",l[l.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(d){return`${s._prefix}${d}`}static parse(d){if(d.startsWith(s._prefix))return d.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/";function a(l){return["application/vnd.code.notebook.stdout","application/x.notebook.stdout","application/x.notebook.stream","application/vnd.code.notebook.stderr","application/x.notebook.stderr"].includes(l)}e.isTextStreamMime=a}),define(ve[119],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,v.createDecorator)("environmentVariableService");var t;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ve[244],we([1,0,3,119]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class D{constructor(p){this.collections=p,this.map=new Map,p.forEach((b,R)=>{const k=b.map.entries();let S=k.next();for(;!S.done;){const y=S.value[0];let h=this.map.get(y);if(h||(h=[],this.map.set(y,h)),h.length>0&&h[0].type===t.EnvironmentVariableMutatorType.Replace){S=k.next();continue}const w=S.value[1];h.unshift({extensionIdentifier:R,value:w.value,type:w.type}),S=k.next()}})}async applyToProcessEnvironment(p,b){let R;v.isWindows&&(R={},Object.keys(p).forEach(k=>R[k.toLowerCase()]=k));for(const[k,S]of this.map){const y=v.isWindows&&R[k.toLowerCase()]||k;for(const h of S){const w=b?await b(h.value):h.value;switch(h.type){case t.EnvironmentVariableMutatorType.Append:p[y]=(p[y]||"")+w;break;case t.EnvironmentVariableMutatorType.Prepend:p[y]=w+(p[y]||"");break;case t.EnvironmentVariableMutatorType.Replace:p[y]=w;break}}}}diff(p){const b=new Map,R=new Map,k=new Map;if(p.map.forEach((S,y)=>{const h=this.map.get(y),w=C(S,h);w&&b.set(y,w)}),this.map.forEach((S,y)=>{const h=p.map.get(y),w=C(S,h);w&&k.set(y,w)}),this.map.forEach((S,y)=>{const h=p.map.get(y),w=T(S,h);w&&R.set(y,w)}),!(b.size===0&&R.size===0&&k.size===0))return{added:b,changed:R,removed:k}}}e.MergedEnvironmentVariableCollection=D;function C(P,p){if(!p)return P;const b=new Set;p.forEach(k=>b.add(k.extensionIdentifier));const R=[];return P.forEach(k=>{b.has(k.extensionIdentifier)||R.push(k)}),R.length===0?void 0:R}function T(P,p){if(!p)return;const b=new Map;p.forEach(k=>b.set(k.extensionIdentifier,k));const R=[];return P.forEach(k=>{const S=b.get(k.extensionIdentifier);S&&(k.type!==S.type||k.value!==S.value)&&R.push(S)}),R.length===0?void 0:R}}),define(ve[120],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=v;function t(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=t;function D(T){return Array.from(T.entries()).map(P=>[P[0],v(P[1].map)])}e.serializeEnvironmentVariableCollections=D;function C(T){return new Map(T.map(P=>[P[0],{map:t(P[1])}]))}e.deserializeEnvironmentVariableCollections=C}),define(ve[245],we([1,0,6,56,3]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function C(c,u){if(!!u)if(D.isWindows)for(const r in u){let o=r;for(const i in c)if(r.toLowerCase()===i.toLowerCase()){o=i;break}const n=u[r];n!==void 0&&T(c,o,n)}else Object.keys(u).forEach(r=>{const o=u[r];o!==void 0&&T(c,r,o)})}e.mergeEnvironments=C;function T(c,u,r){typeof r=="string"?c[u]=r:delete c[u]}function P(c,u,r,o){c.TERM_PROGRAM="vscode",u&&(c.TERM_PROGRAM_VERSION=u),R(c,o)&&(c.LANG=k(r)),c.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function p(c,u){if(!!u)for(const r of Object.keys(u)){const o=u[r];o&&(c[r]=o)}}async function b(c,u){return await Promise.all(Object.entries(u).map(async([r,o])=>{if(typeof o=="string")try{u[r]=await c(o)}catch{u[r]=o}})),u}function R(c,u){if(u==="on")return!0;if(u==="auto"){const r=c.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function k(c){const u=c?c.split("-"):[],r=u.length;if(r===0)return"en_US.UTF-8";if(r===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};u[0]in o&&u.push(o[u[0]])}else u[1]=u[1].toUpperCase();return u.join("_")+".UTF-8"}e.getLangEnvVariable=k;async function S(c,u,r,o,n,i){if(c.cwd){const a=typeof c.cwd=="object"?c.cwd.fsPath:c.cwd,l=await y(a,r);return h(l||a)}let s;return!c.ignoreConfigurationCwd&&n&&(r&&(n=await y(n,r,i)),n&&(v.isAbsolute(n)?s=n:o&&(s=v.join(o.fsPath,n)))),s||(s=o?o.fsPath:u||""),h(s)}e.getCwd=S;async function y(c,u,r){if(u)try{return await u(c)}catch(o){r?.error("Could not resolve terminal cwd",o);return}return c}function h(c){return c.match(/$['"].*['"]^/)&&(c=c.substring(1,c.length-1)),D.OS===1&&c&&c[1]===":"?c[0].toUpperCase()+c.substr(1):c}function w(c,u,r){if(!!r)return o=>r.resolveWithEnvironment(u,c,o)}e.createVariableResolver=w;async function E(c,u,r,o,n,i,s,a=D.platform){let l;s&&(l=m(c,"automationShell",a)),l||(l=m(c,"shell",a));let d=l||u;if(a===3&&!r&&o){const I=v.join(o,"Sysnative").replace(/\//g,"\\").toLowerCase();d&&d.toLowerCase().indexOf(I)===0&&(d=v.join(o,"System32",d.substr(I.length+1)))}if(d&&a===3&&(d=d.replace(/\//g,"\\")),n)try{d=await n(d)}catch(I){i.error("Could not resolve shell",I)}return d}e.getDefaultShell=E;async function g(c,u,r,o,n=D.platform){if(u&&m(c,"automationShell",n))return[];const i=n===3?"windows":n===1?"osx":"linux";let s=c(`terminal.integrated.shellArgs.${i}`);if(!s)return[];if(typeof s=="string"&&n===3)return r?await r(s):s;if(r){const a=[];for(const l of s)try{a.push(await r(l))}catch(d){o.error(`Could not resolve terminal.integrated.shellArgs.${i}`,d),a.push(l)}s=a}return s}e.getDefaultShellArgs=g;function m(c,u,r=D.platform){return c(`terminal.integrated.${u}.${r===3?"windows":r===1?"osx":"linux"}`)}async function f(c,u,r,o,n,i){const s={};if(c.strictEnv)p(s,c.env);else{p(s,i);const a={...u};r&&(a&&await b(r,a),c.env&&await b(r,c.env)),(0,t.sanitizeProcessEnvironment)(s,"VSCODE_IPC_HOOK_CLI"),C(s,a),C(s,c.env),P(s,o,D.locale,n)}return s}e.createTerminalEnvironment=f}),define(ve[80],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(C){C.Delimiter="\0"})(v=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(T,P,p=T.parent){if(T.id===P)return new D([P]);const b=[T.id];for(let R=p;R&&R.id!==P;R=R.parent)b.push(R.id);return b.push(P),new D(b.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const P=T.indexOf("\0");return P===-1?T:T.slice(0,P)}static fromString(T){return new D(T.split("\0"))}static join(T,P){return new D([...T.path,P])}static joinToString(T,P){return T.toString()+"\0"+P}static compare(T,P){return T===P?0:P.startsWith(T+"\0")?2:T.startsWith(P+"\0")?3:1}constructor(T,P=T.length){if(this.path=T,this.viewEnd=P,T.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new D(this.path,T)}compare(T){if(typeof T=="string")return D.compare(this.toString(),T);for(let P=0;P<T.viewEnd&&P<this.viewEnd;P++)if(T.path[P]!==this.path[P])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=D}),define(ve[81],we([1,0,4,47]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var C;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(s){s.serialize=a=>({range:a.range.toJSON(),uri:a.uri.toJSON()}),s.deserialize=a=>({range:t.Range.lift(a.range),uri:v.URI.revive(a.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var P;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(P=e.TestMessageType||(e.TestMessageType={}));var p;(function(s){s.serialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&T.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&T.deserialize(a.location)})})(p=e.ITestErrorMessage||(e.ITestErrorMessage={}));var b;(function(s){s.serialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&T.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&T.deserialize(a.location)})})(b=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(s){s.serialize=a=>a.type===0?p.serialize(a):b.serialize(a),s.deserialize=a=>a.type===0?p.deserialize(a):b.deserialize(a)})(R=e.ITestMessage||(e.ITestMessage={}));var k;(function(s){s.serializeWithoutMessages=a=>({state:a.state,duration:a.duration,messages:[]}),s.serialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(R.serialize)}),s.deserialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(R.deserialize)})})(k=e.ITestTaskState||(e.ITestTaskState={}));const S="\0",y=(s,a)=>s+S+a;e.namespaceTestTag=y;const h=s=>{const a=s.indexOf(S);return{ctrlId:s.slice(0,a),tagId:s.slice(a+1)}};e.denamespaceTestTag=h;var w;(function(s){s.serialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?.toJSON(),range:a.range?.toJSON()||null,description:a.description,error:a.error,sortText:a.sortText}),s.deserialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?v.URI.revive(a.uri):void 0,range:a.range?t.Range.lift(a.range):null,description:a.description,error:a.error,sortText:a.sortText})})(w=e.ITestItem||(e.ITestItem={}));var E;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));var g;(function(s){s.serialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:w.serialize(a.item)}),s.deserialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:w.deserialize(a.item)})})(g=e.InternalTestItem||(e.InternalTestItem={}));var m;(function(s){s.serialize=a=>{let l;return a.item&&(l={},a.item.label!==void 0&&(l.label=a.item.label),a.item.tags!==void 0&&(l.tags=a.item.tags),a.item.busy!==void 0&&(l.busy=a.item.busy),a.item.uri!==void 0&&(l.uri=a.item.uri?.toJSON()),a.item.range!==void 0&&(l.range=a.item.range?.toJSON()),a.item.description!==void 0&&(l.description=a.item.description),a.item.error!==void 0&&(l.error=a.item.error),a.item.sortText!==void 0&&(l.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:l}},s.deserialize=a=>{let l;return a.item&&(l={},a.item.label!==void 0&&(l.label=a.item.label),a.item.tags!==void 0&&(l.tags=a.item.tags),a.item.busy!==void 0&&(l.busy=a.item.busy),a.item.range!==void 0&&(l.range=a.item.range?t.Range.lift(a.item.range):null),a.item.description!==void 0&&(l.description=a.item.description),a.item.error!==void 0&&(l.error=a.item.error),a.item.sortText!==void 0&&(l.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:l}}})(m=e.ITestItemUpdate||(e.ITestItemUpdate={}));const f=(s,a)=>{a.expand!==void 0&&(s.expand=a.expand),a.item!==void 0&&(s.item=s.item?Object.assign(s.item,a.item):a.item)};e.applyTestItemUpdate=f;var c;(function(s){s.serializeWithoutMessages=a=>({...g.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(k.serializeWithoutMessages),retired:a.retired}),s.serialize=a=>({...g.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(k.serialize),retired:a.retired})})(c=e.TestResultItem||(e.TestResultItem={}));var u;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var r;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(s){s.deserialize=a=>a.op===0?{op:a.op,item:g.deserialize(a.item)}:a.op===1?{op:a.op,item:m.deserialize(a.item)}:a.op===2?{op:a.op,uri:v.URI.revive(a.uri),docv:a.docv}:a,s.serialize=a=>a.op===0?{op:a.op,item:g.serialize(a.item)}:a.op===1?{op:a.op,item:m.serialize(a.item)}:a})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class n{add(a){}update(a){}remove(a,l){}complete(){}}e.IncrementalChangeCollector=n;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const l=this.createChangeCollector();for(const d of a)switch(d.op){case 0:{const I=g.deserialize(d.item);if(I.parent){if(this.items.has(I.parent)){const L=this.items.get(I.parent);L.children.add(I.item.extId);const B=this.createItem(I,L);this.items.set(I.item.extId,B),l.add(B)}}else{const L=this.createItem(I);this.roots.add(L),this.items.set(I.item.extId,L),l.add(L)}I.expand===2&&this.busyControllerCount++;break}case 1:{const I=m.deserialize(d.item),L=this.items.get(I.extId);if(!L)break;I.expand!==void 0&&(L.expand===2&&this.busyControllerCount--,I.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(L,I),l.update(L);break}case 3:{const I=this.items.get(d.itemId);if(!I)break;I.parent?this.items.get(I.parent).children.delete(I.item.extId):this.roots.delete(I);const L=[[d.itemId]];for(;L.length;)for(const B of L.pop()){const J=this.items.get(B);J&&(L.push(J.children),this.items.delete(B),l.remove(J,J!==I),J.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(d.itemId);break;case 4:this.updatePendingRoots(d.amount);break;case 6:this._tags.set(d.tag.id,d.tag);break;case 7:this._tags.delete(d.id);break}l.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new n}}e.AbstractIncrementalTestCollection=i}),define(ve[121],we([1,0,14,7,2,83,81,80]),function(oe,e,v,t,D,C,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var p;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(p=e.TestItemEventOp||(e.TestItemEventOp={}));const b=(g,m)=>g===m,R={range:(g,m)=>g===m?!0:!g||!m?!1:g.equalsRange(m),busy:b,label:b,description:b,error:b,tags:(g,m)=>!(g.length!==m.length||g.some(f=>!m.includes(f)))},k=(g,m)=>{let f;for(const[c,u]of Object.entries(R))u(g[c],m[c])||(f?f[c]=m[c]:f={[c]:m[c]});return f};class S extends D.Disposable{get root(){return this.options.root}constructor(m){super(),this.options=m,this.debounceSendDiff=this._register(new v.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(m){this._resolveHandler=m;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const m=this.diff;return this.diff=[],m}pushDiff(m){switch(m.op){case 2:{for(const f of this.diff)if(f.op===2&&f.uri===m.uri){f.docv=m.docv;return}break}case 1:{const f=this.diff[this.diff.length-1];if(f){if(f.op===1&&f.item.extId===m.item.extId){(0,T.applyTestItemUpdate)(f.item,m.item);return}if(f.op===0&&f.item.item.extId===m.item.extId){(0,T.applyTestItemUpdate)(f.item,m.item);return}}break}}this.diff.push(m),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(m,f){const c=this.tree.get(m);if(!!c){if((c.expandLevels===void 0||f>c.expandLevels)&&(c.expandLevels=f),c.expand===1){const u=this.resolveChildren(c);return u.isOpen()?this.expandChildren(c,f-1):u.wait().then(()=>this.expandChildren(c,f-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,f-1)):this.expandChildren(c,f-1)}}dispose(){for(const m of this.tree.values())this.options.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(m,f){switch(f.op){case 3:this.removeItem(P.TestId.joinToString(m.fullId,f.id));break;case 0:this.upsertItem(f.item,m);break;case 5:for(const c of f.ops)this.onTestItemEvent(m,c);break;case 1:this.diffTagRefs(f.new,f.old,m.fullId.toString());break;case 2:this.updateExpandability(m);break;case 4:this.pushDiff({op:1,item:{extId:m.fullId.toString(),item:f.update}});break;case 6:this.documentSynced(m.actual.uri);break;default:(0,C.assertNever)(f)}}documentSynced(m){m&&this.pushDiff({op:2,uri:m,docv:this.options.getDocumentVersion(m)})}upsertItem(m,f){const c=P.TestId.fromExtHostTestItem(m,this.root.id,f?.actual),u=this.options.getApiFor(m);u.parent&&u.parent!==f?.actual&&this.options.getChildren(u.parent).delete(m.id);let r=this.tree.get(c.toString());if(!r){r={fullId:c,actual:m,parent:f?c.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},m.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(m,f),this.pushDiff({op:0,item:{parent:r.parent&&r.parent.toString(),controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(m)}}),this.connectItemAndChildren(m,r,f);return}if(r.actual===m){this.connectItem(m,r,f);return}const o=this.options.getChildren(r.actual),n=r.actual,i=k(this.options.toITestItem(n),this.options.toITestItem(m));this.options.getApiFor(n).listener=void 0,r.actual=m,r.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(m.tags,n.tags,c.toString()),delete i.tags),this.onTestItemEvent(r,{op:4,update:i})),this.connectItemAndChildren(m,r,f);for(const[s,a]of o)this.options.getChildren(m).get(a.id)||this.removeItem(P.TestId.joinToString(c,a.id));this.documentSynced(r.actual.uri)}diffTagRefs(m,f,c){const u=new Set(f.map(r=>r.id));for(const r of m)u.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:c,item:{tags:m.map(r=>(0,T.namespaceTestTag)(this.options.controllerId,r.id))}}}),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(m){const f=this.tags.get(m.id);f?f.refCount++:(this.tags.set(m.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,m.id)}}))}decrementTagRefs(m){const f=this.tags.get(m);f&&!--f.refCount&&(this.tags.delete(m),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,m)}))}setItemParent(m,f){this.options.getApiFor(m).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(m,f,c){this.setItemParent(m,c);const u=this.options.getApiFor(m);u.parent=c?.actual,u.listener=r=>this.onTestItemEvent(f,r),this.updateExpandability(f)}connectItemAndChildren(m,f,c){this.connectItem(m,f,c);for(const[u,r]of this.options.getChildren(m))this.upsertItem(r,f)}updateExpandability(m){let f;this._resolveHandler?m.resolveBarrier?f=m.resolveBarrier.isOpen()?3:2:f=m.actual.canResolveChildren?1:0:f=0,f!==m.expand&&(m.expand=f,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:f}}),f===1&&m.expandLevels!==void 0&&this.resolveChildren(m))}expandChildren(m,f){if(f<0)return;const c=[];for(const[u,r]of this.options.getChildren(m.actual)){const o=this.expand(P.TestId.joinToString(m.fullId,r.id),f);(0,v.isThenable)(o)&&c.push(o)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this._resolveHandler){const r=new v.Barrier;return r.open(),r}m.expand=2,this.pushExpandStateUpdate(m);const f=m.resolveBarrier=new v.Barrier,c=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let u;try{u=this._resolveHandler(m.actual===this.root?void 0:m.actual)}catch(r){c(r)}return(0,v.isThenable)(u)?u.catch(c).then(()=>{f.open(),this.updateExpandability(m)}):(f.open(),this.updateExpandability(m)),m.resolveBarrier}pushExpandStateUpdate(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}removeItem(m){const f=this.tree.get(m);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:m});const c=[f];for(;c.length;){const u=c.pop();if(!!u){this.options.getApiFor(u.actual).listener=void 0;for(const r of u.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(u.fullId.toString());for(const[r,o]of this.options.getChildren(u.actual))c.push(this.tree.get(P.TestId.joinToString(u.fullId,o.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.diffOpEmitter.fire(m)}}e.TestItemCollection=S;class y extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.DuplicateTestItemError=y;class h extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class w extends Error{constructor(m,f,c){super(`TestItem with ID "${m}" is from controller "${f}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=w;const E=(g,m,f)=>{let c=new Map;return{get size(){return c.size},forEach(u,r){for(const o of c.values())u.call(r,o,this)},[Symbol.iterator](){return c.entries()},replace(u){const r=new Map,o=new Set(c.keys()),n={op:5,ops:[]};for(const i of u){if(!(i instanceof f))throw new h(i.id);const s=m(i).controllerId;if(s!==g.controllerId)throw new w(i.id,s,g.controllerId);if(r.has(i.id))throw new y(i.id);r.set(i.id,i),o.delete(i.id),n.ops.push({op:0,item:i})}for(const i of o.keys())n.ops.push({op:3,id:i});g.listener?.(n),c=r},add(u){if(!(u instanceof f))throw new h(u.id);c.set(u.id,u),g.listener?.({op:0,item:u})},delete(u){c.delete(u)&&g.listener?.({op:3,id:u})},get(u){return c.get(u)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=E}),define(ve[122],we([1,0,121]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,D=(T,P)=>{const p={controllerId:P};return t.set(T,p),p};e.createPrivateApiFor=D;const C=T=>{const P=t.get(T);if(!P)throw new v.InvalidTestItemError(T?.id||"<unknown>");return P};e.getPrivateApiFor=C}),define(ve[246],we([1,0,25,5]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(v.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ve[123],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,v.createDecorator)("configurationResolverService");var t;(function(C){C.Unknown="unknown",C.Env="env",C.Config="config",C.Command="command",C.Input="input",C.ExtensionInstallFolder="extensionInstallFolder",C.WorkspaceFolder="workspaceFolder",C.Cwd="cwd",C.WorkspaceFolderBasename="workspaceFolderBasename",C.UserHome="userHome",C.LineNumber="lineNumber",C.SelectedText="selectedText",C.File="file",C.FileWorkspaceFolder="fileWorkspaceFolder",C.RelativeFile="relativeFile",C.RelativeFileDirname="relativeFileDirname",C.FileDirname="fileDirname",C.FileExtname="fileExtname",C.FileBasename="fileBasename",C.FileBasenameNoExtension="fileBasenameNoExtension",C.FileDirnameBasename="fileDirnameBasename",C.ExecPath="execPath",C.ExecInstallFolder="execInstallFolder",C.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(T,P){super(P),this.variable=T}}e.VariableError=D}),define(ve[247],we([1,0,6,28,11,22,3,152,185,123,15]),function(oe,e,v,t,D,C,T,P,p,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(y,h,w,E){this._contributedVariables=new Map,this._context=y,this._labelService=h,this._userHomePromise=w,E&&(this._envVariablesPromise=E.then(g=>this.prepareEnv(g)))}prepareEnv(y){if(T.isWindows){const h=Object.create(null);return Object.keys(y).forEach(w=>{h[w.toLowerCase()]=y[w]}),h}return y}resolveWithEnvironment(y,h,w){return this.recursiveResolve({env:this.prepareEnv(y),userHome:void 0},h?h.uri:void 0,w)}async resolveAsync(y,h){const w={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(w,y?y.uri:void 0,h)}async resolveAnyBase(y,h,w,E){const g=C.deepClone(h);T.isWindows&&g.windows?Object.keys(g.windows).forEach(f=>g[f]=g.windows[f]):T.isMacintosh&&g.osx?Object.keys(g.osx).forEach(f=>g[f]=g.osx[f]):T.isLinux&&g.linux&&Object.keys(g.linux).forEach(f=>g[f]=g.linux[f]),delete g.windows,delete g.osx,delete g.linux;const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,y?y.uri:void 0,g,w,E)}async resolveAnyAsync(y,h,w){return this.resolveAnyBase(y,h,w)}async resolveAnyMap(y,h,w){const E=new Map;return{newConfig:await this.resolveAnyBase(y,h,w,E),resolvedVariables:E}}resolveWithInteractionReplace(y,h,w,E){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,h,w,E){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,h){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,h)}async recursiveResolve(y,h,w,E,g){if(D.isString(w))return this.resolveString(y,h,w,E,g);if(Array.isArray(w))return Promise.all(w.map(m=>this.recursiveResolve(y,h,m,E,g)));if(D.isObject(w)){const m=Object.create(null),f=await Promise.all(Object.keys(w).map(async c=>[await this.resolveString(y,h,c,E,g),await this.recursiveResolve(y,h,w[c],E,g)]));for(const[c,u]of f)m[c]=u;return m}return w}resolveString(y,h,w,E,g){return(0,R.replaceAsync)(w,k.VARIABLE_REGEXP,async(m,f)=>{if(f.includes(k.VARIABLE_LHS))return m;let c=await this.evaluateSingleVariable(y,m,f,h,E);return g?.set(f,c),c!==m&&D.isString(c)&&c.match(k.VARIABLE_REGEXP)&&(c=await this.resolveString(y,h,c,E,g)),c})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}async evaluateSingleVariable(y,h,w,E,g){let m;const f=w.split(":");f.length>1&&(w=f[0],m=f[1]);const c=o=>{const n=this._context.getFilePath();if(n)return n;throw new b.VariableError(o,(0,p.localize)(0,null,h))},u=o=>{const n=c(o);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new b.VariableError(o,(0,p.localize)(1,null,h,v.basename(n)))},r=o=>{if(m){const n=this._context.getFolderUri(m);if(n)return n;throw new b.VariableError(o,(0,p.localize)(2,null,h,m))}if(E)return E;throw this._context.getWorkspaceFolderCount()>1?new b.VariableError(o,(0,p.localize)(3,null,h)):new b.VariableError(o,(0,p.localize)(4,null,h))};switch(w){case"env":if(m){if(y.env){const o=y.env[T.isWindows?m.toLowerCase():m];if(D.isString(o))return o}return""}throw new b.VariableError(b.VariableKind.Env,(0,p.localize)(5,null,h));case"config":if(m){const o=this._context.getConfigurationValue(E,m);if(D.isUndefinedOrNull(o))throw new b.VariableError(b.VariableKind.Config,(0,p.localize)(6,null,h,m));if(D.isObject(o))throw new b.VariableError(b.VariableKind.Config,(0,p.localize)(7,null,h,m));return o}throw new b.VariableError(b.VariableKind.Config,(0,p.localize)(8,null,h));case"command":return this.resolveFromMap(b.VariableKind.Command,h,m,g,"command");case"input":return this.resolveFromMap(b.VariableKind.Input,h,m,g,"input");case"extensionInstallFolder":if(m){const o=await this._context.getExtension(m);if(!o)throw new b.VariableError(b.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,h,m));return this.fsPath(o.extensionLocation)}throw new b.VariableError(b.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,h));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(r(b.VariableKind.WorkspaceFolder)));case"cwd":return E||m?(0,P.normalizeDriveLetter)(this.fsPath(r(b.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(r(b.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(y.userHome)return y.userHome;throw new b.VariableError(b.VariableKind.UserHome,(0,p.localize)(11,null,h))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new b.VariableError(b.VariableKind.LineNumber,(0,p.localize)(12,null,h))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new b.VariableError(b.VariableKind.SelectedText,(0,p.localize)(13,null,h))}case"file":return c(b.VariableKind.File);case"fileWorkspaceFolder":return u(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return E||m?v.relative(this.fsPath(r(b.VariableKind.RelativeFile)),c(b.VariableKind.RelativeFile)):c(b.VariableKind.RelativeFile);case"relativeFileDirname":{const o=v.dirname(c(b.VariableKind.RelativeFileDirname));if(E||m){const n=v.relative(this.fsPath(r(b.VariableKind.RelativeFileDirname)),o);return n.length===0?".":n}return o}case"fileDirname":return v.dirname(c(b.VariableKind.FileDirname));case"fileExtname":return v.extname(c(b.VariableKind.FileExtname));case"fileBasename":return v.basename(c(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=v.basename(c(b.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-v.extname(o).length)}case"fileDirnameBasename":return v.basename(v.dirname(c(b.VariableKind.FileDirnameBasename)));case"execPath":{const o=this._context.getExecPath();return o||h}case"execInstallFolder":{const o=this._context.getAppRoot();return o||h}case"pathSeparator":return v.sep;default:try{const o=m?`${w}:${m}`:w;return this.resolveFromMap(b.VariableKind.Unknown,h,o,g,void 0)}catch{return h}}}}resolveFromMap(y,h,w,E,g){if(w&&E){const m=g===void 0?E[w]:E[g+":"+w];if(typeof m=="string")return m;throw new b.VariableError(y,(0,p.localize)(14,null,h))}return h}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[248],we([1,0,5,79]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,v.createDecorator)("editorGroupsService");var D;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var C;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var P;(function(h){h[h.MAXIMIZE=0]="MAXIMIZE",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var p;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(p=e.MergeGroupMode||(e.MergeGroupMode={}));function b(h){const w=h;return(0,t.isEditorInput)(w?.editor)&&(0,t.isEditorInput)(w?.replacement)}e.isEditorReplacement=b;var R;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function S(h){const w=h;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=S;function y(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=y}),define(ve[124],we([1,0,5,248]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,v.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(C){const T=C;return typeof C=="number"||(0,t.isEditorGroup)(T)}e.isPreferredGroup=D}),define(ve[249],we([1,0,11,246,13,106,78,120,123,79,124,12,205,119]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let h=class{get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}constructor(E,g,m,f,c,u,r,o,n,i){this._remoteAuthority=E,this._channel=g,this._configurationService=m,this._workspaceContextService=f,this._resolverService=c,this._environmentVariableService=u,this._remoteAuthorityResolverService=r,this._logService=o,this._editorService=n,this._labelService=i}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(E,g,m,f,c,u,r,o){await this._configurationService.whenRemoteConfigurationLoaded();const n=Object.create(null),i=m?(0,v.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(m)):void 0;let s;try{s=(await this._resolverService.resolveAnyMap(i,{shellLaunchConfig:E,configuration:g})).resolvedVariables}catch(_){this._logService.error(_)}if(s)for(const[_,te]of s.entries())(/^config:/.test(_)||_==="selectedText"||_==="lineNumber")&&(n[_]=te);const a=[];for(const[_,te]of this._environmentVariableService.collections.entries())a.push([_,(0,P.serializeEnvironmentVariableCollection)(te.map)]);const l=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),d=l.options&&l.options.extensionHostEnv,I=this._workspaceContextService.getWorkspace(),L=I.folders,B=m?this._workspaceContextService.getWorkspaceFolder(m):null,J=b.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:b.SideBySideEditor.PRIMARY,filterByScheme:[k.Schemas.file,k.Schemas.vscodeUserData,k.Schemas.vscodeRemote]}),Z={configuration:g,resolvedVariables:n,envVariableCollections:a,shellLaunchConfig:E,workspaceId:I.id,workspaceName:this._labelService.getWorkspaceLabel(I),workspaceFolders:L,activeWorkspaceFolder:B,activeFileResource:J,shouldPersistTerminal:c,options:f,cols:u,rows:r,unicodeVersion:o,resolverEnv:d};return await this._channel.call("$createProcess",Z)}requestDetachInstance(E,g){return this._channel.call("$requestDetachInstance",[E,g])}acceptDetachInstanceReply(E,g){return this._channel.call("$acceptDetachInstanceReply",[E,g])}attachToProcess(E){return this._channel.call("$attachToProcess",[E])}detachFromProcess(E,g){return this._channel.call("$detachFromProcess",[E,g])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(E,g){return this._channel.call("$processBinary",[E,g])}start(E){return this._channel.call("$start",[E])}input(E,g){return this._channel.call("$input",[E,g])}acknowledgeDataEvent(E,g){return this._channel.call("$acknowledgeDataEvent",[E,g])}setUnicodeVersion(E,g){return this._channel.call("$setUnicodeVersion",[E,g])}shutdown(E,g){return this._channel.call("$shutdown",[E,g])}resize(E,g,m){return this._channel.call("$resize",[E,g,m])}getInitialCwd(E){return this._channel.call("$getInitialCwd",[E])}getCwd(E){return this._channel.call("$getCwd",[E])}orphanQuestionReply(E){return this._channel.call("$orphanQuestionReply",[E])}sendCommandResult(E,g,m){return this._channel.call("$sendCommandResult",[E,g,m])}freePortKillProcess(E,g){return this._channel.call("$freePortKillProcess",[E,g])}installAutoReply(E,g){return this._channel.call("$installAutoReply",[E,g])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(E){return this._channel.call("$getDefaultSystemShell",[E])}getProfiles(E,g,m){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,E,g,m])}acceptPtyHostResolvedVariables(E,g){return this._channel.call("$acceptPtyHostResolvedVariables",[E,g])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(E){return this._channel.call("$getWslPath",[E])}setTerminalLayoutInfo(E){const m={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:E?E.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",m)}updateTitle(E,g,m){return this._channel.call("$updateTitle",[E,g,m])}updateIcon(E,g,m,f){return this._channel.call("$updateIcon",[E,g,m,f])}refreshProperty(E,g){return this._channel.call("$refreshProperty",[E,g])}updateProperty(E,g,m){return this._channel.call("$updateProperty",[E,g,m])}getTerminalLayoutInfo(){const g={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",g)}reviveTerminalProcesses(E,g){return this._channel.call("$reviveTerminalProcesses",[E,g])}getRevivedPtyNewId(E){return this._channel.call("$getRevivedPtyNewId",[E])}serializeTerminalState(E){return this._channel.call("$serializeTerminalState",[E])}};h=Ae([_e(2,t.IWorkbenchConfigurationService),_e(3,T.IWorkspaceContextService),_e(4,p.IConfigurationResolverService),_e(5,y.IEnvironmentVariableService),_e(6,C.IRemoteAuthorityResolverService),_e(7,D.ILogService),_e(8,R.IEditorService),_e(9,S.ILabelService)],h),e.RemoteTerminalChannelClient=h}),define(ve[250],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var v;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(v=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(k){k[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class C{constructor(){this.type=3}serialize(k){k[C.ENV_KEY]="1"}}e.MessagePortExtHostConnection=C,C.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function T(R){delete R[t.ENV_KEY],delete R[D.ENV_KEY],delete R[C.ENV_KEY]}function P(R,k){T(k),R.serialize(k)}e.writeExtHostConnection=P;function p(R){if(R[t.ENV_KEY])return b(R,new t(R[t.ENV_KEY]));if(R[D.ENV_KEY])return b(R,new D);if(R[C.ENV_KEY])return b(R,new C);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=p;function b(R,k){return T(R),k}}),define(ve[125],we([1,0,49,85,116,12,6,16,7,57,77,13,43,3,56,115,2,250]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function m(n={},i,s,a,l){const d=await(0,D.getNLSConfiguration)(s,a.userDataPath);let I={};if(i)try{I=await(0,R.getResolvedShellEnv)(l,a.args,process.env)}catch(te){l.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",te)}const B={...process.env,...I,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(d,void 0,0),...n},J=a.isBuilt?(0,T.join)(a.appRoot,"bin"):(0,T.join)(a.appRoot,"resources","server","bin-dev"),Z=(0,T.join)(J,"remote-cli");let _=u(B,"PATH");return _?_=Z+T.delimiter+_:_=Z,r(B,"PATH",_),a.args["without-browser-env-var"]||(B.BROWSER=(0,T.join)(J,"helpers",y.isWindows?"browser.cmd":"browser.sh")),o(B),B}e.buildUserEnvironment=m;class f{constructor(i,s){this.socket=i,this.initialDataChunk=s}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let i,s,a;return this.socket instanceof b.NodeSocket?(i=!0,s=!1,a=P.VSBuffer.alloc(0)):(i=!1,s=this.socket.permessageDeflate,a=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:i,permessageDeflate:s,inflateBytes:a.buffer.toString("base64")}}}let c=class{constructor(i,s,a,l,d,I,L){this._reconnectionToken=i,this._environmentService=d,this._logService=I,this._extensionHostStatusService=L,this._onClose=new p.Emitter,this.onClose=this._onClose.event,this._canSendSocket=!y.isWindows||!this._environmentService.args["socket-path"],this._disposed=!1,this._remoteAddress=s,this._extensionHostProcess=null,this._connectionData=new f(a,l),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(i){this._logService.info(`${this._logPrefix}${i}`)}_logError(i){this._logService.error(`${this._logPrefix}${i}`)}async _pipeSockets(i,s){const a=new E.DisposableStore;a.add(s.socket),a.add((0,E.toDisposable)(()=>{i.destroy()}));const l=()=>{a.dispose()};a.add(s.socket.onEnd(l)),a.add(s.socket.onClose(l)),a.add(p.Event.fromNodeEventEmitter(i,"end")(l)),a.add(p.Event.fromNodeEventEmitter(i,"close")(l)),a.add(p.Event.fromNodeEventEmitter(i,"error")(l)),a.add(s.socket.onData(d=>i.write(d.buffer))),a.add(p.Event.fromNodeEventEmitter(i,"data")(d=>{s.socket.write(P.VSBuffer.wrap(d))})),s.initialDataChunk.byteLength>0&&i.write(s.initialDataChunk.buffer)}async _sendSocketToExtensionHost(i,s){await s.socketDrain();const a=s.toIExtHostSocketMessage();let l;s.socket instanceof b.NodeSocket?l=s.socket.socket:l=s.socket.socket.socket,i.send(a,l)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const i={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(i)}acceptReconnection(i,s,a){this._remoteAddress=i,this._log("The client has reconnected.");const l=new f(s,a);if(!this._extensionHostProcess){this._connectionData=l;return}this._sendSocketToExtensionHost(this._extensionHostProcess,l)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(i){try{let s=[];i.port&&!process.pkg&&(s=[`--inspect${i.break?"-brk":""}=${i.port}`]);const a=await m(i.env,!0,i.language,this._environmentService,this._logService);(0,h.removeDangerousEnvVariables)(a);let l;if(this._canSendSocket)(0,g.writeExtHostConnection)(new g.SocketExtHostConnection,a),l=null;else{const{namedPipeServer:_,pipeName:te}=await this._listenOnPipe();(0,g.writeExtHostConnection)(new g.IPCExtHostConnection(te),a),l=_}const d={env:a,execArgv:s,silent:!0},I=["--type=extensionHost","--transformURIs"],L=this._environmentService.args["use-host-proxy"];I.push(`--useHostProxy=${L?"true":"false"}`),this._extensionHostProcess=v.fork(C.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,I,d);const B=this._extensionHostProcess.pid;this._log(`<${B}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const J=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),Z=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");if(J(_=>this._log(`<${B}> ${_}`)),Z(_=>this._log(`<${B}><stderr> ${_}`)),this._extensionHostProcess.on("error",_=>{this._logError(`<${B}> Extension Host Process had an error`),this._logService.error(_),this._cleanResources()}),this._extensionHostProcess.on("exit",(_,te)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:_,signal:te}),this._log(`<${B}> Extension Host Process exited with code: ${_}, signal: ${te}.`),this._cleanResources()}),l)l.on("connection",_=>{l.close(),this._pipeSockets(_,this._connectionData)});else{const _=te=>{te.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",_),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",_)}}catch(s){console.error("ExtensionHostConnection errored"),s&&console.error(s)}}_listenOnPipe(){return new Promise((i,s)=>{const a=(0,b.createRandomIPCHandle)(),l=t.createServer();l.on("error",s),l.listen(a,()=>{l?.removeListener("error",s),i({pipeName:a,namedPipeServer:l})})})}};c=Ae([_e(4,S.IServerEnvironmentService),_e(5,k.ILogService),_e(6,w.IExtensionHostStatusService)],c),e.ExtensionHostConnection=c;function u(n,i){const s=Object.keys(n).filter(l=>l.toLowerCase()===i.toLowerCase()),a=s.length>0?s[0]:i;return n[a]}function r(n,i,s){const a=Object.keys(n).filter(d=>d.toLowerCase()===i.toLowerCase()),l=a.length>0?a[0]:i;n[l]=s}function o(n){for(const i of Object.keys(n))n[i]===null&&delete n[i]}}),define(ve[251],we([1,0,7,4,5,35,32]),function(oe,e,v,t,D,C,T){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class p{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=p;class b{constructor(){this.kind=2,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=b;class R{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class k{constructor(a){this.dependency=a}}e.MissingExtensionDependency=k;var S;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=y;class h{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(a,l){const d=[],I=[],L=[],B=[],J=g(this._allExtensions),Z=g(a),_=(fe,j)=>fe.extensionLocation.toString()===j.extensionLocation.toString()||fe.isBuiltin===j.isBuiltin||fe.isUserBuiltin===j.isUserBuiltin||fe.isUnderDevelopment===j.isUnderDevelopment;for(const fe of this._allExtensions){const j=Z.get(C.ExtensionIdentifier.toKey(fe.identifier));if(!j){d.push(fe.identifier),J.delete(C.ExtensionIdentifier.toKey(fe.identifier));continue}if(!_(fe,j)){d.push(fe.identifier),J.delete(C.ExtensionIdentifier.toKey(fe.identifier));continue}}for(const fe of a){const j=J.get(C.ExtensionIdentifier.toKey(fe.identifier));if(!j){I.push(fe);continue}if(!_(j,fe)){d.push(j.identifier),J.delete(C.ExtensionIdentifier.toKey(j.identifier));continue}}const te=E(this._myExtensions),se=E(l);for(const fe of this._myExtensions)se.has(C.ExtensionIdentifier.toKey(fe))||L.push(fe);for(const fe of l)te.has(C.ExtensionIdentifier.toKey(fe))||B.push(fe);const W={toRemove:d,toAdd:I,myToRemove:L,myToAdd:B};return this.delta(W),W}delta(a){const{toRemove:l,toAdd:d,myToRemove:I,myToAdd:L}=a,B=E(l),J=E(I);for(let Z=0;Z<this._allExtensions.length;Z++)B.has(C.ExtensionIdentifier.toKey(this._allExtensions[Z].identifier))&&(this._allExtensions.splice(Z,1),Z--);for(let Z=0;Z<this._myExtensions.length;Z++)J.has(C.ExtensionIdentifier.toKey(this._myExtensions[Z]))&&(this._myExtensions.splice(Z,1),Z--);for(const Z of d)this._allExtensions.push(Z);for(const Z of L)this._myExtensions.push(Z)}containsExtension(a){for(const l of this._myExtensions)if(C.ExtensionIdentifier.equals(l,a))return!0;return!1}}e.ExtensionHostExtensions=h;class w{constructor(a){if(this[P]="ExtensionIdentifierSet",this._map=new Map,this._toKey=C.ExtensionIdentifier.toKey,a)for(const l of a)this.add(l)}get size(){return this._map.size}add(a){return this._map.set(this._toKey(a),a),this}clear(){this._map.clear()}delete(a){return this._map.delete(this._toKey(a))}has(a){return this._map.has(this._toKey(a))}forEach(a,l){this._map.forEach(d=>a.call(l,d,d,this))}*entries(){for(const[a,l]of this._map)yield[l,l]}keys(){return this._map.values()}values(){return this._map.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=w;function E(s){const a=new Set;for(const l of s)a.add(C.ExtensionIdentifier.toKey(l));return a}e.extensionIdentifiersArrayToSet=E;function g(s){const a=new Map;for(const l of s)a.set(C.ExtensionIdentifier.toKey(l.identifier),l);return a}function m(s,a){return s.enabledApiProposals?s.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=m;function f(s,a){if(!m(s,a))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=f;class c{constructor(a,l,d,I){this.codeLoadingTime=a,this.activateCallTime=l,this.activateResolvedTime=d,this.activationReason=I}}e.ActivationTimes=c;class u{constructor(a,l){this.description=a,this.value=l}}e.ExtensionPointContribution=u,e.ExtensionHostLogFileName="exthost";var r;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function o(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function n(s,a){return{identifier:new C.ExtensionIdentifier((0,T.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!a,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=n;class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,l){return Promise.resolve(0)}getInspectPorts(a,l){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,l){return Promise.resolve()}}e.NullExtensionService=i});var _t=this&&this.__classPrivateFieldSet||function(oe,e,v,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!D:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(oe,v):D?D.value=v:e.set(oe,v),v},nt=this&&this.__classPrivateFieldGet||function(oe,e,v,t){if(v==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?t:v==="a"?t.call(oe):t?t.value:e.get(oe)};define(ve[126],we([1,0,18,10,90,24,66,15,11,4,23,17,106,118,251]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h){"use strict";var w,E,g,m,f,c,u,r,o,n,i,s,a,l,d,I,L,B,J,Z,_,te,se;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function W(N){function A(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(A,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(A,N),Object.setPrototypeOf(A.prototype,N.prototype),A}let fe=c=class{static from(...A){let ne=A;return new c(function(){if(ne){for(const ge of ne)ge&&typeof ge.dispose=="function"&&ge.dispose();ne=void 0}})}constructor(A){w.set(this,void 0),_t(this,w,A,"f")}dispose(){typeof nt(this,w,"f")=="function"&&(nt(this,w,"f").call(this),_t(this,w,void 0,"f"))}};w=new WeakMap,fe=c=Ae([W],fe),e.Disposable=fe;let j=u=class{static Min(...A){if(A.length===0)throw new TypeError;let ne=A[0];for(let ge=1;ge<A.length;ge++){const Ue=A[ge];Ue.isBefore(ne)&&(ne=Ue)}return ne}static Max(...A){if(A.length===0)throw new TypeError;let ne=A[0];for(let ge=1;ge<A.length;ge++){const Ue=A[ge];Ue.isAfter(ne)&&(ne=Ue)}return ne}static isPosition(A){if(!A)return!1;if(A instanceof u)return!0;const{line:ne,character:ge}=A;return typeof ne=="number"&&typeof ge=="number"}static of(A){if(A instanceof u)return A;if(this.isPosition(A))return new u(A.line,A.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(A,ne){if(A<0)throw(0,t.illegalArgument)("line must be non-negative");if(ne<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=A,this._character=ne}isBefore(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<A._character}isBeforeOrEqual(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<=A._character}isAfter(A){return!this.isBeforeOrEqual(A)}isAfterOrEqual(A){return!this.isBefore(A)}isEqual(A){return this._line===A._line&&this._character===A._character}compareTo(A){return this._line<A._line?-1:this._line>A.line?1:this._character<A._character?-1:this._character>A._character?1:0}translate(A,ne=0){if(A===null||ne===null)throw(0,t.illegalArgument)();let ge;return typeof A>"u"?ge=0:typeof A=="number"?ge=A:(ge=typeof A.lineDelta=="number"?A.lineDelta:0,ne=typeof A.characterDelta=="number"?A.characterDelta:0),ge===0&&ne===0?this:new u(this.line+ge,this.character+ne)}with(A,ne=this.character){if(A===null||ne===null)throw(0,t.illegalArgument)();let ge;return typeof A>"u"?ge=this.line:typeof A=="number"?ge=A:(ge=typeof A.line=="number"?A.line:this.line,ne=typeof A.character=="number"?A.character:this.character),ge===this.line&&ne===this.character?this:new u(ge,ne)}toJSON(){return{line:this.line,character:this.character}}};j=u=Ae([W],j),e.Position=j;let X=r=class{static isRange(A){return A instanceof r?!0:A?j.isPosition(A.start)&&j.isPosition(A.end):!1}static of(A){if(A instanceof r)return A;if(this.isRange(A))return new r(A.start,A.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(A,ne,ge,Ue){let He,Je;if(typeof A=="number"&&typeof ne=="number"&&typeof ge=="number"&&typeof Ue=="number"?(He=new j(A,ne),Je=new j(ge,Ue)):j.isPosition(A)&&j.isPosition(ne)&&(He=j.of(A),Je=j.of(ne)),!He||!Je)throw new Error("Invalid arguments");He.isBefore(Je)?(this._start=He,this._end=Je):(this._start=Je,this._end=He)}contains(A){return r.isRange(A)?this.contains(A.start)&&this.contains(A.end):j.isPosition(A)?!(j.of(A).isBefore(this._start)||this._end.isBefore(A)):!1}isEqual(A){return this._start.isEqual(A._start)&&this._end.isEqual(A._end)}intersection(A){const ne=j.Max(A.start,this._start),ge=j.Min(A.end,this._end);if(!ne.isAfter(ge))return new r(ne,ge)}union(A){if(this.contains(A))return this;if(A.contains(this))return A;const ne=j.Min(A.start,this._start),ge=j.Max(A.end,this.end);return new r(ne,ge)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(A,ne=this.end){if(A===null||ne===null)throw(0,t.illegalArgument)();let ge;return A?j.isPosition(A)?ge=A:(ge=A.start||this.start,ne=A.end||this.end):ge=this.start,ge.isEqual(this._start)&&ne.isEqual(this.end)?this:new r(ge,ne)}toJSON(){return[this.start,this.end]}};X=r=Ae([W],X),e.Range=X;let O=o=class extends X{static isSelection(A){return A instanceof o?!0:A?X.isRange(A)&&j.isPosition(A.anchor)&&j.isPosition(A.active)&&typeof A.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(A,ne,ge,Ue){let He,Je;if(typeof A=="number"&&typeof ne=="number"&&typeof ge=="number"&&typeof Ue=="number"?(He=new j(A,ne),Je=new j(ge,Ue)):j.isPosition(A)&&j.isPosition(ne)&&(He=j.of(A),Je=j.of(ne)),!He||!Je)throw new Error("Invalid arguments");super(He,Je),this._anchor=He,this._active=Je}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=o=Ae([W],O),e.Selection=O;class U{constructor(A,ne,ge){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,t.illegalArgument)("port");if(typeof ge<"u"&&(typeof ge!="string"||ge.length===0||!/^[0-9A-Za-z\-]+$/.test(ge)))throw(0,t.illegalArgument)("connectionToken");this.host=A,this.port=Math.round(ne),this.connectionToken=ge}}e.ResolvedAuthority=U;class x extends Error{static NotAvailable(A,ne){return new x(A,S.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(A){return new x(A,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(A,ne=S.RemoteAuthorityResolverErrorCode.Unknown,ge){super(A),this._message=A,this._code=ne,this._detail=ge,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}}e.RemoteAuthorityResolverError=x;var ae;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(ae=e.EndOfLine||(e.EndOfLine={}));var ue;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(ue=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Q=n=class{static isTextEdit(A){return A instanceof n?!0:A?X.isRange(A)&&typeof A.newText=="string":!1}static replace(A,ne){return new n(A,ne)}static insert(A,ne){return n.replace(new X(A,A),ne)}static delete(A){return n.replace(A,"")}static setEndOfLine(A){const ne=new n(new X(new j(0,0),new j(0,0)),"");return ne.newEol=A,ne}get range(){return this._range}set range(A){if(A&&!X.isRange(A))throw(0,t.illegalArgument)("range");this._range=A}get newText(){return this._newText||""}set newText(A){if(A&&typeof A!="string")throw(0,t.illegalArgument)("newText");this._newText=A}get newEol(){return this._newEol}set newEol(A){if(A&&typeof A!="number")throw(0,t.illegalArgument)("newEol");this._newEol=A}constructor(A,ne){this._range=A,this._newText=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Q=n=Ae([W],Q),e.TextEdit=Q;let re=i=class{static isNotebookCellEdit(A){return A instanceof i?!0:A?kt.isNotebookRange(A)&&Array.isArray(A.newCells):!1}static replaceCells(A,ne){return new i(A,ne)}static insertCells(A,ne){return new i(new kt(A,A),ne)}static deleteCells(A){return new i(A,[])}static updateCellMetadata(A,ne){const ge=new i(new kt(A,A),[]);return ge.newCellMetadata=ne,ge}static updateNotebookMetadata(A){const ne=new i(new kt(0,0),[]);return ne.newNotebookMetadata=A,ne}constructor(A,ne){this.range=A,this.newCells=ne}};re=i=Ae([W],re),e.NotebookEdit=re;class F{static isSnippetTextEdit(A){return A instanceof F?!0:A?X.isRange(A.range)&&ie.isSnippetString(A.snippet):!1}static replace(A,ne){return new F(A,ne)}static insert(A,ne){return F.replace(new X(A,A),ne)}constructor(A,ne){this.range=A,this.snippet=ne}}e.SnippetTextEdit=F;var M;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace",N[N.Snippet=6]="Snippet"})(M=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(A,ne,ge,Ue){this._edits.push({_type:1,from:A,to:ne,options:ge,metadata:Ue})}createFile(A,ne,ge){this._edits.push({_type:1,from:void 0,to:A,options:ne,metadata:ge})}deleteFile(A,ne,ge){this._edits.push({_type:1,from:A,to:void 0,options:ne,metadata:ge})}replaceNotebookMetadata(A,ne,ge){this._edits.push({_type:3,metadata:ge,uri:A,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(A,ne,ge,Ue){const He=ne.start,Je=ne.end;(He!==Je||ge.length>0)&&this._edits.push({_type:5,uri:A,index:He,count:Je-He,cells:ge,metadata:Ue})}replaceNotebookCellMetadata(A,ne,ge,Ue){this._edits.push({_type:3,metadata:Ue,uri:A,edit:{editType:8,index:ne,metadata:ge}})}replace(A,ne,ge,Ue){this._edits.push({_type:2,uri:A,edit:new Q(ne,ge),metadata:Ue})}insert(A,ne,ge,Ue){this.replace(A,new X(ne,ne),ge,Ue)}delete(A,ne,ge){this.replace(A,ne,"",ge)}has(A){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===A.toString())}set(A,ne){if(ne)for(const ge of ne){if(!ge)continue;let Ue,He;Array.isArray(ge)?(Ue=ge[0],He=ge[1]):Ue=ge,re.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.replaceNotebookCellMetadata(A,Ue.range.start,Ue.newCellMetadata,He):Ue.newNotebookMetadata?this.replaceNotebookMetadata(A,Ue.newNotebookMetadata,He):this.replaceNotebookCells(A,Ue.range,Ue.newCells,He):F.isSnippetTextEdit(Ue)?this._edits.push({_type:6,uri:A,range:Ue.range,edit:Ue.snippet,metadata:He}):this._edits.push({_type:2,uri:A,edit:Ue,metadata:He})}else{for(let ge=0;ge<this._edits.length;ge++){const Ue=this._edits[ge];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===A.toString()&&(this._edits[ge]=void 0);break}}(0,v.coalesceInPlace)(this._edits)}}get(A){const ne=[];for(const ge of this._edits)ge._type===2&&ge.uri.toString()===A.toString()&&ne.push(ge.edit);return ne}entries(){const A=new C.ResourceMap;for(const ne of this._edits)if(ne._type===2){let ge=A.get(ne.uri);ge||(ge=[ne.uri,[]],A.set(ne.uri,ge)),ge[1].push(ne.edit)}return[...A.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=Ae([W],G),e.WorkspaceEdit=G;let ie=s=class{static isSnippetString(A){return A instanceof s?!0:A?typeof A.value=="string":!1}static _escape(A){return A.replace(/\$|}|\\/g,"\\$&")}constructor(A){this._tabstop=1,this.value=A||""}appendText(A){return this.value+=s._escape(A),this}appendTabstop(A=this._tabstop++){return this.value+="$",this.value+=A,this}appendPlaceholder(A,ne=this._tabstop++){if(typeof A=="function"){const ge=new s;ge._tabstop=this._tabstop,A(ge),this._tabstop=ge._tabstop,A=ge.value}else A=s._escape(A);return this.value+="${",this.value+=ne,this.value+=":",this.value+=A,this.value+="}",this}appendChoice(A,ne=this._tabstop++){const ge=A.map(Ue=>Ue.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ge,this.value+="|}",this}appendVariable(A,ne){if(typeof ne=="function"){const ge=new s;ge._tabstop=this._tabstop,ne(ge),this._tabstop=ge._tabstop,ne=ge.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=A,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};ie=s=Ae([W],ie),e.SnippetString=ie;var he;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(he=e.DiagnosticTag||(e.DiagnosticTag={}));var Ee;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(Ee=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let $=a=class{static isLocation(A){return A instanceof a?!0:A?X.isRange(A.range)&&b.URI.isUri(A.uri):!1}constructor(A,ne){if(this.uri=A,ne)if(X.isRange(ne))this.range=X.of(ne);else if(j.isPosition(ne))this.range=new X(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};$=a=Ae([W],$),e.Location=$;let Y=class{static is(A){return A?typeof A.message=="string"&&A.location&&X.isRange(A.location.range)&&b.URI.isUri(A.location.uri):!1}constructor(A,ne){this.location=A,this.message=ne}static isEqual(A,ne){return A===ne?!0:!A||!ne?!1:A.message===ne.message&&A.location.range.isEqual(ne.location.range)&&A.location.uri.toString()===ne.location.uri.toString()}};Y=Ae([W],Y),e.DiagnosticRelatedInformation=Y;let ee=class{constructor(A,ne,ge=Ee.Error){if(!X.isRange(A))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=A,this.message=ne,this.severity=ge}toJSON(){return{severity:Ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(A,ne){return A===ne?!0:!A||!ne?!1:A.message===ne.message&&A.severity===ne.severity&&A.code===ne.code&&A.severity===ne.severity&&A.source===ne.source&&A.range.isEqual(ne.range)&&(0,v.equals)(A.tags,ne.tags)&&(0,v.equals)(A.relatedInformation,ne.relatedInformation,Y.isEqual)}};ee=Ae([W],ee),e.Diagnostic=ee;let z=class{constructor(A,ne){if(!A)throw new Error("Illegal argument, contents must be defined");Array.isArray(A)?this.contents=A:this.contents=[A],this.range=ne}};z=Ae([W],z),e.Hover=z;var q;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(q=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(A,ne=q.Text){this.range=A,this.kind=ne}toJSON(){return{range:this.range,kind:q[this.kind]}}};H=Ae([W],H),e.DocumentHighlight=H;var K;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(K=e.SymbolKind||(e.SymbolKind={}));var le;(function(N){N[N.Deprecated=1]="Deprecated"})(le=e.SymbolTag||(e.SymbolTag={}));let pe=l=class{static validate(A){if(!A.name)throw new Error("name must not be falsy")}constructor(A,ne,ge,Ue,He){this.name=A,this.kind=ne,this.containerName=He,typeof ge=="string"&&(this.containerName=ge),Ue instanceof $?this.location=Ue:ge instanceof X&&(this.location=new $(Ue,ge)),l.validate(this)}toJSON(){return{name:this.name,kind:K[this.kind],location:this.location,containerName:this.containerName}}};pe=l=Ae([W],pe),e.SymbolInformation=pe;let ke=d=class{static validate(A){if(!A.name)throw new Error("name must not be falsy");if(!A.range.contains(A.selectionRange))throw new Error("selectionRange must be contained in fullRange");A.children?.forEach(d.validate)}constructor(A,ne,ge,Ue,He){this.name=A,this.detail=ne,this.kind=ge,this.range=Ue,this.selectionRange=He,this.children=[],d.validate(this)}};ke=d=Ae([W],ke),e.DocumentSymbol=ke;var Te;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(Te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Ne=class{constructor(A,ne){this.title=A,this.kind=ne}};Ne=Ae([W],Ne),e.CodeAction=Ne;let Le=I=class{constructor(A){this.value=A}append(A){return new I(this.value?this.value+I.sep+A:A)}intersects(A){return this.contains(A)||A.contains(this)}contains(A){return this.value===A.value||A.value.startsWith(this.value+I.sep)}};Le.sep=".",Le=I=Ae([W],Le),e.CodeActionKind=Le,Le.Empty=new Le(""),Le.QuickFix=Le.Empty.append("quickfix"),Le.Refactor=Le.Empty.append("refactor"),Le.RefactorExtract=Le.Refactor.append("extract"),Le.RefactorInline=Le.Refactor.append("inline"),Le.RefactorMove=Le.Refactor.append("move"),Le.RefactorRewrite=Le.Refactor.append("rewrite"),Le.Source=Le.Empty.append("source"),Le.SourceOrganizeImports=Le.Source.append("organizeImports"),Le.SourceFixAll=Le.Source.append("fixAll");let me=class{constructor(A,ne){if(this.range=A,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};me=Ae([W],me),e.SelectionRange=me;class be{constructor(A,ne,ge,Ue,He,Je){this.kind=A,this.name=ne,this.detail=ge,this.uri=Ue,this.range=He,this.selectionRange=Je}}e.CallHierarchyItem=be;class ye{constructor(A,ne){this.fromRanges=ne,this.from=A}}e.CallHierarchyIncomingCall=ye;class Me{constructor(A,ne){this.fromRanges=ne,this.to=A}}e.CallHierarchyOutgoingCall=Me;var Oe;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Oe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(A,ne){this.range=A,this.command=ne}get isResolved(){return!!this.command}};Qe=Ae([W],Qe),e.CodeLens=Qe;let je=L=class{static isMarkdownString(A){return A instanceof L?!0:A&&A.appendCodeblock&&A.appendMarkdown&&A.appendText&&A.value!==void 0}constructor(A,ne=!1){E.set(this,void 0),_t(this,E,new D.MarkdownString(A,{supportThemeIcons:ne}),"f")}get value(){return nt(this,E,"f").value}set value(A){nt(this,E,"f").value=A}get isTrusted(){return nt(this,E,"f").isTrusted}set isTrusted(A){nt(this,E,"f").isTrusted=A}get supportThemeIcons(){return nt(this,E,"f").supportThemeIcons}set supportThemeIcons(A){nt(this,E,"f").supportThemeIcons=A}get supportHtml(){return nt(this,E,"f").supportHtml}set supportHtml(A){nt(this,E,"f").supportHtml=A}get baseUri(){return nt(this,E,"f").baseUri}set baseUri(A){nt(this,E,"f").baseUri=A}appendText(A){return nt(this,E,"f").appendText(A),this}appendMarkdown(A){return nt(this,E,"f").appendMarkdown(A),this}appendCodeblock(A,ne){return nt(this,E,"f").appendCodeblock(ne??"",A),this}};E=new WeakMap,je=L=Ae([W],je),e.MarkdownString=je;let qe=class{constructor(A,ne){this.label=A,this.documentation=ne}};qe=Ae([W],qe),e.ParameterInformation=qe;let Ve=class{constructor(A,ne){this.label=A,this.documentation=ne,this.parameters=[]}};Ve=Ae([W],Ve),e.SignatureInformation=Ve;let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};xe=Ae([W],xe),e.SignatureHelp=xe;var Ye;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Ye=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $e;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})($e=e.InlayHintKind||(e.InlayHintKind={}));let Ke=class{constructor(A){this.value=A}};Ke=Ae([W],Ke),e.InlayHintLabelPart=Ke;let ce=class{constructor(A,ne,ge){this.position=A,this.label=ne,this.kind=ge}};ce=Ae([W],ce),e.InlayHint=ce;var Ce;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var Re;(function(N){N[N.Deprecated=1]="Deprecated"})(Re=e.CompletionItemTag||(e.CompletionItemTag={}));let Be=class{constructor(A,ne){this.label=A,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Be=Ae([W],Be),e.CompletionItem=Be;let We=class{constructor(A=[],ne=!1){this.items=A,this.isIncomplete=ne}};We=Ae([W],We),e.CompletionList=We;let Ge=class{constructor(A,ne,ge){this.insertText=A,this.range=ne,this.command=ge}};Ge=Ae([W],Ge),e.InlineSuggestion=Ge;let rt=class{constructor(A){this.commands=void 0,this.items=A}};rt=Ae([W],rt),e.InlineSuggestionList=rt;let it=class{constructor(A,ne,ge){this.insertText=A,this.range=ne,this.command=ge}};it=Ae([W],it),e.InlineSuggestionNew=it;let et=class{constructor(A,ne){this.items=A,this.commands=ne}};et=Ae([W],et),e.InlineSuggestionsNew=et;var st;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(st=e.ViewColumn||(e.ViewColumn={}));var lt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ht;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(ht=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Et;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Et=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Tt;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Tt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ot;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(ot=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var dt;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(dt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function A(ne){switch(ne){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=A}(Tt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ut=class{constructor(A,ne){if(ne&&!b.URI.isUri(ne))throw(0,t.illegalArgument)("target");if(!X.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.target=ne}};ut=Ae([W],ut),e.DocumentLink=ut;let It=class{constructor(A,ne,ge,Ue){this.red=A,this.green=ne,this.blue=ge,this.alpha=Ue}};It=Ae([W],It),e.Color=It;let Pt=class{constructor(A,ne){if(ne&&!(ne instanceof It))throw(0,t.illegalArgument)("color");if(!X.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.color=ne}};Pt=Ae([W],Pt),e.ColorInformation=Pt;let Rt=class{constructor(A){if(!A||typeof A!="string")throw(0,t.illegalArgument)("label");this.label=A}};Rt=Ae([W],Rt),e.ColorPresentation=Rt;var Se;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Se=e.ColorFormat||(e.ColorFormat={}));var Ie;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Ie=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var de;(function(N){N[N.Unknown=0]="Unknown",N[N.Shutdown=1]="Shutdown",N[N.Process=2]="Process",N[N.User=3]="User",N[N.Extension=4]="Extension"})(de=e.TerminalExitReason||(e.TerminalExitReason={}));class V{constructor(A,ne,ge){if(this.startIndex=A,this.length=ne,this.tooltip=ge,typeof A!="number"||A<0)throw(0,t.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,t.illegalArgument)("length");if(ge!==void 0&&typeof ge!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=V;var Pe;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Pe=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(A){if(this.options=A,typeof A!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Fe;var Xe;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Xe=e.TaskRevealKind||(e.TaskRevealKind={}));var ze;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(ze=e.TaskPanelKind||(e.TaskPanelKind={}));let tt=B=class{static from(A){switch(A){case"clean":return B.Clean;case"build":return B.Build;case"rebuild":return B.Rebuild;case"test":return B.Test;default:return}}constructor(A,ne){if(this.label=ne,typeof A!="string"||typeof ne!="string")throw(0,t.illegalArgument)("name");this._id=A}get id(){return this._id}};tt.Clean=new B("clean","Clean"),tt.Build=new B("build","Build"),tt.Rebuild=new B("rebuild","Rebuild"),tt.Test=new B("test","Test"),tt=B=Ae([W],tt),e.TaskGroup=tt;function at(N){let A="";for(let ne=0;ne<N.length;ne++)A+=N[ne].replace(/,/g,",,")+",";return A}let St=class{constructor(A,ne,ge){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=A,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=ge):this._options=ne)}get process(){return this._process}set process(A){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._process=A}get args(){return this._args}set args(A){Array.isArray(A)||(A=[]),this._args=A}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("process"),this._process!==void 0&&A.push(this._process),this._args&&this._args.length>0)for(const ne of this._args)A.push(ne);return at(A)}};St=Ae([W],St),e.ProcessExecution=St;let mt=class{constructor(A,ne,ge){if(this._args=[],Array.isArray(ne)){if(!A)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A,this._args=ne,this._options=ge}else{if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(A){if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A}get command(){return this._command?this._command:""}set command(A){if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A}get args(){return this._args}set args(A){this._args=A||[]}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("shell"),this._commandLine!==void 0&&A.push(this._commandLine),this._command!==void 0&&A.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ne of this._args)A.push(typeof ne=="string"?ne:ne.value);return at(A)}};mt=Ae([W],mt),e.ShellExecution=mt;var gt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(gt=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class Sn{constructor(A){this._callback=A}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(A){this._callback=A}get callback(){return this._callback}}e.CustomExecution=Sn;let At=J=class{constructor(A,ne,ge,Ue,He,Je){this.__deprecated=!1,this._definition=this.definition=A;let Ze;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=ge,this.execution=Ue,Ze=He,this.__deprecated=!0):ne===vt.Global||ne===vt.Workspace?(this.target=ne,this._name=this.name=ge,this._source=this.source=Ue,this.execution=He,Ze=Je):(this.target=ne,this._name=this.name=ge,this._source=this.source=Ue,this.execution=He,Ze=Je),typeof Ze=="string"?(this._problemMatchers=[Ze],this._hasDefinedMatchers=!0):Array.isArray(Ze)?(this._problemMatchers=Ze,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(A){this.__id=A}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof St?this._definition={type:J.ProcessType,id:this._execution.computeId()}:this._execution instanceof mt?this._definition={type:J.ShellType,id:this._execution.computeId()}:this._execution instanceof Sn?this._definition={type:J.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:J.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(A){if(A==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=A}get scope(){return this._scope}set target(A){this.clear(),this._scope=A}get name(){return this._name}set name(A){if(typeof A!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=A}get execution(){return this._execution}set execution(A){A===null&&(A=void 0),this.clear(),this._execution=A;const ne=this._definition.type;(J.EmptyType===ne||J.ProcessType===ne||J.ShellType===ne||J.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(A){if(Array.isArray(A))this.clear(),this._problemMatchers=A,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(A){A!==!0&&A!==!1&&(A=!1),this.clear(),this._isBackground=A}get source(){return this._source}set source(A){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=A}get group(){return this._group}set group(A){A===null&&(A=void 0),this.clear(),this._group=A}get detail(){return this._detail}set detail(A){A===null&&(A=void 0),this._detail=A}get presentationOptions(){return this._presentationOptions}set presentationOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._presentationOptions=A}get runOptions(){return this._runOptions}set runOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._runOptions=A}};At.ExtensionCallbackType="customExecution",At.ProcessType="process",At.ShellType="shell",At.EmptyType="$empty",At=J=Ae([W],At),e.Task=At;var Cn;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Cn=e.ProgressLocation||(e.ProgressLocation={}));var In;(function(N){function A(ne){const ge=ne;return(0,p.isNumber)(ge.value)?ge.tooltip&&!(0,p.isString)(ge.tooltip)?(console.log("INVALID view badge, invalid tooltip",ge.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ge.value),!1)}N.isViewBadge=A})(In=e.ViewBadge||(e.ViewBadge={}));let $t=Z=class{static isTreeItem(A,ne){if(A instanceof Z)return!0;const ge=A;if(ge.label!==void 0&&!(0,p.isString)(ge.label)&&!ge.label?.label)return console.log("INVALID tree item, invalid label",ge.label),!1;if(ge.id!==void 0&&!(0,p.isString)(ge.id))return console.log("INVALID tree item, invalid id",ge.id),!1;if(ge.iconPath!==void 0&&!(0,p.isString)(ge.iconPath)&&!b.URI.isUri(ge.iconPath)&&(!ge.iconPath||!(0,p.isString)(ge.iconPath.id))){const Ue=ge.iconPath;if(!Ue||!(0,p.isString)(Ue.light)&&!b.URI.isUri(Ue.light)&&!(0,p.isString)(Ue.dark)&&!b.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",ge.iconPath),!1}if(ge.description!==void 0&&!(0,p.isString)(ge.description)&&typeof ge.description!="boolean")return console.log("INVALID tree item, invalid description",ge.description),!1;if(ge.resourceUri!==void 0&&!b.URI.isUri(ge.resourceUri))return console.log("INVALID tree item, invalid resourceUri",ge.resourceUri),!1;if(ge.tooltip!==void 0&&!(0,p.isString)(ge.tooltip)&&!(ge.tooltip instanceof je))return console.log("INVALID tree item, invalid tooltip",ge.tooltip),!1;if(ge.command!==void 0&&!ge.command.command)return console.log("INVALID tree item, invalid command",ge.command),!1;if(ge.collapsibleState!==void 0&&ge.collapsibleState<Mt.None&&ge.collapsibleState>Mt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",ge.collapsibleState),!1;if(ge.contextValue!==void 0&&!(0,p.isString)(ge.contextValue))return console.log("INVALID tree item, invalid contextValue",ge.contextValue),!1;if(ge.accessibilityInformation!==void 0&&!ge.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",ge.accessibilityInformation),!1;if(ge.checkboxState!==void 0){(0,h.checkProposedApiEnabled)(ne,"treeItemCheckbox");const Ue=(0,p.isNumber)(ge.checkboxState)?ge.checkboxState:(0,p.isObject)(ge.checkboxState)&&(0,p.isNumber)(ge.checkboxState.state)?ge.checkboxState.state:void 0,He=!(0,p.isNumber)(ge.checkboxState)&&(0,p.isObject)(ge.checkboxState)?ge.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==jt.Checked&&Ue!==jt.Unchecked||He!==void 0&&!(0,p.isString)(He))return console.log("INVALID tree item, invalid checkboxState",ge.checkboxState),!1}return!0}constructor(A,ne=Mt.None){this.collapsibleState=ne,b.URI.isUri(A)?this.resourceUri=A:this.label=A}};$t=Z=Ae([W],$t),e.TreeItem=$t;var Mt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var jt;(function(N){N[N.Unchecked=0]="Unchecked",N[N.Checked=1]="Checked"})(jt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Ht=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(A,ne){this.value=A,this.id=ne??(0,R.generateUuid)()}};Ht=Ae([W],Ht),e.DataTransferItem=Ht;let Vt=class{constructor(A){g.set(this,new Map);for(const[ne,ge]of A??[]){const Ue=nt(this,g,"f").get(ne);Ue?Ue.push(ge):nt(this,g,"f").set(ne,[ge])}}get(A){return nt(this,g,"f").get(A)?.[0]}set(A,ne){nt(this,g,"f").set(A,[ne])}forEach(A,ne){for(const[ge,Ue]of nt(this,g,"f"))for(const He of Ue)A.call(ne,He,ge,this)}*[(g=new WeakMap,Symbol.iterator)](){for(const[A,ne]of nt(this,g,"f"))for(const ge of ne)yield[A,ge]}};Vt=Ae([W],Vt),e.DataTransfer=Vt;let qt=class{constructor(A){this.insertText=A}};qt=Ae([W],qt),e.DocumentDropEdit=qt;let xt=class{constructor(A){this.insertText=A}};xt=Ae([W],xt),e.DocumentPasteEdit=xt;let Dt=class{constructor(A,ne){this.id=A,this.color=ne}};Dt=Ae([W],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let Gt=class{constructor(A){this.id=A}};Gt=Ae([W],Gt),e.ThemeColor=Gt;var Pn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Pn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Kt=class{get base(){return this._base}set base(A){this._base=A,this._baseUri=b.URI.file(A)}get baseUri(){return this._baseUri}set baseUri(A){this._baseUri=A,this._base=A.fsPath}constructor(A,ne){if(typeof A!="string"&&(!A||!b.URI.isUri(A)&&!b.URI.isUri(A.uri)))throw(0,t.illegalArgument)("base");if(typeof ne!="string")throw(0,t.illegalArgument)("pattern");typeof A=="string"?this.baseUri=b.URI.file(A):b.URI.isUri(A)?this.baseUri=A:this.baseUri=A.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Kt=Ae([W],Kt),e.RelativePattern=Kt;let Lt=class{constructor(A,ne,ge,Ue){this.enabled=typeof A=="boolean"?A:!0,typeof ne=="string"&&(this.condition=ne),typeof ge=="string"&&(this.hitCondition=ge),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Lt=Ae([W],Lt),e.Breakpoint=Lt;let Qt=class extends Lt{constructor(A,ne,ge,Ue,He){if(super(ne,ge,Ue,He),A===null)throw(0,t.illegalArgument)("location");this.location=A}};Qt=Ae([W],Qt),e.SourceBreakpoint=Qt;let Yt=class extends Lt{constructor(A,ne,ge,Ue,He){super(ne,ge,Ue,He),this.functionName=A}};Yt=Ae([W],Yt),e.FunctionBreakpoint=Yt;let Xt=class extends Lt{constructor(A,ne,ge,Ue,He,Je,Ze){if(super(Ue,He,Je,Ze),!ne)throw(0,t.illegalArgument)("dataId");this.label=A,this.dataId=ne,this.canPersist=ge}};Xt=Ae([W],Xt),e.DataBreakpoint=Xt;let Jt=class{constructor(A,ne,ge){this.command=A,this.args=ne||[],this.options=ge}};Jt=Ae([W],Jt),e.DebugAdapterExecutable=Jt;let Zt=class{constructor(A,ne){this.port=A,this.host=ne}};Zt=Ae([W],Zt),e.DebugAdapterServer=Zt;let en=class{constructor(A){this.path=A}};en=Ae([W],en),e.DebugAdapterNamedPipeServer=en;let tn=class{constructor(A){this.implementation=A}};tn=Ae([W],tn),e.DebugAdapterInlineImplementation=tn;let nn=class{constructor(A,ne){this.range=A,this.expression=ne}};nn=Ae([W],nn),e.EvaluatableExpression=nn;var Dn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(Dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var kn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(kn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let rn=class{constructor(A,ne){this.range=A,this.text=ne}};rn=Ae([W],rn),e.InlineValueText=rn;let sn=class{constructor(A,ne,ge=!0){this.range=A,this.variableName=ne,this.caseSensitiveLookup=ge}};sn=Ae([W],sn),e.InlineValueVariableLookup=sn;let on=class{constructor(A,ne){this.range=A,this.expression=ne}};on=Ae([W],on),e.InlineValueEvaluatableExpression=on;let an=class{constructor(A,ne){this.frameId=A,this.stoppedLocation=ne}};an=Ae([W],an),e.InlineValueContext=an;var Tn;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Tn=e.FileChangeType||(e.FileChangeType={}));let ln=_=class extends Error{static FileExists(A){return new _(A,k.FileSystemProviderErrorCode.FileExists,_.FileExists)}static FileNotFound(A){return new _(A,k.FileSystemProviderErrorCode.FileNotFound,_.FileNotFound)}static FileNotADirectory(A){return new _(A,k.FileSystemProviderErrorCode.FileNotADirectory,_.FileNotADirectory)}static FileIsADirectory(A){return new _(A,k.FileSystemProviderErrorCode.FileIsADirectory,_.FileIsADirectory)}static NoPermissions(A){return new _(A,k.FileSystemProviderErrorCode.NoPermissions,_.NoPermissions)}static Unavailable(A){return new _(A,k.FileSystemProviderErrorCode.Unavailable,_.Unavailable)}constructor(A,ne=k.FileSystemProviderErrorCode.Unknown,ge){super(b.URI.isUri(A)?A.toString(!0):A),this.code=ge?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype),typeof Error.captureStackTrace=="function"&&typeof ge=="function"&&Error.captureStackTrace(this,ge)}};ln=_=Ae([W],ln),e.FileSystemError=ln;let cn=class{constructor(A,ne,ge){this.start=A,this.end=ne,this.kind=ge}};cn=Ae([W],cn),e.FoldingRange=cn;var Rn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Rn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var An;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(An=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));var Ln;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(Ln=e.CommentThreadState||(e.CommentThreadState={}));class Fn{constructor(A,ne=[]){this.tokenTypes=A,this.tokenModifiers=ne}}e.SemanticTokensLegend=Fn;function On(N){return typeof N>"u"||(0,p.isStringArray)(N)}class un{constructor(A){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,A){this._hasLegend=!0;for(let ne=0,ge=A.tokenTypes.length;ne<ge;ne++)this._tokenTypeStrToInt.set(A.tokenTypes[ne],ne);for(let ne=0,ge=A.tokenModifiers.length;ne<ge;ne++)this._tokenModifierStrToInt.set(A.tokenModifiers[ne],ne)}}push(A,ne,ge,Ue,He){if(typeof A=="number"&&typeof ne=="number"&&typeof ge=="number"&&typeof Ue=="number"&&(typeof He=="number"||typeof He>"u"))return typeof He>"u"&&(He=0),this._pushEncoded(A,ne,ge,Ue,He);if(X.isRange(A)&&typeof ne=="string"&&On(ge))return this._push(A,ne,ge);throw(0,t.illegalArgument)()}_push(A,ne,ge){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(A.start.line!==A.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ue=A.start.line,He=A.start.character,Je=A.end.character-A.start.character,Ze=this._tokenTypeStrToInt.get(ne);let ct=0;if(ge)for(const pt of ge){if(!this._tokenModifierStrToInt.has(pt))throw new Error("`tokenModifier` is not in the provided legend");const yt=this._tokenModifierStrToInt.get(pt);ct|=1<<yt>>>0}this._pushEncoded(Ue,He,Je,Ze,ct)}_pushEncoded(A,ne,ge,Ue,He){if(this._dataIsSortedAndDeltaEncoded&&(A<this._prevLine||A===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const ct=this._data.length/5|0;let pt=0,yt=0;for(let bt=0;bt<ct;bt++){let Ct=this._data[5*bt],Ot=this._data[5*bt+1];Ct===0?(Ct=pt,Ot+=yt):Ct+=pt,this._data[5*bt]=Ct,this._data[5*bt+1]=Ot,pt=Ct,yt=Ot}}let Je=A,Ze=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Je-=this._prevLine,Je===0&&(Ze-=this._prevChar)),this._data[this._dataLen++]=Je,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=ge,this._data[this._dataLen++]=Ue,this._data[this._dataLen++]=He,this._prevLine=A,this._prevChar=ne}static _sortAndDeltaEncode(A){const ne=[],ge=A.length/5|0;for(let Ze=0;Ze<ge;Ze++)ne[Ze]=Ze;ne.sort((Ze,ct)=>{const pt=A[5*Ze],yt=A[5*ct];if(pt===yt){const bt=A[5*Ze+1],Ct=A[5*ct+1];return bt-Ct}return pt-yt});const Ue=new Uint32Array(A.length);let He=0,Je=0;for(let Ze=0;Ze<ge;Ze++){const ct=5*ne[Ze],pt=A[ct+0],yt=A[ct+1],bt=A[ct+2],Ct=A[ct+3],Ot=A[ct+4],bn=pt-He,wi=bn===0?yt-Je:yt,Nt=5*Ze;Ue[Nt+0]=bn,Ue[Nt+1]=wi,Ue[Nt+2]=bt,Ue[Nt+3]=Ct,Ue[Nt+4]=Ot,He=pt,Je=yt}return Ue}build(A){return this._dataIsSortedAndDeltaEncoded?new fn(new Uint32Array(this._data),A):new fn(un._sortAndDeltaEncode(this._data),A)}}e.SemanticTokensBuilder=un;class fn{constructor(A,ne){this.resultId=ne,this.data=A}}e.SemanticTokens=fn;class Nn{constructor(A,ne,ge){this.start=A,this.deleteCount=ne,this.data=ge}}e.SemanticTokensEdit=Nn;class Mn{constructor(A,ne){this.resultId=ne,this.edits=A}}e.SemanticTokensEdits=Mn;var Un;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Un=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Ut=class{constructor(){}};Ut.Back={iconPath:new Dt("arrow-left")},Ut=Ae([W],Ut),e.QuickInputButtons=Ut;var Bn;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(Bn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zn;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(zn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Wn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Wn=e.ExtensionKind||(e.ExtensionKind={}));class $n{static validate(A){if(A.badge){let ne=(0,P.nextCharLength)(A.badge,0);if(ne<A.badge.length&&(ne+=(0,P.nextCharLength)(A.badge,ne)),A.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}if(!A.color&&!A.badge&&!A.tooltip)throw new Error("The decoration is empty");return!0}constructor(A,ne,ge){this.badge=A,this.tooltip=ne,this.color=ge}}e.FileDecoration=$n;let hn=class{constructor(A){this.kind=A}};hn=Ae([W],hn),e.ColorTheme=hn;var jn;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(jn=e.ColorThemeKind||(e.ColorThemeKind={}));class kt{static isNotebookRange(A){return A instanceof kt?!0:A?typeof A.start=="number"&&typeof A.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(A,ne){if(A<0)throw(0,t.illegalArgument)("start must be positive");if(ne<0)throw(0,t.illegalArgument)("end must be positive");A<=ne?(this._start=A,this._end=ne):(this._start=ne,this._end=A)}with(A){let ne=this._start,ge=this._end;return A.start!==void 0&&(ne=A.start),A.end!==void 0&&(ge=A.end),ne===this._start&&ge===this._end?this:new kt(ne,ge)}}e.NotebookRange=kt;class Bt{static validate(A){if(typeof A.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof A.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof A.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(A){return Array.isArray(A)&&A.every(ne=>Bt.isNotebookCellData(ne))}static isNotebookCellData(A){return!0}constructor(A,ne,ge,Ue,He,Je,Ze){this.kind=A,this.value=ne,this.languageId=ge,this.mime=Ue,this.outputs=He??[],this.metadata=Je,this.executionSummary=Ze,Bt.validate(this)}}e.NotebookCellData=Bt;class Hn{constructor(A){this.cells=A}}e.NotebookData=Hn;class wt{static isNotebookCellOutputItem(A){return A instanceof wt?!0:A?typeof A.mime=="string"&&A.data instanceof Uint8Array:!1}static error(A){const ne={name:A.name,message:A.message,stack:A.stack};return wt.json(ne,"application/vnd.code.notebook.error")}static stdout(A){return wt.text(A,"application/vnd.code.notebook.stdout")}static stderr(A){return wt.text(A,"application/vnd.code.notebook.stderr")}static bytes(A,ne="application/octet-stream"){return new wt(A,ne)}static text(A,ne=T.Mimes.text){const ge=nt(wt,m,"f",f).encode(String(A));return new wt(ge,ne)}static json(A,ne="text/x-json"){const ge=JSON.stringify(A,void 0,"	");return wt.text(ge,ne)}constructor(A,ne){this.data=A,this.mime=ne;const ge=(0,T.normalizeMimeType)(ne,!0);if(!ge)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ge}}e.NotebookCellOutputItem=wt,m=wt,f={value:new TextEncoder};class zt{static isNotebookCellOutput(A){return A instanceof zt?!0:!A||typeof A!="object"?!1:typeof A.id=="string"&&Array.isArray(A.items)}static ensureUniqueMimeTypes(A,ne=!1){const ge=new Set,Ue=new Set;for(let He=0;He<A.length;He++){const Je=A[He],Ze=(0,T.normalizeMimeType)(Je.mime);if(!ge.has(Ze)||(0,y.isTextStreamMime)(Ze)){ge.add(Ze);continue}Ue.add(He),ne&&console.warn(`DUPLICATED mime type '${Je.mime}' will be dropped`)}return Ue.size===0?A:A.filter((He,Je)=>!Ue.has(Je))}constructor(A,ne,ge){this.items=zt.ensureUniqueMimeTypes(A,!0),typeof ne=="string"?(this.id=ne,this.metadata=ge):(this.id=(0,R.generateUuid)(),this.metadata=ne??ge)}}e.NotebookCellOutput=zt;var Vn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Vn=e.NotebookCellKind||(e.NotebookCellKind={}));var qn;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(qn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(xn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Gn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Kn{constructor(A,ne){this.text=A,this.alignment=ne}}e.NotebookCellStatusBarItem=Kn;var Qn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Qn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Yn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred",N[N.Hidden=-1]="Hidden"})(Yn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Xn{constructor(A,ne=[]){this.uri=A,this.provides=(0,v.asArray)(ne)}}e.NotebookRendererScript=Xn;let dn=class{constructor(A,ne){this.label=A,this.timestamp=ne}};dn=Ae([W],dn),e.TimelineItem=dn;var Jn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Jn=e.ExtensionMode||(e.ExtensionMode={}));var Zn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Zn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ei;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(ei=e.StandardTokenType||(e.StandardTokenType={}));class ti{constructor(A,ne){this.ranges=A,this.wordPattern=ne}}e.LinkedEditingRanges=ti;class ni{constructor(A,ne){this._port=A,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ni;var ii;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(ii=e.TestResultState||(e.TestResultState={}));var ri;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(ri=e.TestRunProfileKind||(e.TestRunProfileKind={}));let mn=class{constructor(A=void 0,ne=void 0,ge=void 0){this.include=A,this.exclude=ne,this.profile=ge}};mn=Ae([W],mn),e.TestRunRequest=mn;let gn=te=class{static diff(A,ne,ge){const Ue=new te(A);return Ue.expectedOutput=ne,Ue.actualOutput=ge,Ue}constructor(A){this.message=A}};gn=te=Ae([W],gn),e.TestMessage=gn;let pn=class{constructor(A){this.id=A}};pn=Ae([W],pn),e.TestTag=pn;let Ft=class{constructor(A,ne){this.covered=A,this.total=ne}};Ft=Ae([W],Ft),e.CoveredCount=Ft;let vn=se=class{static fromDetails(A,ne){const ge=new Ft(0,0),Ue=new Ft(0,0),He=new Ft(0,0);for(const Ze of ne)if("branches"in Ze){ge.total+=1,ge.covered+=Ze.executionCount>0?1:0;for(const ct of Ze.branches)Ue.total+=1,Ue.covered+=ct.executionCount>0?1:0}else He.total+=1,He.covered+=Ze.executionCount>0?1:0;const Je=new se(A,ge,Ue.total>0?Ue:void 0,He.total>0?He:void 0);return Je.detailedCoverage=ne,Je}constructor(A,ne,ge,Ue){this.uri=A,this.statementCoverage=ne,this.branchCoverage=ge,this.functionCoverage=Ue}};vn=se=Ae([W],vn),e.FileCoverage=vn;let wn=class{constructor(A,ne,ge=[]){this.executionCount=A,this.location=ne,this.branches=ge}};wn=Ae([W],wn),e.StatementCoverage=wn;let yn=class{constructor(A,ne){this.executionCount=A,this.location=ne}};yn=Ae([W],yn),e.BranchCoverage=yn;let En=class{constructor(A,ne){this.executionCount=A,this.location=ne}};En=Ae([W],En),e.FunctionCoverage=En;var si;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(si=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var oi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(oi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ai;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(ai=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class li{constructor(A,ne,ge,Ue,He,Je){this.kind=A,this.name=ne,this.detail=ge,this.uri=Ue,this.range=He,this.selectionRange=Je}}e.TypeHierarchyItem=li;class ci{constructor(A){this.uri=A}}e.TextTabInput=ci;class ui{constructor(A,ne){this.original=A,this.modified=ne}}e.TextDiffTabInput=ui;class fi{constructor(A,ne,ge,Ue){this.base=A,this.input1=ne,this.input2=ge,this.result=Ue}}e.TextMergeTabInput=fi;class hi{constructor(A,ne){this.uri=A,this.viewType=ne}}e.CustomEditorTabInput=hi;class di{constructor(A){this.viewType=A}}e.WebviewEditorTabInput=di;class mi{constructor(A,ne){this.uri=A,this.notebookType=ne}}e.NotebookEditorTabInput=mi;class gi{constructor(A,ne,ge){this.original=A,this.modified=ne,this.notebookType=ge}}e.NotebookDiffEditorTabInput=gi;class pi{constructor(){}}e.TerminalEditorTabInput=pi;class vi{constructor(A,ne){this.uri=A,this.inputBoxUri=ne}}e.InteractiveWindowInput=vi}),define(ve[127],we([1,0,18,16,90,24,136,48,22,11,4,47,157,209,122,79,118,80,81,124,126,64]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Se){function Ie(V){const{selectionStartLineNumber:Pe,selectionStartColumn:Fe,positionLineNumber:Xe,positionColumn:ze}=V,tt=new c.Position(Pe-1,Fe-1),at=new c.Position(Xe-1,ze-1);return new c.Selection(tt,at)}Se.to=Ie;function de(V){const{anchor:Pe,active:Fe}=V;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}Se.from=de})(r=e.Selection||(e.Selection={}));var o;(function(Se){function Ie(V){if(!V)return;const{start:Pe,end:Fe}=V;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}Se.from=Ie;function de(V){if(!V)return;const{startLineNumber:Pe,startColumn:Fe,endLineNumber:Xe,endColumn:ze}=V;return new c.Range(Pe-1,Fe-1,Xe-1,ze-1)}Se.to=de})(o=e.Range||(e.Range={}));var n;(function(Se){function Ie(de){switch(de){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Se.to=Ie})(n=e.TokenType||(e.TokenType={}));var i;(function(Se){function Ie(V){return new c.Position(V.lineNumber-1,V.column-1)}Se.to=Ie;function de(V){return{lineNumber:V.line+1,column:V.character+1}}Se.from=de})(i=e.Position||(e.Position={}));var s;(function(Se){function Ie(Pe,Fe){return(0,v.coalesce)((0,v.asArray)(Pe).map(Xe=>de(Xe,Fe)))}Se.from=Ie;function de(Pe,Fe){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:V(Pe.scheme,Fe),pattern:$e.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function V(Pe,Fe){return Fe&&typeof Pe=="string"?Fe.transformOutgoingScheme(Pe):Pe}})(s=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Se){function Ie(V){switch(V){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Se.from=Ie;function de(V){switch(V){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Se.to=de})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var l;(function(Se){function Ie(V){let Pe;return V.code&&((0,b.isString)(V.code)||(0,b.isNumber)(V.code)?Pe=String(V.code):Pe={value:String(V.code.value),target:V.code.target}),{...o.from(V.range),message:V.message,source:V.source,code:Pe,severity:I.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(d.from),tags:Array.isArray(V.tags)?(0,v.coalesce)(V.tags.map(a.from)):void 0}}Se.from=Ie;function de(V){const Pe=new c.Diagnostic(o.to(V),V.message,I.to(V.severity));return Pe.source=V.source,Pe.code=(0,b.isString)(V.code)?V.code:V.code?.value,Pe.relatedInformation=V.relatedInformation&&V.relatedInformation.map(d.to),Pe.tags=V.tags&&(0,v.coalesce)(V.tags.map(a.to)),Pe}Se.to=de})(l=e.Diagnostic||(e.Diagnostic={}));var d;(function(Se){function Ie(V){return{...o.from(V.location.range),message:V.message,resource:V.location.uri}}Se.from=Ie;function de(V){return new c.DiagnosticRelatedInformation(new c.Location(V.resource,o.to(V)),V.message)}Se.to=de})(d=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var I;(function(Se){function Ie(V){switch(V){case c.DiagnosticSeverity.Error:return y.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return y.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return y.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return y.MarkerSeverity.Hint}return y.MarkerSeverity.Error}Se.from=Ie;function de(V){switch(V){case y.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case y.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case y.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case y.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Se.to=de})(I=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var L;(function(Se){function Ie(V){return typeof V=="number"&&V>=c.ViewColumn.One?V-1:V===c.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}Se.from=Ie;function de(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=de})(L=e.ViewColumn||(e.ViewColumn={}));function B(Se){return typeof Se.range<"u"}function J(Se){return Se.length===0?!0:!!B(Se[0])}e.isDecorationOptionsArr=J;var Z;(function(Se){function Ie(ze){return ze.map(Se.from)}Se.fromMany=Ie;function de(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function V(ze){let tt;if(de(ze)){const{language:gt,value:vt}=ze;tt={value:"```"+gt+`
`+vt+"\n```\n"}}else c.MarkdownString.isMarkdownString(ze)?tt={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?tt={value:ze}:tt={value:""};const at=Object.create(null);tt.uris=at;const St=gt=>{try{let vt=R.URI.parse(gt,!0);vt=vt.with({query:Pe(vt.query,at)}),at[gt]=vt}catch{}return""},mt=new T.marked.Renderer;return mt.link=St,mt.image=gt=>typeof gt=="string"?St(D.parseHrefAndDimensions(gt).href):"",(0,T.marked)(tt.value,{renderer:mt}),tt}Se.from=V;function Pe(ze,tt){if(!ze)return ze;let at;try{at=(0,P.parse)(ze)}catch{}if(!at)return ze;let St=!1;return at=(0,p.cloneAndChange)(at,mt=>{if(R.URI.isUri(mt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[gt]=mt,St=!0,gt}else return}),St?JSON.stringify(at):ze}function Fe(ze){const tt=new c.MarkdownString(ze.value,ze.supportThemeIcons);return tt.isTrusted=ze.isTrusted,tt.supportHtml=ze.supportHtml,tt.baseUri=ze.baseUri?R.URI.from(ze.baseUri):void 0,tt}Se.to=Fe;function Xe(ze){if(!!ze)return typeof ze=="string"?ze:Se.from(ze)}Se.fromStrict=Xe})(Z=e.MarkdownString||(e.MarkdownString={}));function _(Se){return J(Se)?Se.map(Ie=>({range:o.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?Z.fromMany(Ie.hoverMessage):Ie.hoverMessage?Z.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Se.map(Ie=>({range:o.from(Ie)}))}e.fromRangeOrRangeWithMessage=_;function te(Se){return typeof Se>"u"?Se:typeof Se=="string"?R.URI.file(Se):Se}e.pathOrURIToURI=te;var se;(function(Se){function Ie(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?te(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Se.from=Ie})(se=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var W;(function(Se){function Ie(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?te(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?se.from(de.before):void 0,after:de.after?se.from(de.after):void 0}}Se.from=Ie})(W=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var fe;(function(Se){function Ie(de){if(typeof de>"u")return de;switch(de){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Ie})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(Se){function Ie(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?fe.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?W.from(de.light):void 0,dark:de.dark?W.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?te(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?se.from(de.before):void 0,after:de.after?se.from(de.after):void 0}}Se.from=Ie})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var X;(function(Se){function Ie(V){return{text:V.newText,eol:V.newEol&&je.from(V.newEol),range:o.from(V.range)}}Se.from=Ie;function de(V){const Pe=new c.TextEdit(o.to(V.range),V.text);return Pe.newEol=typeof V.eol>"u"?void 0:je.to(V.eol),Pe}Se.to=de})(X=e.TextEdit||(e.TextEdit={}));var O;(function(Se){function Ie(V,Pe){const Fe={edits:[]};if(V instanceof c.WorkspaceEdit){const Xe=new C.ResourceSet;for(const ze of V._allEntries())ze._type===1&&R.URI.isUri(ze.to)&&ze.from===void 0&&Xe.add(ze.to);for(const ze of V._allEntries())ze._type===1?Fe.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Fe.edits.push({resource:ze.uri,textEdit:X.from(ze.edit),versionId:Xe.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Fe.edits.push({resource:ze.uri,textEdit:{range:o.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Xe.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Fe.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Fe.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(We.from)}})}return Fe}Se.from=Ie;function de(V){const Pe=new c.WorkspaceEdit;for(const Fe of V.edits)Fe.textEdit?Pe.replace(R.URI.revive(Fe.resource),o.to(Fe.textEdit.range),Fe.textEdit.text):Pe.renameFile(R.URI.revive(Fe.oldResource),R.URI.revive(Fe.newResource),Fe.options);return Pe}Se.to=de})(O=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(Se){const Ie=Object.create(null);Ie[c.SymbolKind.File]=0,Ie[c.SymbolKind.Module]=1,Ie[c.SymbolKind.Namespace]=2,Ie[c.SymbolKind.Package]=3,Ie[c.SymbolKind.Class]=4,Ie[c.SymbolKind.Method]=5,Ie[c.SymbolKind.Property]=6,Ie[c.SymbolKind.Field]=7,Ie[c.SymbolKind.Constructor]=8,Ie[c.SymbolKind.Enum]=9,Ie[c.SymbolKind.Interface]=10,Ie[c.SymbolKind.Function]=11,Ie[c.SymbolKind.Variable]=12,Ie[c.SymbolKind.Constant]=13,Ie[c.SymbolKind.String]=14,Ie[c.SymbolKind.Number]=15,Ie[c.SymbolKind.Boolean]=16,Ie[c.SymbolKind.Array]=17,Ie[c.SymbolKind.Object]=18,Ie[c.SymbolKind.Key]=19,Ie[c.SymbolKind.Null]=20,Ie[c.SymbolKind.EnumMember]=21,Ie[c.SymbolKind.Struct]=22,Ie[c.SymbolKind.Event]=23,Ie[c.SymbolKind.Operator]=24,Ie[c.SymbolKind.TypeParameter]=25;function de(Pe){return typeof Ie[Pe]=="number"?Ie[Pe]:6}Se.from=de;function V(Pe){for(const Fe in Ie)if(Ie[Fe]===Pe)return Number(Fe);return c.SymbolKind.Property}Se.to=V})(U=e.SymbolKind||(e.SymbolKind={}));var x;(function(Se){function Ie(V){switch(V){case c.SymbolTag.Deprecated:return 1}}Se.from=Ie;function de(V){switch(V){case 1:return c.SymbolTag.Deprecated}}Se.to=de})(x=e.SymbolTag||(e.SymbolTag={}));var ae;(function(Se){function Ie(V){return{name:V.name,kind:U.from(V.kind),tags:V.tags&&V.tags.map(x.from),containerName:V.containerName,location:M.from(V.location)}}Se.from=Ie;function de(V){const Pe=new c.SymbolInformation(V.name,U.to(V.kind),V.containerName,M.to(V.location));return Pe.tags=V.tags&&V.tags.map(x.to),Pe}Se.to=de})(ae=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ue;(function(Se){function Ie(V){const Pe={name:V.name||"!!MISSING: name!!",detail:V.detail,range:o.from(V.range),selectionRange:o.from(V.selectionRange),kind:U.from(V.kind),tags:V.tags?.map(x.from)??[]};return V.children&&(Pe.children=V.children.map(Ie)),Pe}Se.from=Ie;function de(V){const Pe=new c.DocumentSymbol(V.name,V.detail,U.to(V.kind),o.to(V.range),o.to(V.selectionRange));return(0,v.isNonEmptyArray)(V.tags)&&(Pe.tags=V.tags.map(x.to)),V.children&&(Pe.children=V.children.map(de)),Pe}Se.to=de})(ue=e.DocumentSymbol||(e.DocumentSymbol={}));var Q;(function(Se){function Ie(V){const Pe=new c.CallHierarchyItem(U.to(V.kind),V.name,V.detail||"",R.URI.revive(V.uri),o.to(V.range),o.to(V.selectionRange));return Pe._sessionId=V._sessionId,Pe._itemId=V._itemId,Pe}Se.to=Ie;function de(V,Pe,Fe){if(Pe=Pe??V._sessionId,Fe=Fe??V._itemId,Pe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Fe,name:V.name,detail:V.detail,kind:U.from(V.kind),uri:V.uri,range:o.from(V.range),selectionRange:o.from(V.selectionRange),tags:V.tags?.map(x.from)}}Se.from=de})(Q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var re;(function(Se){function Ie(de){return new c.CallHierarchyIncomingCall(Q.to(de.from),de.fromRanges.map(V=>o.to(V)))}Se.to=Ie})(re=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(Se){function Ie(de){return new c.CallHierarchyOutgoingCall(Q.to(de.to),de.fromRanges.map(V=>o.to(V)))}Se.to=Ie})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(Se){function Ie(V){return{range:V.range&&o.from(V.range),uri:V.uri}}Se.from=Ie;function de(V){return new c.Location(R.URI.revive(V.uri),o.to(V.range))}Se.to=de})(M=e.location||(e.location={}));var G;(function(Se){function Ie(V){const Pe=V,Fe=V;return{originSelectionRange:Pe.originSelectionRange?o.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Fe.uri,range:o.from(Pe.targetRange?Pe.targetRange:Fe.range),targetSelectionRange:Pe.targetSelectionRange?o.from(Pe.targetSelectionRange):void 0}}Se.from=Ie;function de(V){return{targetUri:R.URI.revive(V.uri),targetRange:o.to(V.range),targetSelectionRange:V.targetSelectionRange?o.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?o.to(V.originSelectionRange):void 0}}Se.to=de})(G=e.DefinitionLink||(e.DefinitionLink={}));var ie;(function(Se){function Ie(V){return{range:o.from(V.range),contents:Z.fromMany(V.contents)}}Se.from=Ie;function de(V){return new c.Hover(V.contents.map(Z.to),o.to(V.range))}Se.to=de})(ie=e.Hover||(e.Hover={}));var he;(function(Se){function Ie(V){return{range:o.from(V.range),expression:V.expression}}Se.from=Ie;function de(V){return new c.EvaluatableExpression(o.to(V.range),V.expression)}Se.to=de})(he=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ee;(function(Se){function Ie(V){if(V instanceof c.InlineValueText)return{type:"text",range:o.from(V.range),text:V.text};if(V instanceof c.InlineValueVariableLookup)return{type:"variable",range:o.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Ie;function de(V){switch(V.type){case"text":return{range:o.to(V.range),text:V.text};case"variable":return{range:o.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:o.to(V.range),expression:V.expression}}}Se.to=de})(Ee=e.InlineValue||(e.InlineValue={}));var $;(function(Se){function Ie(V){return{frameId:V.frameId,stoppedLocation:o.from(V.stoppedLocation)}}Se.from=Ie;function de(V){return new c.InlineValueContext(V.frameId,o.to(V.stoppedLocation))}Se.to=de})($=e.InlineValueContext||(e.InlineValueContext={}));var Y;(function(Se){function Ie(V){return{range:o.from(V.range),kind:V.kind}}Se.from=Ie;function de(V){return new c.DocumentHighlight(o.to(V.range),V.kind)}Se.to=de})(Y=e.DocumentHighlight||(e.DocumentHighlight={}));var ee;(function(Se){function Ie(de){switch(de){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Se.to=Ie})(ee=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var z;(function(Se){function Ie(de){return{triggerKind:ee.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Se.to=Ie})(z=e.CompletionContext||(e.CompletionContext={}));var q;(function(Se){function Ie(V){switch(V){case c.CompletionItemTag.Deprecated:return 1}}Se.from=Ie;function de(V){switch(V){case 1:return c.CompletionItemTag.Deprecated}}Se.to=de})(q=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Se){const Ie=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function de(Fe){return Ie.get(Fe)??9}Se.from=de;const V=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Pe(Fe){return V.get(Fe)??c.CompletionItemKind.Property}Se.to=Pe})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(Se){function Ie(de,V){const Pe=new c.CompletionItem(de.label);return Pe.insertText=de.insertText,Pe.kind=H.to(de.kind),Pe.tags=de.tags?.map(q.to),Pe.detail=de.detail,Pe.documentation=D.isMarkdownString(de.documentation)?Z.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,k.Range.isIRange(de.range)?Pe.range=o.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:o.to(de.range.insert),replacing:o.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Pe.insertText=new c.SnippetString(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof c.Range?new c.TextEdit(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Fe=>X.to(Fe))),Pe.command=V&&de.command?V.fromInternal(de.command):void 0,Pe}Se.to=Ie})(K=e.CompletionItem||(e.CompletionItem={}));var le;(function(Se){function Ie(V){if(typeof V.label!="string"&&!Array.isArray(V.label))throw new TypeError("Invalid label");return{label:V.label,documentation:Z.fromStrict(V.documentation)}}Se.from=Ie;function de(V){return{label:V.label,documentation:D.isMarkdownString(V.documentation)?Z.to(V.documentation):V.documentation}}Se.to=de})(le=e.ParameterInformation||(e.ParameterInformation={}));var pe;(function(Se){function Ie(V){return{label:V.label,documentation:Z.fromStrict(V.documentation),parameters:Array.isArray(V.parameters)?V.parameters.map(le.from):[],activeParameter:V.activeParameter}}Se.from=Ie;function de(V){return{label:V.label,documentation:D.isMarkdownString(V.documentation)?Z.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map(le.to):[],activeParameter:V.activeParameter}}Se.to=de})(pe=e.SignatureInformation||(e.SignatureInformation={}));var ke;(function(Se){function Ie(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(pe.from):[]}}Se.from=Ie;function de(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(pe.to):[]}}Se.to=de})(ke=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(Se){function Ie(de,V){const Pe=new c.InlayHint(i.to(V.position),typeof V.label=="string"?V.label:V.label.map(Ne.to.bind(void 0,de)),V.kind&&Le.to(V.kind));return Pe.textEdits=V.textEdits&&V.textEdits.map(X.to),Pe.tooltip=D.isMarkdownString(V.tooltip)?Z.to(V.tooltip):V.tooltip,Pe.paddingLeft=V.paddingLeft,Pe.paddingRight=V.paddingRight,Pe}Se.to=Ie})(Te=e.InlayHint||(e.InlayHint={}));var Ne;(function(Se){function Ie(de,V){const Pe=new c.InlayHintLabelPart(V.label);return Pe.tooltip=D.isMarkdownString(V.tooltip)?Z.to(V.tooltip):V.tooltip,S.Command.is(V.command)&&(Pe.command=de.fromInternal(V.command)),V.location&&(Pe.location=M.to(V.location)),Pe}Se.to=Ie})(Ne=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Le;(function(Se){function Ie(V){return V}Se.from=Ie;function de(V){return V}Se.to=de})(Le=e.InlayHintKind||(e.InlayHintKind={}));var me;(function(Se){function Ie(V){return{range:o.from(V.range),url:V.target,tooltip:V.tooltip}}Se.from=Ie;function de(V){let Pe;if(V.url)try{Pe=typeof V.url=="string"?R.URI.parse(V.url,!0):R.URI.revive(V.url)}catch{}return new c.DocumentLink(o.to(V.range),Pe)}Se.to=de})(me=e.DocumentLink||(e.DocumentLink={}));var be;(function(Se){function Ie(V){const Pe=new c.ColorPresentation(V.label);return V.textEdit&&(Pe.textEdit=X.to(V.textEdit)),V.additionalTextEdits&&(Pe.additionalTextEdits=V.additionalTextEdits.map(Fe=>X.to(Fe))),Pe}Se.to=Ie;function de(V){return{label:V.label,textEdit:V.textEdit?X.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(Pe=>X.from(Pe)):void 0}}Se.from=de})(be=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Se){function Ie(V){return new c.Color(V[0],V[1],V[2],V[3])}Se.to=Ie;function de(V){return[V.red,V.green,V.blue,V.alpha]}Se.from=de})(ye=e.Color||(e.Color={}));var Me;(function(Se){function Ie(V){return{range:o.from(V.range)}}Se.from=Ie;function de(V){return new c.SelectionRange(o.to(V.range))}Se.to=de})(Me=e.SelectionRange||(e.SelectionRange={}));var Oe;(function(Se){function Ie(de){switch(de){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Se.to=Ie})(Oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Qe;(function(Se){function Ie(V){switch(V){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Ie;function de(V){switch(V){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Se.to=de})(Qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var je;(function(Se){function Ie(V){if(V===c.EndOfLine.CRLF)return 1;if(V===c.EndOfLine.LF)return 0}Se.from=Ie;function de(V){if(V===1)return c.EndOfLine.CRLF;if(V===0)return c.EndOfLine.LF}Se.to=de})(je=e.EndOfLine||(e.EndOfLine={}));var qe;(function(Se){function Ie(de){if(typeof de=="object")return de.viewId;switch(de){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Ie})(qe=e.ProgressLocation||(e.ProgressLocation={}));var Ve;(function(Se){function Ie(de){const V={start:de.start+1,end:de.end+1};return de.kind&&(V.kind=xe.from(de.kind)),V}Se.from=Ie})(Ve=e.FoldingRange||(e.FoldingRange={}));var xe;(function(Se){function Ie(de){if(de)switch(de){case c.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}Se.from=Ie})(xe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ye;(function(Se){function Ie(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?o.from(de.selection):void 0,override:typeof de.override=="boolean"?w.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Ie})(Ye=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $e;(function(Se){function Ie(Fe){return Fe instanceof c.RelativePattern?Fe.toJSON():typeof Fe=="string"?Fe:de(Fe)||V(Fe)?new c.RelativePattern(Fe.baseUri??Fe.base,Fe.pattern).toJSON():Fe}Se.from=Ie;function de(Fe){const Xe=Fe;return Xe?R.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function V(Fe){const Xe=Fe;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Pe(Fe){return typeof Fe=="string"?Fe:new c.RelativePattern(R.URI.revive(Fe.baseUri),Fe.pattern)}Se.to=Pe})($e=e.GlobPattern||(e.GlobPattern={}));var Ke;(function(Se){function Ie(de){if(de){if(Array.isArray(de))return de.map(Ie);if(typeof de=="string")return de;{const V=de;return{language:V.language,scheme:V.scheme,pattern:$e.from(V.pattern),exclusive:V.exclusive,notebookType:V.notebookType}}}else return}Se.from=Ie})(Ke=e.LanguageSelector||(e.LanguageSelector={}));var ce;(function(Se){function Ie(V){return{start:V.start,end:V.end}}Se.from=Ie;function de(V){return new c.NotebookRange(V.start,V.end)}Se.to=de})(ce=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(Se){function Ie(V){return{timing:typeof V.runStartTime=="number"&&typeof V.runEndTime=="number"?{startTime:V.runStartTime,endTime:V.runEndTime}:void 0,executionOrder:V.executionOrder,success:V.lastRunSuccess}}Se.to=Ie;function de(V){return{lastRunSuccess:V.success,runStartTime:V.timing?.startTime,runEndTime:V.timing?.endTime,executionOrder:V.executionOrder}}Se.from=de})(Ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var De;(function(Se){function Ie(de){if(de===E.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(de===E.NotebookCellExecutionState.Pending)return;if(de===E.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Se.to=Ie})(De=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Re;(function(Se){function Ie(V){switch(V){case c.NotebookCellKind.Markup:return E.CellKind.Markup;case c.NotebookCellKind.Code:default:return E.CellKind.Code}}Se.from=Ie;function de(V){switch(V){case E.CellKind.Markup:return c.NotebookCellKind.Markup;case E.CellKind.Code:default:return c.NotebookCellKind.Code}}Se.to=de})(Re=e.NotebookCellKind||(e.NotebookCellKind={}));var Be;(function(Se){function Ie(V){const Pe={metadata:V.metadata??Object.create(null),cells:[]};for(const Fe of V.cells)c.NotebookCellData.validate(Fe),Pe.cells.push(We.from(Fe));return Pe}Se.from=Ie;function de(V){const Pe=new c.NotebookData(V.cells.map(We.to));return(0,b.isEmptyObject)(V.metadata)||(Pe.metadata=V.metadata),Pe}Se.to=de})(Be=e.NotebookData||(e.NotebookData={}));var We;(function(Se){function Ie(V){return{cellKind:Re.from(V.kind),language:V.languageId,mime:V.mime,source:V.value,metadata:V.metadata,internalMetadata:Ce.from(V.executionSummary??{}),outputs:V.outputs?V.outputs.map(rt.from):[]}}Se.from=Ie;function de(V){return new c.NotebookCellData(Re.to(V.cellKind),V.source,V.language,V.mime,V.outputs?V.outputs.map(rt.to):void 0,V.metadata,V.internalMetadata?Ce.to(V.internalMetadata):void 0)}Se.to=de})(We=e.NotebookCellData||(e.NotebookCellData={}));var Ge;(function(Se){function Ie(V){return{mime:V.mime,valueBytes:t.VSBuffer.wrap(V.data)}}Se.from=Ie;function de(V){return new c.NotebookCellOutputItem(V.valueBytes.buffer,V.mime)}Se.to=de})(Ge=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var rt;(function(Se){function Ie(V){return{outputId:V.id,items:V.items.map(Ge.from),metadata:V.metadata}}Se.from=Ie;function de(V){const Pe=V.items.map(Ge.to);return new c.NotebookCellOutput(Pe,V.outputId,V.metadata)}Se.to=de})(rt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(Se){function Ie(Pe){return V(Pe)?{include:(0,b.withNullAsUndefined)($e.from(Pe.include)),exclude:(0,b.withNullAsUndefined)($e.from(Pe.exclude))}:(0,b.withNullAsUndefined)($e.from(Pe))}Se.from=Ie;function de(Pe){return V(Pe)?{include:$e.to(Pe.include),exclude:$e.to(Pe.exclude)}:$e.to(Pe)}Se.to=de;function V(Pe){const Fe=Pe;return Fe?!(0,b.isUndefinedOrNull)(Fe.include)&&!(0,b.isUndefinedOrNull)(Fe.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var et;(function(Se){function Ie(de,V,Pe){const Fe=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Fe,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Se.from=Ie})(et=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var st;(function(Se){function Ie(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Se.from=Ie})(st=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var lt;(function(Se){function Ie(V){return{uri:V.uri,provides:V.provides}}Se.from=Ie;function de(V){return new c.NotebookRendererScript(R.URI.revive(V.uri),V.provides)}Se.to=de})(lt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Se){function Ie(V){return{message:Z.fromStrict(V.message)||"",type:0,expected:V.expectedOutput,actual:V.actualOutput,location:V.location&&{range:o.from(V.location.range),uri:V.location.uri}}}Se.from=Ie;function de(V){const Pe=new c.TestMessage(typeof V.message=="string"?V.message:Z.to(V.message));return Pe.actualOutput=V.actual,Pe.expectedOutput=V.expected,Pe.location=V.location?M.to(V.location):void 0,Pe}Se.to=de})(ft=e.TestMessage||(e.TestMessage={}));var ht;(function(Se){Se.namespace=m.namespaceTestTag,Se.denamespace=m.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var Et;(function(Se){function Ie(V){const Pe=(0,h.getPrivateApiFor)(V).controllerId;return{extId:g.TestId.fromExtHostTestItem(V,Pe).toString(),label:V.label,uri:R.URI.revive(V.uri),busy:V.busy,tags:V.tags.map(Fe=>ht.namespace(Pe,Fe.id)),range:k.Range.lift(o.from(V.range)),description:V.description||null,sortText:V.sortText||null,error:V.error&&Z.fromStrict(V.error)||null}}Se.from=Ie;function de(V){return{parent:void 0,error:void 0,id:g.TestId.fromString(V.extId).localId,label:V.label,uri:R.URI.revive(V.uri),tags:(V.tags||[]).map(Pe=>{const{tagId:Fe}=ht.denamespace(Pe);return new c.TestTag(Fe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(V.range||void 0),canResolveChildren:!1,busy:V.busy,description:V.description||void 0,sortText:V.sortText||void 0}}Se.toPlain=de})(Et=e.TestItem||(e.TestItem={})),function(Se){function Ie(V){return{id:V.id}}Se.from=Ie;function de(V){return new c.TestTag(V.id)}Se.to=de}(ht=e.TestTag||(e.TestTag={}));var Tt;(function(Se){const Ie=(V,Pe)=>{const Fe=[];for(const[ze,tt]of Pe)g.TestId.compare(tt.item.extId,ze)===2&&(Pe.delete(ze),Fe.push(tt));const Xe={...Et.toPlain(V.item),parent:void 0,taskStates:V.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(tt=>tt.type===0).map(ft.to)})),children:Fe.map(ze=>Ie(ze,Pe))};for(const ze of Xe.children)ze.parent=Xe;return Xe};function de(V){const Pe=[],Fe=new Map;for(const Xe of V.items)Fe.set(Xe.item.extId,Xe),V.request.targets.some(ze=>ze.controllerId===Xe.controllerId&&ze.testIds.includes(Xe.item.extId))&&Pe.push(Xe);return{completedAt:V.completedAt,results:Pe.map(Xe=>Ie(Xe,Fe))}}Se.to=de})(Tt=e.TestResults||(e.TestResults={}));var ot;(function(Se){function Ie(Fe){return{covered:Fe.covered,total:Fe.covered}}function de(Fe){return"line"in Fe?i.from(Fe):o.from(Fe)}function V(Fe){return"branches"in Fe?{count:Fe.executionCount,location:de(Fe.location),type:1,branches:Fe.branches.length?Fe.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&de(Xe.location)})):void 0}:{type:0,count:Fe.executionCount,location:de(Fe.location)}}Se.fromDetailed=V;function Pe(Fe){return{uri:Fe.uri,statement:Ie(Fe.statementCoverage),branch:Fe.branchCoverage&&Ie(Fe.branchCoverage),function:Fe.functionCoverage&&Ie(Fe.functionCoverage),details:Fe.detailedCoverage?.map(V)}}Se.fromFile=Pe})(ot=e.TestCoverage||(e.TestCoverage={}));var dt;(function(Se){function Ie(de){switch(de){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Se.to=Ie})(dt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ut;(function(Se){function Ie(V){const Pe=new c.TypeHierarchyItem(U.to(V.kind),V.name,V.detail||"",R.URI.revive(V.uri),o.to(V.range),o.to(V.selectionRange));return Pe._sessionId=V._sessionId,Pe._itemId=V._itemId,Pe}Se.to=Ie;function de(V,Pe,Fe){if(Pe=Pe??V._sessionId,Fe=Fe??V._itemId,Pe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Fe,kind:U.from(V.kind),name:V.name,detail:V.detail??"",uri:V.uri,range:o.from(V.range),selectionRange:o.from(V.selectionRange),tags:V.tags?.map(x.from)}}Se.from=de})(ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var It;(function(Se){function Ie(de){if(!!de)return{value:de.value,tooltip:de.tooltip}}Se.from=Ie})(It=e.ViewBadge||(e.ViewBadge={}));var Pt;(function(Se){function Ie(de,V){const Pe=de.fileData;return Pe?new class extends c.DataTransferItem{asFile(){return{name:Pe.name,uri:R.URI.revive(Pe.uri),data:(0,u.once)(()=>V())}}}("",de.id):new c.DataTransferItem(de.asString)}Se.toDataTransferItem=Ie})(Pt=e.DataTransferItem||(e.DataTransferItem={}));var Rt;(function(Se){function Ie(V,Pe){const Fe=V.items.map(([Xe,ze])=>[Xe,Pt.toDataTransferItem(ze,()=>Pe(ze.id))]);return new c.DataTransfer(Fe)}Se.toDataTransfer=Ie;async function de(V){const Pe={items:[]},Fe=[];return V.forEach((Xe,ze)=>{Fe.push((async()=>{const tt=await Xe.asString(),at=Xe.asFile();Pe.items.push([ze,{id:Xe.id,asString:tt,fileData:at?{name:at.name,uri:at.uri}:void 0}])})())}),await Promise.all(Fe),Pe}Se.toDataTransferDTO=de})(Rt=e.DataTransfer||(e.DataTransfer={}))}),define(ve[252],we([1,0,47,122,80,121,81,127,4]),function(oe,e,v,t,D,C,T,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const b=(f,c,u,r)=>{let o=c;return{enumerable:!0,configurable:!1,get(){return o},set(n){if(!u(o,n)){const i=o;o=n,f.listener?.(r(n,i))}}}},R=(f,c)=>f===c,k={range:(f,c)=>f===c?!0:!f||!c?!1:f.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(f,c)=>!(f.length!==c.length||f.some(u=>!c.find(r=>u.id===r.id)))},S=f=>c=>({op:4,update:f(c)}),y=(f,c)=>({range:(()=>{let u;const r=S(o=>({range:v.Range.lift(P.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return u},set(o){f.listener?.({op:6}),k.range(u,o)||(u=o,f.listener?.(r(o)))}}})(),label:b(f,c,k.label,S(u=>({label:u}))),description:b(f,void 0,k.description,S(u=>({description:u}))),sortText:b(f,void 0,k.sortText,S(u=>({sortText:u}))),canResolveChildren:b(f,!1,k.canResolveChildren,u=>({op:2,state:u})),busy:b(f,!1,k.busy,S(u=>({busy:u}))),error:b(f,void 0,k.error,S(u=>({error:P.MarkdownString.fromStrict(u)||null}))),tags:b(f,[],k.tags,(u,r)=>({op:1,new:u.map(P.TestTag.from),old:r.map(P.TestTag.from)}))}),h=f=>{const c=D.TestId.fromString(f.extId),u=new E(c.controllerId,c.localId,f.label,p.URI.revive(f.uri)||void 0);return u.range=P.Range.to(f.range||void 0),u.description=f.description||void 0,u.sortText=f.sortText||void 0,u.tags=f.tags.map(r=>P.TestTag.to({id:(0,T.denamespaceTestTag)(r).tagId})),u},w=f=>{let c;for(const u of f.tests){const r=h(u.item);(0,t.getPrivateApiFor)(r).parent=c,c=r}return c};e.toItemFromContext=w;class E{constructor(c,u,r,o){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const n=(0,t.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof g?void 0:n.parent}},children:{value:(0,C.createTestItemChildren)(n,t.getPrivateApiFor,E),enumerable:!0,writable:!1},...y(n,r)})}}e.TestItemImpl=E;class g extends E{constructor(c,u){super(c,c,u,void 0)}}e.TestItemRootImpl=g;class m extends C.TestItemCollection{constructor(c,u,r){super({controllerId:c,getDocumentVersion:o=>o&&r.getDocument(o)?.version,getApiFor:t.getPrivateApiFor,getChildren:o=>o.children,root:new g(c,u),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=m}),define(ve[253],we([1,0,35,186,50]),function(oe,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function C(T,P,p,b){const R=new Map;T.forEach(S=>{const y=v.ExtensionIdentifier.toKey(S.identifier),h=R.get(y);h&&b.warn((0,t.localize)(0,null,h.extensionLocation.fsPath,S.extensionLocation.fsPath)),R.set(y,S)}),P.forEach(S=>{const y=v.ExtensionIdentifier.toKey(S.identifier),h=R.get(y);if(h)if(h.isBuiltin){if(D.gte(h.version,S.version)){b.warn(`Skipping extension ${S.extensionLocation.path} in favour of the builtin extension ${h.extensionLocation.path}.`);return}S.isBuiltin=!0}else b.warn((0,t.localize)(1,null,h.extensionLocation.fsPath,S.extensionLocation.fsPath));else if(S.isBuiltin){b.warn(`Skipping obsolete builtin extension ${S.extensionLocation.path}`);return}R.set(y,S)}),p.forEach(S=>{b.info((0,t.localize)(2,null,S.extensionLocation.fsPath));const y=v.ExtensionIdentifier.toKey(S.identifier),h=R.get(y);h&&h.isBuiltin&&(S.isBuiltin=!0),R.set(y,S)});const k=[];return R.forEach(S=>k.push(S)),k}e.dedupExtensions=C}),define(ve[254],we([1,0,3,46,4,63,12,69,98,94,220,6,28,55,253]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class w{constructor(g,m,f,c,u,r,o){if(this._connectionToken=g,this._environmentService=m,this._userDataProfilesService=f,this._logService=u,this._extensionHostStatusService=r,this._extensionsScannerService=o,m.args["install-builtin-extension"]){const i={isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"]};this.whenExtensionsReady=c.installExtensions([],m.args["install-builtin-extension"],i,!!m.args.force).then(null,s=>{u.error(s)})}else this.whenExtensionsReady=Promise.resolve();const n=m.args["install-extension"];if(n){const i=n.map(s=>/\.vsix$/i.test(s)?D.URI.file((0,k.isAbsolute)(s)?s:(0,k.join)((0,S.cwd)(),s)):s);this.whenExtensionsReady.then(()=>c.installExtensions(i,[],{isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"]},!!m.args.force)).then(null,s=>{u.error(s)})}}async call(g,m,f){switch(m){case"getEnvironmentData":{const c=f,u=(0,C.createURITransformer)(c.remoteAuthority);let r=await this._getEnvironmentData();return r=(0,P.transformOutgoingURIs)(r,u),r}case"getExtensionHostExitInfo":{const c=f;return this._extensionHostStatusService.getExitInfo(c.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const c=f,u=c.language;this._logService.trace(`Scanning extensions using UI language: ${u}`);const r=(0,C.createURITransformer)(c.remoteAuthority),o=c.extensionDevelopmentPath&&c.extensionDevelopmentPath.map(s=>D.URI.revive(r.transformIncoming(s))),n=o?o.filter(s=>s.scheme===T.Schemas.file).map(s=>s.fsPath):void 0;let i=await this._scanExtensions(u,n);return i=(0,P.transformOutgoingURIs)(i,r),this._logService.trace("Scanned Extensions",i),w._massageWhenConditions(i),i}case"scanSingleExtension":{await this.whenExtensionsReady;const c=f,u=c.language,r=c.isBuiltin,o=(0,C.createURITransformer)(c.remoteAuthority),n=D.URI.revive(o.transformIncoming(c.extensionLocation)),i=n.scheme===T.Schemas.file?n.fsPath:null;if(!i)return null;let s=await this._scanSingleExtension(i,r,u);return s?(s=(0,P.transformOutgoingURIs)(s,o),w._massageWhenConditions([s]),s):null}case"getDiagnosticInfo":{const c=f,u={machineInfo:(0,R.getMachineInfo)()},r=c.includeProcesses?(0,b.listProcesses)(process.pid):Promise.resolve();let o=[];const n={};if(c.folders){const i=(0,C.createURITransformer)("");o=c.folders.map(a=>D.URI.revive(i.transformIncoming(a))).filter(a=>a.scheme==="file").map(a=>(0,R.collectWorkspaceStats)(a.fsPath,["node_modules",".git"]).then(l=>{n[(0,k.basename)(a.fsPath)]=l}))}return Promise.all([r,...o]).then(([i,s])=>(u.processes=i||void 0,u.workspaceMetadata=c.folders?n:void 0,u))}}throw new Error(`IPC Command ${m} not found`)}listen(g,m,f){throw new Error("Not supported")}static _massageWhenConditions(g){const m=(n,i)=>n.replace(/file/g,"vscode-remote"),f=n=>{let i="";return i+=n.global?"g":"",i+=n.ignoreCase?"i":"",i+=n.multiline?"m":"",new RegExp(m(n.source,!0),i)},c=new class{mapDefined(n){return p.ContextKeyDefinedExpr.create(n)}mapNot(n){return p.ContextKeyNotExpr.create(n)}mapEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.ContextKeyEqualsExpr.create(n,m(i,!1)):p.ContextKeyEqualsExpr.create(n,i)}mapNotEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.ContextKeyNotEqualsExpr.create(n,m(i,!1)):p.ContextKeyNotEqualsExpr.create(n,i)}mapGreater(n,i){return p.ContextKeyGreaterExpr.create(n,i)}mapGreaterEquals(n,i){return p.ContextKeyGreaterEqualsExpr.create(n,i)}mapSmaller(n,i){return p.ContextKeySmallerExpr.create(n,i)}mapSmallerEquals(n,i){return p.ContextKeySmallerEqualsExpr.create(n,i)}mapRegex(n,i){return n==="resourceScheme"&&i?p.ContextKeyRegexExpr.create(n,f(i)):p.ContextKeyRegexExpr.create(n,i)}mapIn(n,i){return p.ContextKeyInExpr.create(n,i)}mapNotIn(n,i){return p.ContextKeyNotInExpr.create(n,i)}},u=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const i=p.ContextKeyExpr.deserialize(n.when);if(!i)return;const s=i.map(c);n.when=s.serialize()},r=n=>{if(Array.isArray(n))for(const i of n)u(i);else u(n)},o=n=>{for(const i in n)r(n[i])};g.forEach(n=>{n.contributes&&(n.contributes.menus&&o(n.contributes.menus),n.contributes.keybindings&&r(n.contributes.keybindings),n.contributes.views&&o(n.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:D.URI.file(this._environmentService.appRoot),settingsPath:this._environmentService.machineSettingsResource,logsPath:D.URI.file(this._environmentService.logsPath),extensionsPath:D.URI.file(this._environmentService.extensionsPath),extensionHostLogsPath:D.URI.file((0,k.join)(this._environmentService.logsPath,`exthost${w._namePool++}`)),globalStorageHome:this._userDataProfilesService.defaultProfile.globalStorageHome,workspaceStorageHome:this._environmentService.workspaceStorageHome,localHistoryHome:this._environmentService.localHistoryHome,userHome:this._environmentService.userHome,os:v.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this._environmentService.args["use-host-proxy"]}}async _scanExtensions(g,m){const[f,c,u]=await Promise.all([this._scanBuiltinExtensions(g),this._scanInstalledExtensions(g),this._scanDevelopedExtensions(g,m)]);return(0,h.dedupExtensions)(f,c,u,this._logService)}async _scanDevelopedExtensions(g,m){return m?(await Promise.all(m.map(f=>this._extensionsScannerService.scanOneOrMultipleExtensions(D.URI.file((0,k.resolve)(f)),1,{language:g})))).flat().map(f=>(0,y.toExtensionDescription)(f,!0)):[]}async _scanBuiltinExtensions(g){return(await this._extensionsScannerService.scanSystemExtensions({language:g,useCache:!0})).map(f=>(0,y.toExtensionDescription)(f,!1))}async _scanInstalledExtensions(g){return(await this._extensionsScannerService.scanUserExtensions({language:g,useCache:!0})).map(f=>(0,y.toExtensionDescription)(f,!1))}async _scanSingleExtension(g,m,f){const c=D.URI.file((0,k.resolve)(g)),u=m?0:1,r=await this._extensionsScannerService.scanExistingExtension(c,u,{language:f});return r?(0,y.toExtensionDescription)(r,!1):null}}e.RemoteAgentEnvironmentChannel=w,w._namePool=1}),define(ve[128],we([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const t=[];function D(P){const p=new v(P);return t[p.nid]=p,p}e.createProxyIdentifier=D;function C(P){return t[P].sid}e.getStringIdentifierForProxy=C;class T{constructor(p){this.value=p}}e.SerializableObjectWithBuffers=T}),define(ve[255],we([1,0,128]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var C;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(C=e.TabModelOperationKind||(e.TabModelOperationKind={}));var T;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var p;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(p=e.CellOutputKind||(e.CellOutputKind={}));var b;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(b=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(E){return E._id=k._n++,E}}e.IdObject=k,k._n=0;var S;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.command="m",w.kindModifier="n"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var y;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(y=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(h=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,v.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,v.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,v.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,v.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,v.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,v.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,v.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,v.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,v.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,v.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,v.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,v.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,v.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,v.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,v.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,v.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,v.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,v.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,v.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,v.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,v.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,v.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,v.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,v.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,v.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,v.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,v.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,v.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,v.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,v.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,v.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,v.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,v.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,v.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,v.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,v.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,v.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,v.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,v.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,v.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,v.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,v.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,v.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,v.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,v.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,v.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,v.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,v.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,v.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,v.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,v.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,v.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,v.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,v.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,v.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,v.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,v.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,v.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,v.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,v.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,v.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,v.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,v.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,v.createProxyIdentifier)("ExtHostLocalization")}});var _t=this&&this.__classPrivateFieldSet||function(oe,e,v,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!D:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(oe,v):D?D.value=v:e.set(oe,v),v},nt=this&&this.__classPrivateFieldGet||function(oe,e,v,t){if(v==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?t:v==="a"?t.call(oe):t?t.value:e.get(oe)};define(ve[256],we([1,0,11,126,127,22,255,18,13,48,47,86,4,2,5,242,252,16,128,38]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m,f){"use strict";var c,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(l,d){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,u.set(this,void 0),_t(this,c,l.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=d,_t(this,u,l.getProxy(T.MainContext.MainThreadTelemetry),"f"),this.converter=new o(this,I=>{const L=this._apiCommands.get(I);return L?.result===i.Void?L:void 0},d),this._argumentProcessors=[{processArgument(I){return(0,b.revive)(I)}},{processArgument(I){return(0,C.cloneAndChange)(I,function(L){if(R.Range.isIRange(L))return D.Range.to(L);if(k.Position.isIPosition(L))return D.Position.to(L);if(R.Range.isIRange(L.range)&&S.URI.isUri(L.uri))return D.location.to(L);if(L instanceof g.VSBuffer)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(l){this._argumentProcessors.push(l)}registerApiCommand(l){const d=this.registerCommand(!1,l.id,async(...I)=>{const L=l.args.map((J,Z)=>{if(!J.validate(I[Z]))throw new Error(`Invalid argument '${J.name}' when running '${l.id}', received: ${I[Z]}`);return J.convert(I[Z])}),B=await this.executeCommand(l.internalId,...L);return l.result.convert(B,I,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this._apiCommands.set(l.id,l),new t.Disposable(()=>{d.dispose(),this._apiCommands.delete(l.id)})}registerCommand(l,d,I,L,B,J){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:I,thisArg:L,description:B,extension:J}),l&&nt(this,c,"f").$registerCommand(d),new t.Disposable(()=>{this._commands.delete(d)&&l&&nt(this,c,"f").$unregisterCommand(d)})}executeCommand(l,...d){return this._logService.trace("ExtHostCommands#executeCommand",l),this._doExecuteCommand(l,d,!0)}async _doExecuteCommand(l,d,I){if(this._commands.has(l))return nt(this,c,"f").$fireCommandActivationEvent(l),this._executeContributedCommand(l,d,!1);{let L=!1;const B=(0,C.cloneAndChange)(d,function(J){if(J instanceof t.Position)return D.Position.from(J);if(J instanceof t.Range)return D.Range.from(J);if(J instanceof t.Location)return D.location.from(J);if(t.NotebookRange.isNotebookRange(J))return D.NotebookRange.from(J);if(J instanceof ArrayBuffer)return L=!0,g.VSBuffer.wrap(new Uint8Array(J));if(J instanceof Uint8Array)return L=!0,g.VSBuffer.wrap(J);if(J instanceof g.VSBuffer)return L=!0,J;if(!Array.isArray(J))return J});try{const J=await nt(this,c,"f").$executeCommand(l,L?new m.SerializableObjectWithBuffers(B):B,I);return(0,b.revive)(J)}catch(J){if(J instanceof Error&&J.message==="$executeCommand:retry")return this._doExecuteCommand(l,d,!1);throw J}}}async _executeContributedCommand(l,d,I){const L=this._commands.get(l);if(!L)throw new Error("Unknown command");this._reportTelemetry(L,l);const{callback:B,thisArg:J,description:Z}=L;if(Z)for(let _=0;_<Z.args.length;_++)try{(0,v.validateConstraint)(d[_],Z.args[_].constraint)}catch{throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${Z.args[_].name}' - ${Z.args[_].description}`)}try{return await B.apply(J,d)}catch(_){if(l===this.converter.delegatingCommandId){const te=this.converter.getActualCommand(...d);te&&(l=te.command)}throw this._logService.error(_,l,L.extension?.identifier),I?new class extends Error{constructor(){super((0,f.toErrorMessage)(_)),this.id=l,this.source=L.extension?.displayName??L.extension?.name}}:_}}_reportTelemetry(l,d){!l.extension||l.extension.isBuiltin||nt(this,u,"f").$publicLog2("Extension:ActionExecuted",{extensionId:l.extension.identifier.value,id:d})}$executeContributedCommand(l,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",l),this._commands.has(l)?(d=d.map(I=>this._argumentProcessors.reduce((L,B)=>B.processArgument(L),I)),this._executeContributedCommand(l,d,!0)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this._logService.trace("ExtHostCommands#getCommands",l),nt(this,c,"f").$getCommands().then(d=>(l&&(d=d.filter(I=>I[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(const[d,I]of this._commands){const{description:L}=I;L&&(l[d]=L)}return Promise.resolve(l)}};c=new WeakMap,u=new WeakMap,r=Ae([_e(0,w.IExtHostRpcService),_e(1,p.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class o{constructor(l,d,I){this._commands=l,this._lookupApiCommand=d,this._logService=I,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(l,d){if(!l)return;const I={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return I;const L=this._lookupApiCommand(l.command);if(L)I.id=L.internalId,I.arguments=L.args.map((B,J)=>B.convert(l.arguments&&l.arguments[J]));else if((0,P.isNonEmptyArray)(l.arguments)){const B=++this._cachIdPool;this._cache.set(B,l),d.add((0,y.toDisposable)(()=>{this._cache.delete(B),this._logService.trace("CommandsConverter#DISPOSE",B)})),I.$ident=B,I.id=this.delegatingCommandId,I.arguments=[B],this._logService.trace("CommandsConverter#CREATE",l.command,B)}return I}fromInternal(l){return typeof l.$ident=="number"?this._cache.get(l.$ident):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this._cache.get(l[0])}_executeConvertedCommand(...l){const d=this.getActualCommand(...l);return this._logService.trace("CommandsConverter#EXECUTE",l[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class n{constructor(l,d,I,L){this.name=l,this.description=d,this.validate=I,this.convert=L}optional(){return new n(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,d){return new n(l??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",a=>S.URI.isUri(a),a=>a),n.Position=new n("position","A position in a text document",a=>t.Position.isPosition(a),D.Position.from),n.Range=new n("range","A range in a text document",a=>t.Range.isRange(a),D.Range.from),n.Selection=new n("selection","A selection in a text document",a=>t.Selection.isSelection(a),D.Selection.from),n.Number=new n("number","",a=>typeof a=="number",a=>a),n.String=new n("string","",a=>typeof a=="string",a=>a),n.CallHierarchyItem=new n("item","A call hierarchy item",a=>a instanceof t.CallHierarchyItem,D.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",a=>a instanceof t.TypeHierarchyItem,D.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",a=>a instanceof E.TestItemImpl,D.TestItem.from);class i{constructor(l,d){this.description=l,this.convert=d}}e.ApiCommandResult=i,i.Void=new i("no result",a=>a);class s{constructor(l,d,I,L,B){this.id=l,this.internalId=d,this.description=I,this.args=L,this.result=B}}e.ApiCommand=s}),define(ve[257],we([1,0,57,270,29,256,4,13,78]),function(oe,e,v,t,D,C,T,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class b{constructor(S,y,h){this._commands=S,this.logService=y,this._ipcHandlePath=h,this._server=t.createServer((w,E)=>this.onRequest(w,E)),this.setup().catch(w=>(y.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",S=>this.logService.error(S))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(S,y){const h=(E,g)=>{y.writeHead(E,{"content-type":"application/json"}),y.end(JSON.stringify(g||null),m=>m&&this.logService.error(m))},w=[];S.setEncoding("utf8"),S.on("data",E=>w.push(E)),S.on("end",async()=>{try{const E=JSON.parse(w.join(""));let g;switch(E.type){case"open":g=await this.open(E);break;case"openExternal":g=await this.openExternal(E);break;case"status":g=await this.getStatus(E);break;case"extensionManagement":g=await this.manageExtensions(E);break;default:h(404,`Unknown message type: ${E.type}`);break}h(200,g)}catch(E){const g=E instanceof Error?E.message:JSON.stringify(E);h(500,g),this.logService.error("Error while processing pipe request",E)}})}async open(S){const{fileURIs:y,folderURIs:h,forceNewWindow:w,diffMode:E,mergeMode:g,addMode:m,forceReuseWindow:f,gotoLineMode:c,waitMarkerFilePath:u,remoteAuthority:r}=S,o=[];if(Array.isArray(h))for(const a of h)try{o.push({folderUri:T.URI.parse(a)})}catch{}if(Array.isArray(y))for(const a of y)try{(0,p.hasWorkspaceFileExtension)(a)?o.push({workspaceUri:T.URI.parse(a)}):o.push({fileUri:T.URI.parse(a)})}catch{}const n=u?T.URI.file(u):void 0,s={forceNewWindow:w,diffMode:E,mergeMode:g,addMode:m,gotoLineMode:c,forceReuseWindow:f,preferNewWindow:!f&&!n&&!m,waitMarkerFileURI:n,remoteAuthority:r};return this._commands.executeCommand("_remoteCLI.windowOpen",o,s),""}async openExternal(S){for(const y of S.uris){const h=T.URI.parse(y),w=h.scheme==="file"?h:y;await this._commands.executeCommand("_remoteCLI.openExternal",w)}}async manageExtensions(S){const y=w=>w?.map(E=>/\.vsix$/i.test(E)?T.URI.parse(E):E),h={list:S.list,install:y(S.install),uninstall:y(S.uninstall),force:S.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",h)}async getStatus(S){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=b;let R=class extends b{constructor(S,y){super(S,y,(0,v.createRandomIPCHandle)())}};R=Ae([_e(0,C.IExtHostCommands),_e(1,P.ILogService)],R),e.CLIServer=R}),define(ve[258],we([1,0,30,7,22,2,6,3,4,57,63,257,244,120,245,247,125]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class g extends w.AbstractVariableResolverService{constructor(c,u,r,o,n){super({getFolderUri:i=>{const s=u.filter(a=>a.name===i);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(i,s)=>o[`config:${s}`],getExecPath:()=>c.VSCODE_EXEC_PATH,getAppRoot:()=>c.VSCODE_CWD,getFilePath:()=>{if(r)return T.normalize(r.fsPath)},getSelectedText:()=>o.selectedText,getLineNumber:()=>o.lineNumber,getExtension:async i=>{const a=(await n.getInstalled()).find(l=>l.identifier.id===i);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(v.homedir()),Promise.resolve(c))}}class m extends C.Disposable{constructor(c,u,r,o,n){super(),this._environmentService=c,this._logService=u,this._ptyService=r,this._productService=o,this._extensionManagementService=n,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(c,u,r){switch(u){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,r);case"$createProcess":{const o=(0,R.createURITransformer)(c.remoteAuthority);return this._createProcess(o,r)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,r);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,r);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,r);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,r);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,r);case"$start":return this._ptyService.start.apply(this._ptyService,r);case"$input":return this._ptyService.input.apply(this._ptyService,r);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,r);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,r);case"$resize":return this._ptyService.resize.apply(this._ptyService,r);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,r);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,r);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,r);case"$sendCommandResult":return this._sendCommandResult(r[0],r[1],r[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,r);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,r);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,r);case"$getProfiles":return this._getProfiles.apply(this,r);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(r[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(r);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,r);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,r);case"$getRevivedPtyNewId":return this._ptyService.getRevivedPtyNewId.apply(this._ptyService,r);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,r);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,r);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,r);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,r);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,r);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(r[0],r[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(r[0],r[1]);case"$freePortKillProcess":return this._ptyService.freePortKillProcess?.apply(r[0],r[1])}throw new Error(`IPC Command ${u} not found`)}listen(c,u,r){switch(u){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(c,u){const r={name:u.shellLaunchConfig.name,executable:u.shellLaunchConfig.executable,args:u.shellLaunchConfig.args,cwd:typeof u.shellLaunchConfig.cwd=="string"||typeof u.shellLaunchConfig.cwd>"u"?u.shellLaunchConfig.cwd:p.URI.revive(c.transformIncoming(u.shellLaunchConfig.cwd)),env:u.shellLaunchConfig.env,useShellEnvironment:u.shellLaunchConfig.useShellEnvironment,reconnectionProperties:u.shellLaunchConfig.reconnectionProperties,type:u.shellLaunchConfig.type,isFeatureTerminal:u.shellLaunchConfig.isFeatureTerminal},o=await(0,E.buildUserEnvironment)(u.resolverEnv,!!u.shellLaunchConfig.useShellEnvironment,P.language,this._environmentService,this._logService);this._logService.trace("baseEnv",o);const n=W=>({uri:p.URI.revive(c.transformIncoming(W.uri)),name:W.name,index:W.index,toResource:()=>{throw new Error("Not implemented")}}),i=u.workspaceFolders.map(n),s=u.activeWorkspaceFolder?n(u.activeWorkspaceFolder):void 0,a=u.activeFileResource?p.URI.revive(c.transformIncoming(u.activeFileResource)):void 0,l=new g(o,i,a,u.resolvedVariables,this._extensionManagementService),d=h.createVariableResolver(s,process.env,l),I=await h.getCwd(r,v.homedir(),d,s?.uri,u.configuration["terminal.integrated.cwd"],this._logService);r.cwd=I;const L=P.isWindows?"terminal.integrated.env.windows":P.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",B=u.configuration[L],J=await h.createTerminalEnvironment(r,B,d,this._productService.version,u.configuration["terminal.integrated.detectLocale"],o);if(!r.strictEnv){const W=[];for(const[X,O]of u.envVariableCollections)W.push([X,{map:(0,y.deserializeEnvironmentVariableCollection)(O)}]);const fe=new Map(W);await new S.MergedEnvironmentVariableCollection(fe).applyToProcessEnvironment(J,d)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:I,cols:u.cols,rows:u.rows,env:J});const Z=(0,b.createRandomIPCHandle)();J.VSCODE_IPC_HOOK_CLI=Z;const _=await this._ptyService.createProcess(r,I,u.cols,u.rows,u.unicodeVersion,J,o,u.options,u.shouldPersistTerminal,u.workspaceId,u.workspaceName),te={executeCommand:(W,...fe)=>this._executeCommand(_,W,fe,c)},se=new k.CLIServerBase(te,this._logService,Z);return this._ptyService.onProcessExit(W=>W.id===_&&se.dispose()),{persistentTerminalId:_,resolvedShellLaunchConfig:r}}_executeCommand(c,u,r,o){let n,i;const s=new Promise((d,I)=>{n=d,i=I}),a=++this._lastReqId;this._pendingCommands.set(a,{resolve:n,reject:i,uriTransformer:o});const l=(0,D.cloneAndChange)(r,d=>{if(d&&d.$mid===1)return o.transformOutgoing(d);if(d&&d instanceof p.URI)return o.transformOutgoingURI(d)});return this._onExecuteCommand.fire({reqId:a,persistentProcessId:c,commandId:u,commandArgs:l}),s}_sendCommandResult(c,u,r){const o=this._pendingCommands.get(c);if(!o)return;this._pendingCommands.delete(c);const n=(0,D.cloneAndChange)(r,i=>{if(i&&i.$mid===1)return o.uriTransformer.transformIncoming(i)});u?o.reject(n):o.resolve(n)}_getDefaultSystemShell(c){return this._ptyService.getDefaultSystemShell(c)}async _getProfiles(c,u,r,o){return this._ptyService.getProfiles?.(c,u,r,o)||[]}_getEnvironment(){return{...process.env}}_getWslPath(c){return this._ptyService.getWslPath(c)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=m}),define(ve[129],we([1,0,5]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,v.createDecorator)("remoteAgentService")}),define(ve[259],we([1,0,10,2,12,200]),function(oe,e,v,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class T extends C.DiskFileSystemProviderClient{static register(p,b,R){const k=p.getConnection();if(!k)return t.Disposable.None;const S=new t.DisposableStore,y=(async()=>{try{const h=await p.getRawEnvironment();h?b.registerProvider(D.Schemas.vscodeRemote,S.add(new T(h,k))):R.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(h){R.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,v.getErrorMessage)(h))}})();return S.add(b.onWillActivateFileSystemProvider(h=>{h.scheme===D.Schemas.vscodeRemote&&h.join(y)})),S}constructor(p,b){super(b.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:p.os===3})}}e.RemoteFileSystemProviderClient=T}),define(ve[130],we([1,0,29,14,6,11,21,158,271,272]),function(oe,e,v,t,D,C,T,P,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(r,o){let n=o.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=r,this.cause=o}}e.ExtractError=R;function k(u){const r=u.externalFileAttributes>>16||33188;return[448,56,7].map(o=>r&o).reduce((o,n)=>o+n,r&61440)}function S(u){if(u instanceof R)return u;let r;return/end of central directory record signature not found/.test(u.message)&&(r="CorruptZip"),new R(r,u)}function y(u,r,o,n,i,s){const a=D.dirname(r),l=D.join(n,a);if(!l.startsWith(n))return Promise.reject(new Error(P.localize(0,null,r)));const d=D.join(n,r);let I;return s.onCancellationRequested(()=>{I?.destroy()}),Promise.resolve(T.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((L,B)=>{if(!s.isCancellationRequested)try{I=(0,v.createWriteStream)(d,{mode:o}),I.once("close",()=>L()),I.once("error",B),u.once("error",B),u.pipe(I)}catch(J){B(J)}}))}function h(u,r,o,n){let i=(0,t.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{i.cancel(),u.close()}),new Promise((a,l)=>{const d=new t.Sequencer,I=L=>{L.isCancellationRequested||(s++,u.readEntry())};u.once("error",l),u.once("close",()=>i.then(()=>{n.isCancellationRequested||u.entryCount===s?a():l(new R("Incomplete",new Error(P.localize(1,null,s,u.entryCount))))},l)),u.readEntry(),u.on("entry",L=>{if(n.isCancellationRequested)return;if(!o.sourcePathRegex.test(L.fileName)){I(n);return}const B=L.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(B)){const _=D.join(r,B);i=(0,t.createCancelablePromise)(te=>T.Promises.mkdir(_,{recursive:!0}).then(()=>I(te)).then(void 0,l));return}const J=E(u,L),Z=k(L);i=(0,t.createCancelablePromise)(_=>d.queue(()=>J.then(te=>y(te,B,Z,r,o,_).then(()=>I(_)))).then(null,l))})})}function w(u,r=!1){return new Promise((o,n)=>{(0,p.open)(u,r?{lazyEntries:!0}:void 0,(i,s)=>{i?n(S(i)):o((0,C.assertIsDefined)(s))})})}function E(u,r){return new Promise((o,n)=>{u.openReadStream(r,(i,s)=>{i?n(S(i)):o((0,C.assertIsDefined)(s))})})}function g(u,r){return new Promise((o,n)=>{const i=new b.ZipFile;r.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const s=(0,v.createWriteStream)(u);i.outputStream.pipe(s),i.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>o(u))})}e.zip=g;function m(u,r,o={},n){const i=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=w(u,!0);return o.overwrite&&(s=s.then(a=>T.Promises.rm(r).then(()=>a))),s.then(a=>h(a,r,{sourcePathRegex:i},n))}e.extract=m;function f(u,r){return w(u).then(o=>new Promise((n,i)=>{o.on("entry",s=>{s.fileName===r&&E(o,s).then(a=>n(a),a=>i(a))}),o.once("close",()=>i(new Error(P.localize(2,null,r))))}))}function c(u,r){return f(u,r).then(o=>new Promise((n,i)=>{const s=[];o.once("error",i),o.on("data",a=>s.push(a)),o.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=c}),define(ve[260],we([1,0,130,168]),function(oe,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(C){return(0,v.buffer)(C,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=D}),define(ve[131],we([1,0,14,38,10,2,12,6,3,19,50,11,4,23,21,130,167,72,26,235,31,32,53,55,213,236,260,214,234,35,70,17,5,13,27,33,39,37]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m,f,c,u,r,o,n,i,s,a,l,d,I,L,B,J,Z,_,te,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,B.refineServiceDecorator)(c.IExtensionManagementService);let W=class extends f.AbstractExtensionManagementService{constructor(Q,re,F,M,G,ie,he,Ee,$,Y,ee,z){super(Q,re,F,Y,z),this.extensionsScannerService=G,this.extensionsProfileScannerService=ie,this.downloadService=he,this.fileService=$,this.installGalleryExtensionsTasks=new Map;const q=this._register(Ee.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(Ee.createInstance(fe,K=>q.postUninstall(K))),this.manifestCache=this._register(new a.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(Ee.createInstance(n.ExtensionsDownloader));const H=this._register(new l.ExtensionsWatcher(this,$,M,F,ee));this._register(H.onDidChangeExtensionsByAnotherSource(({added:K,removed:le})=>{K.length&&this._onDidInstallExtensions.fire(K.map(pe=>({identifier:pe.identifier,operation:1,local:pe}))),le.forEach(pe=>this._onDidUninstallExtension.fire({identifier:pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(Q){this.logService.trace("ExtensionManagementService#zip",Q.identifier.id);const re=await this.collectFiles(Q),F=await(0,w.zip)((0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)()).fsPath,re);return S.URI.file(F)}async unzip(Q){return this.logService.trace("ExtensionManagementService#unzip",Q.toString()),(await this.install(Q)).identifier}async getManifest(Q){const{location:re,cleanup:F}=await this.downloadVsix(Q),M=P.resolve(re.fsPath);try{return await(0,s.getManifest)(M)}finally{await F()}}getInstalled(Q,re){return this.extensionsScanner.scanExtensions(Q??null,re)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(Q,re={}){this.logService.trace("ExtensionManagementService#install",Q.toString());const{location:F,cleanup:M}=await this.downloadVsix(Q);try{const G=await(0,s.getManifest)(P.resolve(F.fsPath));if(G.engines&&G.engines.vscode&&!(0,I.isEngineValid)(G.engines.vscode,this.productService.version,this.productService.date))throw new Error(E.localize(0,null,(0,u.getGalleryExtensionId)(G.publisher,G.name),this.productService.version));return await this.installExtension(G,F,re)}finally{await M()}}getMetadata(Q){return this.extensionsScannerService.scanMetadata(Q.location)}async updateMetadata(Q,re){this.logService.trace("ExtensionManagementService#updateMetadata",Q.identifier.id);const F={...re};return re.isPreReleaseVersion&&(F.preRelease=!0),Q=await this.extensionsScanner.updateMetadata(Q,F),this.manifestCache.invalidate(),Q}async updateExtensionScope(Q,re){return this.logService.trace("ExtensionManagementService#updateExtensionScope",Q.identifier.id),Q=await this.extensionsScanner.updateMetadata(Q,{isMachineScoped:re}),this.manifestCache.invalidate(),Q}removeUninstalledExtensions(Q){return this.extensionsScanner.cleanUp(Q)}async downloadVsix(Q){if(Q.scheme===T.Schemas.file)return{location:Q,async cleanup(){}};this.logService.trace("Downloading extension from",Q.toString());const re=(0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)());return await this.downloadService.download(Q,re),this.logService.info("Downloaded extension to",re.toString()),{location:re,cleanup:async()=>{try{await this.fileService.del(re)}catch(M){this.logService.error(M)}}}}doCreateInstallExtensionTask(Q,re,F){let M;if(S.URI.isUri(re))M=new O(Q,re,F,this.galleryService,this.extensionsScanner,this.logService);else{const G=u.ExtensionKey.create(re).toString();M=this.installGalleryExtensionsTasks.get(G),M||(this.installGalleryExtensionsTasks.set(G,M=new X(Q,re,F,this.extensionsDownloader,this.extensionsScanner,this.logService)),M.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(G)))}return F.profileLocation?new U(M,F.profileLocation,this.extensionsProfileScannerService):M}doCreateUninstallExtensionTask(Q,re){return re.profileLocation?new ae(Q,re.profileLocation,this.extensionsProfileScannerService):new x(Q,re,this.extensionsScanner)}async collectFiles(Q){const re=async M=>{let G=await h.Promises.readdir(M);G=G.map(Ee=>P.join(M,Ee));const ie=await Promise.all(G.map(Ee=>h.Promises.stat(Ee)));let he=Promise.resolve([]);return ie.forEach((Ee,$)=>{const Y=G[$];Ee.isFile()&&(he=he.then(ee=>[...ee,Y])),Ee.isDirectory()&&(he=he.then(ee=>re(Y).then(z=>[...ee,...z])))}),he};return(await re(Q.location.fsPath)).map(M=>({path:`extension/${P.relative(Q.location.fsPath,M)}`,localPath:M}))}};W=Ae([_e(0,c.IExtensionGalleryService),_e(1,_.ITelemetryService),_e(2,J.ILogService),_e(3,m.INativeEnvironmentService),_e(4,o.IExtensionsScannerService),_e(5,r.IExtensionsProfileScannerService),_e(6,g.IDownloadService),_e(7,B.IInstantiationService),_e(8,L.IFileService),_e(9,Z.IProductService),_e(10,te.IUriIdentityService),_e(11,se.IUserDataProfilesService)],W),e.ExtensionManagementService=W;let fe=class extends C.Disposable{constructor(Q,re,F,M){super(),this.beforeRemovingExtension=Q,this.fileService=re,this.extensionsScannerService=F,this.logService=M,this.uninstalledPath=(0,b.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new v.Queue}async cleanUp(Q){await this.removeUninstalledExtensions(),Q&&await this.removeOutdatedExtensions()}async scanExtensions(Q,re){const F={includeInvalid:!0,profileLocation:re};let M=[];return Q===null||Q===0?M.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},F,!1)):Q===1&&M.push(...await this.extensionsScannerService.scanUserExtensions(F)),M=Q!==null?M.filter(G=>G.type===Q):M,Promise.all(M.map(G=>this.toLocalExtension(G)))}async scanUserExtensions(Q){const re=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!Q,includeInvalid:!0});return Promise.all(re.map(F=>this.toLocalExtension(F)))}async extractUserExtension(Q,re,F,M){const G=Q.toString(),ie=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),he=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,G);try{await h.Promises.rm(he)}catch{throw new c.ExtensionManagementError(E.localize(1,null,he,Q.id),c.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(Q,re,ie,M),await this.extensionsScannerService.updateMetadata(S.URI.file(ie),F);try{await this.rename(Q,ie,he,Date.now()+2*60*1e3),this.logService.info("Renamed to",he)}catch(Ee){try{await h.Promises.rm(ie)}catch{}if(Ee.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",Q.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(Ee)}. Deleted from extracted location`,ie),Ee}return this.scanLocalExtension(S.URI.file(he),1)}async updateMetadata(Q,re){return await this.extensionsScannerService.updateMetadata(Q.location,re),this.scanLocalExtension(Q.location,Q.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...Q){const re=Q.map(F=>u.ExtensionKey.create(F));await this.withUninstalledExtensions(F=>{re.forEach(M=>F[M.toString()]=!0)})}async setInstalled(Q){await this.withUninstalledExtensions(M=>delete M[Q.toString()]);const F=(await this.scanUserExtensions(!0)).find(M=>u.ExtensionKey.create(M).equals(Q))||null;return F?this.updateMetadata(F,{installedTimestamp:Date.now()}):null}async removeExtension(Q,re){this.logService.trace(`Deleting ${re} extension from disk`,Q.identifier.id,Q.location.fsPath),await h.Promises.rm(Q.location.fsPath),this.logService.info("Deleted from disk",Q.identifier.id,Q.location.fsPath)}async removeUninstalledExtension(Q){await this.removeExtension(Q,"uninstalled"),await this.withUninstalledExtensions(re=>delete re[u.ExtensionKey.create(Q).toString()])}async withUninstalledExtensions(Q){return this.uninstalledFileLimiter.queue(async()=>{let re;try{re=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(M){if(M.code!=="ENOENT")throw M}let F={};if(re)try{F=JSON.parse(re)}catch{}return Q&&(Q(F),Object.keys(F).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(F)):await h.Promises.rm(this.uninstalledPath)),F})}async extractAtLocation(Q,re,F,M){this.logService.trace(`Started extracting the extension from ${re} to ${F}`);try{await h.Promises.rm(F)}catch(G){throw new c.ExtensionManagementError(this.joinErrors(G).message,c.ExtensionManagementErrorCode.Delete)}try{await(0,w.extract)(re,F,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${F}:`,Q.id)}catch(G){try{await h.Promises.rm(F)}catch{}let ie=c.ExtensionManagementErrorCode.Extract;throw G instanceof w.ExtractError&&(G.type==="CorruptZip"?ie=c.ExtensionManagementErrorCode.CorruptZip:G.type==="Incomplete"&&(ie=c.ExtensionManagementErrorCode.IncompleteZip)),new c.ExtensionManagementError(G.message,ie)}}async rename(Q,re,F,M){try{await h.Promises.rename(re,F)}catch(G){if(p.isWindows&&G&&G.code==="EPERM"&&Date.now()<M)return this.logService.info(`Failed renaming ${re} to ${F} with 'EPERM' error. Trying again...`,Q.id),this.rename(Q,re,F,M);throw new c.ExtensionManagementError(G.message||E.localize(2,null,re,F),G.code||c.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(Q,re){const F=await this.extensionsScannerService.scanExistingExtension(Q,re,{includeInvalid:!0});if(F)return this.toLocalExtension(F);throw new Error(E.localize(3,null,Q.path))}async toLocalExtension(Q){const re=await this.fileService.resolve(Q.location);let F,M;return re.children&&(F=re.children.find(({name:G})=>/^readme(\.txt|\.md|)$/i.test(G))?.resource,M=re.children.find(({name:G})=>/^changelog(\.txt|\.md|)$/i.test(G))?.resource),{identifier:Q.identifier,type:Q.type,isBuiltin:Q.isBuiltin||!!Q.metadata?.isBuiltin,location:Q.location,manifest:Q.manifest,targetPlatform:Q.targetPlatform,validations:Q.validations,isValid:Q.isValid,readmeUrl:F,changelogUrl:M,publisherDisplayName:Q.metadata?.publisherDisplayName||null,publisherId:Q.metadata?.publisherId||null,isApplicationScoped:!!Q.metadata?.isApplicationScoped,isMachineScoped:!!Q.metadata?.isMachineScoped,isPreReleaseVersion:!!Q.metadata?.isPreReleaseVersion,preRelease:!!Q.metadata?.preRelease,installedTimestamp:Q.metadata?.installedTimestamp,updated:!!Q.metadata?.updated}}async removeUninstalledExtensions(){const Q=await this.getUninstalledExtensions(),re=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),F=new Set;for(const ie of re)Q[u.ExtensionKey.create(ie).toString()]||F.add(ie.identifier.id.toLowerCase());const M=(0,u.groupByExtension)(re,ie=>ie.identifier);await v.Promises.settled(M.map(async ie=>{const he=ie.sort((Ee,$)=>R.rcompare(Ee.manifest.version,$.manifest.version))[0];F.has(he.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(he))}));const G=re.filter(ie=>Q[u.ExtensionKey.create(ie).toString()]);await v.Promises.settled(G.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const Q=await this.extensionsScannerService.scanSystemExtensions({}),re=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),F=[],M=await this.extensionsScannerService.getTargetPlatform(),G=(0,u.groupByExtension)(re,ie=>ie.identifier);for(const ie of G)if(ie.length>1&&F.push(...ie.sort((he,Ee)=>{const $=R.rcompare(he.manifest.version,Ee.manifest.version);return $!==0?$:he.targetPlatform===M?-1:1}).slice(1)),ie[0].type===0){const he=Q.find(Ee=>(0,u.areSameExtensions)(Ee.identifier,ie[0].identifier));(!he||R.gte(he.manifest.version,ie[0].manifest.version))&&F.push(ie[0])}await v.Promises.settled(F.map(ie=>this.removeExtension(ie,"outdated")))}joinErrors(Q){const re=Array.isArray(Q)?Q:[Q];return re.length===1?re[0]instanceof Error?re[0]:new Error(re[0]):re.reduce((F,M)=>new Error(`${F.message}${F.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};fe=Ae([_e(1,L.IFileService),_e(2,o.IExtensionsScannerService),_e(3,J.ILogService)],fe);class j extends f.AbstractExtensionTask{get operation(){return(0,k.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(Q,re,F,M,G){super(),this.identifier=Q,this.source=re,this.options=F,this.extensionsScanner=M,this.logService=G,this._operation=2}async installExtension(Q,re){try{const F=await this.unsetUninstalledAndGetLocal(Q.key);if(F)return this.extensionsScanner.updateMetadata(F,Q.metadata)}catch{throw p.isMacintosh?new c.ExtensionManagementError(E.localize(4,null),c.ExtensionManagementErrorCode.Internal):new c.ExtensionManagementError(E.localize(5,null),c.ExtensionManagementErrorCode.Internal)}return this.extract(Q,re)}async unsetUninstalledAndGetLocal(Q){if(!await this.isUninstalled(Q))return null;this.logService.trace("Removing the extension from uninstalled list:",Q.id);const F=await this.extensionsScanner.setInstalled(Q);return this.logService.info("Removed the extension from uninstalled list:",Q.id),F}async isUninstalled(Q){return!!(await this.extensionsScanner.getUninstalledExtensions())[Q.toString()]}async extract({zipPath:Q,key:re,metadata:F},M){const G=await this.extensionsScanner.extractUserExtension(re,Q,F,M);return this.logService.info("Extracting completed.",re.id),G}}class X extends j{constructor(Q,re,F,M,G,ie){super(re.identifier,re,F,G,ie),this.manifest=Q,this.gallery=re,this.extensionsDownloader=M}async doRun(Q){const F=(await this.extensionsScanner.scanExtensions(null,void 0)).find(ie=>(0,u.areSameExtensions)(ie.identifier,this.gallery.identifier));F&&(this._operation=3);const M={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,d.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,isSystem:F?.type===0?!0:void 0,updated:!!F,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,k.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:F?.preRelease)};if(F?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(F,M),metadata:M};const G=await this.downloadExtension(this.gallery,this._operation);try{const ie=await this.installExtension({zipPath:G,key:u.ExtensionKey.create(this.gallery),metadata:M},Q);return F&&!this.options.profileLocation&&(F.targetPlatform!==ie.targetPlatform||R.neq(F.manifest.version,ie.manifest.version))&&await this.extensionsScanner.setUninstalled(F),{local:ie,metadata:M}}catch(ie){throw await this.deleteDownloadedVSIX(G),ie}}async deleteDownloadedVSIX(Q){try{await this.extensionsDownloader.delete(S.URI.file(Q))}catch(re){this.logService.warn("Error while deleting the downloaded vsix",Q.toString(),(0,D.getErrorMessage)(re))}}async downloadExtension(Q,re){let F;try{this.logService.trace("Started downloading extension:",Q.identifier.id),F=(await this.extensionsDownloader.downloadExtension(Q,re)).fsPath,this.logService.info("Downloaded extension:",Q.identifier.id,F)}catch(M){throw new c.ExtensionManagementError((0,f.joinErrors)(M).message,c.ExtensionManagementErrorCode.Download)}try{return await(0,s.getManifest)(F),F}catch(M){throw await this.deleteDownloadedVSIX(F),new c.ExtensionManagementError((0,f.joinErrors)(M).message,c.ExtensionManagementErrorCode.Invalid)}}}class O extends j{constructor(Q,re,F,M,G,ie){super({id:(0,u.getGalleryExtensionId)(Q.publisher,Q.name)},re,F,G,ie),this.manifest=Q,this.location=re,this.galleryService=M}async doRun(Q){const re=new u.ExtensionKey(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1,void 0)).find(he=>(0,u.areSameExtensions)(this.identifier,he.identifier)),G=await this.getMetadata(this.identifier.id,this.manifest.version,Q);if(G.isApplicationScoped=(0,d.isApplicationScopedExtension)(this.manifest),G.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,G.isBuiltin=this.options.isBuiltin||M?.isBuiltin,G.installedTimestamp=Date.now(),M)if(this._operation=3,re.equals(new u.ExtensionKey(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(E.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&R.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const he=await this.unsetUninstalledAndGetLocal(re);if(he)try{await this.extensionsScanner.removeExtension(he,"existing")}catch{throw new Error(E.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:P.resolve(this.location.fsPath),key:re,metadata:G},Q),metadata:G}}async getMetadata(Q,re,F){try{let[M]=await this.galleryService.getExtensions([{id:Q,version:re}],F);if(M||([M]=await this.galleryService.getExtensions([{id:Q}],F)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class U{constructor(Q,re,F){this.task=Q,this.profileLocation=re,this.extensionsProfileScannerService=F,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const Q=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[Q.local,Q.metadata]],this.profileLocation),Q}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class x extends f.AbstractExtensionTask{constructor(Q,re,F){super(),this.extension=Q,this.options=re,this.extensionsScanner=F}async doRun(Q){const re=[],F=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=u.ExtensionKey.create(this.extension);re.push(...F.filter(G=>M.equals(u.ExtensionKey.create(G))))}else re.push(...F.filter(M=>(0,u.areSameExtensions)(M.identifier,this.extension.identifier)));if(!re.length)throw new Error(E.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...re),this.options.remove)for(const M of re)try{Q.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(G){throw new Error(E.localize(9,null,(0,t.toErrorMessage)(G)))}}}class ae extends f.AbstractExtensionTask{constructor(Q,re,F){super(),this.extension=Q,this.profileLocation=re,this.extensionsProfileScannerService=F}async doRun(Q){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ve[132],we([1,0,76,14,16,10,2,11,25,26,77,13,217,273]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let h=class extends T.Disposable{constructor(E,g,m){super(),this.environmentService=g,this.logService=m,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,g){this.logService.trace("RequestService#request (node) - begin",E.url);const{proxyUrl:m,strictSSL:f}=this;let c;try{c=await(0,R.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const u={...process.env,...c},r=E.agent?E.agent:await(0,S.getProxyAgent)(E.url||"",u,{proxyUrl:m,strictSSL:f});E.agent=r,E.strictSSL=f,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(E,g);return this.logService.trace("RequestService#request (node) - success",E.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",E.url,o),o}}async getNodeRequest(E){return((0,v.parse)(E.url).protocol==="https:"?await new Promise((f,c)=>{oe(["https"],f,c)}):await new Promise((f,c)=>{oe(["http"],f,c)})).request}_request(E,g){return t.Promises.withAsyncBody(async(m,f)=>{const c=(0,v.parse)(E.url),u=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),r={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,P.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(r.auth=E.user+":"+E.password);const o=u(r,n=>{const i=(0,P.isNumber)(E.followRedirects)?E.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...E,url:n.headers.location,followRedirects:i-1},g).then(m,f);else{let s=n;n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,y.createGunzip)())),m({res:n,stream:(0,D.streamToBufferReadableStream)(s)})}});o.on("error",f),E.timeout&&o.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&o.write(E.data),o.end(),g.onCancellationRequested(()=>{o.abort(),f(new C.CancellationError)})})}async resolveProxy(E){}};h=Ae([_e(0,p.IConfigurationService),_e(1,b.INativeEnvironmentService),_e(2,k.ILogService)],h),e.RequestService=h}),define(ve[261],we([1,0,73,13,59,105,25,54,132,42,33,31,114,131,100,51,2,101,61,12,17,27,103,129,43,107,74,108,10,4,6,28,215,72,39,113,58,3,55,117,37,53,62]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m,f,c,u,r,o,n,i,s,a,l,d,I,L,B,J,Z,_,te,se,W,fe,j,X,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class U extends E.Disposable{constructor(Q,re){super(),this.args=Q,this.remoteDataFolder=re,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const Q=await this.initServices();await Q.invokeFunction(async re=>{const F=re.get(t.ILogService);try{await this.doRun(Q.createInstance(i.ExtensionManagementCLI))}catch(M){throw F.error(M),console.error((0,l.getErrorMessage)(M)),M}})}async initServices(){const Q=new v.ServiceCollection,re={_serviceBrand:void 0,...w.default};Q.set(u.IProductService,re);const F=new n.ServerEnvironmentService(this.args,re);Q.set(n.IServerEnvironmentService,F);const M=new t.LogService(new r.SpdLogLogger(o.RemoteExtensionLogFileName,(0,I.join)(F.logsPath,`${o.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(F)));Q.set(t.ILogService,M),M.trace(`Remote configuration data at ${this.remoteDataFolder}`),M.trace("process arguments:",this.args);const G=this._register(new g.FileService(M));Q.set(c.IFileService,G),G.registerProvider(f.Schemas.file,this._register(new m.DiskFileSystemProvider(M)));const ie=new _.UriIdentityService(G);Q.set(Z.IUriIdentityService,ie);const he=this._register(new j.UserDataProfilesService(F,G,ie,M));Q.set(j.IUserDataProfilesService,he);const Ee=this._register(new C.ConfigurationService(he.defaultProfile.settingsResource,G,new O.NullPolicyService,M));return await Ee.initialize(),Q.set(T.IConfigurationService,Ee),Q.set(P.IRequestService,new D.SyncDescriptor(p.RequestService)),Q.set(J.IDownloadService,new D.SyncDescriptor(B.DownloadService)),Q.set(R.ITelemetryService,b.NullTelemetryService),Q.set(k.IExtensionGalleryService,new D.SyncDescriptor(S.ExtensionGalleryServiceWithNoStorageService)),Q.set(X.IExtensionsProfileScannerService,new D.SyncDescriptor(X.ExtensionsProfileScannerService)),Q.set(W.IExtensionsScannerService,new D.SyncDescriptor(fe.ExtensionsScannerService)),Q.set(y.INativeServerExtensionManagementService,new D.SyncDescriptor(y.ExtensionManagementService)),Q.set(s.ILanguagePackService,new D.SyncDescriptor(a.NativeLanguagePackService)),new h.InstantiationService(Q)}async doRun(Q){if(this.args["list-extensions"])return Q.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const re={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return Q.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],re,!!this.args.force)}else{if(this.args["uninstall-extension"])return Q.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return Q.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(Q){return Q.map(re=>/\.vsix$/i.test(re)?d.URI.file((0,I.isAbsolute)(re)?re:(0,I.join)((0,L.cwd)(),re)):re)}}function x(ue){setTimeout(()=>process.exit(ue),0)}async function ae(ue,Q,re){if(ue.help){const M=w.default.serverApplicationName+(se.isWindows?".cmd":"");console.log((0,te.buildHelpMessage)(w.default.nameLong,M,w.default.version,re,{noInputFiles:!0,noPipe:!0}));return}if(ue.version){console.log((0,te.buildVersionMessage)(w.default.version,w.default.commit));return}const F=new U(ue,Q);try{await F.run(),x(0)}catch{x(1)}finally{F.dispose()}}e.run=ae}),define(ve[262],we([1,0,30,7,2,12,6,91,21,41,25,105,71,210,187,72,188,198,189,26,114,31,107,199,131,17,101,61,59,100,73,74,108,13,102,103,51,27,54,216,132,110,33,42,226,111,233,39,113,254,243,219,224,258,63,43,249,129,259,115,55,117,53,37,62,225]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m,f,c,u,r,o,n,i,s,a,l,d,I,L,B,J,Z,_,te,se,W,fe,j,X,O,U,x,ae,ue,Q,re,F,M,G,ie,he,Ee,$,Y,ee,z,q,H,K,le,pe,ke,Te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Ne="monacoworkbench";async function Le(qe,Ve,xe,Ye){const $e=new I.ServiceCollection,Ke=new ye,ce={_serviceBrand:void 0,...te.default};$e.set(se.IProductService,ce);const Ce=new $.ServerEnvironmentService(Ve,ce);$e.set(f.IEnvironmentService,Ce),$e.set(f.INativeEnvironmentService,Ce);const De=new J.LogService(new _.SpdLogLogger(ee.RemoteExtensionLogFileName,T.join(Ce.logsPath,`${ee.RemoteExtensionLogFileName}.log`),!0,!1,(0,J.getLogLevel)(Ce))),Re=new J.MultiplexLogService([new Me((0,J.getLogLevel)(Ce)),De]);$e.set(J.ILogService,Re),setTimeout(()=>je(Ce.logsPath).then(null,ot=>Re.error(ot)),1e4),Re.trace(`Remote configuration data at ${xe}`),Re.trace("process arguments:",Ce.args),Array.isArray(ce.serverGreeting)&&De.info(`

${ce.serverGreeting.join(`
`)}

`),Ke.registerChannel(h.ExtensionHostDebugBroadcastChannel.ChannelName,new h.ExtensionHostDebugBroadcastChannel);const Be=new b.StaticRouter(ot=>ot.clientId==="renderer");Ke.registerChannel("logger",new Z.LogLevelChannel(Re));const We=Ye.add(new s.FileService(Re));$e.set(i.IFileService,We),We.registerProvider(C.Schemas.file,Ye.add(new a.DiskFileSystemProvider(Re)));const Ge=new re.UriIdentityService(We);$e.set(Q.IUriIdentityService,Ge);const rt=new pe.UserDataProfilesService(Ce,We,Ge,Re);$e.set(pe.IUserDataProfilesService,rt);const it=new k.ConfigurationService(Ce.machineSettingsResource,We,new ke.NullPolicyService,Re);$e.set(R.IConfigurationService,it),await it.initialize();const et=new q.ExtensionHostStatusService;$e.set(q.IExtensionHostStatusService,et),$e.set(W.IRequestService,new l.SyncDescriptor(j.RequestService));let st=U.NullAppender;const lt=await(0,P.getMachineId)(),ft=(0,U.isInternalTelemetry)(ce,it);if((0,U.supportsTelemetry)(ce,Ce)){ce.aiConfig&&ce.aiConfig.ariaKey&&(st=new Te.OneDataSystemAppender(ft,Ne,null,ce.aiConfig.ariaKey),Ye.add((0,D.toDisposable)(()=>st?.flush())));const ot={appenders:[st],commonProperties:(0,X.resolveCommonProperties)(We,(0,v.release)(),(0,v.hostname)(),process.arch,ce.commit,ce.version+"-remote",lt,ft,Ce.installSourcePath,"remoteAgent"),piiPaths:(0,U.getPiiPathsFromEnvironment)(Ce)},dt=Ce.args["telemetry-level"];let ut=3;dt==="all"?ut=3:dt==="error"?ut=2:dt==="crash"?ut=1:dt!==void 0&&(ut=0),$e.set(ie.IServerTelemetryService,new l.SyncDescriptor(ie.ServerTelemetryService,[ot,ut]))}else $e.set(ie.IServerTelemetryService,ie.ServerNullTelemetryService);$e.set(u.IExtensionGalleryService,new l.SyncDescriptor(c.ExtensionGalleryServiceWithNoStorageService));const ht=Ke.getChannel("download",Be);$e.set(w.IDownloadService,new E.DownloadServiceChannelClient(ht,()=>be("renderer"))),$e.set(le.IExtensionsProfileScannerService,new l.SyncDescriptor(le.ExtensionsProfileScannerService)),$e.set(H.IExtensionsScannerService,new l.SyncDescriptor(K.ExtensionsScannerService)),$e.set(n.INativeServerExtensionManagementService,new l.SyncDescriptor(n.ExtensionManagementService));const Et=new d.InstantiationService($e);$e.set(L.ILanguagePackService,Et.createInstance(B.NativeLanguagePackService));const Tt=Et.createInstance(ue.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:it.getValue("terminal.integrated.persistentSessionScrollback")??100});return $e.set(ae.IPtyService,Tt),$e.set(g.IEncryptionMainService,new l.SyncDescriptor(m.EncryptionMainService,[lt])),$e.set(S.ICredentialsMainService,new l.SyncDescriptor(y.CredentialsWebMainService)),Et.invokeFunction(ot=>{const dt=ot.get(n.INativeServerExtensionManagementService),ut=ot.get(H.IExtensionsScannerService),It=new F.RemoteAgentEnvironmentChannel(qe,Ce,rt,Et.createInstance(r.ExtensionManagementCLI),Re,et,ut);Ke.registerChannel("remoteextensionsenvironment",It);const Pt=new G.ServerTelemetryChannel(ot.get(ie.IServerTelemetryService),st);Ke.registerChannel("telemetry",Pt),Ke.registerChannel(Y.REMOTE_TERMINAL_CHANNEL_NAME,new he.RemoteTerminalChannel(Ce,Re,Tt,ce,dt));const Rt=new M.RemoteAgentFileSystemProviderChannel(Re,Ce);Ke.registerChannel(z.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Rt),Ke.registerChannel("request",new fe.RequestChannel(ot.get(W.IRequestService)));const Se=new o.ExtensionManagementChannel(dt,V=>be(V.remoteAuthority));Ke.registerChannel("extensions",Se);const Ie=b.ProxyChannel.fromService(ot.get(g.IEncryptionMainService));Ke.registerChannel("encryption",Ie);const de=b.ProxyChannel.fromService(ot.get(S.ICredentialsMainService));return Ke.registerChannel("credentials",de),dt.removeUninstalledExtensions(!0),Ye.add(new x.default(ot.get(O.ITelemetryService))),{telemetryService:ot.get(O.ITelemetryService)}}),{socketServer:Ke,instantiationService:Et}}e.setupServerServices=Le;const me=Object.create(null);function be(qe){return me[qe]||(me[qe]=(0,Ee.createURITransformer)(qe)),me[qe]}class ye extends b.IPCServer{constructor(){const Ve=new t.Emitter;super(Ve.event),this._onDidConnectEmitter=Ve}acceptConnection(Ve,xe){this._onDidConnectEmitter.fire({protocol:Ve,onDidClientDisconnect:xe})}}e.SocketServer=ye;class Me extends J.AbstractLogger{constructor(Ve=J.DEFAULT_LOG_LEVEL){super(),this.setLevel(Ve),this.useColors=Boolean(process.stdout.isTTY)}trace(Ve,...xe){this.getLevel()<=J.LogLevel.Trace&&(this.useColors?console.log(`\x1B[90m[${Oe()}]\x1B[0m`,Ve,...xe):console.log(`[${Oe()}]`,Ve,...xe))}debug(Ve,...xe){this.getLevel()<=J.LogLevel.Debug&&(this.useColors?console.log(`\x1B[90m[${Oe()}]\x1B[0m`,Ve,...xe):console.log(`[${Oe()}]`,Ve,...xe))}info(Ve,...xe){this.getLevel()<=J.LogLevel.Info&&(this.useColors?console.log(`\x1B[90m[${Oe()}]\x1B[0m`,Ve,...xe):console.log(`[${Oe()}]`,Ve,...xe))}warn(Ve,...xe){this.getLevel()<=J.LogLevel.Warning&&(this.useColors?console.warn(`\x1B[93m[${Oe()}]\x1B[0m`,Ve,...xe):console.warn(`[${Oe()}]`,Ve,...xe))}error(Ve,...xe){this.getLevel()<=J.LogLevel.Error&&(this.useColors?console.error(`\x1B[91m[${Oe()}]\x1B[0m`,Ve,...xe):console.error(`[${Oe()}]`,Ve,...xe))}critical(Ve,...xe){this.getLevel()<=J.LogLevel.Critical&&(this.useColors?console.error(`\x1B[90m[${Oe()}]\x1B[0m`,Ve,...xe):console.error(`[${Oe()}]`,Ve,...xe))}dispose(){}flush(){}}function Oe(){const qe=new Date;return`${Qe(qe.getHours())}:${Qe(qe.getMinutes())}:${Qe(qe.getSeconds())}`}function Qe(qe){return qe<10?`0${qe}`:String(qe)}async function je(qe){const Ve=T.basename(qe),xe=T.dirname(qe),Ke=(await p.Promises.readdir(xe)).filter(Ce=>/^\d{8}T\d{6}$/.test(Ce)).sort().filter(Ce=>Ce!==Ve),ce=Ke.slice(0,Math.max(0,Ke.length-9));await Promise.all(ce.map(Ce=>p.Promises.rm(T.join(xe,Ce))))}}),define(ve[263],we([1,0,109,29,85,264,76,133,16,10,36,2,12,6,46,3,15,4,23,140,95,57,5,13,27,75,33,125,238,239,43,262,241]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S,y,h,w,E,g,m,f,c,u,r,o,n,i,s,a,l,d,I,L,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const J=5*60*1e3;let Z=class extends k.Disposable{constructor(W,fe,j,X,O,U,x,ae){super(),this._socketServer=W,this._connectionToken=fe,this._vsdaMod=j,this._environmentService=O,this._productService=U,this._logService=x,this._instantiationService=ae,this._webEndpointOriginChecker=te.create(this._productService),this._serverRootPath=(0,i.getRemoteServerRootPath)(U),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=X?this._instantiationService.createInstance(B.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(W,fe){if(W.method!=="GET")return(0,B.serveError)(W,fe,405,`Unsupported method ${W.method}`);if(!W.url)return(0,B.serveError)(W,fe,400,"Bad request.");const j=T.parse(W.url,!0);let X=j.pathname;if(!X)return(0,B.serveError)(W,fe,400,"Bad request.");if(X.startsWith(this._serverRootPath)&&X.charCodeAt(this._serverRootPath.length)===47&&(X=X.substring(this._serverRootPath.length)),X==="/version")return fe.writeHead(200,{"Content-Type":"text/plain"}),fe.end(this._productService.commit||"");if(X==="/delay-shutdown")return this._delayShutdown(),fe.writeHead(200),fe.end("OK");if(!(0,d.requestHasValidConnectionToken)(this._connectionToken,W,j))return(0,B.serveError)(W,fe,403,"Forbidden.");if(X==="/vscode-remote-resource"){const O=j.query.path;if(typeof O!="string")return(0,B.serveError)(W,fe,400,"Bad request.");let U;try{U=g.URI.from({scheme:S.Schemas.file,path:O}).fsPath}catch{return(0,B.serveError)(W,fe,400,"Bad request.")}const x=Object.create(null);this._environmentService.isBuilt&&((0,R.isEqualOrParent)(U,this._environmentService.builtinExtensionsPath,!w.isLinux)||(0,R.isEqualOrParent)(U,this._environmentService.extensionsPath,!w.isLinux))&&(x["Cache-Control"]="public, max-age=31536000"),x.Vary="Origin";const ae=W.headers.origin;return ae&&this._webEndpointOriginChecker.matches(ae)&&(x["Access-Control-Allow-Origin"]=ae),(0,B.serveFile)(U,1,this._logService,W,fe,x)}if(this._webClientServer){this._webClientServer.handle(W,fe,j);return}return fe.writeHead(404,{"Content-Type":"text/plain"}),fe.end("Not found")}handleUpgrade(W,fe){let j=(0,m.generateUuid)(),X=!1,O=!1;if(W.url){const re=T.parse(W.url,!0).query;typeof re.reconnectionToken=="string"&&(j=re.reconnectionToken),re.reconnection==="true"&&(X=!0),re.skipWebSocketFrames==="true"&&(O=!0)}if(W.headers.upgrade===void 0||W.headers.upgrade.toLowerCase()!=="websocket"){fe.end("HTTP/1.1 400 Bad Request");return}const U=W.headers["sec-websocket-key"],x=v.createHash("sha1");x.update(U+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ae=x.digest("base64"),ue=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ae}`];let Q=!1;if(!O&&!this._environmentService.args["disable-websocket-compression"]&&W.headers["sec-websocket-extensions"]){const re=Array.isArray(W.headers["sec-websocket-extensions"])?W.headers["sec-websocket-extensions"]:[W.headers["sec-websocket-extensions"]];for(const F of re)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(F)){if(/\b(permessage-deflate)\b/.test(F)){Q=!0,ue.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(F)){Q=!0,ue.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}fe.write(ue.join(`\r
`)+`\r
\r
`),fe.setTimeout(0),fe.setNoDelay(!0),O?this._handleWebSocketConnection(new u.NodeSocket(fe,`server-connection-${j}`),X,j):this._handleWebSocketConnection(new u.WebSocketNodeSocket(new u.NodeSocket(fe,`server-connection-${j}`),Q,null,!0),X,j)}handleServerError(W){this._logService.error("Error occurred in server"),this._logService.error(W)}_getRemoteAddress(W){let fe;return W instanceof u.NodeSocket?fe=W.socket:fe=W.socket.socket,fe.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(W,fe,j){const X=fe.getSocket();this._logService.error(`${W} ${j}.`);const O={type:"error",reason:j};fe.sendControl(p.VSBuffer.fromString(JSON.stringify(O))),fe.dispose(),await X.drain(),X.dispose()}_handleWebSocketConnection(W,fe,j){const X=this._getRemoteAddress(W),O=`[${X}][${j.substr(0,8)}]`,U=new c.PersistentProtocol(W),x=this._vsdaMod?new this._vsdaMod.validator:null,ae=this._vsdaMod?new this._vsdaMod.signer:null;let ue;(function(M){M[M.WaitingForAuth=0]="WaitingForAuth",M[M.WaitingForConnectionType=1]="WaitingForConnectionType",M[M.Done=2]="Done",M[M.Error=3]="Error"})(ue||(ue={}));let Q=0;const re=M=>{Q=3,F.dispose(),this._rejectWebSocketConnection(O,U,M)},F=U.onControlMessage(M=>{if(Q===0){let G;try{G=JSON.parse(M.toString())}catch{return re("Malformed first message")}if(G.type!=="auth")return re("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(G.auth))return re("Unauthorized client refused: auth mismatch");let ie=(0,m.generateUuid)();if(ae)try{ie=ae.sign(G.data)}catch{}let he=(0,m.generateUuid)();if(x)try{he=x.createNewMessage(he)}catch{}const Ee={type:"sign",data:he,signedData:ie};U.sendControl(p.VSBuffer.fromString(JSON.stringify(Ee))),Q=1}else if(Q===1){let G;try{G=JSON.parse(M.toString())}catch{return re("Malformed second message")}if(G.type!=="connectionType")return re("Invalid second message");if(typeof G.signedData!="string")return re("Invalid second message field type");const ie=G.commit,he=this._productService.commit;if(ie&&he&&ie!==he)return re("Client refused: version mismatch");let Ee=!1;if(!x)Ee=!0;else if(this._connectionToken.validate(G.signedData))Ee=!0;else try{Ee=x.validate(G.signedData)==="ok"}catch{}if(!Ee){if(this._environmentService.isBuilt)return re("Unauthorized client refused");this._logService.error(`${O} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const $ in this._managementConnections)this._managementConnections[$].shortenReconnectionGraceTimeIfNecessary();for(const $ in this._extHostConnections)this._extHostConnections[$].shortenReconnectionGraceTimeIfNecessary();Q=2,F.dispose(),this._handleConnectionType(X,O,U,W,fe,j,G)}})}async _handleConnectionType(W,fe,j,X,O,U,x){const ae=x.desiredConnectionType===1?`${fe}[ManagementConnection]`:x.desiredConnectionType===2?`${fe}[ExtensionHostConnection]`:fe;if(x.desiredConnectionType===1)if(O){if(!this._managementConnections[U])return this._allReconnectionTokens.has(U)?this._rejectWebSocketConnection(ae,j,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ae,j,"Unknown reconnection token (never seen)");j.sendControl(p.VSBuffer.fromString(JSON.stringify({type:"ok"})));const ue=j.readEntireBuffer();j.dispose(),this._managementConnections[U].acceptReconnection(W,X,ue)}else{if(this._managementConnections[U])return this._rejectWebSocketConnection(ae,j,"Duplicate reconnection token");j.sendControl(p.VSBuffer.fromString(JSON.stringify({type:"ok"})));const ue=new l.ManagementConnection(this._logService,U,W,j);this._socketServer.acceptConnection(ue.protocol,ue.onClose),this._managementConnections[U]=ue,this._allReconnectionTokens.add(U),ue.onClose(()=>{delete this._managementConnections[U]})}else if(x.desiredConnectionType===2){const ue=x.args||{language:"en"},Q=await this._updateWithFreeDebugPort(ue);if(Q.port&&this._logService.trace(`${ae} - startParams debug port ${Q.port}`),this._logService.trace(`${ae} - startParams language: ${Q.language}`),this._logService.trace(`${ae} - startParams env: ${JSON.stringify(Q.env)}`),O){if(!this._extHostConnections[U])return this._allReconnectionTokens.has(U)?this._rejectWebSocketConnection(ae,j,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ae,j,"Unknown reconnection token (never seen)");j.sendPause(),j.sendControl(p.VSBuffer.fromString(JSON.stringify(Q.port?{debugPort:Q.port}:{})));const re=j.readEntireBuffer();j.dispose(),this._extHostConnections[U].acceptReconnection(W,X,re)}else{if(this._extHostConnections[U])return this._rejectWebSocketConnection(ae,j,"Duplicate reconnection token");j.sendPause(),j.sendControl(p.VSBuffer.fromString(JSON.stringify(Q.port?{debugPort:Q.port}:{})));const re=j.readEntireBuffer();j.dispose();const F=this._instantiationService.createInstance(a.ExtensionHostConnection,U,W,X,re);this._extHostConnections[U]=F,this._allReconnectionTokens.add(U),F.onClose(()=>{delete this._extHostConnections[U],this._onDidCloseExtHostConnection()}),F.start(Q)}}else if(x.desiredConnectionType===3){const ue=x.args;this._createTunnel(j,ue)}else return this._rejectWebSocketConnection(ae,j,"Unknown initial data received")}async _createTunnel(W,fe){const j=W.getSocket().socket,X=W.readEntireBuffer();W.dispose(),j.pause();const O=await this._connectTunnelSocket(fe.host,fe.port);X.byteLength>0&&O.write(X.buffer),O.on("end",()=>j.end()),O.on("close",()=>j.end()),O.on("error",()=>j.destroy()),j.on("end",()=>O.end()),j.on("close",()=>O.end()),j.on("error",()=>O.destroy()),O.pipe(j),j.pipe(O)}_connectTunnelSocket(W,fe){return new Promise((j,X)=>{const O=D.createConnection({host:W,port:fe},()=>{O.removeListener("error",X),O.pause(),j(O)});O.once("error",X)})}_updateWithFreeDebugPort(W){return typeof W.port=="number"?(0,f.findFreePort)(W.port,10,5e3).then(fe=>(W.port=fe,W)):(W.debugId=void 0,W.port=void 0,W.break=void 0,Promise.resolve(W))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},J))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};Z=Ae([_e(4,I.IServerEnvironmentService),_e(5,n.IProductService),_e(6,o.ILogService),_e(7,r.IInstantiationService)],Z),e.RemoteExtensionHostAgentServer=Z;async function _(se,W,fe){const j=await(0,d.determineServerConnectionToken)(W);j instanceof d.ServerConnectionTokenParseError&&(console.warn(j.message),process.exit(1));const X=new k.DisposableStore,{socketServer:O,instantiationService:U}=await(0,L.setupServerServices)(j,W,fe,X);U.invokeFunction(G=>{const ie=G.get(o.ILogService);(0,b.setUnexpectedErrorHandler)(he=>{he&&he.code==="EPIPE"&&he.syscall==="write"&&he.stack&&/unexpectedErrorHandler/.test(he.stack)||ie.error(he)}),process.on("SIGPIPE",()=>{(0,b.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),U.invokeFunction(G=>{const ie=G.get(o.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const he=(0,y.join)(process.env.HOMEDRIVE,"node_modules"),Ee=(0,y.dirname)((0,y.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),$=(0,y.join)(Ee,"node_modules");if(t.existsSync(he)||t.existsSync($)){const Y=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${he}
* ${$}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;ie.warn(Y),console.warn(Y),process.exit(0)}}});const x=U.invokeFunction(G=>{const ie=G.get(o.ILogService);if(t.existsSync((0,y.join)(S.FileAccess.asFileUri("",oe).fsPath,"../node_modules/vsda")))try{return oe.__$__nodeRequire("vsda")}catch(Ee){ie.error(Ee)}return null}),ae=t.existsSync(S.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",oe).fsPath);if(ae&&se&&typeof se!="string"){const G=j.type!==0?`?${S.connectionTokenQueryName}=${j.value}`:"";console.log(`Web UI available at http://localhost${se.port===80?"":`:${se.port}`}/${G}`)}const ue=U.createInstance(Z,O,j,x,ae);h.mark("code/server/ready");const Q=C.performance.now(),re=global.vscodeServerStartTime,F=global.vscodeServerListenTime,M=global.vscodeServerCodeLoadedTime;if(U.invokeFunction(G=>{G.get(s.ITelemetryService).publicLog2("serverStart",{startTime:re,startedTime:F,codeLoadedTime:M,readyTime:Q})}),W["print-startup-performance"]){const G=P.LoaderStats.get();let ie="";ie+=`

### Load AMD-module
`,ie+=P.LoaderStats.toMarkdownTable(["Module","Duration"],G.amdLoad),ie+=`

### Load commonjs-module
`,ie+=P.LoaderStats.toMarkdownTable(["Module","Duration"],G.nodeRequire),ie+=`

### Invoke AMD-module factory
`,ie+=P.LoaderStats.toMarkdownTable(["Module","Duration"],G.amdInvoke),ie+=`

### Invoke commonjs-module
`,ie+=P.LoaderStats.toMarkdownTable(["Module","Duration"],G.nodeEval),ie+=`Start-up time: ${F-re}
`,ie+=`Code loading time: ${M-re}
`,ie+=`Initialized time: ${Q-re}
`,ie+=`
`,console.log(ie)}return ue}e.createServer=_;class te{static create(W){const fe=W.webEndpointUrlTemplate,j=W.commit,X=W.quality;if(!fe||!j||!X)return new te(null);const O=(0,m.generateUuid)(),x=new URL(fe.replace("{{uuid}}",O).replace("{{commit}}",j).replace("{{quality}}",X)).origin,ae=(0,E.escapeRegExpCharacters)(x).replace(O,"[a-zA-Z0-9\\-]+");try{const ue=(0,E.createRegExp)(`^${ae}$`,!0,{matchCase:!1});return new te(ue)}catch{return new te(null)}}constructor(W){this._originRegExp=W}matches(W){return this._originRegExp?this._originRegExp.test(W):!1}}}),define(ve[274],we([1,0,30,29,12,261,263,58,6,264,43,51,46]),function(oe,e,v,t,D,C,T,P,p,b,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,S.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=b.performance.now();const y={onMultipleValues:(i,s)=>{console.error(`Option '${i}' can only be defined once. Using value ${s}.`)},onEmptyValue:i=>{console.error(`Ignoring option '${i}': Value must not be empty.`)},onUnknownOption:i=>{console.error(`Ignoring option '${i}': not supported for server.`)},onDeprecatedOption:(i,s)=>{console.warn(`Option '${i}' is deprecated: ${s}`)}},h=(0,P.parseArgs)(process.argv.slice(2),R.serverOptions,y),w=h["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,p.join)(v.homedir(),k.default.serverDataFolderName||".vscode-remote"),E=(0,p.join)(w,"data"),g=(0,p.join)(E,"User"),m=(0,p.join)(g,"globalStorage"),f=(0,p.join)(g,"History"),c=(0,p.join)(E,"Machine");h["user-data-dir"]=E;const u=(0,p.dirname)(D.FileAccess.asFileUri("",oe).fsPath),r=(0,p.join)(u,"extensions");h["builtin-extensions-dir"]=r,h["extensions-dir"]=h["extensions-dir"]||(0,p.join)(w,"extensions"),[w,h["extensions-dir"],E,g,c,m,f].forEach(i=>{try{t.existsSync(i)||t.mkdirSync(i,{mode:448})}catch(s){console.error(s)}});function o(){(0,C.run)(h,w,R.serverOptions)}e.spawnCli=o;function n(i){return(0,T.createServer)(i,h,w)}e.createServer=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/129500ee4c8ab7263461ffe327268ba56b9f210d/core/vs/server/node/server.main.js.map
